# YaoBlocks

Standard basic quantum circuit simulator building blocks.

This is a component package for [Yao.jl](https://github.com/QuantumBFS/Yao.jl). It contains the abstract definitions and basic implementation of Yao's circuit building blocks.

using Test, YaoAPI, YaoBlocks, YaoArrayRegister

@testset "test chain" begin
    include("chain.jl")
end

@testset "test add" begin
    include("add.jl")
end

@testset "test kron" begin
    include("kron.jl")
end

@testset "test control" begin
    include("control.jl")
end

@testset "test put" begin
    include("put.jl")
end

@testset "test repeated" begin
    include("repeated.jl")
end

@testset "test subroutine" begin
    include("subroutine.jl")
end

@testset "test tag" begin
    include("tag.jl")
    include("cache.jl")
end

@testset "test single block chsubblocks" begin
    @test chsubblocks(chain(X), Y) == chain(Y)
    @test chsubblocks(kron(X), Y) == kron(Y)
    @test chsubblocks(*(X), Y) == *(Y)
    @test chsubblocks(+(X), Y) == +(Y)
end

@testset "extension" begin
    # check extension fallback errors
    struct MockedQFT{D} <: CompositeBlock{D} end
    @test_throws MethodError ishermitian(MockedQFT{2}())
    @test_throws MethodError isunitary(MockedQFT{2}())
    @test Val(im)*X == im*X
end

# NOTE: we cannot change subblocks of a primitive block
#      since they are primitive, therefore we return themselves
chsubblocks(x::PrimitiveBlock, it) = x
subblocks(x::PrimitiveBlock) = ()
# NOTE: all primitive block should name with postfix Gate
#       and each primitive block should stay in a single
#       file whose name is in lowercase and underscore.
include("const_gate.jl")
include("identity_gate.jl")
include("phase_gate.jl")
include("shift_gate.jl")
include("rotation_gate.jl")
include("time_evolution.jl")
include("projector.jl")
include("reflect.jl")
include("general_matrix_gate.jl")
include("measure.jl")

YaoAPI.isdiagonal(p::PrimitiveBlock) = isdiagonal(mat(p))

# Certain blocks, like X block can have faster getindex, but this performance (~2ns) is probably enough!
# Go to each block file to specialize!
function unsafe_getindex(::Type{T}, op::PrimitiveBlock{D}, i::Integer, j::Integer) where {T,D}
    return @inbounds mat(T, op)[i+1, j+1]
end
function unsafe_getcol(::Type{T}, op::PrimitiveBlock{D}, j::DitStr{D}) where {T,D}
    # TODO: check luxury sparse implementation of M[:,j]
    return getcol(mat(T, op), j)
end
function getcol(op::AbstractMatrix, j::DitStr{D,N,TI}) where {D,N,TI}
    res = op[:,buffer(j)+1]
    if res isa SparseVector
        return DitStr{D,N,TI}.(res.nzind .- 1), res.nzval
    else
        return DitStr{D,N,TI}.(0:size(op, 1)-1), res
    end
end
function getcol(op::PermMatrix, j::DitStr{D,N,TI}) where {D,N,TI}
    i = findfirst(==(buffer(j)+1), op.perm)
    return [DitStr{D,N,TI}(i-1)], [op.vals[i]]
end
function getcol(op::Diagonal, j::DitStr{D,N,TI}) where {D,N,TI}
    return [j], [op.diag[buffer(j)+1]]
end
function getcol(A::IMatrix, j::DitStr{D,N,TI}) where {D,N,TI}
    return [j], [one(eltype(A))]
end

"""
    paulipropagation2yao(n::Int, circ::AbstractVector{Gate}, thetas::AbstractVector)
    paulipropagation2yao(pc::PauliCircuit)

Convert a Pauli propagation circuit to a Yao circuit. You must `using PauliPropagation` before using this function.

# Arguments
- `n::Int`: Number of qubits.
- `circ::AbstractVector{Gate}`: Pauli propagation circuit.
- `thetas::AbstractVector`: Vector of parameters.

Or:
- `pc::PauliCircuit`: A PauliCircuit intermediate representation.
"""
function paulipropagation2yao(args...)
    error("You must `using PauliPropagation` first to use this feature.")
end

"""
    yao2paulipropagation(circ::ChainBlock; observable)

Convert a Yao circuit to a Pauli propagation circuit representation. You must `using PauliPropagation` before using this function.

# Arguments
- `circ::ChainBlock`: Yao circuit in the form of a chain of basic gates.

# Keyword Arguments
- `observable`: A Yao block specifying the observable to measure (required). Must be a sum of Pauli strings, e.g. `kron(5, 2=>X, 3=>X) + 2.0 * kron(5, 1=>Z)`. Will be converted to a `PauliSum`.

# Returns
- `PauliPropagationCircuit`: An intermediate representation that can be evaluated with `propagate(pc)`.
"""
function yao2paulipropagation(args...; kwargs...)
    error("You must `using PauliPropagation` first to use this feature.")
end

using YaoBlocks.AD, YaoBlocks
using Test

@testset "patches" begin
    include("patches.jl")
end

@testset "outerproduct_and_projection" begin
    include("outerproduct_and_projection.jl")
end

@testset "NoParams" begin
    include("NoParams.jl")
end

@testset "apply_back" begin
    include("apply_back.jl")
end

@testset "mat_back" begin
    include("mat_back.jl")
end

@testset "specializes" begin
    include("specializes.jl")
end

@testset "chainrules_patch" begin
    include("chainrules_patch.jl")
end

"""
    KrausChannel{D} <: AbstractQuantumChannel{D}
    KrausChannel(operators)

Create a Kraus representation of a quantum channel, where `operators` is a list of Kraus operators.
The kraus channel is defined as below

```math
\\phi(\\rho) = \\sum_i K_i ρ K_i^\\dagger,
```

where ``\\rho`` in a [`DensityMatrix`](@ref) as the register to apply on, ``K_i`` is the i-th operator in `operators`.

### Examples

```jldoctest; setup=:(using Yao)
julia> KrausChannel([X, Y, Z])
nqubits: 1
kraus_channel
├─ X
├─ Y
└─ Z
```
"""
struct KrausChannel{D} <: AbstractQuantumChannel{D}
    n::Int
    operators::Vector{AbstractBlock{D}}
    function KrausChannel(operators::Vector{AbstractBlock{D}}) where D
        n = _check_block_sizes(operators)
        new{D}(n, operators)
    end
end
function KrausChannel(it)
    length(it) == 0 && error("The input operator list size can not be 0!")
    D = nlevel(first(it))
    KrausChannel(collect(AbstractBlock{D}, it))
end
nqudits(uc::KrausChannel) = uc.n

# noisy_instruct! is used when the matrix representation of the kraus channel is available
function noisy_instruct!(r::DensityMatrix{D,T}, x::KrausChannel, locs) where {D,T}
    return unsafe_apply!(r, KrausChannel([put(nqudits(r), locs => op) for op in x.operators]))
end
# unsafe_apply! is used when the matrix representation of the kraus channel is not available
function YaoAPI.unsafe_apply!(r::DensityMatrix{D,T}, x::KrausChannel) where {D,T}
    r0 = copy(r)
    # first
    unsafe_apply!(r, first(x.operators))
    for o in x.operators[2:end-1]
        r.state .+= unsafe_apply!(copy(r0), o).state
    end
    # last
    r.state .+= unsafe_apply!(r0, last(x.operators)).state
    return r
end

subblocks(x::KrausChannel) = x.operators
chsubblocks(x::KrausChannel, it) = KrausChannel(collect(it))
occupied_locs(x::KrausChannel) = union(occupied_locs.(x.operators)...)

function cache_key(x::KrausChannel)
    return hash(ntuple(i -> hash(x.operators[i]), length(x.operators)))
end

function Base.:(==)(lhs::KrausChannel, rhs::KrausChannel)
    return (lhs.n == rhs.n) && (lhs.operators == rhs.operators)
end

Base.adjoint(x::KrausChannel) = KrausChannel(adjoint.(x.operators))

# convert kraus channel to superop
SuperOp(x::KrausChannel) = SuperOp(ComplexF64, x)
function SuperOp(::Type{T}, x::KrausChannel{D}) where {T,D}
    superop = sum(x.operators) do op
        m = mat(T, op)
        kron(conj(m), m)
    end
    return SuperOp{D}(x.n, superop)
end

# Note: the kron of two kraus channels is kron of its components
function LinearAlgebra.kron(x::KrausChannel, y::KrausChannel)
    return KrausChannel([kron(op1, op2) for op1 in x.operators for op2 in y.operators])
end

export print_tree, print_annotation, print_prefix, print_title, print_block

struct BlockTreeCharSet
    mid::Any
    terminator::Any
    skip::Any
    dash::Any
end

# Default Charset
BlockTreeCharSet() = BlockTreeCharSet('├', '└', '│', '─')

_charwidth(c::Char) = textwidth(c)
_charwidth(s) = sum(map(textwidth, collect(s)))

"""
    print_prefix(io, depth, charset, active_levels)

print prefix of a tree node in a single line.
"""
function print_prefix(io::IO, depth, charset, active_levels)
    for current_depth = 2:depth
        if current_depth in active_levels
            print(io, charset.skip, " "^(_charwidth(charset.dash) + 1))
        else
            print(io, " "^(_charwidth(charset.skip) + _charwidth(charset.dash) + 1))
        end
    end
end

"""
    print_title(io, block)

Print the title of given `block` of an [`AbstractBlock`](@ref).
"""
function print_title(io::IO, x::AbstractBlock)
    printstyled(io, "nqudits: ", nqudits(x); bold = false, color = :cyan)
end

function print_title(io::IO, x::AbstractBlock{2})
    printstyled(io, "nqubits: ", nqudits(x); bold = false, color = :cyan)
end

"""
    print_annotation(io, root, node, child, k)

Print the annotation of `k`-th `child` of node, aka the `k`-th element of
`subblocks(node)`.
"""
print_annotation(io::IO, root, node, child, k) = nothing

"""
    print_tree([io=stdout], root)

Print the block tree.
"""
print_tree(root; kwargs...) = print_tree(stdout, root; kwargs...)

Base.show(io::IO, blk::AbstractBlock) = show(io, "plain/text", blk)
Base.show(io::IO, ::MIME"plain/text", blk::AbstractBlock) = print_tree(io, blk)


function Base.show(io::IO, ::MIME"plain/text", blk::TagBlock{<:PrimitiveBlock})
    return print_tree(io, blk; title = false, compact = false)
end

Base.show(io::IO, ::MIME"plain/text", blk::PrimitiveBlock) =
    print_tree(io, blk; title = false, compact = true)

print_tree(io::IO, root::AbstractBlock; kwargs...) = print_tree(io, root, root; kwargs...)

"""
    print_tree(io, root, node[, depth=1, active_levels=()]; kwargs...)

Print the block tree.

# Keywords

- `maxdepth`: max tree depth to print
- `charset`: default is ('├','└','│','─'). See also `YaoBlocks.BlockTreeCharSet`.
- `title`: control whether to print the title, `true` or `false`, default is `true`
"""
function print_tree(
    io::IO,
    root::AbstractBlock,
    node::AbstractBlock,
    depth::Int = 1,
    islast::Bool = false,
    active_levels = ();
    maxdepth = 5,
    charset = BlockTreeCharSet(),
    title = true,
    compact = false,
)

    if root === node && title
        print_title(io, root)
        println(io)
    end

    if root === node
        islast = true
    end

    print_block(io, node)
    _println(io, node, islast, compact)

    kwargs = (maxdepth = maxdepth, charset = charset, title = false, compact = compact)
    for (k, each_node) in enumerate(subblocks(node))
        if k == lastindex(subblocks(node))
            print_prefix(io, depth, charset, active_levels)
            print(io, charset.terminator, charset.dash)
            print(io, " ")
            print_annotation(io, root, node, each_node, k)
            print_tree(
                io,
                root,
                each_node,
                depth + 1,
                islast && isempty(subblocks(each_node)),
                active_levels;
                kwargs...,
            )
        else
            print_prefix(io, depth, charset, active_levels)
            print(io, charset.mid, charset.dash)
            print(io, " ")
            print_annotation(io, root, node, each_node, k)
            print_tree(
                io,
                root,
                each_node,
                depth + 1,
                false,
                (active_levels..., depth + 1);
                kwargs...,
            )
        end
    end

    return nothing
end

function print_tree(
    io::IO,
    root::AbstractBlock,
    node::TagBlock,
    depth::Int = 1,
    islast::Bool = false,
    active_levels = ();
    maxdepth = 5,
    charset = BlockTreeCharSet(),
    title = true,
    compact = false,
)

    if root === node && title
        print_title(io, root)
        println(io)
    end

    if root === node
        print_annotation(io, root, root, root, 1)
        islast = true
    end

    kwargs = (maxdepth = maxdepth, charset = charset, title = false, compact = compact)
    child = content(node)
    print_annotation(io, root, node, child, 1)
    print_tree(
        io,
        root,
        child,
        depth + 1,
        islast && isempty(subblocks(child)),
        active_levels;
        kwargs...,
    )

    return nothing
end

_println(io::IO, node::AbstractBlock, islast, compact) = !compact && println(io)
function _println(io::IO, node::Union{TagBlock,PrimitiveBlock}, islast, compact)
    if !compact && !islast
        println(io)
    end
end

# Custom layouts
color(m::AbstractBlock) = color(typeof(m))
color(::Type{<:ControlBlock}) = :red
color(::Type{<:ChainBlock}) = :blue
color(::Type{<:Add}) = :red
color(::Type{<:PutBlock}) = :cyan
color(::Type{<:RepeatedBlock}) = :cyan
color(::Type{<:GeneralMatrixBlock}) = :red

print_block(io::IO, g::PhaseGate) = print(io, "phase(", g.theta, ")")
print_block(io::IO, S::ShiftGate) = print(io, "shift(", S.theta, ")")
print_block(io::IO, R::RotationGate) = print(io, "rot(", content(R), ", ", R.theta, ")")
print_block(io::IO, x::KronBlock) =
    printstyled(io, "kron"; bold = true, color = color(KronBlock))
print_block(io::IO, x::ChainBlock) =
    printstyled(io, "chain"; bold = true, color = color(ChainBlock))
print_block(io::IO, x::MixedUnitaryChannel) = printstyled(io, "mixed_unitary_channel"; bold = true)
print_block(io::IO, x::KrausChannel) = printstyled(io, "kraus_channel"; bold = true)
print_block(io::IO, c::Subroutine) = print(io, "Subroutine: ", occupied_locs(c))
print_block(io::IO, c::CachedBlock) = print_block(io, content(c))
print_block(io::IO, c::Add) = printstyled(io, "+"; bold = true, color = color(Add))
print_block(io::IO, c::TagBlock) = nothing
print_block(io::IO, c::GeneralMatrixBlock) =
    printstyled(io, c.tag; color = color(GeneralMatrixBlock))

function print_block(io::IO, c::Measure{D,K,OT}) where {D,K,OT}
    strs = String[]
    if c.operator != ComputationalBasis()
        push!(strs, "operator=$(repr(c.operator))")
    end

    if c.locations != AllLocs()
        push!(strs, "locs=$(repr(c.locations))")
    end

    if !(c.postprocess isa NoPostProcess)
        push!(strs, "postprocess=$(c.postprocess)")
    end

    out = join(strs, ", ")
    if !isempty(strs)
        out = "Measure($(nqudits(c));" * out
    else
        out = "Measure($(nqudits(c))" * out
    end

    return print(io, out, ")")
end

# TODO: use OhMyREPL's default syntax highlighting for functions
function print_block(io::IO, te::TimeEvolution)
    println(io, "Time Evolution Δt = $(te.dt), tol = $(te.tol)")
    print_tree(io, te.H; title = false)
end

function print_block(io::IO, x::ControlBlock)
    printstyled(io, "control("; bold = true, color = color(ControlBlock))

    for i in eachindex(x.ctrl_locs)
        x.ctrl_config[i] == 0 &&
            printstyled(io, '¬'; bold = true, color = color(ControlBlock))
        printstyled(io, x.ctrl_locs[i]; bold = true, color = color(ControlBlock))

        if i != lastindex(x.ctrl_locs)
            printstyled(io, ", "; bold = true, color = color(ControlBlock))
        end
    end
    printstyled(io, ")"; bold = true, color = color(ControlBlock))
end

function print_block(io::IO, pb::PutBlock)
    printstyled(io, "put on ("; bold = true, color = color(PutBlock))
    for i in eachindex(pb.locs)
        printstyled(io, pb.locs[i]; bold = true, color = color(PutBlock))
        if i != lastindex(pb.locs)
            printstyled(io, ", "; bold = true, color = color(PutBlock))
        end
    end
    printstyled(io, ")"; bold = true, color = color(PutBlock))
end

function print_block(io::IO, rb::RepeatedBlock)
    printstyled(io, "repeat on ("; bold = true, color = color(RepeatedBlock))
    for i in eachindex(rb.locs)
        printstyled(io, rb.locs[i]; bold = true, color = color(RepeatedBlock))
        if i != lastindex(rb.locs)
            printstyled(io, ", "; bold = true, color = color(RepeatedBlock))
        end
    end
    printstyled(io, ")"; bold = true, color = color(RepeatedBlock))
end

# forward to simplify interfaces
function print_annotation(
    io::IO,
    root::AbstractBlock,
    node::AbstractBlock,
    child::AbstractBlock,
    k = 1,
)
    print_annotation(io, child)
end

print_annotation(io::IO, node::AbstractBlock) = nothing # skip
print_annotation(io::IO, c::Daggered) =
    printstyled(io, " [†]"; bold = true, color = :yellow)
print_annotation(io::IO, c::CachedBlock) =
    printstyled(io, "[cached] "; bold = true, color = :yellow)

function print_annotation(io::IO, x::OnLevels)
    printstyled(io, "[on levels: ", x.levels, "] "; bold = true, color = :yellow)
end

function print_annotation(io::IO, x::Scale)
    if x.alpha == im
        printstyled(io, "[+im] "; bold = true, color = :yellow)
    elseif x.alpha == -im
        printstyled(io, "[-im] "; bold = true, color = :yellow)
    elseif x.alpha == 1
        printstyled(io, "[+] "; bold = true, color = :yellow)
    elseif x.alpha == -1
        printstyled(io, "[-] "; bold = true, color = :yellow)
    elseif real(x.alpha) == 0
        printstyled(io, "[scale: ", imag(x.alpha), "im] "; bold = true, color = :yellow)
    else
        printstyled(io, "[scale: ", x.alpha, "] "; bold = true, color = :yellow)
    end
end

function print_annotation(io::IO, x::Scale{Val{S}}) where {S}
    print_annotation(io, Scale(S, x))
end

function print_annotation(
    io::IO,
    root::AbstractBlock,
    node::KronBlock,
    child::AbstractBlock,
    k::Int,
)
    if length(node.locs[k]) == 1
        printstyled(io, node.locs[k].start; bold = true, color = :white)
    else
        printstyled(io, node.locs[k]; bold = true, color = :white)
    end
    print(io, "=>")
    print_annotation(io, child)
end

function print_annotation(
    io::IO,
    root::AbstractBlock,
    node::ControlBlock,
    child::AbstractBlock,
    k::Int,
)

    printstyled(io, node.locs; bold = true, color = :white)
    print(io, " ")
    print_annotation(io, child)
end

function print_annotation(
    io::IO,
    root::AbstractBlock,
    node::MixedUnitaryChannel,
    child::AbstractBlock,
    k::Int,
)
    print_annotation(io, child)
    printstyled(io, "[", node.probs[k], "] "; color = :cyan)
end

"""
    eigenbasis(op::AbstractBlock)

Return the `eigenvalue` and `eigenvectors` of target operator.
By applying `eigenvector`' to target state,
one can swith the basis to the eigenbasis of this operator.
However, `eigenvalues` does not have a specific form.
"""
function eigenbasis(op::AbstractBlock{D}) where {D}
    if isdiagonal(op)
        return op, IdentityGate{D}(nqudits(op))
    else
        @debug "eigenbasis on blocktype `$(typeof(op))` calls into the fallback implementation, which might be slow. Try using `kron`, `repeat` if items commute to each other."
        E, V = eigen!(Matrix(mat(op)))
        matblock(Diagonal(E)), matblock(V)
    end
end

# assume composition does not change diagonal property
"""
Return true if operators commute to each other.
"""
function simple_commute_eachother(ops::Vector{<:AbstractBlock{D}}) where {D}
    n = _check_block_sizes(ops)
    occ = zeros(Bool, n)
    for op in ops
        for i in occupied_locs(op)
            if occ[i]
                return false
            else
                occ[i] = true
            end
        end
    end
    return true
end

function eigenbasis(op::ChainBlock)
    # detect commute operators
    if simple_commute_eachother(subblocks(op))
        E = chain(op.n)
        blks = chain(op.n)
        for b in subblocks(op)
            Ei, Vi = eigenbasis(b)
            push!(E, Ei)
            push!(blks, Vi)
        end
        return E, blks
    else
        if op.n > 5
            @warn "eigenbasis on blocktype `ChainBlock` (size $(op.n)) calls into the fallback implementation, which might be slow. Try using `kron`, `repeat` if items commute to each oher. If this behavior is not what you expected, please file an issue here: https://github.com/QuantumBFS/Yao.jl/issues."
        end
        invoke(eigenbasis, Tuple{AbstractBlock}, op)
    end
end

function eigenbasis(op::Add)
    # detect commute operators
    if simple_commute_eachother(subblocks(op))
        E = Add(op.n)
        blks = chain(op.n)
        for b in subblocks(op)
            Ei, Vi = eigenbasis(b)
            push!(E, Ei)
            push!(blks, Vi)
        end
        return E, blks
    else
        if op.n > 5
            @warn "eigenbasis on blocktype `Add` (size $(op.n)) calls into the fallback implementation, which might be slow. Try using `kron`, `repeat` if items commute to each oher. If this behavior is not what you expected, please file an issue here: https://github.com/QuantumBFS/Yao.jl/issues."
        end
        invoke(eigenbasis, Tuple{AbstractBlock}, op)
    end
end

for GT in [:PutBlock, :RepeatedBlock, :ControlBlock, :Daggered]
    @eval function eigenbasis(op::$GT)
        E, V = eigenbasis(content(op))
        chcontent(op, E), chcontent(op, V)
    end
end

for GT in [:RotationGate, :TimeEvolution, :Scale]
    @eval function eigenbasis(op::$GT)
        E, V = eigenbasis(content(op))
        chcontent(op, E), V
    end
end

for GT in [:CachedBlock]
    @eval function eigenbasis(op::$GT)
        eigenbasis(content(op))
    end
end

function eigenbasis(op::KronBlock)
    E = []
    blks = []
    for (k, b) in op
        Ei, Vi = eigenbasis(b)
        push!(E, k => Ei)
        push!(blks, k => Vi)
    end
    kron(op.n, E...), kron(op.n, blks...)
end

function eigenbasis(op::XGate)
    Z, H
end

function eigenbasis(op::YGate)
    Z, ConstGate.S * H
end

function measure!(
    postprocess::NoPostProcess,  # operator measuring does not allow removing bits or resetting vaules.
    op::AbstractBlock,
    reg::AbstractRegister,
    locs::AllLocs;
    kwargs...,
)
    _check_msize(op, reg, locs)
    E, V = eigenbasis(op)
    res = measure!(postprocess, BlockedBasis(diag(mat(E))), reg |> V', locs; kwargs...)
    apply!(reg, V)
    return res
end

# `BlockedBasis` is for measuring operators on its eigen basis, where a `block` is a subspace with the same eigenvalue.
# * `perm` is the permutation that permute the basis by the ascending order of eigenvalues,
# * `values` are eigenvalues of target observable for each block,
# * `block_ptr` is the pointers for blocks, e.g. to index block `i`, one can use `block_ptr[i]:block_ptr[i-1]`, or `subblock(blockbasis, i)` for short.
struct BlockedBasis{VT}
    perm::Vector{Int}
    values::VT
    block_ptr::Vector{Int}
end

subblock(bb::BlockedBasis, i::Int) = bb.block_ptr[i]:bb.block_ptr[i+1]-1
nblocks(bb::BlockedBasis) = length(bb.block_ptr) - 1

function BlockedBasis(values::AbstractVector{T}) where {T}
    if length(values) == 1
        return BlockedBasis([1], values, [1, 2])
    elseif length(values) == 0
        return BlockedBasis([], values, [1])
    end
    order = sortperm(values; by = real)
    values = values[order]
    vpre = values[1]
    block_ptr = [1]
    unique_values = [vpre]
    k = 1
    @inbounds for i = 2:length(values)
        v = values[i]
        if !isapprox(v, vpre)  # use approx in order to ignore the round off error
            k += 1
            push!(block_ptr, i)
            push!(unique_values, v)
        end
        vpre = v
    end
    push!(block_ptr, length(values) + 1)
    return BlockedBasis(order, unique_values, block_ptr)
end

function YaoAPI.measure!(
    ::NoPostProcess,
    bb::BlockedBasis,
    reg::AbstractArrayReg{D,T},
    ::AllLocs;
    rng::AbstractRNG = Random.GLOBAL_RNG,
) where {D,T}
    B = YaoArrayRegister._asint(nbatch(reg))
    state = @inbounds (reg|>rank3)[bb.perm, :, :]  # permute to make eigen values sorted
    pl = dropdims(sum(abs2, state, dims = 2), dims = 2)
    pl_block = zeros(eltype(pl), nblocks(bb), B)
    @inbounds for ib = 1:B
        for i = 1:nblocks(bb)
            for k in subblock(bb, i)
                pl_block[i, ib] += pl[k, ib]
            end
        end
    end
    res = Vector{Int}(undef, B)
    @inbounds @views for ib = 1:B
        ires = sample(rng, 1:nblocks(bb), Weights(pl_block[:, ib]))
        # notice ires is `BitStr` type, can be use as indices directly.
        range = subblock(bb, ires)
        state[range, :, ib] ./= sqrt(pl_block[ires, ib])
        state[1:range.start-1, :, ib] .= zero(T)
        state[range.stop+1:size(state, 1), :, ib] .= zero(T)
        res[ib] = ires
    end
    # undo permute and assign back
    _state = reshape(state, 1 << nactive(reg), :)
    rstate = reshape(reg.state, 1 << nactive(reg), :)
    @inbounds for j = 1:size(rstate, 2)
        for i = 1:size(rstate, 1)
            rstate[bb.perm[i], j] = _state[i, j]
        end
    end
    return reg isa ArrayReg ? bb.values[res[]] : bb.values[res]
end

function YaoAPI.measure!(
    ::NoPostProcess,
    bb::BlockedBasis,
    rho::DensityMatrix{D, T},
    ::AllLocs;
    rng::AbstractRNG = Random.GLOBAL_RNG,
) where {D,T}
    state = @inbounds rho.state[bb.perm, bb.perm]  # permute to make eigen values sorted
    pl = diag(state)
    # cummulate probabilities in each block
    pl_block = zeros(eltype(pl), nblocks(bb))
    for i = 1:nblocks(bb)
        for k in subblock(bb, i)
            pl_block[i] += pl[k]
        end
    end
    res = sample(rng, 1:nblocks(bb), Weights(real.(pl_block)))
    # collapse to the selected block
    range = subblock(bb, res)
    mblock = state[range, range] ./ pl_block[res]
    state .= zero(T)
    state[range, range] .= mblock

    # undo permute and assign back
    rho.state[bb.perm, bb.perm] .= state
    return bb.values[res]
end


function YaoAPI.measure!(
    p::ResetTo,
    op::AbstractBlock,
    reg::AbstractRegister,
    locs::AllLocs;
    kwargs...,
)
    throw(ArgumentError("post processing `$p` is not allowed when measuring an operator."))
end
 
function YaoAPI.measure!(
    p::RemoveMeasured,
    op::AbstractBlock,
    reg::AbstractRegister,
    locs::AllLocs;
    kwargs...,
)
    throw(ArgumentError("post processing `$p` is not allowed when measuring an operator."))
end
 
function measure(op::AbstractBlock, reg::AbstractRegister, locs::AllLocs; kwargs...)
    _check_msize(op, reg, locs)
    E, V = eigenbasis(op)
    res = measure(ComputationalBasis(), copy(reg) |> V', locs; kwargs...)
    diag(mat(E))[Int64.(res).+1]
end
function measure(op::AbstractBlock, rho::DensityMatrix, locs::AllLocs; kwargs...)
    Base.invoke(measure, Tuple{AbstractBlock,AbstractRegister,AllLocs}, op, rho, locs; kwargs...)
end

render_mlocs(alllocs::AllLocs, locs) = locs
render_mlocs(alllocs, locs) = alllocs[locs]

function _check_msize(op, reg, locs)
    if (locs isa AllLocs ? nactive(reg) : length(locs)) != nqubits(op)
        throw(
            QubitMismatchError(
                "operator of size $(nqubits(op)) does not match register size $(nactive(reg))",
            ),
        )
    end
end

function measure(op::Scale, reg::AbstractRegister, locs::AllLocs; kwargs...)
    factor(op) .* measure(content(op), reg, locs; kwargs...)
end

function measure(op::CachedBlock, reg::AbstractRegister, locs::AllLocs; kwargs...)
    measure(content(op), reg, locs; kwargs...)
end

function measure(op::Daggered, reg::AbstractRegister, locs::AllLocs; kwargs...)
    conj(measure(content(op), reg, locs; kwargs...))
end

function measure(op::PutBlock, reg::AbstractRegister, locs; kwargs...)
    _check_msize(op, reg, locs)

    # get eigen basis
    E, V = eigenbasis(op)
    ai = AddressInfo(nactive(reg), locs)
    _E = map_address(E, ai)
    _V = map_address(V, ai)
    _reg = copy(reg) |> _V'

    # perform equivalent measure
    E = diag(mat(content(_E)))
    res = measure(ComputationalBasis(), _reg, _E.locs; kwargs...)
    map(ri -> E[Int64(ri)+1], res)
end

function measure(op::PutBlock, reg::AbstractRegister, locs::AllLocs; kwargs...)
    invoke(measure, Tuple{PutBlock,AbstractRegister,Any}, op, reg, locs; kwargs...)
end

export apply_back!, apply_back

const Rotor{D,T} = Union{RotationGate{D,T},PutBlock{D,<:Any,<:RotationGate{<:Any,T}}}

as_scalar(arr::AbstractArray{T,0}) where {T} = arr[]
as_scalar(arr) = arr

"""
    generator(rot::Rotor) -> AbstractBlock

Return the generator of rotation block.
"""
generator(rot::RotationGate) = rot.block
generator(rot::PutBlock) =
    PutBlock(rot.n, generator(rot |> content), rot |> occupied_locs)

function apply_back!(st, block::AbstractBlock, collector) #,AbstractContainer{<:PrimitiveBlock}
    out, outδ = st
    if nparameters(block) == 0
        adjblock = block'
        in = apply!(out, adjblock)
        inδ = apply!(outδ, adjblock)
        return (in, inδ)
    else
        throw(MethodError(apply_back, (st, block, collector)))
    end
end

function apply_back!(st, block::Subroutine{D}, collector) where {D}
    out, outδ = st
    focus!(out, block.locs)
    focus!(outδ, block.locs)
    apply_back!((out, outδ), content(block), collector)
    relax!(out, block.locs; to_nactive = nqudits(block))
    relax!(outδ, block.locs; to_nactive = nqudits(block))
    return (out, outδ)
end

function apply_back!(st, block::Rotor{D}, collector) where {D}
    out, outδ = st
    adjblock = block'
    backward_params!((out, outδ), block, collector)
    in = apply!(out, adjblock)
    inδ = apply!(outδ, adjblock)
    return (in, inδ)
end

function apply_back!(st, block::TimeEvolution, collector)
    out, outδ = st
    adjblock = block'

    out, outδ = st
    input = apply!(out, adjblock)
    for i=1:YaoArrayRegister._asint(nbatch(outδ))
        o = viewbatch(outδ, i)
        !all(x -> x ≈ 0.0im, o.state) && apply!(o, adjblock)
    end
    pushfirst!(collector, -sum(imag(input' * apply!(copy(outδ), block.H))))
    return (input, outδ)
end

function apply_back!(st, block::PutBlock, collector)
    out, outδ = st
    adjblock = block'
    in = apply!(out, adjblock)
    adjmat = outerprod(outδ, in)
    mat_back!(datatype(in), block, adjmat, collector)
    inδ = apply!(outδ, adjblock)
    return (in, inδ)
end

function apply_back!(st, block::KronBlock, collector)
    apply_back!(st, chain(nqudits(block), [put(loc => block[loc]) for loc in block.locs]), collector)
end

function apply_back!(st, block::ControlBlock, collector)
    out, outδ = st
    adjblock = block'
    in = apply!(out, adjblock)
    adjmat = outerprod(outδ, in)
    mat_back!(datatype(in), block, adjmat, collector)
    inδ = apply!(outδ, adjblock)
    return (in, inδ)
end

function apply_back!(st, block::Daggered, collector)
    out, outδ = st
    adjblock = block'
    in = apply!(out, adjblock)
    adjmat = outerprod(in, outδ)
    mat_back!(datatype(in), content(block), adjmat, collector)
    inδ = apply!(outδ, adjblock)
    return (in, inδ)
end

function apply_back!(st, block::Scale, collector)
    out, outδ = st
    # recoverting inputs
    if isunitary(block)
        in = apply!(out, block')
    elseif isunitary(content(block))
        in = apply!(regscale!(out, inv(factor(block))), content(block)')
    else
        @warn "rescaling a non-unitary block, call into inefficient back-propgation routine."
        in = apply!(out, matblock(inv(Matrix(block))))
    end
    # adjoint of matrix
    adjmat = outerprod(outδ, in)
    mat_back!(datatype(in), block, adjmat, collector)

    inδ = apply!(outδ, block')

    # differentiate scaling
    #if niparams(block) > 0
    #    g = dropdims(sum(conj.(state(in)) .* state(outδ), dims = (1, 2)), dims = (1, 2)) |> as_scalar
    #    pushfirst!(collector, g')
    #end
    return (in, inδ)
end

function apply_back!(st, circuit::ChainBlock, collector)
    for blk in Base.Iterators.reverse(subblocks(circuit))
        st = apply_back!(st, blk, collector)
    end
    return st
end

function apply_back!(st, circuit::AbstractAdd, collector; in)
    out, outδ = st
    adjmat = outerprod(outδ, in)
    for blk in Base.Iterators.reverse(subblocks(circuit))
        mat_back!(datatype(in), blk, adjmat, collector)
    end
    inδ = apply!(outδ, circuit')
    (in, inδ)
end

function apply_back!(st, block::RepeatedBlock{D,C}, collector) where {D,C}
    if nparameters(content(block)) == 0
        return apply!.(st, Ref(block'))
    end
    res = Any[]
    st = apply_back!(st, chain(nqudits(block), [put(loc => content(block)) for loc in block.locs]), res)
    res = dropdims(sum(reshape(res, :, C), dims = 2), dims = 2) |> as_scalar
    prepend!(collector, res)
    return st
end

# TODO: concentrator, repeat, kron
apply_back!(st, block::Measure, collector) =
    throw(MethodError(apply_back!, (st, block, collector)))

function backward_params!(st, block::Rotor, collector)
    in, outδ = st
    Σ = generator(block)
    g = vec(state(in |> Σ))' * vec(state(outδ)) |> as_scalar
    pushfirst!(collector, -imag(g) / 2)
    in |> Σ
    nothing
end

"""
    apply_back(st::Tuple{<:AbstractArrayReg, <:AbstractArrayReg}, block::AbstractBlock; kwargs...) -> (out, outδ), paramsδ

The backward function of `apply!`. Returns a tuple of ((input register, gradient of input register), parameter gradients)
"""
function apply_back(st::Tuple{<:AbstractArrayReg, <:AbstractArrayReg}, block::AbstractBlock; kwargs...)
    col = []
    in, inδ = apply_back!(st, block, col; kwargs...)
    (in, inδ), col
end

using Test, YaoBlocks

@testset "utils" begin
    include("utils.jl")
end

@testset "test primitive block" begin
    include("primitive/primitive.jl")
end

@testset "test composite block" begin
    include("composite/composite.jl")
end

@testset "test symbolic algebra" begin
    include("algebra.jl")
end

@testset "test layouts" begin
    include("layouts.jl")
end

@testset "test matrix manipulation routines" begin
    include("rountines.jl")
end

@testset "test block tools" begin
    include("blocktools.jl")
end

@testset "Yao/#166" begin
    @test_throws ErrorException put(100, 1 => X) |> mat
end

@testset "dispatch" begin
    g = dispatch!(chain(Rx(0.1), Rx(0.2)), [0.3, 0])
    @test getiparams(g[1]) == 0.3
    @test getiparams(g[2]) == 0.0

    g = dispatch(chain(Rx(0.1), Rx(0.2)), [0.0f3, 0.0f0])
    @test getiparams(g[1]) === 0.0f3
    @test getiparams(g[2]) === 0.0f0
end

@testset "abstract blocks" begin
    include("abstract_blocks.jl")
end

@testset "extending reg blocks" begin
    include("extending_reg.jl")
end

@testset "measure_ops" begin
    include("measure_ops.jl")
end

@testset "test tree utils" begin
    include("treeutils/treeutils.jl")
end

@testset "autodiff" begin
    include("autodiff/autodiff.jl")
end

@testset "channel" begin
    include("channel/channel.jl")
end

@testset "pauli propagation" begin
    include("pauli_propagation.jl")
end

@testset "openqasm" begin
    using OpenQASM
    include("openqasm/openqasm.jl")
end

using Test, YaoBlocks, YaoArrayRegister

@test shift(1) isa ShiftGate{Float64}

@testset "test constructor" for T in [Float16, Float32, Float64]
    @test ShiftGate(T(0.1)) isa ShiftGate{T}
    @test shift(T(0.1)) isa ShiftGate{T}
    @test adjoint(shift(0.1)) == shift(-0.1)
end

@testset "test matrix" begin
    g = ShiftGate{Float64}(pi)
    @test mat(g) ≈ exp(im * pi / 2) * [exp(-im * pi / 2) 0; 0 exp(im * pi / 2)]
end

@testset "test apply" begin
    g = ShiftGate{Float64}(pi)
    reg = rand_state(1)
    @test mat(g) * state(reg) ≈ state(apply!(reg, g))
end

@testset "test compare" begin
    @test (ShiftGate(2.0) == ShiftGate(2.0)) == true
    @test (ShiftGate(2.0) == ShiftGate(1.0)) == false
end

@testset "test copy" begin
    g = ShiftGate(0.1)
    cg = copy(g)
    cg.theta = 0.2
    @test g.theta == 0.1
end

@testset "test properties" begin
    g = ShiftGate{Float64}(0.1)
    @test nqubits(g) == 1
    @test isreflexive(g) == false
    @test isunitary(g) == true
    @test ishermitian(g) == false
    @test isdiagonal(g) == isdiagonal(mat(g)) == true

    g = ShiftGate{ComplexF64}(0.1 + 0im)
    @test @test_nowarn isunitary(g) == true

    g = ShiftGate{ComplexF64}(0.1 + 1im)
    @test @test_logs (
        :warn,
        "θ in ShiftGate is not real, got θ=0.1 + 1.0im, fallback to matrix-based method",
    ) isunitary(g) == false
end

@testset "test parameters" begin
    @test nparameters(shift(0.1)) == 1
    @test parameters(shift(0.1)) == [0.1]
    @test parameters(dispatch!(shift(0.1), 0.2)) == [0.2]
    @test parameters(dispatch(shift(0.1), 2)) == [2]
end

using Test, YaoAPI, YaoBlocks, BitBasis, YaoArrayRegister, Random
using StatsBase: mean

@testset "measure ghz" begin
    # GHZ state
    st = normalize!(arrayreg(bit"0000") + arrayreg(bit"1111"))
    Random.seed!(1234)

    # measure it at 1, 2
    # should collapse to 0000 or 1111 since entangled
    g = Measure(4; locs = (1, 2))
    @test occupied_locs(g) == (1, 2)
    st |> g
    @test (copy(st) |> g) isa ArrayReg

    @test g.results[1] == 0 ? st.state[end] == 0 : st.state[1] == 0
    g = Measure(4; locs = (1, 2), resetto = 2)
    @test g.postprocess isa ResetTo{BitStr64{2}}

    m = Measure(4)
    @test occupied_locs(m) == (1, 2, 3, 4)
    @test m.postprocess isa NoPostProcess
end

@testset "resetto" begin
    Random.seed!(1234)

    st = rand_state(5; nbatch = 3)
    g = Measure(5; locs = (1, 2), resetto = bit"00011")
    @test num_measured(g) == 2
    st |> g
    for k = 1:32
        if !(st.state[k] ≈ 0.0)
            @test all(BitStr64{5}(k - 1)[1:2] .== 1)
        end
    end
    @test Measure(5; locs = (1, 2), resetto = 0b0011).postprocess isa ResetTo{BitStr64{2}}
    @test_throws AssertionError Measure(5; locs = (1, 2), resetto = 0b0011, operator=put(5, 2=>X))
end

@testset "error handling" begin
    @test_throws ErrorException Measure(
        5;
        locs = (1, 2),
        resetto = bit"00011",
        remove = true,
    )
    @test_throws ErrorException mat(Measure(5; locs = (1, 2), resetto = bit"00011"))
end


@testset "op-measures" begin
    Random.seed!(1234)

    reg = rand_state(6, nbatch = 10)
    op = repeat(3, X)

    # measure!
    reg2 = reg |> copy
    res = measure!(op, reg2, 2:4)
    res2 = measure!(op, reg2, 2:4)
    @test size(res) == (10,)
    @test res2 == res

    # measure_resetto! and measure_remove! for operators are no-longer supported due to its ill property.
    reg = clone(ArrayReg(ComplexF64[1, -1] / sqrt(2.0)), 10)
    @test measure!(X, reg) |> mean ≈ -1
    reg = clone(ArrayReg(ComplexF64[1.0, 0]), 1000)
    @test abs(measure!(X, reg) |> mean) < 0.1
end

@testset "op-measures" begin
    reg = rand_state(8; nbatch = 32)
    op = repeat(5, X, 1:5)

    # measure!
    reg2 = reg |> copy
    res = measure!(op, reg2, 2:6)
    res2 = measure!(op, reg2, 2:6)
    @test size(res) == (32,)
    @test res2 == res

    # measure
    reg2 = reg |> copy
    res = measure(op, reg2, 2:6; nshots = 100)
    @test size(res) == (100, 32)
    @test reg ≈ reg2

    reg = clone(ArrayReg([1, -1 + 0im] / sqrt(2.0)), 10)
    @test measure!(X, reg) |> mean ≈ -1
    reg = clone(ArrayReg([1.0, 0 + 0im]), 1000)
    @test abs(measure!(X, reg) |> mean) < 0.1

    m = Measure(1)
    @test chmeasureoperator(m, X) == Measure(1, operator = X)
    @test_throws AssertionError chmeasureoperator(m, put(5, 2=>X))
end

@testset "measure an operator correctly" begin
    op = kron(Z, Z)
    reg = ArrayReg(ComplexF64[1/sqrt(2), 0, 0, 1/sqrt(2)])
    res = measure!(op, reg)
    @test res == 1
    @test reg ≈ ArrayReg(ComplexF64[1/sqrt(2), 0, 0, 1/sqrt(2)])
    reg = uniform_state(2)
    res = measure!(op, reg)
    @test count(!iszero, reg.state) == 2

    # batched
    reg =
        BatchedArrayReg(reshape(ComplexF64[1/sqrt(2), 0, 0, 1/sqrt(2), 0.5, 0.5, 0.5, 0.5], 4, 2))
    res = measure!(op, reg)
    @test length(reg) == 2 && res[1] == 1
    @test reg.state[:, 1] ≈ ComplexF64[1/sqrt(2), 0, 0, 1/sqrt(2)]
    @test count(!iszero, reg.state) == 4
    @test isnormalized(reg)

    # with virtual dimension
    reg =
        ArrayReg(
            reshape(ComplexF64[1/sqrt(2), 0, 0, 1/sqrt(2), 0.5, 0.5, 0.5, 0.5], 4, 2),
        ) / sqrt(2)
    res = measure!(op, reg)
    @test reg isa ArrayReg
    c = count(!iszero, reg.state)
    @test (c == 4 && res ≈ 1) || (c == 2 && res == -1)
    @test isnormalized(reg)

    # measure zero space
    reg = ArrayReg(ComplexF64[1.0])
    res = measure!(matblock(fill(3.0 + 0im, 1, 1)), reg)
    @test res ≈ 3.0
    @test reg == zero_state(0)
end

@testset "error_prob in Measure" begin
    count0 = 0
    count1 = 0
    p = 0.2

    Random.seed!(1234)
    for _ in 1:10000
        st = normalize!(arrayreg(bit"0000"))
        g = Measure(4; locs = (1, 2), error_prob = p)
        st |> g
        for i in 1:2
            readbit(g.results, i) == 0 ? count0 += 1 : count1 += 1
        end
    end
    @test count1 / (count0 + count1) ≈ p atol = 0.01
end

@testset "Measure throw error when error_prob is not supported" begin
    m = Measure(1)
    @test_throws AssertionError Measure{3}(1, m.rng, m.operator, m.locations, m.postprocess, 0.2)
    m = Measure(1; error_prob = 1.0, operator = Z)
    st = product_state(bit"0")
    apply!(st, m)
    @test st ≈ product_state(bit"0")
    @test m.results == -1
end

export LowRankMatrix, OuterProduct, projection, outerprod
abstract type LowRankMatrix{T} <: AbstractMatrix{T} end

"""
$(TYPEDEF)

If `ATL(R) <: AbstractVector`, it represents an outer product `x.left*transpose(x.right)`.
Else if `ATL(R) <: AbstractMatrix`, then it is an outer product `x.left*transpose(x.right)`.
"""
struct OuterProduct{T,ATL<:AbstractArray{T},ATR<:AbstractArray{T}} <: LowRankMatrix{T}
    left::ATL
    right::ATR
    function OuterProduct(left::ATL, right::ATR) where {T,ATL<:AbstractArray{T},ATR<:AbstractArray{T}}
        size(left, 2) != size(right, 2) && throw(
            DimensionMismatch(
                "The seconds dimension of left ($(size(left,2))) and right $(size(right,2)) does not match.",
            ),
        )
        return new{T,ATL,ATR}(left, right)
    end
end

const BatchedOuterProduct{T,MTL,MTR} =
    OuterProduct{T,MTL,MTR} where {MTL<:AbstractMatrix,MTR<:AbstractMatrix}
const SimpleOuterProduct{T,VTL,VTR} =
    OuterProduct{T,VTL,VTR} where {VTL<:AbstractVector,VTR<:AbstractVector}

LinearAlgebra.rank(op::OuterProduct) = size(op.left, 2)
Base.getindex(op::OuterProduct{T,<:AbstractVector}, i::Int, j::Int) where {T} =
    op.left[i] * op.right[j]
Base.getindex(op::BatchedOuterProduct, i::Int, j::Int) =
    sum(k -> op.left[i, k] * op.right[j, k], 1:rank(op))
Base.size(op::OuterProduct) = (size(op.left, 1), size(op.right, 1))
Base.size(op::OuterProduct, i::Int) =
    i == 1 ? size(op.left, 1) : (i == 2 ? size(op.right, 1) : throw(DimensionMismatch("")))

Base.:(*)(a::OuterProduct, b::AbstractVector) = a.left * (transpose(a.right) * b)
Base.:(*)(a::OuterProduct, b::AbstractMatrix) =
    OuterProduct(a.left, transpose(transpose(a.right) * b))
Base.:(*)(a::AbstractMatrix, b::OuterProduct) = OuterProduct(a * b.left, b.right)
Base.:(*)(a::LinearAlgebra.AdjointAbsVec, b::OuterProduct) = (a * b.left) * transpose(b.right)
Base.:(*)(a::OuterProduct, b::OuterProduct) =
    OuterProduct(a.left * (transpose(a.right) * b.left), b.right)
LinearAlgebra.rmul!(a::OuterProduct, b::Number) = (rmul!(a.left, b); a)
Base.:(*)(a::Number, b::OuterProduct) = OuterProduct(a * b.left, b.right)
Base.:(*)(b::OuterProduct, a::Number) = a * b

Base.conj!(op::OuterProduct) = OuterProduct(conj!(op.left), conj!(op.right))
Base.transpose(op::OuterProduct) = OuterProduct(op.right, op.left)
Base.adjoint(op::OuterProduct) = OuterProduct(conj(op.right), conj(op.left))

outerprod(left::AbstractVector, right::AbstractVector) = OuterProduct(left, right)
outerprod(left::AbstractMatrix, right::AbstractMatrix) = OuterProduct(left, right)
outerprod(outδ::ArrayReg{D}, in::ArrayReg{D}) where D =
    outerprod(statevec(outδ), conj(statevec(in)))
outerprod(outδ::BatchedArrayReg{D}, in::BatchedArrayReg{D}) where {D} =
    outerprod(statevec(outδ), conj(statevec(in)))


"""
    projection(y::AbstractMatrix, op::AbstractMatrix) -> typeof(y)

Project `op` to sparse matrix with same sparsity as `y`.
"""
function projection(y::AbstractMatrix, op::AbstractMatrix)
    size(y) == size(op) || throw(
        DimensionMismatch(
            "can not project a matrix of size $(size(op)) to target size $(size(y))",
        ),
    )
    out = _zero(y)
    unsafe_projection!(out, op)
end
_zero(y) = y
_zero(y::SparseMatrixCSC) = SparseMatrixCSC(y.m, y.n, y.colptr, y.rowval, zero(y.nzval))

unsafe_projection!(y::Diagonal, m::AbstractMatrix) = (y.diag .= diag(m); y)
unsafe_projection!(y::Diagonal, op::OuterProduct) = (y.diag .+= op.left .* op.right; y)

unsafe_projection!(y::Matrix, adjy, v) = y .+= adjy .* v

@inline function unsafe_projection!(y::AbstractSparseMatrix, m::AbstractMatrix)
    for (k, (i, j, _)) in enumerate(IterNz(y))
        @inbounds y.nzval[k] += m[i, j]
    end
    y
end

@inline function unsafe_projection!(y::PermMatrix, m::AbstractMatrix)
    for i = 1:size(y, 1)
        @inbounds y.vals[i] = m[i, y.perm[i]]
    end
    y
end

projection(x::RT, adjx::Complex) where {RT<:Real} = RT(real(adjx))
projection(x::T, y::T) where {T} = y
projection(x::T1, y::T2) where {T1,T2} = convert(T1, y)

export Scale, factor

"""
    Scale{S <: Union{Number, Val}, D, BT <: AbstractBlock{D}} <: TagBlock{BT, D}
    Scale(factor, block)

Multiply a block with a scalar factor, which can be a number or a `Val`.
If the factor is a number, it is regarded as a parameter that can be changed dynamically.
If the factor is a `Val`, it is regarded as a constant.

### Examples

```jldoctest; setup=:(using YaoBlocks)
julia> 2 * X
[scale: 2] X

julia> im * Z
[+im] Z

julia> -im * Z
[-im] Z

julia> -Z
[-] Z
```
"""
mutable struct Scale{S<:Union{Number,Val},D,BT<:AbstractBlock{D}} <: TagBlock{BT,D}
    alpha::S
    content::BT
end

content(x::Scale) = x.content
factor(x::Scale{<:Number}) = x.alpha
factor(x::Scale{Val{X}}) where {X} = X

# parameter interface
getiparams(s::Scale{<:Number}) = (factor(s),)
setiparams(s::Scale{<:Number}, alpha::Number) = Scale(alpha, s.content)
setiparams!(s::Scale{T1}, alpha::T2) where {T1<:Number, T2<:Number} = (s.alpha = T1(alpha); s)

Base.copy(x::Scale) = Scale(x.alpha, copy(x.content))
Base.adjoint(x::Scale{<:Number}) = Scale(adjoint(x.alpha), adjoint(content(x)))
Base.adjoint(x::Scale{Val{X}}) where {X} = Scale(Val(adjoint(X)), adjoint(content(x)))

LinearAlgebra.ishermitian(s::Scale) =
    (ishermitian(s |> content) && ishermitian(s |> factor)) || ishermitian(mat(s))
YaoAPI.isunitary(s::Scale) =
    (isunitary(s |> content) && isunitary(s |> factor)) || isunitary(mat(s))
YaoAPI.isreflexive(s::Scale) =
    (isreflexive(s |> content) && isreflexive(s |> factor)) || isreflexive(mat(s))
YaoAPI.iscommute(x::Scale, y::Scale) = iscommute(x |> content, y |> content)
YaoAPI.iscommute(x::AbstractBlock, y::Scale) = iscommute(x, y |> content)
YaoAPI.iscommute(x::Scale, y::AbstractBlock) = iscommute(x |> content, y)

Base.:(==)(x::Scale, y::Scale) = (factor(x) == factor(y)) && (content(x) == content(y))

chsubblocks(x::Scale, blk::AbstractBlock) = Scale(x.alpha, blk)
cache_key(x::Scale) = (factor(x), cache_key(content(x)))

mat(::Type{T}, x::Scale) where {T} = T(x.alpha) * mat(T, content(x))
mat(::Type{T}, x::Scale{Val{S}}) where {T,S} = T(S) * mat(T, content(x))

function YaoAPI.unsafe_apply!(r::AbstractArrayReg, x::Scale{S}) where {S}
    YaoAPI.unsafe_apply!(r, content(x))
    regscale!(r, factor(x))
    return r
end
function YaoAPI.unsafe_apply!(r::DensityMatrix, x::Scale{S}) where {S}
    YaoAPI.unsafe_apply!(r, content(x))
    regscale!(r, abs2(factor(x)))
    return r
end

function unsafe_getindex(::Type{T}, x::Scale, i::Integer, j::Integer) where T
    return unsafe_getindex(T, content(x), i, j) * factor(x)
end

function unsafe_getcol(::Type{T}, x::Scale, j::DitStr) where T
    locs, vals = unsafe_getcol(T, content(x), j)
    return locs, rmul!(vals, factor(x))
end

abstract type AbstractErrorType end

"""
    CoherentError{BT<:AbstractBlock} <: AbstractErrorType
    CoherentError(block::BT)

Coherent unitary error channel with error gate `block`.

# Fields
- `block::BT`: the error gate
"""
struct CoherentError{BT<:AbstractBlock} <: AbstractErrorType
    block::BT
    function CoherentError(block::BT) where BT<:AbstractBlock
        isunitary(block) || throw(ArgumentError("block must be unitary, got $(block)"))
        new{BT}(block)
    end
end
quantum_channel(err::CoherentError) = MixedUnitaryChannel(err)
MixedUnitaryChannel(err::CoherentError) = MixedUnitaryChannel([err.block], [1.0])

"""
    BitFlipError(p)

Bit flip error channel with error probability `p`.
It is equivalent to the [`PauliError`](@ref) channel with `px = py = 0` and `pz = p`.

# Fields
- `p::RT`: the error probability, must be non-negative and less than or equal to 1
"""
struct BitFlipError{RT<:Real} <: AbstractErrorType
    p::RT
    function BitFlipError(p::RT) where RT<:Real
        0 ≤ p ≤ 1 || throw(ArgumentError("p must be in [0, 1], got $p"))
        new{RT}(p)
    end
end
MixedUnitaryChannel(p::BitFlipError) = MixedUnitaryChannel([I2, X], [1-p.p, p.p])

"""
    PhaseFlipError(p)

Phase flip error channel with error probability `p`.
It is equivalent to the [`PauliError`](@ref) channel with `px = py = p` and `pz = 0`.

# Fields
- `p::RT`: the error probability, must be non-negative and less than or equal to 1
"""
struct PhaseFlipError{RT<:Real} <: AbstractErrorType
    p::RT
    function PhaseFlipError(p::RT) where RT<:Real
        0 ≤ p ≤ 1 || throw(ArgumentError("p must be in [0, 1], got $p"))
        new{RT}(p)
    end
end
MixedUnitaryChannel(p::PhaseFlipError) = MixedUnitaryChannel([I2, Z], [1-p.p, p.p])

"""
    DepolarizingError(p)

Depolarizing error channel with error probability `p` for `n` qubits. It is defined as:
```math
E(ρ) = (1 - p) ρ + p \\tr(ρ) \\frac{I}{2^n}
```
where `P_i` is the projector onto the `i`-th computational basis state.

For single-qubit depolarizing error, it is equivalent to the [`PauliError`](@ref) channel with `px = py = pz = p/4`.

# Fields
- `n::Int`: the number of qubits
- `p::RT`: the error probability, must be non-negative and less than or equal to ``4^n/(4^n-1)``    
"""
struct DepolarizingError{RT<:Real} <: AbstractErrorType
    n::Int
    p::RT
    function DepolarizingError(n::Int, p::RT) where RT<:Real
        n ≥ 1 || throw(ArgumentError("n must be at least 1, got $n"))
        0 ≤ p ≤ 4^n/(4^n-1) || throw(ArgumentError("p must be in [0, 4^n/(4^n-1)] (n = $n), got $p"))
        new{RT}(n, p)
    end
end
MixedUnitaryChannel(p::DepolarizingError) = MixedUnitaryChannel(PauliError(p))
quantum_channel(p::DepolarizingError) = DepolarizingChannel(p.n, p.p)

"""
    PauliError(px, py, pz)

Pauli error channel with error probabilities `px`, `py`, and `pz`.
When applied to a density matrix `ρ`, the error channel is given by:
```math
(1 - (p_x + p_y + p_z))⋅ρ + p_x⋅X⋅ρ⋅X + p_y⋅Y⋅ρ⋅Y  + p_z⋅Z⋅ρ⋅Z
```

# Fields
- `px::RT`: the error probability of Pauli X, must be non-negative
- `py::RT`: the error probability of Pauli Y, must be non-negative
- `pz::RT`: the error probability of Pauli Z, must be non-negative
"""
struct PauliError{RT<:Real} <: AbstractErrorType
    px::RT
    py::RT
    pz::RT
    function PauliError(px::RT, py::RT, pz::RT) where RT<:Real
        px ≥ 0 || throw(ArgumentError("px must be non-negative, got $px"))
        py ≥ 0 || throw(ArgumentError("py must be non-negative, got $py"))
        pz ≥ 0 || throw(ArgumentError("pz must be non-negative, got $pz"))
        px + py + pz ≤ 1 || throw(ArgumentError("sum of error probability is larger than 1, got $px + $py + $pz"))
        new{RT}(px, py, pz)
    end
end
# convert error types to pauli error
PauliError(err::BitFlipError{T}) where T = PauliError(err.p, zero(T), zero(T))
PauliError(err::PhaseFlipError{T}) where T = PauliError(zero(T), zero(T), err.p)
function PauliError(err::DepolarizingError{T}) where T
    @assert err.n == 1 "only single-qubit depolarizing error is supported to convert to Pauli error"
    p = err.p/4
    return PauliError(p, p, p)
end

MixedUnitaryChannel(p::PauliError) = MixedUnitaryChannel([I2, X, Y, Z], [1-p.px-p.py-p.pz, p.px, p.py, p.pz])

for T in [:BitFlipError, :PhaseFlipError, :DepolarizingError, :PauliError]
    @eval KrausChannel(err::$T) = KrausChannel(MixedUnitaryChannel(err))
end
for T in [:BitFlipError, :PhaseFlipError, :PauliError]
    @eval quantum_channel(p::$T) = MixedUnitaryChannel(p)
end

"""
    ResetError(p0, p1)

Reset error channel with error probabilities `p0` and `p1` for resetting to 0 and 1 respectively.
When applied to a density matrix `ρ`, the error channel is given by:
```math
(1 - p_0 - p_1)⋅ρ + p_0⋅(P_0⋅ρ⋅P_0 + P_d⋅ρ⋅P_d') + p_1⋅(P_1⋅ρ⋅P_1 + P_u⋅ρ⋅P_u')
```
where `P_0` and `P_1` are the projectors onto the 0 and 1 eigenstates of the Pauli Z operator, and `P_u` and `P_d` are the projectors onto the up and down eigenstates of the Pauli X operator.

This channel is modelled by the following Kraus matrices:
```math
\\begin{align}
K_0 = \\sqrt{1 - p_0 - p_1} I\\\\
K_1 = \\sqrt{p_0} P_0\\\\
K_2 = \\sqrt{p_0} P_d\\\\
K_3 = \\sqrt{p_1} P_1\\\\
K_4 = \\sqrt{p_1} P_u
\\end{align}
```
where ``p_0 \\in [0,1]`` is the probability of a reset to 0, and ``p_1 \\in [0,1]`` is the probability of a reset to 1 error.

### Note
The Kraus operators are not unique, and the above is not the simplest form.
"""
struct ResetError{RT<:Real} <: AbstractErrorType
    p0::RT
    p1::RT
    function ResetError(p0::RT, p1::RT2) where {RT<:Real, RT2<:Real}
        T = promote_type(RT, RT2)
        p0 ≥ 0 || throw(ArgumentError("p0 must be non-negative, got $p0"))
        p1 ≥ 0 || throw(ArgumentError("p1 must be non-negative, got $p1"))
        p0 + p1 ≤ 1 || throw(ArgumentError("sum of error probability is larger than 1, got $p0 + $p1"))
        new{T}(T(p0), T(p1))
    end
end
quantum_channel(p::ResetError) = KrausChannel(p)

# https://docs.pennylane.ai/en/stable/code/api/pennylane.ResetError.html
function KrausChannel(err::ResetError)
    p0, p1 = err.p0, err.p1
    p0 + p1 ≤ 1 || throw(ArgumentError("sum of error probability is larger than 1"))
    operators = AbstractBlock{2}[sqrt(1 - p0 - p1) * I2]
    if !iszero(p0)
        push!(operators, sqrt(p0) * ConstGate.P0)
        push!(operators, sqrt(p0) * ConstGate.Pd)
    end
    if !iszero(p1)
        push!(operators, sqrt(p1) * ConstGate.P1)
        push!(operators, sqrt(p1) * ConstGate.Pu)
    end
    return KrausChannel(operators)
end

"""
    ThermalRelaxationError{RT<:Real} <: AbstractErrorType
    ThermalRelaxationError(T1, T2, time, excited_state_population=zero(RT))

Thermal relaxation error channel with error probabilities `T1`, `T2`, `time`, and `excited_state_population`.
It can be viewed as a special case of [`PhaseAmplitudeDampingError`](@ref) with:
```math
\\begin{align}
a = 1 - \\exp\\left(-\\frac{t}{T_1}\\right)\\\\
b = 1 - \\exp\\left(-\\frac{t}{T_{\\phi}}\\right)\\\\
\\end{align}
```
where ``T_{\\phi} = \\frac{T_1 T_2}{2 T_1 - T_2}``.

# Fields
- `T1::RT`: the T1 time (energy relaxation time), must be positive
- `T2::RT`: the T2 time (dephasing time), must be positive and satisfy `T2 ≤ 2T1`.
  - If `T2 ≤ T1` the error can be expressed as a mixed reset and unitary error channel.
  - If `T1 < T2 ≤ 2T1` the error must be expressed as a general non-unitary Kraus error channel.
- `time::RT`: the duration of the error, must be non-negative
- `excited_state_population::RT`: the probability of state |1⟩ at thermal equilibrium
"""
struct ThermalRelaxationError{RT<:Real} <: AbstractErrorType
    T1::RT
    T2::RT
    time::RT
    excited_state_population::RT
    function ThermalRelaxationError(T1::RT, T2::RT, time::RT2, excited_state_population::RT3=zero(RT)) where {RT<:Real, RT2<:Real, RT3<:Real}
        T = promote_type(RT, RT2, RT3)
        T1 > 0 || throw(ArgumentError("T1 must be positive, got $T1"))
        T2 > 0 || throw(ArgumentError("T2 must be positive, got $T2"))
        T2 ≤ 2T1 || throw(ArgumentError("T2 must be less than or equal to 2T1, got $T2"))
        time ≥ 0 || throw(ArgumentError("time must be non-negative, got $time"))
        0 ≤ excited_state_population ≤ 1 || throw(ArgumentError("excited_state_population must be in [0, 1], got $excited_state_population"))
        new{T}(T(T1), T(T2), T(time), T(excited_state_population))
    end
end
quantum_channel(err::ThermalRelaxationError) = KrausChannel(err)

# Ref: https://quantumcomputing.stackexchange.com/questions/27017/what-is-the-concrete-difference-between-qiskit-thermal-relaxation-error-and-phas
function KrausChannel(err::ThermalRelaxationError)
    T1, T2, time = err.T1, err.T2, err.time
    Tϕ = (T1*T2)/(2 * T1 - T2)
    amplitude = 1 - exp(-time/T1)
    phase = 1 - exp(-time/Tϕ)
    KrausChannel(PhaseAmplitudeDampingError(amplitude, phase, err.excited_state_population))
end

"""
    PhaseAmplitudeDampingError{RT<:Real} <: AbstractErrorType
    PhaseAmplitudeDampingError(amplitude::RT, phase::RT, excited_state_population::RT2=zero(RT)) where {RT<:Real, RT2<:Real}

Phase amplitude and phase damping error channel, described by the following Kraus matrices:

```math
A_0 = √(1 - p_1) * \\begin{bmatrix} 1 & 0 \\\\ 0 & √(1 - a - b) \\end{bmatrix}
A_1 = √(1 - p_1) * \\begin{bmatrix} 0 & √a \\\\ 0 & 0 \\end{bmatrix}
A_2 = √(1 - p_1) * \\begin{bmatrix} 0 & 0 \\\\ 0 & √b \\end{bmatrix}
B_0 = √p_1 * \\begin{bmatrix} √(1 - a - b) & 0 \\\\ 0 & 1 \\end{bmatrix}
B_1 = √p_1 * \\begin{bmatrix} 0 & 0 \\\\ √a & 0 \\end{bmatrix}
B_2 = √p_1 * \\begin{bmatrix} √b & 0 \\\\ 0 & 0 \\end{bmatrix}
```

where ``a`` = `amplitude`, ``b`` = `phase` and ``p_1`` = `excited_state_population`. The equilibrium state is given by:
```math
ρ_0 = \\begin{bmatrix} 1-p_1 & 0 \\\\ 0 & p_1 \\end{bmatrix}
```

# Fields
- `amplitude::RT`: the amplitude damping error parameter, must be non-negative
- `phase::RT`: the phase damping error parameter, must be non-negative and satisfy `phase + amplitude ≤ 1`
- `excited_state_population::RT`: the probability of state |1⟩ at thermal equilibrium, must be in [0, 1]
"""
struct PhaseAmplitudeDampingError{RT<:Real} <: AbstractErrorType
    amplitude::RT
    phase::RT
    excited_state_population::RT
    function PhaseAmplitudeDampingError(amplitude::RT, phase::RT, excited_state_population::RT2=zero(RT)) where {RT<:Real, RT2<:Real}
        T = promote_type(RT, RT2)
        0 ≤ amplitude ≤ 1 || throw(ArgumentError("amplitude must be in [0, 1], got $amplitude"))
        0 ≤ phase ≤ 1 || throw(ArgumentError("phase must be in [0, 1], got $phase"))
        phase + amplitude ≤ 1 || throw(ArgumentError("phase + amplitude must be less than or equal to 1, got $phase + $amplitude"))
        0 ≤ excited_state_population ≤ 1 || throw(ArgumentError("excited_state_population must be in [0, 1], got $excited_state_population"))
        new{T}(T(amplitude), T(phase), T(excited_state_population))
    end
end

quantum_channel(err::PhaseAmplitudeDampingError) = KrausChannel(err)
function KrausChannel(err::PhaseAmplitudeDampingError{T}) where T
    CT = Complex{T}
    a, b, p1 = err.amplitude, err.phase, err.excited_state_population
    blocks = AbstractBlock{2}[]
    if !(p1 ≈ 1)
        # dampling operators to 0 state
        push!(blocks, matblock(sqrt(1 - p1) * CT[1 0; 0 sqrt(1 - a - b)]; tag = "A0"))
        if !iszero(a)
            push!(blocks, matblock(sqrt(1 - p1) * CT[0 sqrt(a); 0 0]; tag = "A1"))
        end
        if !iszero(b)
            push!(blocks, matblock(sqrt(1 - p1) * CT[0 0; 0 sqrt(b)]; tag = "A2"))
        end
    end
    if !(p1 ≈ 0)
        # dampling operators to 1 state
        push!(blocks, matblock(sqrt(p1) * CT[sqrt(1 - a - b) 0; 0 1]; tag = "B0"))
        if !iszero(a)
            push!(blocks, matblock(sqrt(p1) * CT[0 0; sqrt(a) 0]; tag = "B1"))
        end
        if !iszero(b)
            push!(blocks, matblock(sqrt(p1) * CT[sqrt(b) 0; 0 0]; tag = "B2"))
        end
    end
    return KrausChannel(blocks)
end

"""
    PhaseDampingError{RT<:Real} <: AbstractErrorType
    PhaseDampingError(phase::RT) where RT<:Real

Phase damping error channel, described by the following Kraus matrices:

```math
A_0 = \\begin{bmatrix} 1 & 0 \\\\ 0 & √(1 - b) \\end{bmatrix}
A_2 = \\begin{bmatrix} 0 & 0 \\\\ 0 & √b \\end{bmatrix}
```

where ``b`` = `phase`.
The equilibrium state is given by:
```math
ρ_0 = \\begin{bmatrix} ρ_{00} & 0 \\\\ 0 & ρ_{11} \\end{bmatrix}
```
where ``ρ_{00}`` and ``ρ_{11}`` are the diagonal elements of the input density matrix.

# Fields
- `phase::RT`: the phase damping error parameter, must be non-negative
"""
struct PhaseDampingError{RT<:Real} <: AbstractErrorType
    phase::RT
    function PhaseDampingError(phase::RT) where RT<:Real
        0 ≤ phase ≤ 1 || throw(ArgumentError("phase must be in [0, 1], got $phase"))
        new{RT}(phase)
    end
end
quantum_channel(err::PhaseDampingError) = KrausChannel(err)
KrausChannel(err::PhaseDampingError{T}) where T = KrausChannel(PhaseAmplitudeDampingError(zero(T), err.phase, zero(T)))

"""
    AmplitudeDampingError{RT<:Real} <: AbstractErrorType
    AmplitudeDampingError(amplitude::RT, excited_state_population::RT2=zero(RT)) where {RT<:Real, RT2<:Real}

Amplitude damping error channel, described by the following Kraus matrices:

```math
A_0 = √(1 - p_1) * \\begin{bmatrix} 1 & 0 \\\\ 0 & √(1 - a) \\end{bmatrix}
A_1 = √(1 - p_1) * \\begin{bmatrix} 0 & √a \\\\ 0 & 0 \\end{bmatrix}
B_0 = √p_1 * \\begin{bmatrix} √(1 - a) & 0 \\\\ 0 & 1 \\end{bmatrix}
B_1 = √p_1 * \\begin{bmatrix} 0 & 0 \\\\ √a & 0 \\end{bmatrix}
```

where ``a`` = `amplitude` and ``p_1`` = `excited_state_population`. The equilibrium state is given by:
```math
ρ_0 = \\begin{bmatrix} 1-p_1 & 0 \\\\ 0 & p_1 \\end{bmatrix}
```

# Fields
- `amplitude::RT`: the amplitude damping error parameter, must be non-negative
- `excited_state_population::RT`: the probability of state |1⟩ at thermal equilibrium, must be non-negative and less than or equal to 1
"""
struct AmplitudeDampingError{RT<:Real} <: AbstractErrorType
    amplitude::RT
    excited_state_population::RT
    function AmplitudeDampingError(amplitude::RT, excited_state_population::RT2=zero(RT)) where {RT<:Real, RT2<:Real}
        T = promote_type(RT, RT2)
        0 ≤ amplitude ≤ 1 || throw(ArgumentError("amplitude must be in [0, 1], got $amplitude"))
        0 ≤ excited_state_population ≤ 1 || throw(ArgumentError("excited_state_population must be in [0, 1], got $excited_state_population"))
        new{T}(T(amplitude), T(excited_state_population))
    end
end
quantum_channel(err::AmplitudeDampingError) = KrausChannel(err)
KrausChannel(err::AmplitudeDampingError{T}) where T = KrausChannel(PhaseAmplitudeDampingError(err.amplitude, zero(T), err.excited_state_population))

# convert error types to superop
SuperOp(::Type{T}, x::AbstractErrorType) where T = SuperOp(T, quantum_channel(x))
SuperOp(x::AbstractErrorType) = SuperOp(Complex{Float64}, x)

for F in [:expect, :fidelity, :fidelity2, :operator_fidelity]
    @eval Base.adjoint(::typeof($F)) = Adjoint($F)
    @eval Base.show(io::IO, ::Adjoint{Any,typeof($F)}) = print(io, "$($F)'")
    @eval Base.show(io::IO, ::MIME"text/plain", ::Adjoint{Any,typeof($F)}) =
        print(io, "$($F)'")
end

function (::Adjoint{Any,typeof(expect)})(op::AbstractBlock, reg_or_circuit)
    expect_g(op, reg_or_circuit)
end

function expect_g(op::AbstractBlock, circuit::Pair{<:AbstractArrayReg,<:AbstractBlock})
    reg, c = circuit
    out = copy(reg) |> c
    outδ = 2copy(out) |> op
    (in, inδ), paramsδ = apply_back((out, outδ), c)
    return inδ => paramsδ
end

function expect_g(op::AbstractBlock, reg::AbstractArrayReg)
    2copy(reg) |> op
end

_eval(p::Pair{<:AbstractRegister,<:AbstractBlock}) = copy(p.first) |> p.second
_eval(reg::AbstractRegister) = reg
YaoAPI.fidelity(p1, p2) = fidelity(_eval(p1), _eval(p2))
YaoAPI.fidelity2(p1, p2) = fidelity2(_eval(p1), _eval(p2))

function (::Adjoint{Any,typeof(fidelity)})(
    reg1::Union{AbstractArrayReg,Pair{<:AbstractArrayReg,<:AbstractBlock}},
    reg2::Union{AbstractArrayReg,Pair{<:AbstractArrayReg,<:AbstractBlock}},
)
    fidelity_g(reg1, reg2)
end

function (::Adjoint{Any,typeof(fidelity2)})(
    reg1::Union{AbstractArrayReg,Pair{<:AbstractArrayReg,<:AbstractBlock}},
    reg2::Union{AbstractArrayReg,Pair{<:AbstractArrayReg,<:AbstractBlock}},
)
    fidelity2_g(reg1, reg2)
end

function fidelity_g(
    reg1::Union{AbstractArrayReg,Pair{<:AbstractArrayReg,<:AbstractBlock}},
    reg2::Union{AbstractArrayReg,Pair{<:AbstractArrayReg,<:AbstractBlock}},
)
    if reg1 isa Pair
        in1, c1 = reg1
        out1 = copy(in1) |> c1
    else
        out1 = reg1
    end

    if reg2 isa Pair
        in2, c2 = reg2
        out2 = copy(in2) |> c2
    else
        out2 = reg2
    end
    if nremain(out1) != 0
        throw(
            ArgumentError(
                "The gradient of registers with environment is not implemented yet.
However, back propagating over a focused register is possible,
please file an issue if you really need this feature.",
            ),
        )
    end
    overlap = out1' * out2

    out1δ = copy(out2)
    regscale!.(viewbatch.(Ref(out1δ), 1:length(overlap)), conj.(overlap) ./ abs.(overlap))
    out2δ = copy(out1)
    regscale!.(viewbatch.(Ref(out2δ), 1:length(overlap)), overlap ./ abs.(overlap))

    if reg1 isa Pair
        (_, in1δ), params1δ = apply_back((out1, out1δ), c1)
        res1 = in1δ => params1δ
    else
        res1 = out1δ
    end

    if reg2 isa Pair
        (_, in2δ), params2δ = apply_back((out2, out2δ), c2)
        res2 = in2δ => params2δ
    else
        res2 = out2δ
    end

    return res1, res2
end

function fidelity2_g(
    reg1::Union{AbstractArrayReg,Pair{<:AbstractArrayReg,<:AbstractBlock}},
    reg2::Union{AbstractArrayReg,Pair{<:AbstractArrayReg,<:AbstractBlock}},
)
    if reg1 isa Pair
        in1, c1 = reg1
        out1 = copy(in1) |> c1
    else
        out1 = reg1
    end

    if reg2 isa Pair
        in2, c2 = reg2
        out2 = copy(in2) |> c2
    else
        out2 = reg2
    end
    if nremain(out1) != 0
        throw(
            ArgumentError(
                "The gradient of registers with environment is not implemented yet.
However, back propagating over a focused register is possible,
please file an issue if you really need this feature.",
            ),
        )
    end
    overlap = out1' * out2

    out1δ = copy(out2)
    regscale!.(viewbatch.(Ref(out1δ), 1:length(overlap)), 2.0.*conj.(overlap))
    out2δ = copy(out1)
    regscale!.(viewbatch.(Ref(out2δ), 1:length(overlap)), 2.0.*overlap)

    if reg1 isa Pair
        (_, in1δ), params1δ = apply_back((out1, out1δ), c1)
        res1 = in1δ => params1δ
    else
        res1 = out1δ
    end

    if reg2 isa Pair
        (_, in2δ), params2δ = apply_back((out2, out2δ), c2)
        res2 = in2δ => params2δ
    else
        res2 = out2δ
    end

    return res1, res2
end

function (::Adjoint{Any,typeof(operator_fidelity)})(b1::AbstractBlock, b2::AbstractBlock)
    operator_fidelity_g(b1, b2)
end

function operator_fidelity_g(b1::AbstractBlock, b2::AbstractBlock)
    U1 = mat(b1)
    U2 = mat(b2)
    s = sum(conj(U1) .* U2)
    adjs = conj(s) / abs(s) / size(U1, 1)
    adjm1 = U2 * adjs
    adjm2 = U1 * conj(adjs)
    mat_back(b1, adjm1), mat_back(b2, adjm2)
end

export OnLevels

"""
    OnLevels{D, Ds, T <: AbstractBlock{Ds}} <: TagBlock{T, D}

Define a gate that is applied to a subset of levels.

### Fields
- `gate`: the gate to be applied.
- `levels`: the levels to apply the gate to.
"""
struct OnLevels{D, Ds, T <: AbstractBlock{Ds}} <: TagBlock{T, D}
    gate::T
    levels::NTuple{Ds, Int}
    function OnLevels{D}(gate::T, levels::NTuple{Ds, Int}) where {D, Ds, T <: AbstractBlock{Ds}}
        @assert nqudits(gate) == 1 "only single qubit gate is supported"
        new{D, Ds, T}(gate, levels)
    end
end
content(g::OnLevels) = g.gate
function mat(::Type{T}, g::OnLevels{D, Ds}) where {T, D, Ds}
    m = mat(T, g.gate)
    iter = IterNz(m)
    nnz = length(iter)
    is, js, vs = Vector{Int}(undef, nnz), Vector{Int}(undef, nnz), Vector{T}(undef, nnz)
    for (k, (i, j, v)) in enumerate(iter)
        is[k] = g.levels[i]
        js[k] = g.levels[j]
        vs[k] = v
    end
    return sparse(is, js, vs, D, D)
end
PropertyTrait(::OnLevels) = PreserveAll()
Base.adjoint(x::OnLevels{D}) where D = OnLevels{D}(adjoint(x.gate), x.levels)
Base.copy(x::OnLevels{D}) where D = OnLevels{D}(copy(x.gate), x.levels)

export map_address, AddressInfo

struct AddressInfo
    nbits::Int
    addresses::Vector{Int}
end
AddressInfo(nbits::Int, ::AllLocs) = AddressInfo(nbits, collect(1:nbits))
AddressInfo(nbits::Int, iter) = AddressInfo(nbits, collect(iter))
Base.copy(info::AddressInfo) = AddressInfo(copy(info.addresses))
Base.:/(locs, info::AddressInfo) = map(loc -> info.addresses[loc], locs)
Base.:/(locs::AllLocs, info::AddressInfo) = info.addresses

"""
    map_address(block::AbstractBlock, info::AddressInfo) -> AbstractBlock

map the locations in `block` to target locations.

# Example

`map_address` can be used to embed a sub-circuit to a larger one.

```jldoctest; setup=:(using YaoBlocks)
julia> c = chain(5, repeat(H, 1:5), put(2=>X), kron(1=>X, 3=>Y))
nqubits: 5
chain
├─ repeat on (1, 2, 3, 4, 5)
│  └─ H
├─ put on (2)
│  └─ X
└─ kron
   ├─ 1=>X
   └─ 3=>Y


julia> map_address(c, AddressInfo(10, [6,7,8,9,10]))
nqubits: 10
chain
├─ repeat on (6, 7, 8, 9, 10)
│  └─ H
├─ put on (7)
│  └─ X
└─ kron
   ├─ 6=>X
   └─ 8=>Y
```
"""
function map_address end

function map_address(block::AbstractBlock, info::AddressInfo)
    throw(NotImplementedError(:map_address, typeof(block)))
end

function map_address(blk::Measure{D}, info::AddressInfo) where D
    m = Measure{D}(info.nbits,
        blk.rng,
        blk.operator,
        (blk.locations / info...,),
        blk.postprocess,
        blk.error_prob,
    )
    if isdefined(blk, :results)
        m.results = blk.results
    end
    return m
end

function map_address(blk::PrimitiveBlock, info::AddressInfo)
    @assert length(info.addresses) == nqudits(blk) "expected $(nqudits(blk)) addresses, got $(length(info.addresses))"
    if length(info.addresses) == info.nbits
        return blk
    else
        # raise the number of qubits
        return put(info.nbits, info.addresses => blk)
    end
end
map_address(blk::PutBlock, info::AddressInfo) =
    put(info.nbits, blk.locs / info => content(blk))

function map_address(blk::ControlBlock, info::AddressInfo)
    ControlBlock(info.nbits,
        blk.ctrl_locs / info,
        blk.ctrl_config,
        content(blk),
        blk.locs / info,
    )
end

function map_address(blk::KronBlock, info::AddressInfo)
    kron(info.nbits, [l => G for (l, G) in zip(blk.locs / info, blk.blocks)]...)
end

function map_address(blk::RepeatedBlock, info::AddressInfo)
    repeat(info.nbits, content(blk), blk.locs / info)
end

function map_address(blk::Subroutine, info::AddressInfo)
    subroutine(info.nbits, content(blk), blk.locs / info)
end

function map_address(blk::ChainBlock, info::AddressInfo)
    chain(info.nbits, map(b -> map_address(b, info), subblocks(blk)))
end

function map_address(blk::Daggered, info::AddressInfo)
    Daggered(map_address(content(blk), info))
end

function map_address(blk::CachedBlock, info::AddressInfo)
    CachedBlock(blk.server, map_address(content(blk), info), blk.level)
end

function map_address(blk::Scale, info::AddressInfo)
    Scale(blk.alpha, map_address(content(blk), info))
end

function map_address(blk::AbstractAdd, info::AddressInfo)
    chsubblocks(blk, map(b -> map_address(b, info), subblocks(blk)))
end

export @const_gate,
    ConstantGate,
    ConstGate,
    X,
    Y,
    Z,
    H,
    I2,
    SWAP,
    T,
    XGate,
    YGate,
    ZGate,
    HGate,
    I2Gate,
    SWAPGate,
    TGate

"""
    ConstGate

A module contains all constant gate definitions.
"""
module ConstGate
import ..YaoBlocks
using LuxurySparse, YaoAPI, BitBasis
using YaoArrayRegister: logdi
import MLStyle: @match
using SparseArrays, LinearAlgebra

export ConstantGate, PauliGate

"""
    ConstantGate{N, D} <: PrimitiveBlock{N, D}

Abstract type for constant gates. Constant gates are
quantum gates with constant value, e.g Pauli gates,
T gate, Hadmard gates, etc. Type parameter `N` is the number of qubits.
"""
abstract type ConstantGate{N,D} <: YaoBlocks.PrimitiveBlock{D} end

include("const_gate_tools.jl")
include("const_gate_gen.jl")

const PauliGate = Union{I2Gate,XGate,YGate,ZGate}

YaoBlocks.cache_key(x::ConstantGate) = 0x1
end

# import some frequently-used objects
import .ConstGate:
    XGate,
    YGate,
    ZGate,
    HGate,
    I2Gate,
    SWAPGate,
    TGate,
    X,
    Y,
    Z,
    H,
    I2,
    SWAP,
    T,
    @const_gate,
    ConstantGate,
    PauliGate

occupied_locs(::I2Gate) = ()
nqudits(::ConstantGate{N}) where N = N

function unsafe_getindex(::Type{T}, rg::XGate, i::Integer, j::Integer) where {T}
    i==j ? zero(T) : one(T)
end
function unsafe_getindex(::Type{T}, rg::YGate, i::Integer, j::Integer) where {T}
    if i==j
        zero(T)
    elseif i > j
        T(im)
    else
        T(-im)
    end
end
function unsafe_getindex(::Type{T}, rg::ZGate, i::Integer, j::Integer) where {T}
    if i==j
        if i==0
            one(T)
        else
            -one(T)
        end
    else
        zero(T)
    end
end
# NOTE: The above function has no speedup if I specialize `unsafe_getcol`

# NOTE: The following function fixes the problem of having too many entries when get a column.
function unsafe_getcol(::Type{T}, rg::ConstGate.P0Gate, j::DitStr{2}) where {T}
    if iszero(j)
        return [j], [one(T)]
    else
        return typeof(j)[], T[]
    end
end
function unsafe_getcol(::Type{T}, rg::ConstGate.P1Gate, j::DitStr{2}) where {T}
    if iszero(j)
        return typeof(j)[], T[]
    else
        return [j], [one(T)]
    end
end

export RepeatedBlock, repeat

"""
    RepeatedBlock{D,C,GT<:AbstractBlock} <: AbstractContainer{GT,D}

Repeat the same block on given locations.
"""
struct RepeatedBlock{D,C,GT<:AbstractBlock} <: AbstractContainer{GT,D}
    n::Int
    content::GT
    locs::NTuple{C,Int}
end

function RepeatedBlock(n::Int, block::AbstractBlock{D}, locs::NTuple{C,Int}) where {D,C}
    @assert_locs_safe n [i:i+nqudits(block)-1 for i in locs]
    nqudits(block) > 1 && throw(
        ArgumentError("RepeatedBlock does not support multi-qubit content for the moment."),
    )
    # sort the locations
    slocs = sort([locs...])
    return RepeatedBlock{D,C,typeof(block)}(n, block, (slocs...,))
end

function RepeatedBlock(n::Int, block::AbstractBlock{D}, locs::UnitRange{Int}) where {D}
    (0 < locs.start) && (locs.stop <= n) ||
        throw(LocationConflictError("locations conflict."))
    nqudits(block) > 1 && throw(
        ArgumentError("RepeatedBlock does not support multi-qubit content for the moment."),
    )
    return RepeatedBlock{D,length(locs),typeof(block)}(n, block, Tuple(locs))
end


function RepeatedBlock(n::Int, block::GT) where {D,GT<:AbstractBlock{D}}
    return RepeatedBlock{D,n,GT}(n::Int, block, Tuple(1:nqudits(block):n-nqudits(block)+1))
end
YaoAPI.nqudits(m::RepeatedBlock) = m.n

"""
    repeat(n, subblock::AbstractBlock[, locs]) -> RepeatedBlock{n}

Create a `n`-qudit [`RepeatedBlock`](@ref) block, which is conceptually a [`kron`] block with all gates being the same.
If `locs` is provided, repeat on `locs`, otherwise repeat on all locations.
Let ``G`` be a ``2\\times 2`` matrix, the matrix representation of `repeat(n, X)` is

```math
X^{\\otimes n}
```

The `RepeatedBlock` can be used to accelerate repeated applying certain gate types: `X`, `Y`, `Z`, `S`, `T`, `Sdag`, and `Tdag`.

### Examples

This will create a repeat block which puts 4 X gates on each location.

```jldoctest; setup=:(using Yao)
julia> repeat(4, X)
nqubits: 4
repeat on (1, 2, 3, 4)
└─ X
```

You can also specify the location

```jldoctest; setup=:(using Yao)
julia> repeat(4, X, (1, 2))
nqubits: 4
repeat on (1, 2)
└─ X
```

But repeat won't copy the gate, thus, if it is a gate with parameter, e.g a `phase(0.1)`, the parameter
will change simultaneously.

```jldoctest; setup=:(using Yao)
julia> g = repeat(4, phase(0.1))
nqubits: 4
repeat on (1, 2, 3, 4)
└─ phase(0.1)

julia> g.content
phase(0.1)

julia> g.content.theta = 0.2
0.2

julia> g
nqubits: 4
repeat on (1, 2, 3, 4)
└─ phase(0.2)
```

Repeat over certain gates will provide speed up.

```julia
julia> reg = rand_state(20);

julia> @time apply!(reg, repeat(20, X));
  0.002252 seconds (5 allocations: 656 bytes)

julia> @time apply!(reg, chain([put(20, i=>X) for i=1:20]));
  0.049362 seconds (82.48 k allocations: 4.694 MiB, 47.11% compilation time)
```
"""
Base.repeat(n::Int, x::AbstractBlock, locs::Int...) = repeat(n, x, locs)
Base.repeat(n::Int, x::AbstractBlock, locs::NTuple{C,Int}) where {C} =
    RepeatedBlock(n, x, locs)
Base.repeat(n::Int, x::AbstractBlock, locs) = repeat(n, x, (locs...,))
Base.repeat(n::Int, x::AbstractBlock, locs::UnitRange) = RepeatedBlock(n, x, locs)
Base.repeat(n::Int, x::AbstractBlock) = RepeatedBlock(n, x)
Base.repeat(x::AbstractBlock) = @λ(n -> repeat(n, x))

"""
    repeat(x::AbstractBlock, locs)

Lazy curried version of [`repeat`](@ref).
"""
Base.repeat(x::AbstractBlock, locs) = @λ(n -> repeat(n, x, locs...))

occupied_locs(rb::RepeatedBlock) =
    (vcat([[i .+ occupied_locs(rb.content) .- 1...] for i in rb.locs]...)...,)
chsubblocks(x::RepeatedBlock{D}, blk::AbstractBlock{D}) where {D} =
    RepeatedBlock(x.n, blk, x.locs)
PropertyTrait(x::RepeatedBlock) = PreserveAll()

mat(::Type{T}, rb::RepeatedBlock{D}) where {T,D} =
    YaoArrayRegister.hilbertkron(rb.n, fill(mat(T, rb.content), length(rb.locs)), [rb.locs...]; nlevel=D)
mat(::Type{T}, rb::RepeatedBlock{D,0,GT}) where {T,D,GT} = IMatrix{T}(D^nqudits(rb))

function YaoAPI.unsafe_apply!(r::AbstractRegister, rp::RepeatedBlock)
    for addr in rp.locs
        YaoAPI.unsafe_apply!(r, put(nqudits(rp), addr:addr+nqudits(rp.content)-1=>rp.content))
    end
    return r
end

# specialization
for G in [:X, :Y, :Z, :S, :T, :Sdag, :Tdag]
    GT = Expr(:(.), :ConstGate, QuoteNode(Symbol(G, :Gate)))
    @eval function YaoAPI.unsafe_apply!(r::AbstractRegister, rp::RepeatedBlock{N,C,$GT}) where {N,C}
        instruct!(r, Val($(QuoteNode(G))), rp.locs)
        return r
    end
end

YaoAPI.unsafe_apply!(reg::AbstractRegister, rp::RepeatedBlock{D,0}) where D = reg

cache_key(rb::RepeatedBlock) = (rb.locs, cache_key(rb.content))

Base.adjoint(blk::RepeatedBlock{D}) where {D} =
    RepeatedBlock(nqudits(blk), adjoint(blk.content), blk.locs)
Base.copy(x::RepeatedBlock) = RepeatedBlock(nqudits(x), x.content, x.locs)
Base.:(==)(A::RepeatedBlock, B::RepeatedBlock) = A.locs == B.locs && A.content == B.content

function YaoAPI.iscommute(x::RepeatedBlock{D}, y::RepeatedBlock{D}) where {D}
    if nqudits(x) != nqudits(y)
        throw(QubitMismatchError("got nqudits = `$(nqudits(x))` and `$(nqudits(y))`"))
    end
    if x.locs == y.locs
        return iscommute(x.content, y.content)
    else
        iscommute_fallback(x, y)
    end
end

function unsafe_getindex(::Type{T}, rp::RepeatedBlock{D}, i::Integer, j::Integer) where {T,D}
    repeat_instruct_get_element(T, Val{D}(), nqudits(rp), rp.content, rp.locs, i, j)
end

function unsafe_getcol(::Type{T}, pb::RepeatedBlock{D,C}, j::DitStr{D}) where {T,D,C}
    n = nqudits(pb.content)
    kron_instruct_get_column(T, ntuple(i->pb.content, C), ntuple(i->(pb.locs[i]:pb.locs[i]+n-1), C), j)
end

using YaoArrayRegister, YaoBlocks, YaoBlocks.ConstGate, Random
using BenchmarkTools, PkgBenchmark

function bench(block)
    N = nqubits(block)
    r = rand_state(N)
    return @benchmarkable apply!($r, $block)
end

const SUITE = BenchmarkGroup()

SUITE["primitive"] = BenchmarkGroup()
SUITE["composite"] = BenchmarkGroup()

for G in [:X, :Y, :Z, :S, :T, :Sdag, :Tdag]
    GT = Expr(:(.), :ConstGate, QuoteNode(Symbol(G, :Gate)))
    GN = Expr(:(.), :ConstGate, QuoteNode(G))

    SUITE["primitive"][string(G)] = BenchmarkGroup()
    for n = 1:4:25
        SUITE["primitive"][string(G)][n] = @eval bench(repeat($n, $GN))
    end
end

for n = 5:5:25
    SUITE["composite"]["kron(rand_const)"] = bench(kron(rand([X, Y, Z, H]) for _ = 1:n))
    SUITE["composite"]["kron(sparse_const)"] =
        bench(kron(n, k => rand([X, Y, Z, H]) for k in randperm(n)[1:n÷5]))
    SUITE["composite"]["swap"] = bench(swap(n, 2, 4))
    SUITE["composite"]["swap"] = bench(pswap(n, 2, 4, 0.5))
end

function heisenberg(n::Int; periodic::Bool = true)
    Sx(i) = put(n, i => X)
    Sy(i) = put(n, i => Y)
    Sz(i) = put(n, i => Z)

    return sum(1:(periodic ? n : n - 1)) do i
        j = mod1(i, n)
        Sx(i) * Sx(j) + Sy(i) * Sy(j) + Sz(i) * Sz(j)
    end
end

for n = 5:5:25
    SUITE["primitive"]["TimeEvolution(heisenberg(n), 0.2)"] =
        bench(TimeEvolution(heisenberg(n), 0.2))
end

export postwalk, prewalk, blockfilter!, blockfilter, collect_blocks, gatecount

"""
    parse_block(n, ex)

This function parse the julia object `ex` to a quantum block,
it defines the syntax of high level interfaces. `ex` can be
a function takes number of qubits `n` as input or it can be
a pair.
"""
function parse_block end

parse_block(n::Int, x::Function) = x(n)

parse_block(n::Int, ex) =
    throw(Meta.ParseError("cannot parse expression $ex, expect a pair or quantum block"))

function parse_block(n::Int, x::AbstractBlock{D}) where {D}
    n == nqudits(x) || throw(ArgumentError("number of qubits does not match: $x"))
    return x
end

# if it is a single qubit pair, parse it to put block
parse_block(n::Int, x::Pair{Int,<:AbstractBlock}) = error("got $x, do you mean put($x)?")
# infer the number of qubits if the inner function was curried
parse_block(n::Int, x::Pair{Int,<:Function}) = error("got $x, do you mean put($x)?")

# error if it is not single qubit case
function parse_block(n::Int, x::Pair)
    error(
        "please specifiy the block type of $x, consider to use concentrate for large block in local scope.",
    )
end

"""
    prewalk(f, src::AbstractBlock)

Walk the tree and call `f` once the node is visited.
"""
function prewalk(f::Base.Callable, src::AbstractBlock)
    out = f(src)
    for each in subblocks(src)
        prewalk(f, each)
    end
    return out
end

"""
    postwalk(f, src::AbstractBlock)

Walk the tree and call `f` after the children are visited.
"""
function postwalk(f::Base.Callable, src::AbstractBlock)
    for each in subblocks(src)
        postwalk(f, each)
    end
    return f(src)
end

blockfilter!(f, v::Vector, blk::AbstractBlock) = postwalk(x -> f(x) ? push!(v, x) : v, blk)

blockfilter(f, blk) = blockfilter!(f, [], blk)

"""
    collect_blocks(block_type, root)

Return a [`ChainBlock`](@ref) with all block of `block_type` in root.
"""
collect_blocks(::Type{T}, x::AbstractBlock) where {T<:AbstractBlock} =
    blockfilter!(x -> x isa T, T[], x)

#expect(op::AbstractBlock, r::AbstractRegister) = r' * apply!(copy(r), op)

#expect(op::AbstractBlock, dm::DensityMatrix) = mapslices(x->sum(mat(op).*x)[], dm.state, dims=[1,2]) |> vec

"""
    expect(op::AbstractBlock, reg) -> Real
    expect(op::AbstractBlock, reg => circuit) -> Real
    expect(op::AbstractBlock, density_matrix) -> Real

Get the expectation value of an operator, the second parameter can be a register `reg` or a pair of input register and circuit `reg => circuit`.

expect'(op::AbstractBlock, reg=>circuit) -> Pair
expect'(op::AbstractBlock, reg) -> AbstracRegister

Obtain the gradient with respect to registers and circuit parameters.
For pair input, the second return value is a pair of `gψ=>gparams`,
with `gψ` the gradient of input state and `gparams` the gradients of circuit parameters.
For register input, the return value is a register.

!!! note

    For batched register, `expect(op, reg=>circuit)` returns a vector of size number of batch as output. However, one can not differentiate over a vector loss, so `expect'(op, reg=>circuit)` accumulates the gradient over batch, rather than returning a batched gradient of parameters.
"""
function expect(op::AbstractBlock, reg::AbstractRegister)
    # NOTE: broadcast because the input register can be a batched one
    return safe_real.(sandwich(reg, op, reg))
end
function expect(op, plan::Pair{<:AbstractRegister,<:AbstractBlock})
    expect(op, copy(plan.first) |> plan.second)
end

function expect(op::AbstractBlock, dm::DensityMatrix)
    # NOTE: we use matrix form here because the matrix size is known to be small,
    # while applying a circuit on a reduced density matrix might take much more than constructing the matrix.
    mop = mat(op)
    # TODO: switch to `IterNz`
    # sum(x->dm.state[x[2],x[1]]*x[3], IterNz(mop))
    return safe_real(sum(transpose(dm.state) .* mop))
end
function expect(op::AbstractAdd, reg::DensityMatrix)
    # NOTE: this is faster in e.g. when the op is Heisenberg
    invoke(expect, Tuple{AbstractBlock, DensityMatrix}, op, reg)
end
function expect(op::Scale, reg::DensityMatrix)
    factor(op) * expect(content(op), reg)
end

"""
    sandwich(bra::AbstractRegister, op::AbstractBlock, ket::AbstracRegister) -> Complex

Compute the sandwich function ⟨bra|op|ket⟩.
"""
sandwich(bra::AbstractArrayReg, op::AbstractBlock, reg::AbstractArrayReg) = bra' * apply!(copy(reg), op)

function sandwich(bra::BatchedArrayReg, op::AbstractBlock, reg::BatchedArrayReg)
    @assert nbatch(bra) == nbatch(reg)
    B = YaoArrayRegister._asint(nbatch(reg))
    ket = apply!(copy(reg), op)
    if !(bra.state isa Transpose)  # not-transposed storage
        C = reshape(ket.state, :, B)
        A = reshape(bra.state, :, B)
        # reduce over the 1st dimension
        conjsumprod1(A, C)
    elseif size(bra.state, 2) == B  # transposed storage, no environment qubits
        # reduce over the second dimension
        conjsumprod2(bra.state.parent, ket.state.parent)
    else
        C = reshape(ket.state.parent, :, B, size(bra.state, 1))
        A = reshape(bra.state.parent, :, B, size(bra.state, 1))
        # reduce over the 1st and 3rd dimension
        conjsumprod13(A, C)
    end
end

# TODO: make it GPU compatible!
# dropdims(sum(conj.(A) .* C, dims = 1), dims = 1)
function conjsumprod1(A::AbstractArray, C::AbstractArray)
    Na, B = size(A)
    res = zeros(eltype(C), B)
    @inbounds for b=1:B, i=1:Na
        res[b] += conj(A[i, b]) * C[i, b]
    end
    res
end

# dropdims(sum(conj.(A) .* C, dims = 2), dims = 2)
function conjsumprod2(A::AbstractArray, C::AbstractArray)
    B, Na = size(A)
    res = zeros(eltype(C), B)
    @inbounds for i=1:Na, b=1:B
        res[b] += conj(A[b, i]) * C[b, i]
    end
    res
end

# dropdims(sum(conj.(A) .* C, dims = (1, 3)), dims = (1, 3))
function conjsumprod13(A::AbstractArray, C::AbstractArray)
    Nr, B, Na = size(A)
    res = zeros(eltype(C), B)
    @inbounds for i=1:Na, b=1:B, r=1:size(C, 1)
        res[b] += conj(A[r, b, i]) * C[r, b, i]
    end
    res
end

for REG in [:AbstractArrayReg, :BatchedArrayReg]
    @eval function sandwich(bra::$REG, op::AbstractAdd, reg::$REG)
        sum(opi -> sandwich(bra, opi, reg), op)
    end
    @eval function sandwich(bra::$REG, op::Scale, reg::$REG)
        factor(op) * sandwich(bra, content(op), reg)
    end
end

# obtaining Dense Matrix of a block
LinearAlgebra.Matrix(blk::AbstractBlock) = Matrix(mat(blk))

"""
    operator_fidelity(b1::AbstractBlock, b2::AbstractBlock) -> Number

Operator fidelity defined as

```math
F^2 = \\frac{1}{d}\\left[{\\rm Tr}(b1^\\dagger b2)\\right]
```

Here, `d` is the size of the Hilbert space. Note this quantity is independant to global phase.
See arXiv: 0803.2940v2, Equation (2) for reference.
"""
function operator_fidelity(b1::AbstractBlock, b2::AbstractBlock)
    U1 = mat(b1)
    U2 = mat(b2)
    return abs(sum(conj(U1) .* U2)) / size(U1, 1)
end

gatecount(blk::AbstractBlock) = gatecount!(blk, Dict{Type{<:AbstractBlock},Int}())

for BT in [:ChainBlock, :KronBlock, :Add, :PutBlock, :CachedBlock]
    @eval gatecount!(c::$BT, storage::AbstractDict) = (gatecount!.(c |> subblocks, Ref(storage)); storage)
end

function gatecount!(c::RepeatedBlock, storage::AbstractDict)
    k = typeof(content(c))
    n = length(c.locs)
    if haskey(storage, k)
        storage[k] += n
    else
        storage[k] = n
    end
    storage
end

# NOTE: static scale defines a gate, dynamic scale is parameter.
function gatecount!(c::Scale{S}, storage::AbstractDict) where S
    if S <: Val
        k = typeof(c)
        storage[k] = get(storage, k, 0) + 1
    else
        gatecount!(c.content, storage)
    end
    return storage
end

# default: do not recurse
function gatecount!(c::AbstractBlock, storage::AbstractDict)
    k = typeof(c)
    storage[k] = get(storage, k, 0) + 1
    storage
end

export @const_gate

"""
    @const_gate <gate name> = <expr>
    @const_gate <gate name>::<type> = <expr>
    @const_gate <gate>::<type>

This macro simplify the definition of a constant gate. It will automatically bind the matrix form
to a constant which will reduce memory allocation in the runtime.

### Examples

```julia
@const_gate X = ComplexF64[0 1;1 0]
```

or

```julia
@const_gate X::ComplexF64 = [0 1;1 0]
```

You can bind new element types by simply re-declare with a type annotation.

```julia
@const_gate X::ComplexF32
```
"""
macro const_gate(ex, ex2=:(nlevel=2))
    @match ex2 begin
        :(nlevel = $nlevel) => begin
            if !(nlevel isa Integer)
                error("You should provide an integer as the value of `nlevel`! e.g. `nlevel=3`")
            end
            _const_gate(__module__, __source__, ex, nlevel)
        end
        _ => begin
            error("The second argument should be e.g. `nlevel=3`")
        end
    end
end

function _const_gate(__module__::Module, __source__::LineNumberNode, ex, nlevel)
    @match ex begin
        :($name::$t = $expr) => define_gate(__module__, __source__, name, t, expr, nlevel)
        :($name = $expr) => define_gate(__module__, __source__, name, expr, nlevel)
        :($name::$t) => define_typed_binding(__module__, __source__, name, t)
        _ => throw(Meta.ParseError("use @const_gate <gate name> = <expr> or
            @const_gate <gate name>::<type> = <expr> to define new gate, or
            use @const_gate <gate name>::<new type> to bind new type"))
    end
end

"""
    gatetype_name(name)

Returns the name of a constant gate by adding postfix `Gate`.
"""
gatetype_name(name) = Symbol(name, "Gate")

"""
    constant_name(name)

Return the name of a constant binding of the matrix for a constant gate.
"""
constant_name(name) = gensym(Symbol("Const", "_", name))

"""
    define_gate(__module__::Module, __source__::LineNumberNode, name, type, expr)

Return the expression to define a constant gate with given type (value of `expr`
will be converted to given `type`).
"""
function define_gate(__module__::Module, __source__::LineNumberNode, name, type, expr, nlevel)
    const_binding = constant_name(name)
    gt_name = gatetype_name(name)

    return quote
        $(define_binding(__module__, const_binding, type, expr))
        $(define_struct(__module__, __source__, const_binding, name, nlevel))
        $(define_methods(__module__, const_binding, name))
        $(define_properties(__module__, const_binding, name))
    end
end

"""
    define_gate(__module__::Module, __source__::LineNumberNode, name, expr, nlevel)

Return the expression to define a constant gate, use the inferred type.
"""
function define_gate(__module__::Module, __source__::LineNumberNode, name, expr, nlevel)
    const_binding = constant_name(name)
    gt_name = gatetype_name(name)

    return quote
        $(define_binding(__module__, const_binding, expr))
        $(define_struct(__module__, __source__, const_binding, name, nlevel))
        $(define_methods(__module__, const_binding, name))
        $(define_properties(__module__, const_binding, name))
    end
end

"""
    define_typed_binding(__module__::Module, __source__::LineNumberNode, name, type)

Define a new binding to a new type.
"""
function define_typed_binding(__module__::Module, __source__::LineNumberNode, name, type)
    gt_name = gatetype_name(name)
    const_binding = constant_name(name)
    return quote
        @eval $__module__ begin
            if !isdefined($__module__, $(QuoteNode(name)))
                throw(UndefVarError($(QuoteNode(name))))
            end

            const $const_binding = YaoBlocks.mat($type, $gt_name)
            YaoBlocks.mat(::Type{$type}, ::Type{$gt_name}) = $const_binding
        end
    end
end

function define_struct(__module__::Module, __source__::LineNumberNode, const_binding, name, nlevel)
    gt_name = gatetype_name(name)
    ex = Expr(:block)

    # export bindings if this is not in Main
    if __module__ !== Main
        push!(ex.args, :(export $name, $gt_name))
    end
    # calculate new shape
    N = gensym(:N)
    push!(ex.args, :(@eval $__module__ $N = $logdi(size($(const_binding), 1), $nlevel)))

    # we allow overwrite in order to support the following syntax
    # @const_gate X = BLABLA
    # @const_gate X = Correct_Matrix
    if isdefined(__module__, gt_name)
        msg = "$(string(gt_name)) is already defined, overwritten by new definition at $__source__"
        push!(ex.args, :(@warn $msg))
        push!(
            ex.args,
            :(@eval $__module__ @assert $N == $logdi(size(mat($name), 1), $nlevel) "new constant does not have the same size with previous definitions"),
        )
    else
        push!(
            ex.args,
            :(@eval $__module__ Base.@__doc__ struct $gt_name <:
                                                     YaoBlocks.ConstGate.ConstantGate{$N,$nlevel} end),
        )
    end
    push!(ex.args, :(@eval $__module__ Base.@__doc__ const $(name) = $(gt_name)()))
    return ex
end

function define_binding(__module__::Module, const_binding, type, expr)
    return quote
        @eval $__module__ begin
            const $const_binding = similar($expr, $type)
            if size($(const_binding), 1) != size($(const_binding), 2)
                throw(DimensionMismatch("Quantum Gates must be square matrix."))
            end
            copyto!($const_binding, $(expr))
        end
    end
end

function define_binding(__module__::Module, const_binding, expr)
    return quote
        @eval $__module__ begin
            const $const_binding = $(expr)
            if size($(const_binding), 1) != size($(const_binding), 2)
                throw(DimensionMismatch("Quantum Gates must be square matrix."))
            end
        end
    end
end

# forward instance to const gate type
YaoBlocks.mat(::Type{T}, ::GT) where {T,GT<:ConstantGate} = YaoBlocks.mat(T, GT)

function define_methods(__module__::Module, const_binding, name)
    gt_name = gatetype_name(name)
    return quote
        @eval $__module__ begin
            YaoBlocks.mat(::Type{eltype($const_binding)}, ::Type{$gt_name}) = $const_binding

            function YaoBlocks.mat(::Type{T}, ::Type{$gt_name}) where {T}
                src = YaoBlocks.mat(eltype($const_binding), $gt_name)
                dst = similar(src, T)
                copyto!(dst, src)
                return dst
            end

            function YaoBlocks.print_block(io::IO, ::$gt_name)
                print(io, $(QuoteNode(name)))
            end
        end # eval
    end # quote
end

function define_properties(__module__::Module, const_binding, name)
    gt_name = gatetype_name(name)
    function def(property)
        flag = gensym(:flag)
        return quote
            @eval $__module__ begin
                const $flag = YaoBlocks.$property($const_binding)
                YaoBlocks.$property(::$gt_name) = $flag
                YaoBlocks.$property(::Type{GT}) where {GT<:$gt_name} = $flag
            end
        end
    end

    ex = Expr(:block)
    for each in [:ishermitian, :isreflexive, :isunitary]
        push!(ex.args, def(each))
    end
    return ex
end

"""
    SuperOp{D,T,MT<:AbstractMatrix{T}} <: AbstractQuantumChannel{D}

    SuperOp{D}(n::Int, superop::AbstractMatrix)
    SuperOp(superop::AbstractMatrix; nlevel::Int=2)

Superoperator representation of a quantum channel. Its matrix size is `D^(2n) × D^(2n)`, where `D` is the dimension of the system and `n` is the number of qubits.
A superoperator is a linear map from the space of density matrices to itself.

### Fields
- `n::Int`: the number of qubits
- `superop::AbstractMatrix`: the superoperator matrix


## Arguments
- `nlevel::Int`: the number of levels of the superoperator, default to 2 for a single qubit channel.
"""
struct SuperOp{D,T,MT<:AbstractMatrix{T}} <: AbstractQuantumChannel{D}
    n::Int
    superop::MT
    function SuperOp{D}(n::Int, superop::AbstractMatrix) where D
        @assert size(superop, 1) == size(superop, 2) == D^(2n) "The size of the superoperator matrix must be D^(2n) × D^(2n), given D=$D and n=$n, but got $(size(superop))"
        new{D,eltype(superop),typeof(superop)}(n, superop)
    end
end
function SuperOp{D}(superop::AbstractMatrix) where D
    n = logdi(size(superop, 1), 2*D)
    SuperOp{D}(n, superop)
end
SuperOp(superop::AbstractMatrix) = SuperOp{2}(superop)
function Base.:(*)(x::SuperOp{D}, y::SuperOp{D}) where D
    @assert x.n == y.n "The number of qubits of the two superoperators must be the same, but got $(x.n) and $(y.n)"
    SuperOp{D}(x.n, x.superop * y.superop)
end

nqudits(uc::SuperOp) = uc.n
subblocks(::SuperOp) = ()

print_block(io::IO, x::SuperOp) = print(io, "SuperOp{$(nqudits(x))}($(x.superop))")

# applied on few qubits
function noisy_instruct!(rho::DensityMatrix{D,T}, x::SuperOp, locs) where {D,T}
    reg = ArrayReg{D}(vec(rho.state))
    instruct!(reg, x.superop, (locs..., (locs .+ nqudits(rho))...))
    return rho
end
# applied on all qubits
function YaoAPI.unsafe_apply!(rho::DensityMatrix{D,T}, x::SuperOp) where {D,T}
    reg = ArrayReg{D}(vec(rho.state))
    unsafe_apply!(reg, GeneralMatrixBlock{D}(2*x.n, 2*x.n, x.superop))
    return rho
end

function cache_key(x::SuperOp)
    return hash(x.n, hash(x.superop))
end
function Base.:(==)(lhs::SuperOp, rhs::SuperOp)
    return (lhs.n == rhs.n) && (lhs.superop == rhs.superop)
end
Base.isapprox(x::SuperOp, y::SuperOp; kwargs...) = isapprox(x.superop, y.superop; kwargs...)
Base.adjoint(x::SuperOp{D}) where D = SuperOp{D}(x.n, adjoint(x.superop))

# convert block to superop
function SuperOp(::Type{T}, x::AbstractBlock{D}) where {D,T}
    isnoisy(x) && return noisy_superop(T, x)
    m = mat(T, x)
    SuperOp{D}(kron(conj(m), m))
end
function noisy_superop(::Type{T}, x::ChainBlock{D}) where {D,T}
    return prod(SuperOp(T, b) for b in x.blocks[end:-1:1])
end
SuperOp(x::AbstractBlock{D}) where D = SuperOp(Complex{Float64}, x)

export projector, print_blocktree

"""
    projector(x)

Return projector on `0` or projector on `1`.
"""
projector(x) = x == 0 ? mat(ConstGate.P0) : mat(ConstGate.P1)

"""
    print_subtypetree(::Type[, level=1, indent=4])

Print subtype tree, `level` specify the depth of the tree.
"""
function print_subtypetree(t::Type, level = 1, indent = 4)
    level == 1 && println(t)
    for s in subtypes(t)
        println(join(fill(" ", level * indent)) * string(s))
        print_subtypetree(s, level + 1, indent)
    end
end

"""
    rmlines(ex)

Remove `LineNumberNode` from an `Expr`.
"""
rmlines(ex::Expr) = begin
    hd = ex.head
    hd == :macrocall && return ex
    tl = map(rmlines, filter(!islinenumbernode, ex.args))
    Expr(hd, tl...)
end
rmlines(@nospecialize(a)) = a
islinenumbernode(@nospecialize(x)) = x isa LineNumberNode

"""
    rand_unitary([T=ComplexF64], N::Int) -> Matrix

Create a random unitary matrix.

### Examples

```jldoctest; setup=:(using Yao)
julia> isunitary(rand_unitary(2))
true

julia> eltype(rand_unitary(ComplexF32, 2))
ComplexF32 (alias for Complex{Float32})
```
"""
rand_unitary(N::Int) = rand_unitary(ComplexF64, N)
rand_unitary(::Type{T}, N::Int) where {T} = qr(randn(T, N, N)).Q |> Matrix

"""
    sprand_unitary([T=ComplexF64], N::Int, density) -> SparseMatrixCSC

Create a random sparse unitary matrix.
"""
sprand_unitary(N::Int, density::Real) = sprand_unitary(ComplexF64, N, density)
sprand_unitary(::Type{T}, N::Int, density::Real) where {T} =
    SparseMatrixCSC(qr(sprandn(T, N, N, density)).Q)


"""
    rand_hermitian([T=ComplexF64], N::Int) -> Matrix

Create a random hermitian matrix.

```jldoctest; setup=:(using Yao)
julia> ishermitian(rand_hermitian(2))
true
```
"""
rand_hermitian(N::Int) = rand_hermitian(ComplexF64, N)

function rand_hermitian(::Type{T}, N::Int) where {T}
    A = randn(T, N, N)
    A + A'
end

"""
    sprand_hermitian([T=ComplexF64], N, density)

Create a sparse random hermitian matrix.
"""
sprand_hermitian(N::Int, density) = sprand_hermitian(ComplexF64, N, density)

function sprand_hermitian(::Type{T}, N::Int, density::Real) where {T}
    A = sprandn(T, N, N, density)
    return A + A'
end

@static if VERSION < v"1.1.0"
    function SparseArrays.sprandn(::Type{T}, n::Int, m::Int, density::Real) where {T<:Real}
        return T.(sprandn(n, m, density))
    end

    function SparseArrays.sprandn(
        ::Type{Complex{T}},
        n::Int,
        m::Int,
        density::Real,
    ) where {T<:Real}
        return T.(sprandn(n, m, density)) + im * T.(sprandn(n, m, density))
    end
end

BitBasis.unsafe_reorder(A::IMatrix, orders::NTuple{N,<:Integer}; nlevel=2) where {N} = A

function BitBasis.unsafe_reorder(A::PermMatrix, orders::NTuple{N,<:Integer}; nlevel=2) where {N}
    od = Vector{Int}(undef, nlevel ^ length(orders))
    for (i, b) in enumerate(ReorderedBasis(orders))
        @inbounds od[i] = 1 + b
    end

    perm = similar(A.perm)
    vals = similar(A.vals)

    @simd for i = 1:length(perm)
        @inbounds perm[od[i]] = od[A.perm[i]]
        @inbounds vals[od[i]] = A.vals[i]
    end

    return PermMatrix(perm, vals)
end

function logdi(x::Integer, d::Integer)
    @assert x > 0 && d > 0
    res = log(x) / log(d)
    r = round(Int, res)
    if !(res ≈ r)
        throw(ArgumentError("`$x` is not an integer power of `$d`."))
    end
    return r
end

##################### Entry Table #########################
"""
    EntryTable{IT<:DitStr, ET}

A table of ditstring-amplitude, which can be used for e.g. indexing and operator or representing the output of operator indexing.

### Examples
```jldoctest; setup=:(using Yao)
julia> EntryTable([dit"121;3", dit"111;3"], [0.6, 0.8im])
EntryTable{DitStr64{3, 3}, ComplexF64}:
  121 ₍₃₎   0.6 + 0.0im
  111 ₍₃₎   0.0 + 0.8im
```

The following example shows how to create a Hamiltonian and scatter this bit string by this Hamiltonian.

```jldoctest; setup=:(using Yao)
julia> b = kron(X,Z,Y)
nqubits: 3
kron
├─ 1=>X
├─ 2=>Z
└─ 3=>Y

julia> b[:,bit"010"]
EntryTable{DitStr{2, 3, Int64}, ComplexF64}:
  111 ₍₂₎   0.0 - 1.0im

julia> b[:,b[:,bit"010"]]
EntryTable{DitStr{2, 3, Int64}, ComplexF64}:
  010 ₍₂₎   1.0 + 0.0im
```
"""
struct EntryTable{IT<:DitStr, ET}
    configs::Vector{IT}
    amplitudes::Vector{ET}
end
function YaoArrayRegister.print_table(io::IO, t::EntryTable; digits::Int=5)
    println(io, "$(typeof(t)):")
    for (i, a) in zip(t.configs, t.amplitudes)
        # to support symbolic
        if a isa AbstractFloat || a isa Complex
            a = round(a; digits)
        end
        println(io, "  $i   $a")
    end
end
Base.show(io::IO, ::MIME"text/plain", t::EntryTable) = YaoArrayRegister.print_table(io, t; digits=5)
Base.show(io::IO, t::EntryTable) = YaoArrayRegister.print_table(io, t; digits=5)
Base.:(==)(e1::EntryTable, e2::EntryTable) = e1.configs == e2.configs && e1.amplitudes == e2.amplitudes
Base.length(et::EntryTable) = length(et.configs)
Base.iterate(et::EntryTable, args...) = iterate(zip(et.configs, et.amplitudes), args...)

function Base.Vector(et::EntryTable{<:DitStr{D,N}, ET}) where {D,N,ET}
    v = zeros(ET, D^N)
    for (c, a) in et
        v[buffer(c)+1] += a  # accumulate to support duplicated entries
    end
    return v
end
function SparseArrays.SparseVector(et::EntryTable{DitStr{D,N,TI}, ET}) where {D,N,ET,TI}
    length(et.configs) == 0 && return SparseVector(D^N, TI[], ET[])
    locs = buffer.(et.configs) .+ 1
    locs, amps = _cleanup(locs, et.amplitudes; zero_threshold=0.0)
    return SparseVector(D^N, locs, amps)
end

"""
    cleanup(entries::EntryTable; zero_threshold=0.0)

Clean up the entry table by 1) sort entries, 2) merge items and 3) clean up zeros.
Any value with amplitude ≤ `zero_threshold` will be regarded as zero.

```jldoctest; setup=:(using Yao)
julia> et = EntryTable([bit"000",bit"011",bit"101",bit"101",bit"011",bit"110",bit"110",bit"011",], [1.0 + 0.0im,-1, 1,1,1,-1,1,1,-1])
EntryTable{DitStr{2, 3, Int64}, ComplexF64}:
  000 ₍₂₎   1.0 + 0.0im
  011 ₍₂₎   -1.0 + 0.0im
  101 ₍₂₎   1.0 + 0.0im
  101 ₍₂₎   1.0 + 0.0im
  011 ₍₂₎   1.0 + 0.0im
  110 ₍₂₎   -1.0 + 0.0im
  110 ₍₂₎   1.0 + 0.0im
  011 ₍₂₎   1.0 + 0.0im


julia> cleanup(et)
EntryTable{DitStr{2, 3, Int64}, ComplexF64}:
  000 ₍₂₎   1.0 + 0.0im
  011 ₍₂₎   1.0 + 0.0im
  101 ₍₂₎   2.0 + 0.0im
```
"""
function cleanup(et::EntryTable; zero_threshold=0)
    EntryTable(_cleanup(et.configs, et.amplitudes; zero_threshold)...)
end
function _cleanup(locs, amps; zero_threshold)
    length(locs) == 0 && return locs, amps
    order = sortperm(locs; by=Int)
    @inbounds locs, amps = locs[order], amps[order]
    k = 1
    pre = locs[1]
    @inbounds for i=2:length(locs)
        this = locs[i]
        if this != pre
            # made complicated to support Basic
            if !_iszero(amps[k], zero_threshold)
                k += 1
            end
            locs[k] = this
            amps[k] = amps[i]
        else
            amps[k] += amps[i]
        end
        pre = this
    end
    if _iszero(amps[k], zero_threshold)
        k -= 1
    end
    if k != length(locs)
        resize!(locs, k)
        resize!(amps, k)
    end
    return locs, amps
end

_iszero(ampk, zero_threshold) = iszero(zero_threshold) ? iszero(ampk) : abs(ampk) <= zero_threshold

"""
    isclean(entries::EntryTable; zero_threshold=0.0)

Return true if the entries are ordered, unique and amplitudes are nonzero.
Any value with amplitude ≤ `zero_threshold` will be regarded as zero.
"""
function isclean(et::EntryTable; zero_threshold=0)
    local kpre
    for (i, (k, v)) in enumerate(et)
        abs(v) <= zero_threshold && return false
        if i==1
            kpre = k
            continue
        else
            if buffer(k) <= buffer(kpre)
                return false
            else
                kpre = k
            end
        end
    end
    return true
end

function Base.merge(et::EntryTable{DitStr{D,N,TI},T}, ets::EntryTable{DitStr{D,N,TI},T}...) where {D,N,TI,T}
    length(ets) == 0 && return et
    EntryTable(vcat(et.configs, [e.configs for e in ets]...), vcat(et.amplitudes, [e.amplitudes for e in ets]...))
end

function unsafe_getindex(et::EntryTable{T,ET}, i::T) where {T,ET}
    ind = searchsortedfirst(et.configs, i; by=Int)
    if ind > length(et)
        return zero(ET)
    else
        return et.amplitudes[ind]
    end
end

function Base.getindex(et::EntryTable{T}, i::T) where T
    if !isclean(et)
        error("entry table is not clean, please use `cleanup` to clean up the table first!")
    else
        return unsafe_getindex(et, i)
    end
end

SparseArrays.sparse(et::EntryTable) = SparseVector(et)
Base.vec(et::EntryTable) = Vector(et)

# convert a (maybe complex) number x to real number.
function safe_real(x::Complex{T}) where T
    img = imag(x)
    if !iszero(img) && !(hasmethod(eps, Tuple{Type{T}}) && isapprox(x - im*img, x; rtol=10*eps(T), atol=10*eps(T)))
        @warn "Convert number $x to real is unsafe due to the nonzero imaginary part: $img. Maybe you want to use the `sandwich` function?"
    end
    return real(x)
end
safe_real(x) = x

using Test, YaoBlocks, YaoAPI
using LuxurySparse

@testset "baisc" begin
    @test repeat(5, X, 2, 3) isa RepeatedBlock
    @test repeat(5, X, [2, 3]) isa RepeatedBlock
    @test repeat(X, (2,3))(5) == repeat(5, X, (2,3))
    @test repeat(X)(5) == repeat(5, X, 1:5)
    reg = rand_state(5)
    @test apply(reg, repeat(5, X, ())) == reg
    rp = RepeatedBlock(5, X, (1, 2, 3))
    @test iscommute(RepeatedBlock(5, X, (1, 2, 3)), repeat(5, Val(im)*X, (1, 2, 3)))
    @test_throws QubitMismatchError iscommute(RepeatedBlock(5, X, (1, 2, 3)), repeat(3, Val(im)*X, (1, 2, 3)))
    @test iscommute(RepeatedBlock(5, X, (1, 2, 3)), repeat(5, Val(im)*X, (1, 2)))
    @test isreflexive(rp)
    @test ishermitian(rp)
    @test isunitary(rp)
    @test (chsubblocks(rp, [Z]) |> subblocks .== [Z]) |> all
    @test occupied_locs(rp) == (1, 2, 3)
    @test occupied_locs(repeat(5, I2)) == ()
    @test occupied_locs(repeat(5, X)) == (1, 2, 3, 4, 5)
    @test rp |> copy == rp
    @test YaoBlocks.PropertyTrait(rp) == YaoBlocks.PreserveAll()

    @test repeat(10, H, 1:10) == repeat(10, H, Tuple(1:10))
    @test_throws ArgumentError repeat(10, SWAP, (1, 3))

    @test_throws QubitMismatchError apply!(rand_state(2), repeat(10, X, (1, 2, 3)))
    @test_throws QubitMismatchError apply!(rand_state(2), repeat(10, put(1, 1 => X), ()))

    @test mat(repeat(10, X, ())) == IMatrix(1<<10)
end

@testset "instruct_get_element" begin
    for pb in [repeat(3, Y, (3,2)), repeat(5, matblock(rand_unitary(3); nlevel=3), (5, 2))]
        mpb = mat(pb)
        allpass = true
        for i=basis(pb), j=basis(pb)
            allpass &= pb[i, j] == mpb[Int(i)+1, Int(j)+1]
        end
        @test allpass

        allpass = true
        for j=basis(pb)
            allpass &= vec(pb[:, j]) == mpb[:, Int(j)+1]
            allpass &= vec(pb[:, EntryTable([j], [1.0+0im])]) == mpb[:, Int(j)+1]
            allpass &= vec(pb[j, :]) == mpb[Int(j)+1, :]
            allpass &= isclean(pb[:,j])
        end
        @test allpass
    end
end

export ControlBlock, control, cnot, cz

"""
    $(TYPEDSIGNATURES)

A control block is a composite block that applies a block when the control qubits are all ones.

!!! note
    If control qubit index is negative, it means the inverse control, i.e., the block is applied when the control qubit is zero.

### Fields
$(TYPEDFIELDS)
"""
struct ControlBlock{BT<:AbstractBlock,C,M} <: AbstractContainer{BT,2}
    n::Int
    ctrl_locs::NTuple{C,Int}
    ctrl_config::NTuple{C,Int}
    content::BT
    locs::NTuple{M,Int}
    function ControlBlock{BT,C,M}(n,
        ctrl_locs,
        ctrl_config,
        block,
        locs,
    ) where {C,M,BT<:AbstractBlock}
        @assert_locs_safe n (ctrl_locs..., locs...)
        @assert nqudits(block) == M "number of locations doesn't match the size of block"
        @assert block isa AbstractBlock "expect a block, got $(typeof(block))"
        @assert !isnoisy(block) "controlled block can not contain noisy channel"
        new{BT,C,M}(n, ctrl_locs, ctrl_config, block, locs)
    end
end

"""
    decode_sign(ctrls...)

Decode signs into control sequence on control or inversed control.
"""
decode_sign(ctrls::NTuple{N,Int}) where {N} =
    tuple(ctrls .|> abs, ctrls .|> sign .|> (x -> (1 + x) ÷ 2))

function ControlBlock(n::Int,
    ctrl_locs::NTuple{C},
    ctrl_config::NTuple{C},
    block::BT,
    locs::NTuple{K},
) where {C,K,BT<:AbstractBlock{2}}
    nqudits(block) == K || throw(DimensionMismatch("block position not maching its size!"))
    return ControlBlock{BT,C,K}(n, ctrl_locs, ctrl_config, block, locs)
end

# control bit configs are 1 by default, it use sign to encode control bit code
ControlBlock(n::Int, ctrl_locs::NTuple{C}, block::AbstractBlock, locs::NTuple) where {C} =
    ControlBlock(n::Int, decode_sign(ctrl_locs)..., block, locs)

# use pair to represent block under control in a compact way
ControlBlock(n::Int, ctrl_locs::NTuple{C}, target::Pair) where {C} =
    ControlBlock(n, ctrl_locs, target.second, (target.first...,))

nqudits(c::ControlBlock) = c.n

"""
    control(n, ctrl_locs, locations => subblock)

Return a `n`-qubit [`ControlBlock`](@ref), where the control locations `ctrl_locs` and the subblock `locations` in the third argument can be an integer, a tuple or a range,
and the size of the subblock should match the length of `locations`.
Let ``I`` be the ``2 \\times 2`` identity matrix, ``G`` be a ``2 \\times 2`` subblock,
``P_0=|0\\rangle\\langle 0|`` and ``P_1=|1\\rangle\\langle 1|`` be two single qubit projection operators to subspace ``|0\\rangle`` and ``|1\\rangle``,
``i`` and ``j`` be two integers that ``i>j``.
The matrix representation of `control(n, i, j=>G)` is

```math
\\begin{align}
&I^{\\otimes n-i} P_0 \\otimes I^{\\otimes i-j-1} \\otimes I\\otimes I^{\\otimes j-1}
+\\\\
& I^{\\otimes n-i} P_1 \\otimes I^{\\otimes i-j-1} \\otimes G\\otimes I^{\\otimes j-1}
\\end{align}
```

The multi-controlled multi-qubit controlled block is more complicated, it means apply the gate when control qubits are all ones.
Each control location can take a negative sign to represent the inverse control, meaning only when this qubit is `0`, the controlled gate is applied.

### Examples

```jldoctest; setup=:(using Yao)
julia> control(4, (1, 2), 3=>X)
nqubits: 4
control(1, 2)
└─ (3,) X

julia> control(4, 1, 3=>X)
nqubits: 4
control(1)
└─ (3,) X
```
"""
control(total::Int, ctrl_locs, target::Pair) = ControlBlock(total, Tuple(ctrl_locs), target)
control(total::Int, control_location::Int, target::Pair) =
    control(total, (control_location,), target)

"""
    control(ctrl_locs, target) -> f(n)

Return a lambda that takes the number of total active qubits as input. See also
[`control`](@ref).

### Examples

```jldoctest; setup=:(using YaoBlocks)
julia> control((2, 3), 1=>X)
(n -> control(n, (2, 3), 1 => X))

julia> control(2, 1=>X)
(n -> control(n, 2, 1 => X))
```
"""
control(ctrl_locs, target::Pair) = @λ(n -> control(n, ctrl_locs, target))
control(control_location::Int, target::Pair) = @λ(n -> control(n, control_location, target))

"""
    cnot([n, ]ctrl_locs, location)

Return a speical [`ControlBlock`](@ref), aka CNOT gate with number of active qubits
`n` and locs of control qubits `ctrl_locs`, and `location` of `X` gate.

### Examples

```jldoctest; setup=:(using YaoBlocks)
julia> cnot(3, (2, 3), 1)
nqubits: 3
control(2, 3)
└─ (1,) X

julia> cnot(2, 1)
(n -> cnot(n, 2, 1))
```
"""
cnot(total::Int, ctrl_locs, locs::Int) = control(total, ctrl_locs, locs => X)
cnot(ctrl_locs, loc::Int) = @λ(n -> cnot(n, ctrl_locs, loc))

"""
    cz([n, ]ctrl_locs, location)

Return a special [`ControlBlock`](@ref), aka CZ gate with number of active qubits
`n` and locs of control qubits `ctrl_locs`, and `location` of `Z` gate. See also
[`cnot`](@ref).

### Examples

```jldoctest; setup=:(using Yao)
julia> cz(2, 1, 2)
nqubits: 2
control(1)
└─ (2,) Z
```
"""
cz(total::Int, ctrl_locs, locs::Int) = control(total, ctrl_locs, locs => Z)
cz(ctrl_locs, loc::Int) = @λ(n -> cz(n, ctrl_locs, loc))


mat(::Type{T}, c::ControlBlock{BT,C}) where {T,BT,C} =
    cunmat(c.n, c.ctrl_locs, c.ctrl_config, mat(T, c.content), c.locs)

function YaoAPI.unsafe_apply!(r::AbstractRegister, c::ControlBlock)
    instruct!(r, mat_matchreg(r, c.content), c.locs, c.ctrl_locs, c.ctrl_config)
    return r
end

# specialization
for G in [:X, :Y, :Z, :S, :T, :Sdag, :Tdag]
    GT = Expr(:(.), :ConstGate, QuoteNode(Symbol(G, :Gate)))

    @eval function YaoAPI.unsafe_apply!(r::AbstractRegister, c::ControlBlock{<:$GT})
        instruct!(r, Val($(QuoteNode(G))), c.locs, c.ctrl_locs, c.ctrl_config)
        return r
    end
end

PropertyTrait(::ControlBlock) = PreserveAll()

occupied_locs(c::ControlBlock) =
    (c.ctrl_locs..., map(x -> c.locs[x], occupied_locs(c.content))...)
chsubblocks(pb::ControlBlock, blk::AbstractBlock) =
    ControlBlock(pb.n, pb.ctrl_locs, pb.ctrl_config, blk, pb.locs)

# NOTE: ControlBlock will forward parameters directly without loop
cache_key(ctrl::ControlBlock) = cache_key(ctrl.content)

function Base.:(==)(
    lhs::ControlBlock{BT,C,M},
    rhs::ControlBlock{BT,C,M},
) where {BT,C,M}
    return nqudits(lhs) == nqudits(rhs) &&
            (lhs.ctrl_locs == rhs.ctrl_locs) &&
           (lhs.content == rhs.content) &&
           (lhs.locs == rhs.locs)
end

Base.adjoint(blk::ControlBlock) =
    ControlBlock(blk.n, blk.ctrl_locs, blk.ctrl_config, adjoint(blk.content), blk.locs)

# NOTE: we only copy one hierachy (shallow copy) for each block
function Base.copy(ctrl::ControlBlock{BT,C,M}) where {BT,C,M}
    return ControlBlock{BT,C,M}(ctrl.n, ctrl.ctrl_locs, ctrl.ctrl_config, ctrl.content, ctrl.locs)
end

function YaoAPI.iscommute(x::ControlBlock, y::ControlBlock)
    _check_block_sizes(x, y)
    if x.locs == y.locs
        return iscommute(x.content, y.content)
    elseif !any(l -> l in y.ctrl_locs, x.locs) && !any(l -> l in x.ctrl_locs, y.locs)
        return true
    else
        return iscommute_fallback(x, y)
    end
end

function unsafe_getindex(::Type{T}, ctrl::ControlBlock, i::Integer, j::Integer) where {T}
    instruct_get_element(T, Val{2}(), nqudits(ctrl), ctrl.content, ctrl.locs, ctrl.ctrl_locs, ctrl.ctrl_config, i, j)
end
function unsafe_getcol(::Type{T}, ctrl::ControlBlock, j::DitStr{D}) where {T,D}
    instruct_get_column(T, ctrl.content, ctrl.locs, ctrl.ctrl_locs, ctrl.ctrl_config, j)
end

"""
    @yao_str
    yao"..."

The mark up language for quantum circuit.
"""
macro yao_str(str::String)
    yaofromstring(str)
end

function yaofromstring(x::String)
    ex = Meta.parse(x)
    parse_yaoscript(ex)
end

macro yaoscript(ex)
    parse_yaoscript(ex)
end

function parse_yaoscript(ex)
    @match ex begin
        Expr(:let, header, body) => begin
            info = ParseInfo(-1, "")
            if header.head != :block
                header = [header]
            else
                header = header.args
            end
            for hd in header
                @match hd begin
                    :(nqubits = $n) => (info.nbit = Int(n))
                    :(version = $v) => (info.version = String(v))
                    _ => error("unknown configuration $header")
                end
            end
            parse_ex(body |> rmlines, info)
        end
        _ => error(
            "wrong format, expect expression like `let nqubits=5 GATEDEF end`, got $ex",
        )
    end
end

yaofromfile(x::String) = yaofromstring(read(x, String))
parse_ex(ex, nbit::Int) = parse_ex(ex, ParseInfo(nbit, ""))

mutable struct ParseInfo
    nbit::Int
    version::String
end

function parse_param(x)
    @match x begin
        ::Number => x
        :(:π) => x
        _ => error("can not parse parameter $x.")
    end
end

function parse_ex(ex, info::ParseInfo)
    @match ex begin
        :(version = $vnumber) => (info.version = String(vnumber); nothing)
        :(nqubits = $x) => (info.nbit = Int(x); nothing)
        ::Nothing => nothing
        :($g') => :($(parse_ex(g, info))')
        :($a * $b) => :($(Number(a)) * $(parse_ex(b, info)))
        :(kron($(args...))) =>
            :(kron($(parse_ex.(args, Ref(ParseInfo(1, info.version)))...)))
        :(repeat($(exloc...)) => $g) => begin
            loc = render_loc((exloc...,), info.nbit)
            :(repeat($(info.nbit), $(parse_ex(g, ParseInfo(1, info.version))), $loc))
        end
        :(cache($g)) => :(cache($(parse_ex(g, info))))
        :(rot($g, $theta)) => :(rot($(parse_ex(g, info)), $(parse_param(theta))))
        :(time($dt) => $h) => :(time_evolve($(parse_ex(h, info)), $(parse_param(dt))))
        :($exloc => Measure) => parse_ex(:($exloc => Measure(nothing) => nothing), info)
        :($exloc => Measure($op)) => parse_ex(:($exloc => Measure($op) => nothing), info)
        :($exloc => Measure => $post) =>
            parse_ex(:($exloc => Measure(nothing) => $post), info)
        :($exloc => Measure($op) => $post) => begin
            locs = exloc == :ALL ? :(AllLocs()) : render_loc(exloc, info.nbit)
            op =
                op isa Nothing || op == :nothing ? :(ComputationalBasis()) :
                parse_ex(op, exloc == :ALL ? info : ParseInfo(length(locs), info.version))
            @match post begin
                ::Nothing || :nothing =>
                    :(Measure($(info.nbit); locs = $locs, operator = $(op)))
                :(resetto($(rbits...))) => begin
                    cb = bit_literal(render_bitstring.(rbits)...)
                    :(Measure($(info.nbit); locs = $locs, operator = $(op), resetto = $cb))
                end
                :remove => :(Measure(
                    $(info.nbit);
                    locs = $locs,
                    operator = $(op),
                    remove = true,
                ))
            end
        end
        :(+($(args...))) => :(+($(parse_ex.(args, Ref(info))...)))
        :(focus($(exloc...)) => $g) => begin
            loc = render_loc((exloc...,), info.nbit)
            :(subroutine(
                $(info.nbit),
                $(parse_ex(g, ParseInfo(length(loc), info.version))),
                $loc,
            ))
        end
        :(
            begin
                $(cargs...)
            end
        ) => begin
            args = filter(x -> x !== nothing, [parse_ex(arg, info) for arg in cargs])
            :(chain($(info.nbit), [$(args...)]))
        end
        :($exloc => $gate) => begin
            loc = render_loc(exloc, info.nbit)
            :(put(
                $(info.nbit),
                $loc => $(parse_ex(gate, ParseInfo(length(loc), info.version))),
            ))
        end
        :($(cargs...), $exloc => $gate) => begin
            loc = render_loc(exloc, info.nbit)
            cbits = render_cloc.(cargs, Ref(info))
            if cbits[1] isa Integer
                :(control(
                    $(info.nbit),
                    $cbits,
                    $loc => $(parse_ex(gate, ParseInfo(length(loc), info.version))),
                ))
            else
                :(kron(
                    $(info.nbit),
                    $(cbits...),
                    $loc => $(parse_ex(gate, ParseInfo(1, info.version))),
                ))
            end
        end
        :($f($(args...))) => gate_expr(Val(Symbol(f)), args, info)

        ::LineNumberNode => nothing
        ::Symbol => ex  # const gate
        _ => error("scipt format error! got $ex of type $(typeof(ex))")
    end
end

function check_dumpload(gate::AbstractBlock)
    gate2 = eval(parse_ex(dump_gate(gate), nqudits(gate)))
    gate2 == gate || mat(gate2) ≈ mat(gate)
end

render_bitstring(ex) = @match ex begin
    ::Number => begin
        if ex == 1 || ex == 0
            ex
        else
            error("expect a bitstring like `1` or `(1,0)`, got $ex")
        end
    end
    ::Tuple => render_bitstring.(ex)
    :($(args...),) => (render_bitstring.(args)...,)
    _ => error("expect a bitstring like `1` or `(1,0)`, got $ex")
end

render_loc(ex, nbit::Int) = @match ex begin
    :($(args...),) => (render_loc.(args, nbit)...,)
    ::Number => Int(ex)
    :($a:$b) => Int(a):Int(b)
    :ALL => (1:nbit...,)
    :($a:$step:$b) => Int(a):Int(step):Int(b)
    ::Tuple => Int.(ex)
    ::UnitRange{Int} => ex
    _ => error("expect a location specification like `2`, `2:5` or `(2,3)`, got $ex")
end

render_cloc(ex, info) = @match ex begin
    :($a => C($b)) => begin
        if !(b == 1 || b == 0)
            error("expect a control values `0` or `1`, got $ex")
        end
        Int(a) * (2 * Int(b) - 1)
    end
    :($a => C) => render_cloc(:($a => C(1)), info)
    :($a => $g) =>
        :($(render_loc(a, info.nbit)) => $(parse_ex(g, ParseInfo(1, info.version))))
    _ => error("expect a control location specification like `2=>0` or `3=>1`, got $ex")
end

"""
    gate_expr(::Val{G}, args, info)

Obtain the gate constructior from its YaoScript expression.
`G` is a symbol for the gate type,
the default constructor is `G(args...)`.
`info` contains the informations about the number of qubit and Yao version.
"""
function gate_expr(::Val{G}, args, info) where {G}
    throw(NotImplementedError(:gate_expr, (Val(G), args, info)))
end

render_arg(ex, info) = @match ex begin
    # locs
    :($(args...),) => (render_loc.(args, info.nbit)...,)
    ::Integer => Int(ex)
    :($a:$b) => Int(a):Int(b)
    :ALL => (1:nbit...,)
    :($a:$step:$b) => Int(a):Int(step):Int(b)
    ::Tuple => Int.(ex)

    # floating point numbers
    ::Number => Number(ex)

    # Pair of (loc => gate)
    :($a => $g) => begin
        locs = render_loc(a, info.nbit)
        :($(locs) => $(parse_ex(g, ParseInfo(length(locs), info.version))))
    end

    # try parse a gate
    _ => parse_ex(ex, info)
end

for (G, F) in [(:ShiftGate, :shift), (:PhaseGate, :phase)]
    fname = QuoteNode(F)
    @eval function dump_gate(blk::$G)
        Expr(:call, $fname, tokenize_param(blk.theta))
    end
    @eval function gate_expr(::Val{$(QuoteNode(F))}, args, info)
        Expr(:call, $fname, parse_param(args[1]))
    end
end

export mat_back_jacobian, apply_back_jacobian, ng
export test_apply_back, test_mat_back

function ng(f, θ, δ = 1e-5)
    res = []
    for i = 1:length(θ)
        push!(
            res,
            (f(ireplace(θ, i => θ[i] + δ / 2)) - f(ireplace(θ, i => θ[i] - δ / 2))) / δ,
        )
    end
    cat(res..., dims = 3)
end

ireplace(vec::Vector, pair::Pair) = (v = copy(vec); v[pair.first] = pair.second; v)
ireplace(vec::Number, pair::Pair) = pair.second

function mat_back_jacobian(T, block, θ; use_outeradj = false)
    dispatch!(block, θ)
    m = mat(T, block)
    N = size(m, 1)
    jac = zeros(T, size(m)..., length(θ))
    zm = use_outeradj ? OuterProduct(zeros(T, N), zeros(T, N)) : zero(m)
    for j = 1:size(m, 2)
        @inbounds for i = 1:size(m, 1)
            if m[i, j] != 0
                _setval(zm, i, j, 1)
                jac[i, j, :] = mat_back(ComplexF64, block, zm)
                _setval(zm, i, j, 1im)
                jac[i, j, :] += 1im * mat_back(ComplexF64, block, zm)
                _setval(zm, i, j, 0)
            end
        end
    end
    return jac
end
_setval(m::AbstractMatrix, i, j, v) = (m[i, j] = v; m)
_setval(m::OuterProduct, i, j, v) = (m.left[i] = v == 0 ? 0 : 1; m.right[j] = v; m)
Base.setindex!(m::PermMatrix, v, i, j) = m.perm[i] == j ? m.vals[i] = v : error()

function apply_back_jacobian(reg0::AbstractArrayReg{D}, block, θ; kwargs...) where D
    dispatch!(block, θ)
    out = apply!(copy(reg0), block)
    m = out.state
    zm = zero(m)
    jac = zeros(eltype(m), size(m)..., length(θ))
    for j = 1:size(m, 2)
        @inbounds for i = 1:size(m, 1)
            if m[i, j] != 0
                zm[i, j] = 1
                (in, inδ), col =
                    apply_back((copy(out), similar(reg0, copy(zm))), block; kwargs...)
                @assert in ≈ reg0
                jac[i, j, :] .= col
                zm[i, j] *= 1im
                (in, inδ), col = apply_back((copy(out), similar(reg0, copy(zm))), block)
                jac[i, j, :] .+= 1im .* col
                zm[i, j] = 0
            end
        end
    end
    return jac
end

function test_mat_back(
    T,
    block::AbstractBlock{D},
    param;
    δ = 1e-5,
    use_outeradj::Bool = false,
) where {D}
    function mfunc(param)
        dispatch!(block, param)
        mat(T, block)
    end
    # test loss is `real(sum(rand_matrix .* m))`
    got = mat_back_jacobian(T, block, param; use_outeradj = use_outeradj)
    num = ng(mfunc, param, δ)
    res = isapprox(got, num, atol = 10 * δ)
    if !res
        @show size(got)
        @show got
        @show num
    end
    return res
end

function test_apply_back(
    reg0,
    block::AbstractBlock{D},
    param;
    δ = 1e-5,
    kwargs...,
) where {D}
    function mfunc(param)
        block = dispatch(block, param)
        apply!(copy(reg0), block).state
    end
    # test loss is `real(sum(rand_matrix .* m))`
    got = apply_back_jacobian(reg0, block, param; kwargs...)
    num = ng(mfunc, param, δ)
    res = isapprox(got, num, atol = 10 * δ)
    if !res
        @show got
        @show num
    end
    return res
end

export ShiftGate, shift

"""
    ShiftGate <: PrimitiveBlock

Phase shift gate.
"""
mutable struct ShiftGate{T} <: PrimitiveBlock{2}
    theta::T
end

ShiftGate(theta::Integer) = ShiftGate(Float64(theta))
nqudits(blk::ShiftGate) = 1

"""
    shift(θ)

Create a [`ShiftGate`](@ref) with phase `θ`.

```math
\\begin{pmatrix}
1 & 0\\\\
0 & e^{i\\theta}
\\end{pmatrix}
```

### Examples

```jldoctest; setup=:(using YaoBlocks)
julia> shift(0.1)
shift(0.1)
```
"""
shift(θ) = ShiftGate(θ)
mat(::Type{T}, gate::ShiftGate) where {T} = Diagonal(T[1.0, exp(im * gate.theta)])

cache_key(gate::ShiftGate) = gate.theta

# parametric interface
niparams(::Type{<:ShiftGate}) = 1
getiparams(x::ShiftGate) = x.theta
setiparams!(r::ShiftGate, param::Number) = (r.theta = param; r)
setiparams(r::ShiftGate, param::Number) = ShiftGate(param)
render_params(::ShiftGate{T}, ::Val{:random}) where {T} = (T(rand()*2π),)

Base.adjoint(blk::ShiftGate) = ShiftGate(-blk.theta)
Base.copy(block::ShiftGate{T}) where {T} = ShiftGate{T}(block.theta)
Base.:(==)(lhs::ShiftGate, rhs::ShiftGate) = lhs.theta == rhs.theta

# fallback to matrix method if it is not real
YaoAPI.isunitary(r::ShiftGate{<:Real}) = true

function YaoAPI.isunitary(r::ShiftGate)
    isreal(r.theta) && return true
    @warn "θ in ShiftGate is not real, got θ=$(r.theta), fallback to matrix-based method"
    return isunitary(mat(r))
end
YaoAPI.isdiagonal(r::ShiftGate) = true

iparams_range(::ShiftGate{T}) where {T} = ((zero(T), T(2.0 * pi)),)

export PutBlock, put, Swap, swap, PSwap, pswap

"""
    PutBlock{D,C,GT<:AbstractBlock} <: AbstractContainer{GT,D}

Type for putting a block at given locations.
"""
struct PutBlock{D,C,GT<:AbstractBlock} <: AbstractContainer{GT,D}
    n::Int
    content::GT
    locs::NTuple{C,Int}

    function PutBlock(n::Int,block::GT, locs::NTuple{C,Int}) where {D,C,GT<:AbstractBlock{D}}
        @assert_locs_safe n locs
        @assert nqudits(block) == C "number of locations doesn't match the size of block"
        return new{D,C,GT}(n, block, locs)
    end
end
nqudits(pb::PutBlock) = pb.n

"""
    put(n::Int, locations => subblock) => PutBlock

Create a `n`-qudit [`PutBlock`](@ref). The second argument is a pair of locations and subblock,
where the locations can be a tuple, an integer or a range and the subblock size should match the length of locations.
Let ``I`` be a ``2\\times 2`` identity matrix and ``G`` be a ``2\\times 2`` matrix, the matrix representation of `put(n, i=>G)` is defined as

```math
I^{\\otimes n-i} \\otimes G \\otimes I^{\\otimes i-1}
```

For multiple locations, the expression can be complicated, 
which corresponds to the matrix representation of multi-qubit gate applied on `n`-qubit space in quantum computing.

### Examples

```jldoctest; setup=:(using Yao)
julia> put(4, 1=>X)
nqubits: 4
put on (1)
└─ X
```

If you want to put a multi-qubit gate on specific locations, you need to write down all possible locations.

```jldoctest; setup=:(using Yao)
julia> put(4, (1, 3)=>kron(X, Y))
nqubits: 4
put on (1, 3)
└─ kron
   ├─ 1=>X
   └─ 2=>Y
```

The outter locations creates a scope which make it seems to be a contiguous two qubits for the block inside `PutBlock`.

!!! tips
    It is better to use [`subroutine`](@ref) instead of `put` for large blocks, since put will use the matrix of its contents
    directly instead of making use of what's in it. `put` is more efficient for small blocks.
"""
put(total::Int, pa::Pair{NTuple{M,Int},<:AbstractBlock}) where {M} =
    PutBlock(total, pa.second, pa.first)
put(total::Int, pa::Pair{Int,<:AbstractBlock}) = PutBlock(total, pa.second, (pa.first,))
put(total::Int, pa::Pair{<:Any,<:AbstractBlock}) =
    PutBlock(total, pa.second, Tuple(pa.first))

"""
    put(pair) -> f(n)

Lazy curried version of [`put`](@ref).

### Examples

```jldoctest; setup=:(using Yao)
julia> put(1=>X)
(n -> put(n, 1 => X))
```
"""
put(pa::Pair) = @λ(n -> put(n, pa))

occupied_locs(x::PutBlock) = map(i -> x.locs[i], x.content |> occupied_locs)
chsubblocks(x::PutBlock, b::AbstractBlock) = PutBlock(x.n, b, x.locs)
PropertyTrait(::PutBlock) = PreserveAll()
cache_key(pb::PutBlock) = cache_key(pb.content)

mat(::Type{T}, pb::PutBlock{2,1}) where {T} = u1mat(pb.n, mat(T, pb.content), pb.locs...)
function mat(::Type{T}, pb::PutBlock{D,C}) where {T,D,C}
    return unmat(Val{D}(), nqudits(pb), mat(T, pb.content), pb.locs)
end

function YaoAPI.unsafe_apply!(r::AbstractRegister, pb::PutBlock{D}) where D
    isnoisy(pb.content) && return noisy_instruct!(r, pb.content, pb.locs)
    instruct!(r, mat_matchreg(r, pb.content), pb.locs)
    return r
end

function noisy_instruct!(r::AbstractRegister, pb::PutBlock{D}, locs) where {D}
    noisy_instruct!(r, pb.content, map(i -> locs[i], pb.locs))
end

# NOTE: Roger: these specialization should be removed after the new interpret
# mechanism is implemented
# specialization
for G in [:X, :Y, :Z, :T, :S, :Sdag, :Tdag, :H]
    GT = Expr(:(.), :ConstGate, QuoteNode(Symbol(G, :Gate)))
    @eval function YaoAPI.unsafe_apply!(r::AbstractRegister, pb::PutBlock{2,C,<:$GT}) where {C}
        instruct!(r, Val($(QuoteNode(G))), pb.locs)
        return r
    end
end

Base.adjoint(x::PutBlock) = PutBlock(nqudits(x), adjoint(content(x)), x.locs)
Base.copy(x::PutBlock) = PutBlock(x.n, x.content, x.locs)
function Base.:(==)(lhs::PutBlock{D,C,GT}, rhs::PutBlock{D,C,GT}) where {D,C,GT}
    return (lhs.n == rhs.n) && (lhs.content == rhs.content) && (lhs.locs == rhs.locs)
end

function YaoAPI.iscommute(x::PutBlock{D}, y::PutBlock{D}) where {D}
    _check_block_sizes(x, y)
    if x.locs == y.locs
        return iscommute(x.content, y.content)
    else
        return iscommute_fallback(x, y)
    end
end

"""
    Swap = PutBlock{2,2,G} where {G<:ConstGate.SWAPGate}
    Swap(n::Int, locs::Tuple{Int,Int})

Swap gate, which swaps two qubits.
"""
const Swap = PutBlock{2,2,G} where {G<:ConstGate.SWAPGate}

"""
    PSwap = PutBlock{2,2,RotationGate{2,T,G}} where {G<:ConstGate.SWAPGate}
    PSwap(n::Int, locs::Tuple{Int,Int}, θ::Real)

Parametrized swap gate that swaps two qubits with a phase, defined as

```math
{\\rm SWAP}(θ) = e^{-iθ{\\rm SWAP}/2}
```
"""
const PSwap{T} = PutBlock{2,2,RotationGate{2,T,G}} where {G<:ConstGate.SWAPGate}
Swap(n::Int, locs::Tuple{Int,Int}) = PutBlock(n, ConstGate.SWAPGate(), locs)
PSwap(n::Int, locs::Tuple{Int,Int}, θ::Real) =
    PutBlock(n, rot(ConstGate.SWAPGate(), θ), locs)

"""
    swap(n, loc1, loc2)

Create a `n`-qubit [`Swap`](@ref) gate which swap `loc1` and `loc2`.

### Examples

```jldoctest; setup=:(using Yao)
julia> swap(4, 1, 2)
nqubits: 4
put on (1, 2)
└─ SWAP
```
"""
swap(n::Int, loc1::Int, loc2::Int) = Swap(n, (loc1, loc2))

"""
    swap(loc1, loc2) -> f(n)

Create a lambda that takes the total number of active qubits as input. Lazy curried
version of `swap(n, loc1, loc2)`. See also [`Swap`](@ref).

### Examples

```jldoctest; setup=:(using Yao)
julia> swap(1, 2)
(n -> swap(n, 1, 2))
```
"""
swap(loc1::Int, loc2::Int) = @λ(n -> swap(n, loc1, loc2))

function mat(::Type{T}, g::Swap) where {T}
    mask = bmask(g.locs[1], g.locs[2])
    orders = map(b -> swapbits(b, mask) + 1, 0:1<<g.n-1)
    return PermMatrix(orders, ones(T, nlevel(g)^g.n))
end

YaoAPI.unsafe_apply!(r::AbstractRegister, g::Swap) = (instruct!(r, Val(:SWAP), g.locs); r)
occupied_locs(g::Swap) = g.locs

"""
    pswap(n::Int, i::Int, j::Int, α::Real)
    pswap(i::Int, j::Int, α::Real) -> f(n)

parametrized swap gate.

### Examples

```jldoctest; setup=:(using Yao)
julia> pswap(2, 1, 2, 0.1)
nqubits: 2
put on (1, 2)
└─ rot(SWAP, 0.1)
```
"""
pswap(n::Int, i::Int, j::Int, α::Real) = PSwap(n, (i, j), α)
pswap(i::Int, j::Int, α::Real) = n -> pswap(n, i, j, α)

for (G, GT) in [
    (:Rx, :(PutBlock{2,1,RotationGate{2, T,XGate}} where {T})),
    (:Ry, :(PutBlock{2,1,RotationGate{2, T,YGate}} where {T})),
    (:Rz, :(PutBlock{2,1,RotationGate{2, T,ZGate}} where {T})),
    (:PSWAP, :(PSwap)),
]
    @eval function YaoAPI.unsafe_apply!(reg::AbstractRegister, g::$GT)
        instruct!(reg, Val($(QuoteNode(G))), g.locs, g.content.theta)
        return reg
    end
end

function unsafe_getindex(::Type{T}, pb::PutBlock{D}, i::Integer, j::Integer) where {T,D}
    instruct_get_element(T, Val{D}(), nqudits(pb), pb.content, pb.locs, (), (), i, j)
end
function unsafe_getcol(::Type{T}, pb::PutBlock{D}, j::DitStr{D}) where {T,D}
    instruct_get_column(T, pb.content, pb.locs, (), (), j)
end

using Test, YaoAPI, YaoBlocks, YaoArrayRegister
using LuxurySparse

@testset "test constructors" begin
    g = ChainBlock(kron(2, 1 => X, 2 => Y), kron(2, 1 => phase(0.1)))

    @test g isa ChainBlock && g.n == 2 # default type
    @test g.blocks == [kron(2, X, Y), kron(2, 1 => phase(0.1))]
    blks = [X, Y, Rx(0.3)]
    @test_throws QubitMismatchError chsubblocks(g, blks) |> subblocks |> collect == blks
    @test chsubblocks(chain(X, Y, Z), X for _ = 1:3) |> subblocks |> collect == [X, X, X]

    c1 = ChainBlock(put(5, 1 => X), put(5, 3 => Y))
    c2 = ChainBlock(put(5, 4 => X), put(5, 5 => Y))
    @test iscommute(c1, c2)
    @test iscommute(c1, c2, c2)
    @test ishermitian(ChainBlock(c1, c2))

    c = ChainBlock(1, [X, Y])
    c[1] = put(1, 1 => X)
    @test c[1] == put(1, 1 => X)
    c = ChainBlock([X, Y])
    c[1] = put(1, 1 => X)
    @test c[1] == put(1, 1 => X)
    @test occupied_locs(chain(put(5, 2 => X), put(5, 3 => I2))) == (2,)
end

@testset "test chain" begin
    @test chain(kron(1 => X), control(2, 1 => X))(4) |> nqubits == 4
    @test chain(control(4, 2, 1 => X), kron(1 => X)) |> nqubits == 4
    @test chain(control(4, 2, 1 => X), kron(4, 1 => X)) |> nqubits == 4

    list = []
    push!(list, X)
    @test chain(list) == chain(X)

    @test chain(4, []) == chain(4)
    @test chain(X for _ = 1:3) == chain(X, X, X)
    @test chain(put(1 => X))(4) == chain(put(4, 1 => X))
    @test chain(put(1 => X), put(2 => X))(4) == chain(put(4, 1 => X), put(4, 2 => X))
    @test chain()(4) == chain(4)

    @test_throws ErrorException chain(4, 1 => X)
    @test_throws ErrorException chain(4, put(1 => X), 3 => X)

    @test_throws ErrorException chain(1 => chain())
    @test_throws ErrorException chain(4, 2:3 => kron(X, X))
    @test_throws QubitMismatchError apply!(rand_state(5), chain(X, X))
end

@testset "#15" begin
    @test chain(4, n -> kron(n, 1 => H)) isa ChainBlock
end

@testset "test operations" begin
    g = ChainBlock(kron(2, 1 => X, 2 => Y), kron(2, 1 => phase(0.1)))

    m = mat(kron(2, 1 => phase(0.1))) * mat(kron(2, X, Y))
    @test mat(g) ≈ m

    g = ChainBlock(kron(4, 1 => X, 2 => Y), kron(4, 1 => phase(0.1)))

    @test occupied_locs(g) == (1, 2)

    g = ChainBlock(kron(2, X, Y), kron(2, 1 => phase(0.1)))
    r = rand_state(2)
    @test statevec(apply!(copy(r), g)) ≈ mat(g) * r.state
    apply!(copy(r), g)

    @test chain(X, Y, Z, H)[2:4] == chain(Y, Z, H)

    @testset "copy" begin
        g = chain(phase(0.1))
        g1 = copy(g)
        g[1] = X
        @test g1[1] == phase(0.1)
    end

    @testset "similar" begin
        g = chain(X, Y, Z)
        @test similar(g) == chain(1)
    end

    @testset "push!" begin
        g = chain(2, put(1 => X))
        push!(g, put(2 => X))
        @test g == chain(2, put(1 => X), put(2 => X))
    end

    @testset "append!" begin
        g1 = chain(X, Y, Z)
        g2 = chain(Z, Z, Z)
        @test append!(g1, g2) == chain(X, Y, Z, Z, Z, Z) == g1
    end

    @testset "prepend!" begin
        g1 = chain(X, Y, Z)
        g2 = chain(Z, Z, Z)
        @test prepend!(g1, g2) == chain(Z, Z, Z, X, Y, Z) == g1
    end

    @testset "adjoint" begin
        @test adjoint(chain(X, Y, Z, H)) == chain(H, Z, Y, X)
        @test adjoint(chain(3)) == chain(3)
    end

    @testset "insert!" begin
        @test insert!(chain(X, Y, Z), 2, H) == chain(X, H, Y, Z)
    end
end

@testset "test iteration" begin
    test_list = [X, Y, phase(0.1), rot(X, 0.0)]
    g = ChainBlock(test_list)

    for (src, tg) in zip(g, test_list)
        @test src == tg
    end

    for (src, tg) in zip(eachindex(g), 1:length(test_list))
        @test src == tg
    end
end

@testset "additional" begin
    g = ChainBlock(X, Y)
    push!(g, Z)
    @test g[3] == Z

    append!(g, [rot(X, 0.0), rot(Y, 0.0)])
    @test g[4] == rot(X, 0.0)
    @test g[5] == rot(Y, 0.0)

    prepend!(g, [phase(0.1)])
    @test g[1] == phase(0.1)
    @test g[2] == X
    @test g[end] == rot(Y, 0.0)
    first = popfirst!(g)
    last = pop!(g)
    @test first == phase(0.1)
    @test last == rot(Y, 0.0)
    @test g == chain(1, [X, Y, Z, rot(X, 0.0)])
end

@testset "test addition" begin
    g = ChainBlock(X, Y)
    push!(g, Z)
    @test g[3] == Z

    append!(g, [rot(X, 0.0), rot(Y, 0.0)])
    @test g[4] == rot(X, 0.0)
    @test g[5] == rot(Y, 0.0)

    prepend!(g, [phase(0.1)])
    @test g[1] == phase(0.1)
    @test g[2] == X
    @test g[end] == rot(Y, 0.0)
    first = popfirst!(g)
    last = pop!(g)
    @test first == phase(0.1)
    @test last == rot(Y, 0.0)
    @test g == chain(1, [X, Y, Z, rot(X, 0.0)])
end


@testset "test inspect" begin
    # TODO: check traits when primitive blocks' traits are all defined
    g = ChainBlock(X, Y)
    @test isunitary(g) == true
    @test isreflexive(g) == false
    @test ishermitian(g) == false
    @test !isdiagonal(chain([X,Y]))
    @test isdiagonal(chain([Z,Z]))
    @test length(g) == 2
    @test eltype(g) == eltype(g.blocks)
    @test ishermitian(ChainBlock(put(2, 1=>X), put(2, 1=>2X)))
end

@testset "Yao/#204" begin
    @test mat(chain(2)) == IMatrix{ComplexF64}(4)
end

@testset "instruct_get_element" begin
    for pb in [chain(3), chain(put(3, 2=>Y)),
        chain(put(4, (4,2)=>matblock(rand_unitary(9); nlevel=3)), put(4, (3,)=>matblock(rand_unitary(3); nlevel=3)))
    ]
        mpb = mat(pb)
        allpass = true
        for i=basis(pb), j=basis(pb)
            allpass &= pb[i, j] == mpb[Int(i)+1, Int(j)+1]
        end
        @test allpass
        allpass = true
        for j=basis(pb)
            allpass &= vec(pb[:, j]) == mpb[:, Int(j)+1]
            allpass &= vec(pb[:, EntryTable([j], [1.0+0im])]) == mpb[:, Int(j)+1]
            allpass &= vec(pb[j,:]) == mpb[Int(j)+1,:]
            allpass &= vec(pb[EntryTable([j], [1.0+0im]),:]) == mpb[Int(j)+1,:]
            allpass &= isclean(pb[:,j])
        end
        @test allpass
    end
end

@testset "chain construction bug fix" begin
    cz_phase = chain(cz(2, 2, 1), put(2 => shift(0.1)))
    @test length(cz_phase) == 2
end

export RotationGate, Rx, Ry, Rz, rot

"""
    RotationGate{D,T,GT<:AbstractBlock{D}} <: PrimitiveBlock{D}

RotationGate, with GT both hermitian and isreflexive.

# Definition

Expression `rot(G, θ)` defines the following gate

```math
\\cos \\frac{\\theta}{2}I - i \\sin \\frac{\\theta}{2} G
```
"""
mutable struct RotationGate{D,T,GT<:AbstractBlock{D}} <: PrimitiveBlock{D}
    block::GT
    theta::T
    function RotationGate{D,T,GT}(block::GT, theta) where {D,T,GT<:AbstractBlock{D}}
        ishermitian(block) && isreflexive(block) ||
            throw(ArgumentError("Gate type $GT is not hermitian or not isreflexive."))
        new{D,T,GT}(block, T(theta))
    end
end

RotationGate(block::GT, theta::T) where {D,T,GT<:AbstractBlock{D}} =
    RotationGate{D,T,GT}(block, theta)
RotationGate(block::GT, theta::Integer) where {D,GT<:AbstractBlock{D}} =
    RotationGate{D,Float64,GT}(block, Float64(theta))
nqudits(rg::RotationGate) = nqudits(rg.block)

# bindings
"""
    Rx(theta)

Return a [`RotationGate`](@ref) on X axis.

# Example

```jldoctest; setup=:(using YaoBlocks)
julia> Rx(0.1)
rot(X, 0.1)
```
"""
Rx(theta) = RotationGate(X, theta)

"""
    Ry(theta)

Return a [`RotationGate`](@ref) on Y axis.

# Example

```jldoctest; setup=:(using YaoBlocks)
julia> Ry(0.1)
rot(Y, 0.1)
```
"""
Ry(theta) = RotationGate(Y, theta)

"""
    Rz(theta)

Return a [`RotationGate`](@ref) on Z axis.

# Example

```jldoctest; setup=:(using YaoBlocks)
julia> Rz(0.1)
rot(Z, 0.1)
```
"""
Rz(theta) = RotationGate(Z, theta)

"""
    rot(U, theta)

Return a [`RotationGate`](@ref) on U axis.
"""
rot(axis::AbstractBlock, theta) = RotationGate(axis, theta)

content(x::RotationGate) = x.block
chcontent(x::RotationGate, gen::AbstractBlock) = RotationGate(gen, x.theta)
# General definition
function mat(::Type{T}, R::RotationGate{D}) where {D,T}
    I = IMatrix{T}(D^nqudits(R))
    return I * cos(T(R.theta) / 2) - im * sin(T(R.theta) / 2) * mat(T, R.block)
end

# Specialized
mat(::Type{T}, R::RotationGate{D,<:Any,<:XGate}) where {D,T} =
    T[cos(R.theta / 2) -im*sin(R.theta / 2); -im*sin(R.theta / 2) cos(R.theta / 2)]
mat(::Type{T}, R::RotationGate{D,<:Any,<:YGate}) where {D,T} =
    T[cos(R.theta / 2) -sin(R.theta / 2); sin(R.theta / 2) cos(R.theta / 2)]
# mat(R::RotationGate{1, T, ZGate{Complex{T}}}) where T =
#     SMatrix{2, 2, Complex{T}}(cos(R.theta/2)-im*sin(R.theta/2), 0, 0, cos(R.theta/2)+im*sin(R.theta/2))

function YaoAPI.unsafe_apply!(r::AbstractArrayReg{D}, rb::RotationGate{D}) where D
    v0 = copy(r.state)
    unsafe_apply!(r, rb.block)
    # NOTE: we should not change register's memory address,
    # or batch operations may fail
    r.state .= (-im * sin(rb.theta / 2)) .* r.state .+ cos(rb.theta / 2) .* v0
    return r
end
function YaoAPI.unsafe_apply!(r::DensityMatrix{D,T}, rb::RotationGate{D}) where {T,D}
    m = mat(T, rb)
    r.state .= m * r.state * m'
    return r
end

# parametric interface
niparams(::Type{<:RotationGate}) = 1
getiparams(x::RotationGate) = x.theta
# no need to specify the type of param, Julia will try to do the conversion
setiparams!(r::RotationGate, param::Number) = (r.theta = param; r)
setiparams(r::RotationGate, param::Number) = RotationGate(r.block, param)
render_params(::RotationGate{D,T}, ::Val{:random}) where {D,T} = (T(rand()*2π),)

# fallback to matrix methods if it is not real
YaoAPI.isunitary(r::RotationGate{D,<:Real}) where {D} = true

function YaoAPI.isunitary(r::RotationGate)
    isreal(r.theta) && return true
    @warn "θ in RotationGate is not real, got θ=$(r.theta), fallback to matrix-based method"
    return isunitary(mat(r))
end
YaoAPI.isdiagonal(op::RotationGate) = isdiagonal(op.block)

Base.adjoint(blk::RotationGate) = RotationGate(blk.block, -blk.theta)
Base.copy(R::RotationGate) = RotationGate(R.block, R.theta)
Base.:(==)(lhs::RotationGate{TA,GTA}, rhs::RotationGate{TB,GTB}) where {TA,TB,GTA,GTB} =
    false
Base.:(==)(lhs::RotationGate{TA,GT}, rhs::RotationGate{TB,GT}) where {TA,TB,GT} =
    lhs.theta == rhs.theta

cache_key(R::RotationGate) = R.theta

iparams_range(::RotationGate{D,T,GT}) where {D,T,GT} = ((zero(T), T(2 * pi)),)

occupied_locs(g::RotationGate) = (1:nqudits(g)...,)

function unsafe_getindex(::Type{T}, rg::RotationGate{D}, i::Integer, j::Integer) where {D,T}
    return (i==j ? cos(T(rg.theta)/2) : zero(T)) - im * sin(T(rg.theta)/2) * unsafe_getindex(T, rg.block, i, j)
end
function unsafe_getcol(::Type{T}, rg::RotationGate{D}, j::DitStr{D}) where {D,T}
    rows, vals = unsafe_getcol(T, rg.block, j)
    rmul!(vals, -im * sin(T(rg.theta)/2))
    push!(rows, j)
    push!(vals, cos(T(rg.theta)/2))
    return rows, vals
end

"""
    dump_gate(blk::AbstractBlock) -> Expr

convert a gate to a YaoScript expression for serization.
The fallback is `GateTypeName(fields...)`
"""
function dump_gate end

function dump_gate(blk::ConstantGate)
    Symbol("$(typeof(blk).name.name)"[1:end-4])
end

function dump_gate(blk::ControlBlock)
    pairs = [:($b => C($c)) for (b, c) in zip(blk.ctrl_locs, blk.ctrl_config)]
    :($(pairs...), $(blk.locs) => $(dump_gate(blk.content)))
end

function dump_gate(blk::ChainBlock)
    Expr(:block, [dump_gate(b) for b in blk]...)
end

function dump_gate(blk::RotationGate)
    :(rot($(dump_gate(blk.block)), $(tokenize_param(blk.theta))))
end

function dump_gate(blk::TimeEvolution)
    :(time($(tokenize_param(blk.dt))) => $(dump_gate(blk.H)))
end

function dump_gate(blk::PutBlock)
    :($(blk.locs) => $(dump_gate(blk.content)))
end

function dump_gate(blk::KronBlock)
    if any(x -> nqubits(x) != 1, subblocks(blk))
        error("unsupported multi-qubit in kron while dumping to Yao script.")
    end
    if length(occupied_locs(blk)) == nqudits(blk)
        :(kron($([dump_gate(blk[i]) for i = 1:nqudits(blk)]...)))
    else
        :(($([:($i => $(dump_gate(g))) for (i, g) in blk]...),))
    end
end

function dump_gate(blk::RepeatedBlock)
    :(repeat($(blk.locs...)) => $(dump_gate(blk.content)))
end

function dump_gate(blk::Add)
    :(+($(dump_gate.(subblocks(blk))...)))
end

function dump_gate(blk::Daggered)
    :($(dump_gate(blk.content))')
end

function dump_gate(blk::CachedBlock)
    :(cache($(dump_gate(blk.content))))
end

function dump_gate(blk::Scale)
    :($(factor(blk)) * $(dump_gate(blk.content)))
end

function dump_gate(blk::Measure)
    if blk.operator == ComputationalBasis()
        MOP = :(Measure)
    else
        MOP = :(Measure($(dump_gate(blk.operator))))
    end
    locs = blk.locations isa AllLocs ? :ALL : blk.locations
    if blk.postprocess isa NoPostProcess
        :($locs => $MOP)
    elseif blk.postprocess isa ResetTo
        :($locs => $MOP => resetto($(blk.postprocess.x...)))
    elseif blk.postprocess isa RemoveMeasured
        :($locs => $MOP => remove)
    end
end

function dump_gate(blk::Subroutine)
    :(focus($(blk.locs...)) => $(dump_gate(blk.content)))
end

tokenize_param(param::Number) = param

yaotoscript(block::AbstractBlock) =
    Expr(:block, :(nqubits = $(nqudits(block))), dump_gate(block)) |> rmlines
function yaotoscript(block::ChainBlock)
    ex = dump_gate(block)
    Expr(:let, Expr(:block, :(nqubits = $(nqudits(block))), :(version = "0.6")), ex)
end
yaotofile(filename::String, block) = write(filename, string(yaotoscript(block)))

macro dumpload_fallback(blocktype, fname)
    quote
        function YaoBlocks.dump_gate(blk::$(esc(blocktype)))
            vars = [getproperty(blk, x) for x in fieldnames($(esc(blocktype)))]
            Expr(:call, $(QuoteNode(fname)), vars...)
        end
        function YaoBlocks.gate_expr(::Val{$(QuoteNode(fname))}, args, info)
            Expr(:call, $(QuoteNode(fname)), render_arg.(args, Ref(info))...)
        end
    end
end

using Test, Random, LinearAlgebra, YaoArrayRegister, YaoBlocks, YaoAPI
using SparseArrays: sprand
using YaoArrayRegister.LuxurySparse: pmrand

A = rand(ComplexF64, 4, 4)
mg = matblock(A)
mg2 = copy(mg)
@test mg2 == mg
@test mat(ComplexF64, mg) ≈ A
@test_logs (:warn,) mat(ComplexF32, mg)

mg2.mat[:, 2] .= 10
@test mg2 != mg
@test nqubits(mg) == 2
@test_throws ArgumentError matblock(randn(3, 3))
@test matblock(randn(3, 3); nlevel=3) isa GeneralMatrixBlock

reg = rand_state(2)
@test apply!(copy(reg), mg) |> statevec == mat(mg) * reg.state |> vec

@test matblock(X) == GeneralMatrixBlock(mat(X))

a = rand_unitary(2)
@test mat(matblock(a))' == mat(matblock(a)')

# fallback test #59, return a correct matrix type for matblock
a = rand_unitary(2) .|> ComplexF32
@test eltype(mat(matblock(a))) == ComplexF32

@test !isdiagonal(matblock(randn(64, 64)))
@test isdiagonal(matblock(Diagonal(randn(128))))

@testset "instruct_get_element" begin
    for pb in [matblock(mat(kron(X,X))),
            matblock(rand_unitary(9); nlevel=3),
            matblock(mat(igate(2))),
            matblock(sprand(ComplexF64, 4,4,0.5)),
            ]
        mpb = mat(pb)
        allpass = true
        for i=basis(pb), j=basis(pb)
            allpass &= pb[i, j] == mpb[Int(i)+1, Int(j)+1]
        end
        @test allpass

        allpass = true
        for j=basis(pb)
            allpass &= vec(pb[:, j]) == mpb[:, Int(j)+1]
            allpass &= vec(pb[j,:]) == mpb[Int(j)+1,:]
            allpass &= isclean(pb[:,j])
        end
        @test allpass
    end
end

@testset "setting index" begin
    h = matblock(zeros(ComplexF64, 2, 2))
    h[bit"1", bit"0"] = 1
    @test ishermitian(h + h')
end

using YaoBlocks, YaoArrayRegister, LinearAlgebra
using Test

@testset "check apply" begin
    r = rand_state(1)
    @test_throws ErrorException UnitaryChannel([X, Y, Z], [1, 0.2, 0])
    channel = UnitaryChannel([X, Y, Z], [1, 0, 0])
    print(channel)
    k1 = cache_key(channel)
    k2 = cache_key(chsubblocks(channel, [Z, Z, Z]))
    @test k1 != k2
    # broken because Unitary channel does not have a matrix representation
    @test_throws ErrorException apply!(copy(r), channel)
    @test apply!(density_matrix(r), channel) ≈ density_matrix(apply!(copy(r), X))

    r = rand_state(3)
    @test_throws QubitMismatchError apply!(copy(r), channel)
end

@testset "check mat" begin
    @test_throws ErrorException mat(UnitaryChannel([X, Y, Z], [1, 0, 0]))
end

@testset "check compare" begin
    @test UnitaryChannel([X, Y, Z], [1, 0, 0]) == UnitaryChannel([X, Y, Z], [1, 0, 0])
    @test_throws AssertionError UnitaryChannel([X, Y], [1, 1, 0])
end

@testset "check adjoint" begin
    channel = UnitaryChannel([X, Y, Z], [0.2, 0.8, 0.0])
    adj_channel = adjoint(channel)
    @test adjoint.(adj_channel.operators) == channel.operators
end

@testset "check ocuppied locations" begin
    channel = UnitaryChannel(put.(6, [1 => X, 3 => Y, 5 => Z]), [0.1, 0.2, 0.7])
    @test occupied_locs(channel) == [1, 3, 5]
end

@testset "density matrix" begin
    @test_throws ErrorException UnitaryChannel(put.(6, [1 => X, 3 => Y, 5 => Z]), [0.1, 0.3, 0.1])
    ops = put.(6, [1 => chain(Rx(0.4), Ry(0.5), Rz(0.4)), 3 => Y, 5 => Z])
    channel = UnitaryChannel(ops, [0.3, 0.1, 0.6])
    r = density_matrix(rand_state(12), (3,2,1,5,6,9))
    ms = mat.(ops)
    @test apply(r, channel).state ≈ channel.probs[1] * ms[1] * r.state * ms[1]' + channel.probs[2] * ms[2] * r.state * ms[2]' + channel.probs[3] * ms[3] * r.state * ms[3]'

    channel1 = unitary_channel([put(6, 2=>chain(Rx(0.4), Ry(0.5), Rz(0.4))), put(6, 3=>Y), put(6, 2=>Z)], [0.3, 0.1, 0.6])
    ops = unitary_channel([put(2, 1=>chain(Rx(0.4), Ry(0.5), Rz(0.4))), put(2,2=>Y), put(2,1=>Z)], [0.3, 0.1, 0.6])
    channel2 = put(6, (2,3)=>ops)
    @test apply(r, channel1) ≈ apply(r, channel2)
end

@testset "kron and repeat" begin
    dm = density_matrix(ghz_state(5), 1:3)
    dpolarizing = single_qubit_depolarizing_channel(0.1)
    dmkron = apply(dm, kron(3, 1=>dpolarizing, 2=>dpolarizing))
    dmrepeat = apply(dm, repeat(3, dpolarizing, (1, 2)))
    dmput = apply(apply(dm, put(3, 1=>dpolarizing)), put(3, 2=>dpolarizing))
    @test dmkron ≈ dmrepeat
    @test dmkron ≈ dmput
end

@testset "kron" begin
    n_qubits = 3
    op1 = matblock(rand_unitary(2))
    op2 = matblock(rand_unitary(2))
    mixed_unitary_channel = MixedUnitaryChannel([op1, op2], [0.5, 0.5])
    mixed_unitary_channel2 = MixedUnitaryChannel([op1, op2], [0.5, 0.5])
    mixed_unitary_channel3 = kron(mixed_unitary_channel, mixed_unitary_channel2)

    circ1 = chain(n_qubits, put(n_qubits, 1 => mixed_unitary_channel), put(n_qubits, 2 => mixed_unitary_channel2))
    circ2 = chain(n_qubits, put(n_qubits, (1, 2) => mixed_unitary_channel3))

    reg = rand_state(n_qubits)
    @test noisy_simulation(reg, circ1) ≈ noisy_simulation(reg, circ2)
end

@testset "depolarizing channel - constructor" begin
    n_qubits = 2
    p = 0.1
    depolarizing = DepolarizingChannel(n_qubits, p)
    @test cache_key(depolarizing) isa UInt64
    @test depolarizing == copy(depolarizing)
    @test depolarizing' == depolarizing
    @test subblocks(depolarizing) == ()
    @test occupied_locs(depolarizing) == (1, 2)
end

@testset "depolarizing channel - representations" begin
    for n_qubits in [1, 3]
        p = 0.1
        depolarizing = DepolarizingChannel(n_qubits, p)
        mixed_unitary_channel = MixedUnitaryChannel(depolarizing)
        @test SuperOp(depolarizing) ≈ SuperOp(mixed_unitary_channel)

        # test apply
        r = rand_state(n_qubits)
        rho = density_matrix(r)
        r1 = apply(rho, depolarizing)
        r2 = apply(rho, mixed_unitary_channel)
        expected_state = (1-p) * rho.state + p/(2^n_qubits) * IMatrix(size(rho.state, 1))
        @test tr(expected_state) ≈ 1
        @test tr(r1.state) ≈ 1
        @test tr(r2.state) ≈ 1
        @test r1.state ≈ expected_state
        @test r2.state ≈ expected_state
    end
end

using Test, YaoBlocks, YaoArrayRegister
import YaoBlocks.ConstGate: Toffoli
using YaoAPI: QubitMismatchError
using LinearAlgebra: I

@testset "construction" begin
    @test X + Y + Z == +(X, Y, Z)
    @test sum([X, Y, Z]) == +(X, Y, Z)
    @test X + (Y + Z) == Add(X, Add(Y, Z))

    @test X * Y * Z == *(X, Y, Z)
    @test X * (Y * Z) == *(X, *(Y, Z))
    @test Val(im) * X == Scale(Val(im), X)
    @test X * Val(im) == Scale(Val(im), X)
    @test X * im == Scale(im, X)
    @test im * X == Scale(im, X)
    @test Val(im) * (Val(im) * X) == Scale(Val(-1+0im), X)
    @test im * (im * X) == Scale(-1+0im, X)
    @test (Val(im) * X) * Val(im) == Scale(Val(-1+0im), X)
    @test (im * X) * im == Scale(-1+0im, X)

    @test mat(X - Y) ≈ mat(X) - mat(Y)
    @test mat(X / 2) ≈ 0.5 * mat(X)
end


@testset "block operations" begin
    r = rand_state(1)
    @test copy(r) |> X * Y * Z |> state ≈ mat(X * Y * Z) * state(r)
    @test copy(r) |> X + Y + Z |> state ≈ mat(X + Y + Z) * state(r)
end

@testset "empty add" begin
    c = Add(4)
    @test mat(Float64, c) == zeros(16, 16)
end

@testset "algebra" begin
    @test factor(-X) == -1
    @test -(-X) === X
    @test factor(-(2X)) === -2
    @test factor((2X)*(2X)) == 4
    @test factor((2X)*Y) == 2
    @test factor(X*(2Y)) == 2
    @test 2(-X) isa Scale{Int, 2, Scale{Val{-1}, 2, XGate}}
    @test mat(X^2) ≈ Matrix(I, 2, 2)
end

using YaoBlocks, LuxurySparse, SparseArrays, LinearAlgebra
using YaoBlocks.AD
using Test, Random

@testset "zero rand!" begin
    T = ComplexF64
    D = 10
    Random.seed!(2)
    for pm in [pmrand(T, D), Diagonal(randn(T, D)), sprand(T, D, D, 0.4)]
        z = zero(pm)
        @test z == zeros(D, D)
    end
end

using Test
using YaoBlocks
using YaoArrayRegister
using LinearAlgebra

@testset "basic error channels" begin
    dm = rand_density_matrix(3)
    ch = put(3, 1 => phase_flip_channel(0.2))
    opZ = mat(put(3, 1=>Z))
    @test 0.8 * dm.state + 0.2 * opZ * dm.state * opZ ≈ apply(dm, ch).state

    dm = rand_density_matrix(3)
    ch = put(3, 1 => bit_flip_channel(0.2))
    opX = mat(put(3, 1=>X))
    @test 0.8 * dm.state + 0.2 * opX * dm.state * opX ≈ apply(dm, ch).state

    dm = rand_density_matrix(3)
    ch = depolarizing_channel(3; p=0.2)
    @test (0.8 .* dm.state .+ (0.2 / 2^3) .* IMatrix(1<<3)) ≈ apply(dm, ch).state

    dm = rand_density_matrix(3)
    ch = depolarizing_channel(3, p=1.)
    @test apply(dm, ch).state ≈ IMatrix(1<<3) ./ 2^3

    dm = rand_density_matrix(1)
    ch1 = put(1, 1 => single_qubit_depolarizing_channel(0.1))
    ch2 = depolarizing_channel(1, p=0.1)
    @test apply(dm, ch1) ≈ apply(dm, ch2)

    dm = rand_density_matrix(2)
    ch1 = put(2, (1, 2) => two_qubit_depolarizing_channel(0.1))
    ch2 = depolarizing_channel(2, p=0.1)
    @test apply(dm, ch1) ≈ apply(dm, ch2)
end

@testset "pauli channel" begin
    dm = rand_density_matrix(3)
    ch = put(3, 1 => pauli_error_channel(pz=0.2, py=0.1, px=0.3))
    opX = mat(put(3, 1=>X))
    opY = mat(put(3, 1=>Y))
    opZ = mat(put(3, 1=>Z))

    @test 0.4 * dm.state + 0.3 * opX * dm.state * opX + 
        0.1 * opY * dm.state * opY +
        0.2 * opZ * dm.state * opZ ≈ apply(dm, ch).state
end

export Subroutine, subroutine

"""
    Subroutine{D, BT <: AbstractBlock, C} <: AbstractContainer{BT, D}

Subroutine node on given locations. This allows you to shoehorn a smaller
circuit to a larger one.
"""
struct Subroutine{D,BT<:AbstractBlock,C} <: AbstractContainer{BT,D}
    n::Int
    content::BT
    locs::NTuple{C,Int}
end

function Subroutine(n::Int, block::BT, locs::NTuple{C,Int}) where {D,C,BT<:AbstractBlock{D}}
    @assert_locs_safe n locs
    if !(length(locs) == nqudits(block) && n>= nqudits(block))
        throw(
            LocationConflictError(
                "length of locs must be equal to the size of block, and smaller than size of itself.",
            ),
        )
    end
    return Subroutine{D,BT,C}(n, block, locs)
end
YaoAPI.nqudits(b::Subroutine) = b.n

"""
    subroutine(n, block, locs)

Create a `n`-qudit [`Subroutine`](@ref) block, where the `subblock` is a subprogram of size `m`, and `locs` is a tuple or range of length `m`.
It runs a quantum subprogram with smaller size on a subset of locations.
While its mathematical definition is the same as the [`put`](@ref) block, while it is more suited for running a larger chunk of circuit.

### Examples

Subroutine is equivalent to [`put`](@ref) a block on given position mathematically, but more efficient
and convenient for large blocks.

```jldoctest; setup=:(using Yao)
julia> r = rand_state(3)
ArrayReg{2, ComplexF64, Array...}
    active qubits: 3/3
    nlevel: 2

julia> apply!(copy(r), subroutine(X, 1)) ≈ apply!(copy(r), put(1=>X))
true
```

It works for in-contigious locs as well

```jldoctest; setup=:(using Yao)
julia> r = rand_state(4)
ArrayReg{2, ComplexF64, Array...}
    active qubits: 4/4
    nlevel: 2

julia> cc = subroutine(4, kron(X, Y), (1, 3))
nqubits: 4
Subroutine: (1, 3)
└─ kron
   ├─ 1=>X
   └─ 2=>Y

julia> pp = chain(4, put(1=>X), put(3=>Y))
nqubits: 4
chain
├─ put on (1)
│  └─ X
└─ put on (3)
   └─ Y

julia> apply!(copy(r), cc) ≈ apply!(copy(r), pp)
true
```
"""
function subroutine(n::Int, block::AbstractBlock, locs)
    return Subroutine(n, block, Tuple(locs))
end

# support lazy qubits
subroutine(n::Int, block::Function, locs) =
    subroutine(n, parse_block(length(locs), block), locs)

"""
    subroutine(block, locs) -> f(n)

Lazy curried version of [`subroutine`](@ref).
"""
subroutine(block::AbstractBlock, locs) = @λ(n -> subroutine(n, block, locs))
subroutine(block::Function, locs) = @λ(n -> subroutine(n, block, locs))

occupied_locs(c::Subroutine) = map(i -> c.locs[i], c.content |> occupied_locs)
chsubblocks(pb::Subroutine{D}, blk::AbstractBlock{D}) where {D} = Subroutine(pb.n, blk, pb.locs)
PropertyTrait(::Subroutine) = PreserveAll()

function YaoAPI.unsafe_apply!(r::AbstractRegister, c::Subroutine)
    focus!(r, c.locs)
    YaoAPI.unsafe_apply!(r, c.content)
    relax!(r, c.locs, to_nactive = nqudits(c))
    return r
end

function mat(::Type{T}, c::Subroutine{D,<:AbstractBlock}) where {D,T}
    mat(T, PutBlock(c.n, c.content, c.locs))
end

Base.adjoint(blk::Subroutine) = Subroutine(blk.n, adjoint(blk.content), blk.locs)

function Base.:(==)(a::Subroutine{D,BT}, b::Subroutine{D,BT}) where {D,BT}
    return a.n == b.n && a.content == b.content && a.locs == b.locs
end

YaoAPI.nactive(c::Subroutine) = length(c.locs)

function YaoAPI.iscommute(x::Subroutine{D}, y::Subroutine{D}) where {D}
    _check_block_sizes(x, y)
    isempty(setdiff(occupied_locs(x), occupied_locs(y))) && return true
    if x.locs == y.locs
        return iscommute(x.content, y.content)
    else
        return iscommute_fallback(x, y)
    end
end

function unsafe_getindex(::Type{T}, sr::Subroutine{D}, i::Integer, j::Integer) where {T,D}
    instruct_get_element(T, Val{D}(), nqudits(sr), sr.content, sr.locs, (), (), i, j)
end
function unsafe_getcol(::Type{T}, pb::Subroutine{D}, j::DitStr{D}) where {T,D}
    instruct_get_column(T, pb.content, pb.locs, (), (), j)
end

using Test, YaoBlocks, YaoArrayRegister
using YaoBlocks.ConstGate
using SparseArrays
using LinearAlgebra

@testset "construct" begin
    @test_throws AssertionError put(2, 1 => swap(2, 1, 2))
end

@testset "apply!" begin
    n = 6
    Reg = rand_state(n)

    pb = PutBlock(n, X, (3,))
    @test copy(pb) == pb
    rb = repeat(n, X, (3,))
    @test apply!(copy(Reg), pb) ≈ apply!(copy(Reg), rb)
    @test pb |> applymatrix ≈ mat(pb)
    pb = PutBlock(n, rot(X, 0.3), (3,))
    @test pb |> applymatrix ≈ mat(pb)

    pb = PutBlock(n, rot(CNOT, 0.3), (6, 3))
    @test pb |> applymatrix ≈ mat(pb)
    pb = PutBlock(n, matblock(mat(rot(CNOT, 0.3)) |> Matrix), (6, 3))
    @test pb |> applymatrix ≈ mat(pb)

    pb = PutBlock(n, rot(X, 0.3), (3,))
    @test pb |> applymatrix ≈ mat(pb)
    pb = PutBlock(n, matblock(mat(rot(X, 0.3)) |> Matrix), (3,))
    @test pb |> applymatrix ≈ mat(pb)

    Cb = control(n, (3,), 5 => X)
    pb = PutBlock(n, CNOT, (3, 5))
    @test apply!(copy(Reg), Cb) ≈ apply!(copy(Reg), pb)

    blks = [control(2, 1, 2 => Z)]
    @test (chsubblocks(pb, blks) |> subblocks .== blks) |> all

    pb = PutBlock(1000, X, (3,))
    @test pb |> ishermitian
    @test pb |> isunitary
    @test pb |> isreflexive

    @test_throws QubitMismatchError apply!(rand_state(4), put(1000, 2 => Rx(0.4)))
    @test_throws MethodError apply!(rand_state(4), put(4, 2 => matblock(randn(3,3); nlevel=3)))
end

@testset "test swap gate" begin
    include("swap_gate.jl")
end

@testset "rotation gate" begin
    reg = rand_state(5)
    @test apply!(copy(reg), put(5, 2 => Rx(0.3))) |> state ≈
          mat(put(5, 2 => Rx(0.3))) * reg.state
    @test apply!(copy(reg), put(5, 2 => Ry(0.3))) |> state ≈
          mat(put(5, 2 => Ry(0.3))) * reg.state
    @test apply!(copy(reg), put(5, 2 => Rz(0.3))) |> state ≈
          mat(put(5, 2 => Rz(0.3))) * reg.state
end

@testset "operators" begin
    @test size(mat(put(2,1=>matblock(rand_unitary(3); nlevel=3)))) == (9, 9)
    @test size(mat(repeat(2,matblock(rand_unitary(3); nlevel=3)))) == (9, 9)
end

@testset "put matrix" begin
    u = sparse(randn(ComplexF64, 2, 2))
    m1 = mat(put(10, (4,)=>matblock(u)))
    m2 = invoke(YaoBlocks.unmat, Tuple{Val,Int,AbstractMatrix,NTuple}, Val{2}(), 10, u, (4,))
    @test m1 ≈ m2

    u = sparse(randn(ComplexF64, 4, 4))
    m1 = mat(put(10, (2,4)=>matblock(u)))
    m2 = invoke(YaoBlocks.unmat, Tuple{Val,Int,AbstractMatrix,NTuple}, Val{2}(), 10, u, (2,4))
    @test nnz(m1) == nnz(m2)
    @test m1 ≈ m2

    u = randn(ComplexF64, 8, 8)
    m1 = mat(put(10, (4,2,9)=>matblock(u)))
    m2 = invoke(YaoBlocks.unmat, Tuple{Val,Int,AbstractMatrix,NTuple}, Val{2}(), 10, u, (4,2,9))
    @test m1 ≈ m2

    RP1 = matblock(rand_unitary(3); nlevel=3)
    RNr = matblock(rand_unitary(3); nlevel=3)
    @test mat(put(5, 2=>RP1)) ≈ kron(Matrix(I,27,27), mat(RP1), Matrix(I, 3,3))
    @test mat(put(5, (2,3)=>kron(RNr,RP1))) ≈ kron(Matrix(I,9,9), mat(RP1), mat(RNr), Matrix(I, 3,3))

    # corner case, single qubit gate
    @test mat(put(1, 1=>RP1)) ≈ mat(RP1)
end

@testset "instruct_get_element" begin
    for pb in [put(3, 2=>Y), put(4, (4,2)=>matblock(rand_unitary(9); nlevel=3))]
        mpb = mat(pb)
        allpass = true
        for i=basis(pb), j=basis(pb)
            allpass &= pb[i, j] == mpb[Int(i)+1, Int(j)+1]
        end
        @test allpass

        allpass = true
        for j=basis(pb)
            allpass &= vec(pb[:, j]) == mpb[:, Int(j)+1]
            allpass &= vec(pb[:, EntryTable([j], [1.0+0im])]) == mpb[:, Int(j)+1]
            allpass &= vec(pb[j,:]) == mpb[Int(j)+1,:]
            allpass &= vec(pb[EntryTable([j], [1.0+0im]),:]) == mpb[Int(j)+1,:]
            allpass &= isclean(pb[:,j])
        end
        @test allpass
    end
end

export mat_back!, mat_back
############### Primitive
"""
The matrix gradient of a rotation block.
"""
@inline function rotgrad(::Type{T}, rb::RotationGate{D}) where {D,T}
    -sin(rb.theta / 2) / 2 * IMatrix(D^nqudits(rb)) +
    im / 2 * cos(rb.theta / 2) * conj(mat(T, rb.block))
end

function mat_back!(::Type{T}, rb::RotationGate{D,RT}, adjy, collector) where {T,D,RT}
    pushfirst!(collector, projection(rb.theta, sum(adjy .* rotgrad(T, rb))))
end

function mat_back!(::Type{T}, rb::TimeEvolution, adjy, collector) where {T}
    pushfirst!(
        collector,
        projection(rb.dt, im * _sum_A_Bconj(adjy, mat(T, rb.H) * mat(T, rb))),
    )
end

#=
function mat_back!(::Type{T}, A::GeneralMatrixBlock, adjy, collector) where T
    for i in length(adjy):-1:1
        pushfirst!(collector, adjy[i])
    end
end
=#

function mat_back!(::Type{T}, rb::PhaseGate, adjy, collector) where {T}
    s = exp(-im * rb.theta)
    res = -1im * (adjy[1, 1] * s + adjy[2, 2] * s)
    pushfirst!(collector, projection(rb.theta, res))
end

function mat_back!(::Type{T}, rb::ShiftGate, adjy, collector) where {T}
    res = -1im * adjy[2, 2] * exp(-1im * rb.theta)
    pushfirst!(collector, projection(rb.theta, res))
end

######################## Composite
function mat_back!(::Type{T}, rb::AbstractBlock, adjy, collector) where {T}
    nparameters(rb) == 0 && return collector
    throw(MethodError(mat_back!, (T, rb, adjy, collector)))
end

function mat_back!(::Type{T}, rb::PutBlock{D,C,RT}, adjy, collector) where {T,D,C,RT}
    nparameters(rb) == 0 && return collector
    adjm = adjcunmat(adjy, nqudits(rb), (), (), mat(T, content(rb)), rb.locs)
    mat_back!(T, content(rb), adjm, collector)
end

function mat_back!(::Type{T}, rb::Subroutine, adjy, collector) where {T}
    nparameters(rb) == 0 && return collector
    adjm = adjcunmat(adjy, nqudits(rb), (), (), mat(T, content(rb)), rb.locs)
    mat_back!(T, content(rb), adjm, collector)
end

function mat_back!(::Type{T}, rb::CachedBlock, adjy, collector) where {T}
    mat_back!(T, content(rb), adjy, collector)
end

function mat_back!(::Type{T}, rb::Daggered, adjy, collector) where {T}
    mat_back!(T, content(rb), adjy', collector)
end

function mat_back!(::Type{T}, rb::ControlBlock, adjy, collector) where {T}
    nparameters(rb) == 0 && return collector
    adjm = adjcunmat(adjy, nqudits(rb), rb.ctrl_locs, rb.ctrl_config, mat(T, content(rb)), rb.locs)
    mat_back!(T, content(rb), adjm, collector)
end

function mat_back!(::Type{T}, rb::ChainBlock{D}, adjy, collector) where {T,D}
    np = nparameters(rb)
    np == 0 && return collector
    length(rb) == 1 && return mat_back!(T, rb[1], adjy, collector)

    # cache the tape
    mi = mat(T, rb[1])
    cache = Any[mi]
    for b in rb[2:end-1]
        mi = mat(T, b) * mi
        push!(cache, mi)
    end
    adjb = adjy * cache[end]'
    for ib = length(rb):-1:1
        b = rb[ib]
        #adjb = ib==1 ? adjy : adjy*cache[ib]'
        mat_back!(T, b, adjb, collector)
        if ib != 1
            if adjb isa DenseMatrix
                adjb = apply!(ArrayReg{D}(apply!(ArrayReg{D}(adjb), b').state'), rb[ib-1]').state'
            else
                adjb = mat(T, b)' * adjb * mat(T, rb[ib-1])
            end
        end
    end
    return collector
end

function mat_back!(::Type{T}, rb::KronBlock, adjy, collector) where {T}
    nparameters(rb) == 0 && return collector
    mat_back!(T, chain(nqudits(rb), [put(loc => rb[loc]) for loc in rb.locs]), adjy, collector)
    return collector
end

function mat_back!(::Type{T}, rb::AbstractAdd, adjy, collector) where {T}
    nparameters(rb) == 0 && return collector
    for b in subblocks(rb)[end:-1:1]
        mat_back!(T, b, adjy, collector)
    end
    return collector
end

function mat_back!(::Type{T}, rb::Scale, adjy, collector) where {T}
    np = nparameters(rb)
    np == 0 && return collector
    mat_back!(T, content(rb), factor(rb) * adjy, collector)
    if niparams(rb) > 0
        pushfirst!(collector, projection(rb.alpha, _sum_A_Bconj(adjy, mat(T, content(rb)))))
    end
    return collector
end

# ∑ A .* B*, A is mutated.
_sum_A_Bconj(A::AbstractMatrix, B::AbstractMatrix) = sum(A .* conj.(B))
function _sum_A_Bconj(A::OuterProduct, B::AbstractMatrix)
    res = conj(A.left' * (B * conj(A.right)))
    return ndims(res) != 0 ? sum(diag(res)) : res
end

"""
    mat_back([::Type{T}, ]block::AbstractBlock, adjm::AbstractMatrix) -> Vector

The backward function of `mat`. Returns the gradients of parameters.
"""
mat_back(block::AbstractBlock, adjm::AbstractMatrix{T}) where {T} =
    mat_back!(T, block, adjm, parameters_eltype(block)[])
mat_back(::Type{T}, block::AbstractBlock, adjm::AbstractMatrix) where {T} =
    mat_back!(T, block, adjm, parameters_eltype(block)[])

# forward content properties
cache_key(tb::TagBlock) = cache_key(content(tb))
occupied_locs(x::TagBlock) = occupied_locs(content(x))
nqudits(x::TagBlock) = nqudits(content(x))

Base.:(==)(a::TB, b::TB) where {TB<:TagBlock} = content(a) == content(b)

"""
    QASMIOContext{IOT} <: IO

An IO context for QASM output.

# Fields
- `io::IOT`: the underlying IO object
"""
struct QASMIOContext{IOT} <: IO
    io::IOT
end

for T in [SubString{String}, String, Symbol, Any]
    @eval Base.print(io::QASMIOContext, str::$T) = print(io.io, str)
end

function Base.show(io::QASMIOContext, ::MIME"qasm/open", blk::AbstractBlock)
    println(io, blk)
end

"""
    qasm(block::AbstractBlock; include_header::Bool=false) -> String

Convert a YaoBlocks circuit to an OpenQASM string. The output uses OpenQASM 3.0 syntax
(e.g., `ctrl @`, `negctrl @`, `inv @` modifiers) while maintaining compatibility with
common OpenQASM 2.0 gate definitions through `qelib1.inc`.

# Arguments
- `block::AbstractBlock`: The quantum circuit block to convert
- `include_header::Bool=false`: Whether to include the QASM header with version,
  include statement, and qubit register declaration

# Returns
- `String`: The OpenQASM representation of the circuit

# Supported Blocks
- **Primitive gates**: `I2`, `X`, `Y`, `Z`, `H`, `S`, `Sdag`, `T`, `Tdag`
- **Rotation gates**: `Rx`, `Ry`, `Rz` (→ `rx`, `ry`, `rz`)
- **Phase gate**: `shift` (→ `p`)
- **Composite blocks**: `PutBlock`, `ControlBlock`, `ChainBlock`
- **Modifiers**: `Daggered` (→ `inv @`)
- **Custom gates**: `GeneralMatrixBlock` with tag (outputs the tag name)

# Notes
- Qubit indices in QASM are 0-based, while YaoBlocks uses 1-based indexing
- Circuits are automatically simplified using `Optimise.canonicalize` before compilation
- Parsing via `parseblock` supports both OpenQASM 2.0 and 3.0 inputs

# Examples

```jldoctest; setup=:(using Yao)
julia> qasm(put(2, 1=>X))
"x q[0]"

julia> qasm(control(2, 1, 2=>X))
"cx q[0], q[1]"

julia> qasm(chain(put(2, 1=>H), control(1, 2=>X)); include_header=true)
"OPENQASM 2.0;\\ninclude \\"qelib1.inc\\";\\nqreg q[2];\\ncreg c[2];\\nh q[0];\\ncx q[0], q[1];\\n"
```

See also: [`parseblock`](@ref)
"""
function YaoBlocks.qasm(block::AbstractBlock; include_header::Bool=false)
    # Recursively simplify circuit before compiling: eliminate nested blocks and convert to basic types
    block = Optimise.canonicalize(block)

    io = QASMIOContext(IOBuffer())
    include_header && println(io, """OPENQASM 2.0;
include "qelib1.inc";
qreg q[$(nqubits(block))];
creg c[$(nqubits(block))];""")
    print_qasm(io, block)
    String(take!(io.io))
end

######################## Basic Building Blocks ########################

# -> composite blocks
function print_qasm(io::QASMIOContext, blk::PutBlock{D,M,GT}) where {D, M, GT <: PrimitiveBlock}
    # Skip global phase gates as they don't affect measurement outcomes
    content(blk) isa PhaseGate && return nothing
    print_qasm(io, content(blk))
    print(io, " ")
    print_addrs(io, blk.locs)
end

# Handle PutBlock with ControlBlock content - need to remap qubit locations
function print_qasm(io::QASMIOContext, blk::PutBlock{D,M,GT}) where {D, M, GT <: ControlBlock}
    ctrl_blk = content(blk)
    locs = blk.locs
    # Map the control and target locations from the inner system to the outer system
    ctrl_locs = Tuple(locs[i] for i in ctrl_blk.ctrl_locs)
    target_locs = Tuple(locs[i] for i in ctrl_blk.locs)
    print_control_gate(io, content(ctrl_blk), ctrl_locs, target_locs, ctrl_blk.ctrl_config)
end

function print_qasm(io::QASMIOContext, blk::ControlBlock{GT}) where GT <: PrimitiveBlock
    print_control_gate(io, content(blk), blk.ctrl_locs, blk.locs, blk.ctrl_config)
end

# Helper to print controlled gates - shared logic for ControlBlock and PutBlock{ControlBlock}
function print_control_gate(io::QASMIOContext, gate, ctrl_locs, target_locs, ctrl_config)
    # Single positive control - use QASM 2.0 gates
    if length(ctrl_locs) == 1 && ctrl_config[1] == 1
        if gate isa XGate
            print(io, "cx ")
        elseif gate isa YGate
            print(io, "cy ")
        elseif gate isa ZGate
            print(io, "cz ")
        elseif gate isa HGate
            print(io, "ch ")
        elseif gate isa ShiftGate
            print(io, "cu1")
            print_params(io, getiparams(gate))
            print(io, " ")
        elseif gate isa RotationGate{2, T, ZGate} where T
            print(io, "crz")
            print_params(io, getiparams(gate))
            print(io, " ")
        else
            # Fallback to QASM 3.0 syntax
            print(io, "ctrl @ ")
            print_qasm(io, gate)
            print(io, " ")
        end
        print_addrs(io, (ctrl_locs..., target_locs...))
    # Double positive control for X gate (Toffoli)
    elseif length(ctrl_locs) == 2 && all(==(1), ctrl_config) && gate isa XGate
        print(io, "ccx ")
        print_addrs(io, (ctrl_locs..., target_locs...))
    else
        # Fallback to QASM 3.0 syntax for complex cases
        for c in ctrl_config
            print(io, c == 1 ? "ctrl @ " : "negctrl @ ")
        end
        print_qasm(io, gate)
        print(io, " ")
        print_addrs(io, (ctrl_locs..., target_locs...))
    end
end

function print_qasm(io::QASMIOContext, blk::ChainBlock)
    for b in subblocks(blk)
        @assert b isa CompositeBlock "primitive gate in chain block should be a composite block."
        # Skip global phase gates as they don't produce QASM output
        _is_global_phase(b) && continue
        print_qasm(io, b)
        println(io, ";")
    end
end

# Check if a block is a global phase (doesn't affect measurement outcomes)
_is_global_phase(::AbstractBlock) = false
_is_global_phase(blk::PutBlock) = content(blk) isa PhaseGate

function print_qasm(io::QASMIOContext, blk::Daggered)
    print(io, "inv @ ")
    print_qasm(io, content(blk))
end

# -> Primitive blocks
function print_qasm(io::QASMIOContext, blk::GeneralMatrixBlock)
    tag_str = string(blk.tag)
    if isempty(tag_str)
        error("GeneralMatrixBlock has empty tag; cannot emit valid OpenQASM output. Set a tag with `matblock(matrix; tag=\"name\")`.")
    end
    print(io, tag_str)
end

# x, y, z, h, s, sdag, t, tdag
print_qasm(io::QASMIOContext, ::I2Gate) = print(io, "id")
print_qasm(io::QASMIOContext, ::XGate) = print(io, "x")
print_qasm(io::QASMIOContext, ::YGate) = print(io, "y")
print_qasm(io::QASMIOContext, ::ZGate) = print(io, "z")
print_qasm(io::QASMIOContext, ::HGate) = print(io, "h")
print_qasm(io::QASMIOContext, ::ConstGate.SGate) = print(io, "s")
print_qasm(io::QASMIOContext, ::TGate) = print(io, "t")
print_qasm(io::QASMIOContext, ::ConstGate.SdagGate) = print(io, "inv @ s")
print_qasm(io::QASMIOContext, ::ConstGate.TdagGate) = print(io, "inv @ t")

# rx, ry, rz
function print_qasm(io::QASMIOContext, blk::RotationGate{2, T, <:PrimitiveBlock}) where T
    print(io, "r")
    print_qasm(io, content(blk))
    print_params(io, getiparams(blk))
end

# p (phase gate)
function print_qasm(io::QASMIOContext, blk::ShiftGate)
    print(io, "p")
    print_params(io, getiparams(blk))
end

# swap gate
print_qasm(io::QASMIOContext, ::SWAPGate) = print(io, "swap")

# rzz gate - rotation around ZZ
function print_qasm(io::QASMIOContext, blk::RotationGate{2, T, <:KronBlock}) where T
    kb = content(blk)
    # Check if this is a ZZ rotation (kron(Z, Z))
    subs = subblocks(kb)
    if length(subs) == 2 && subs[1] isa ZGate && subs[2] isa ZGate
        print(io, "rzz")
        print_params(io, getiparams(blk))
    else
        error("Only ZZ rotation (rzz) is supported for KronBlock rotation, got: $blk")
    end
end

# PhaseGate (global phase) - ignore in QASM output as it doesn't affect measurement outcomes
print_qasm(io::QASMIOContext, ::PhaseGate) = nothing

# Fallback for unsupported blocks
function print_qasm(io::QASMIOContext, blk::AbstractBlock)
    error("block type not supported for QASM output, got: $blk")
end

# HELPERS
function print_addrs(io::QASMIOContext, locs)
    for (k, i) in enumerate(locs)
        print(io, "q[$(i-1)]")
        k != length(locs) && print(io, ", ")
    end
end

function print_params(io::QASMIOContext, params)
    print(io, "(")
    for (k, p) in enumerate(params)
        print(io, p)
        k != length(params) && print(io, ", ")
    end
    print(io, ")")
end

"""
    ErrorPattern

A pattern of error for noise simulation.

# Fields
- `locs::Vector{Vector{Int}}`: The locations of the error. The locations are nested vectors, and is 1-based.
- `operations::Vector{String}`: The operations of the error.
- `error::AbstractErrorType`: The error type.
"""
struct ErrorPattern
    locs::Vector{Vector{Int}}
    operations::Vector{String}
    error::AbstractErrorType
end

"""
    SimulationTask

A simulation task containing a circuit and outcomes.

# Fields
- `circuit::AbstractBlock`: The circuit to simulate
- `outcomes::Vector{Any}`: The measurement outcome references
"""
struct SimulationTask
    circuit::AbstractBlock
    outcomes::Vector{Any}
end

"""
    AtLoc{MT<:Measure}

A reference to a specific measurement location.

# Fields
- `ref::MT`: The measurement reference
- `i::Int`: The index within the measurement
"""
struct AtLoc{MT<:Measure}
    ref::MT
    i::Int
end
Base.:(==)(a::AtLoc, b::AtLoc) = a.ref == b.ref && a.i == b.i

"""
    parseblock(qasm::String, gate_error::Vector{ErrorPattern}=ErrorPattern[]) -> SimulationTask

Parse an OpenQASM 2.0 string into a YaoBlocks circuit.

# Arguments
- `qasm::String`: The OpenQASM string to parse
- `gate_error::Vector{ErrorPattern}=ErrorPattern[]`: Optional error patterns for noisy simulation

# Returns
- `SimulationTask`: Contains `.circuit` (the quantum circuit) and `.outcomes` (measurement references)

# Supported Gates
- **Single-qubit**: `id`, `x`, `y`, `z`, `h`, `s`, `sdg`, `t`, `tdg`, `sx`
- **Rotations**: `rx(θ)`, `ry(θ)`, `rz(θ)`, `r(θ,ϕ)`
- **U gates**: `u1(λ)`/`p(λ)`, `u2(ϕ,λ)`, `u3(θ,ϕ,λ)`
- **Two-qubit**: `cx`, `cy`, `cz`, `ch`, `swap`, `crz(θ)`, `cu1(λ)`/`cp(λ)`, `cu3(θ,ϕ,λ)`, `rxx(θ)`, `rzz(θ)`
- **Three-qubit**: `ccx` (Toffoli)
- **Measurement**: `measure q -> c;` or `measure q[i] -> c[j];`

# Notes
- Only `include "qelib1.inc"` is supported for include statements
- `qreg` and `creg` declarations must appear before gates
- Barriers are ignored with a warning
- QASM uses 0-based indexing; this is automatically converted to 1-based for YaoBlocks

# Examples

```jldoctest; setup=:(using Yao)
julia> qasm_str = \"\"\"
       OPENQASM 2.0;
       include "qelib1.inc";
       qreg q[2];
       creg c[2];
       h q[0];
       cx q[0],q[1];
       measure q -> c;
       \"\"\";

julia> task = parseblock(qasm_str);

julia> nqubits(task.circuit)
2

julia> task.circuit
nqubits: 2
chain
├─ put on (1)
│  └─ H
├─ control(1)
│  └─ (2,) X
└─ Measure(2)
```

See also: [`qasm`](@ref)
"""
function YaoBlocks.parseblock(qasm::String, gate_error::Vector{ErrorPattern}=ErrorPattern[])
    ast = OpenQASM.parse(qasm)
    parseblock(ast, gate_error)
end

# parse block from AST
function YaoBlocks.parseblock(ast::OpenQASM.Types.MainProgram, gate_error::Vector{ErrorPattern})
    c = nothing
    outcomes = nothing
    for stmt in ast.prog
        if stmt isa OpenQASM.Types.GateDecl
            not_supported_error(stmt)
        elseif stmt isa OpenQASM.Types.Gate
            not_supported_error(stmt)
        elseif stmt isa OpenQASM.Types.Instruction
            parse_instruction!(c, stmt.name, parse_location.(stmt.qargs), parsenode.(stmt.cargs), gate_error)
        elseif stmt isa OpenQASM.Types.Include
            @assert convert(String, stmt.file) == "qelib1.inc" "Only `qelib1.inc` is supported to be included. Got: $(convert(String, stmt.file))"
        elseif stmt isa OpenQASM.Types.RegDecl
            if convert(String, stmt.type) == "qreg"
                @assert c === nothing "The `qreg` register has already been declared. Only one quantum register declaration is allowed per QASM program."
                c = chain(convert(Int, stmt.size))
            elseif convert(String, stmt.type) == "creg"
                @assert outcomes === nothing "The `creg` register has already been declared. Only one classical register declaration is allowed per QASM program."
                outcomes = Vector{Any}(undef, convert(Int, stmt.size))
            else
                error("Unsupported register type: $(stmt.type)")
            end
        elseif stmt isa OpenQASM.Types.Barrier
            @warn "Barrier is ignored. got: $stmt"
        elseif stmt isa OpenQASM.Types.Reset
            not_supported_error(stmt)
        elseif stmt isa OpenQASM.Types.IfStmt
            not_supported_error(stmt)
        elseif stmt isa OpenQASM.Types.Measure
            loc = parse_location(stmt.qarg)
            cloc = parse_location(stmt.carg)
            cloc = cloc isa AllLocs ? (1:length(outcomes)) : cloc
            m = Measure(nqubits(c); locs=loc)
            if loc isa AllLocs
                for i in 1:nqubits(c)
                    outcomes[cloc[i]] = AtLoc(m, i)
                end
            else
                outcomes[cloc] = m
            end
            push!(c, m)
        elseif stmt isa OpenQASM.Types.Opaque
            not_supported_error(stmt)
        elseif stmt isa OpenQASM.Types.Neg
            not_supported_error(stmt)
        elseif stmt isa OpenQASM.Types.Bit
            not_supported_error(stmt)
        elseif stmt isa OpenQASM.Types.Call
            not_supported_error(stmt)
        elseif stmt isa OpenQASM.Types.CXGate
            ctrl_loc = parse_location(stmt.ctrl)
            qarg_loc = parse_location(stmt.qarg)
            push!(c, control(nqubits(c), ctrl_loc, qarg_loc => X))
            # Add noise for CX gates
            add_noise!(c, "cx", [ctrl_loc, qarg_loc], gate_error)
        elseif stmt isa OpenQASM.Types.UGate
            not_supported_error(stmt)
        else
            not_supported_error(stmt)
        end
    end
    return SimulationTask(c, outcomes)
end

function not_supported_error(stmt)
    error("Statement type not supported: $stmt of type $(typeof(stmt)), with fields: $(fieldnames(typeof(stmt)))")
end

# Ref: https://github.com/Qiskit/qiskit/blob/main/qiskit/qasm/libs/qelib1.inc
function parse_instruction!(c::ChainBlock, name, qargs, cargs, gate_error::Vector{ErrorPattern})
    n = nqubits(c)
    if name == "id"
        push!(c, put(n, qargs[1] => I2))
    elseif name == "x"
        push!(c, put(n, qargs[1] => X))
    elseif name == "y"
        push!(c, put(n, qargs[1] => Y))
    elseif name == "z"
        push!(c, put(n, qargs[1] => Z))
    elseif name == "h"
        push!(c, put(n, qargs[1] => H))
    elseif name == "s"
        push!(c, put(n, qargs[1] => ConstGate.S))
    elseif name == "r"
        θ, ϕ = cargs
        push!(c, put(n, qargs[1] => matblock([cos(θ/2) -im*exp(-im*ϕ)*sin(θ/2); -im*exp(im*ϕ)*sin(θ/2) cos(θ/2)]; tag="r")))
    elseif name == "sdg"
        push!(c, put(n, qargs[1] => ConstGate.Sdag))
    elseif name == "sx"
        # sqrt(X)
        push!(c, put(n, qargs[1] => matblock([1+im 1-im; 1-im 1+im]/2; tag="sx")))
    elseif name == "t"
        push!(c, put(n, qargs[1] => T))
    elseif name == "tdg"
        push!(c, put(n, qargs[1] => ConstGate.Tdag))
    elseif name == "rx"
        push!(c, put(n, qargs[1] => Rx(cargs[1])))
    elseif name == "ry"
        push!(c, put(n, qargs[1] => Ry(cargs[1])))
    elseif name == "rz"
        push!(c, put(n, qargs[1] => Rz(cargs[1])))
    elseif name == "u1" || name == "p"
        λ = cargs[1]
        push!(c, put(n, qargs[1] => shift(λ)))
    elseif name == "u2"
        ϕ, λ = cargs
        push!(c, put(n, qargs[1] => matblock([1 -exp(im*λ); exp(im*ϕ) exp(im * (ϕ + λ))] / sqrt(2); tag="u2")))
    elseif name == "u3"
        θ, ϕ, λ = cargs
        push!(c, put(n, qargs[1] => matblock([cos(θ/2) -exp(im*λ)*sin(θ/2); exp(im*ϕ)*sin(θ/2) exp(im * (ϕ + λ))*cos(θ/2)]; tag="u3")))
    elseif name == "cx"
        push!(c, control(n, qargs[1], qargs[2] => X))
    elseif name == "cy"
        push!(c, control(n, qargs[1], qargs[2] => Y))
    elseif name == "cz"
        push!(c, control(n, qargs[1], qargs[2] => Z))
    elseif name == "ch"
        push!(c, control(n, qargs[1], qargs[2] => H))
    elseif name == "ccx"
        push!(c, control(n, (qargs[1], qargs[2]), qargs[3] => X))
    elseif name == "crz"
        push!(c, control(n, qargs[1], qargs[2] => Rz(cargs[1])))
    elseif name == "rxx"
        push!(c, put(n, (qargs[1], qargs[2]) => rot(kron(X, X), cargs[1])))
    elseif name == "rzz"
        push!(c, put(n, (qargs[1], qargs[2]) => rot(kron(Z, Z), cargs[1])))
    elseif name == "swap"
        push!(c, swap(n, qargs[1], qargs[2]))
    elseif name == "cu1" || name == "cp"
        push!(c, control(n, qargs[1], qargs[2] => shift(cargs[1])))
    elseif name == "cu3"
        θ, ϕ, λ = cargs
        push!(c, control(n, qargs[1], qargs[2] => matblock([cos(θ/2) -exp(im*λ)*sin(θ/2); exp(im*ϕ)*sin(θ/2) exp(im * (ϕ + λ))*cos(θ/2)]; tag="u3")))
    else
        error("Unsupported instruction: $name")
    end

    # Add noise after each gate
    add_noise!(c, name, qargs, gate_error)
    return c
end

function add_noise!(c::ChainBlock, gate_name::String, qargs, gate_error::Vector{ErrorPattern})
    for error_pattern in gate_error
        if gate_name in error_pattern.operations
            @assert all(loc -> length(loc) == length(qargs), error_pattern.locs) "The number of qubits in the gate ($gate_name) and the error pattern must match. Got: $(length(qargs)) and $(length.(error_pattern.locs))"
            if qargs in error_pattern.locs
                push!(c, put(nqubits(c), Tuple(qargs) => quantum_channel(error_pattern.error)))
            end
        end
    end
end

function parsenode(t::OpenQASM.RBNF.Token{:float64})
    return convert(Float64, t)
end
function parsenode(t::OpenQASM.RBNF.Token{:int})
    return convert(Int, t)
end
function parsenode(t::OpenQASM.RBNF.Token{:id})
    return convert(String, t)
end
function parsenode(t::OpenQASM.RBNF.Token{:reserved})
    return if t.str == "pi"
        π
    elseif t.str == "/"
        /
    elseif t.str == "*"
        *
    elseif t.str == "+"
        +
    elseif t.str == "-"
        -
    else
        error("Unsupported reserved token: $t")
    end
end
function parsenode(t::OpenQASM.Types.Neg)
    return -parsenode(t.val)
end
function parsenode(t::Tuple)
    args = parsenode.(t)
    if length(args) == 3 && args[2] in [+, -, *, /]
        return args[2](args[1], args[3])
    else
        error("Unsupported token: $t")
    end
end

function parse_location(loc::OpenQASM.Types.Bit)
    if loc.address === nothing
        return AllLocs()
    else
        return convert(Int, loc.address) + 1  # In Julia, we start counting from 1
    end
end

### Noise model parsing
"""
    CustomKrausError <: AbstractErrorType

Custom Kraus error from a list of Kraus operators.

# Fields
- `kraus_ops::Vector{Matrix{ComplexF64}}`: The Kraus operators
"""
struct CustomKrausError <: AbstractErrorType
    kraus_ops::Vector{Matrix{ComplexF64}}
end
KrausChannel(error::CustomKrausError) = KrausChannel([matblock(op; tag="K$i") for (i, op) in enumerate(error.kraus_ops)])
quantum_channel(error::CustomKrausError) = KrausChannel(error)

"""
    ReadOutError

A readout error.

# Fields
- `locs::Vector{Vector{Int}}`: The locations of the readout error. To make it consistent with the noise model, the locations are nested vectors, each with one element, and is 1-based.
- `probability::Vector{Vector{Float64}}`: The probability of the readout error. The first element is the probability of 0, the second element is the probability of 1.
"""
struct ReadOutError
    locs::Vector{Vector{Int}}
    probability::Vector{Vector{Float64}}
end

"""
    parse_noise_model(data)

Parse a noise model from a dictionary.

# Arguments
- `data`: A vector of dictionaries, each containing noise type and parameters

# Returns
- `Tuple{Vector{ErrorPattern}, Vector{ReadOutError}}`: Gate errors and readout errors

# Supported noise types
- `"depolarizing"`: Single-qubit depolarizing noise
- `"depolarizing2"`: Two-qubit depolarizing noise
- `"thermal_relaxation"`: Thermal relaxation noise
- `"coherent_unitary"`: Coherent unitary error
- `"pauli"`: Pauli error with probability vector [X, Y, Z]
- `"amplitude_damping"`: Amplitude damping error
- `"phase_damping"`: Phase damping error
- `"phase_amplitude_damping"`: Combined phase and amplitude damping
- `"kraus"`: Kraus operators error
- `"roerror"`: Readout error
"""
function parse_noise_model(data)
    gate_errors = ErrorPattern[]
    ro_errors = ReadOutError[]
    _render_locs(locs) = [collect(Int, loc) .+ 1 for loc in locs]

    for noise in data
        noise_type = noise["type"]

        if noise_type == "depolarizing"
            # Single-qubit depolarizing noise
            err = DepolarizingError(1, noise["probability"])
            push!(gate_errors, ErrorPattern(_render_locs(noise["qubits"]), collect(String, noise["operations"]), err))

        elseif noise_type == "depolarizing2"
            # Two-qubit depolarizing noise
            err = DepolarizingError(2, noise["probability"])
            push!(gate_errors, ErrorPattern(_render_locs(noise["qubits"]), collect(String, noise["operations"]), err))

        elseif noise_type == "thermal_relaxation"
            # Thermal relaxation noise
            err = ThermalRelaxationError(noise["T1"], noise["T2"], noise["time"])
            push!(gate_errors, ErrorPattern(_render_locs(noise["qubits"]), collect(String, noise["operations"]), err))

        elseif noise_type == "coherent_unitary"
            # Coherent unitary error
            unitary_matrix = reduce(hcat, noise["unitary"])  # Convert to matrix
            unitary_block = matblock(unitary_matrix)
            err = CoherentError(unitary_block)
            push!(gate_errors, ErrorPattern(_render_locs(noise["qubits"]), collect(String, noise["operations"]), err))

        elseif noise_type == "pauli"
            # Pauli error with probability vector [X, Y, Z]
            probs = noise["probability"]  # [prob_X, prob_Y, prob_Z]
            err = PauliError(probs[1], probs[2], probs[3])
            push!(gate_errors, ErrorPattern(_render_locs(noise["qubits"]), collect(String, noise["operations"]), err))

        elseif noise_type == "amplitude_damping"
            # Amplitude damping error
            gamma = noise["gamma_amplitude"]
            excited_state_pop = noise["excited_state_population"]
            err = AmplitudeDampingError(gamma, excited_state_pop)
            push!(gate_errors, ErrorPattern(_render_locs(noise["qubits"]), collect(String, noise["operations"]), err))

        elseif noise_type == "phase_damping"
            # Phase damping error
            gamma = noise["gamma_phase"]
            err = PhaseDampingError(gamma)
            push!(gate_errors, ErrorPattern(_render_locs(noise["qubits"]), collect(String, noise["operations"]), err))

        elseif noise_type == "phase_amplitude_damping"
            # Combined phase and amplitude damping
            gamma_amp = noise["gamma_amplitude"]
            gamma_phase = noise["gamma_phase"]
            excited_state_pop = noise["excited_state_population"]
            err = PhaseAmplitudeDampingError(gamma_amp, gamma_phase, excited_state_pop)
            push!(gate_errors, ErrorPattern(_render_locs(noise["qubits"]), collect(String, noise["operations"]), err))

        elseif noise_type == "kraus"
            # Kraus operators error
            kraus_ops = [reduce(hcat, op) for op in noise["kraus_ops"]]  # Convert to matrices
            err = CustomKrausError(kraus_ops)
            push!(gate_errors, ErrorPattern(_render_locs(noise["qubits"]), collect(String, noise["operations"]), err))

        elseif noise_type == "roerror"
            # Readout error
            probability_matrix = noise["probability"]
            ro_error = ReadOutError(_render_locs(noise["qubits"]), probability_matrix)
            push!(ro_errors, ro_error)
        else
            error("unknown noise type: $(noise_type)")
        end
    end

    return gate_errors, ro_errors
end

export CacheFragment, CachedBlock, update_cache
export cache, pull, update!, update_cache, clearall!, iscached, iscacheable

"""
    CacheFragment{BT, K, MT}

A fragment that will be stored for each cached block (of type `BT`) on a cache server.
"""
struct CacheFragment{BT,K,MT}
    ref::BT
    storage::Dict{K,MT}

    function CacheFragment{BT,K,MT}(x::BT) where {BT,K,MT}
        new{BT,K,MT}(x, Dict{K,MT}())
    end

    function CacheFragment{BT,K}(x::BT) where {BT} where {K}
        new{BT,K,cache_type(BT)}(x, Dict{K,cache_type(BT)}())
    end

    function CacheFragment(x::BT) where {BT}
        CacheFragment{BT,typeof(cache_key(x))}(x)
    end
end

# default update rule
function CacheServers.update!(frag::CacheFragment, val)
    if !iscached(frag)
        frag.storage[cache_key(frag.ref)] = val
    end
    frag
end

CacheServers.iscached(frag::CacheFragment) = cache_key(frag.ref) in keys(frag.storage)
CacheServers.pull(frag::CacheFragment) = frag.storage[cache_key(frag.ref)]
CacheServers.clear!(frag::CacheFragment) = (empty!(frag.storage); frag)

"""
    CachedBlock{ST, BT, D} <: TagBlock{BT, D}

A label type that tags an instance of type `BT`. It forwards
every methods of the block it contains, except [`mat`](@ref)
and [`apply!`](@ref), it will cache the matrix form whenever
the program has.
"""
struct CachedBlock{ST,BT,D} <: TagBlock{BT,D}
    server::ST
    content::BT
    level::Int

    function CachedBlock(server::ST, x::BT, level::Int) where {ST,D,BT<:AbstractBlock{D}}
        alloc!(server, x, CacheFragment(x))
        new{ST,BT,D}(server, x, level)
    end
end

CacheServers.iscached(c::CachedBlock) = iscached(c.server, c.content)
iscacheable(c::CachedBlock) = iscacheable(c.server, c.content)
chsubblocks(cb::CachedBlock, blk::AbstractBlock) = CachedBlock(cb.server, blk, cb.level)
occupied_locs(x::CachedBlock) = occupied_locs(content(x))
PropertyTrait(::CachedBlock) = PreserveAll()

function update_cache(::Type{T}, c::CachedBlock) where {T}
    if !iscached(c.server, c.content)
        m = mat(T, c.content)
        push!(c.server, m, c.content)
    end
    return c
end

CacheServers.clear!(x::AbstractBlock) = x
CacheServers.clear!(c::CachedBlock) = (clear!(c.server, c.content); c)

function mat(::Type{T}, c::CachedBlock) where {T}
    if !iscached(c.server, c.content)
        m = mat(T, c.content)
        push!(c.server, m, c.content)
        return m
    end
    return pull(c)
end

function CacheServers.pull(c::CachedBlock)
    return pull(c.server, c.content)
end

YaoAPI.unsafe_apply!(r::AbstractRegister, c::CachedBlock) = YaoAPI.unsafe_apply!(r, c.content)
YaoAPI.unsafe_apply!(r::AbstractArrayReg{D,T}, c::CachedBlock) where {D,T} = (r.state .= mat(T, c) * r.state; r)
YaoAPI.unsafe_apply!(r::DensityMatrix{D,T}, c::CachedBlock) where {D,T} = (m = mat(T, c); r.state .= m * r.state * m'; r)

Base.similar(c::CachedBlock, level::Int) = CachedBlock(c.server, c.content, level)
Base.copy(c::CachedBlock) = CachedBlock(c.server, copy(c.content), c.level)
Base.length(x::CachedBlock) = length(content(x))
Base.getindex(c::CachedBlock, index...) = getindex(content(c), index...)
Base.setindex!(c::CachedBlock, val, index...) = setindex!(content(c), val, index...)
Base.iterate(c::CachedBlock) = iterate(content(c))
Base.iterate(c::CachedBlock, st) = iterate(content(c), st)
Base.eltype(x::CachedBlock) = eltype(content(x))


const DefaultCacheServer = get_server(AbstractBlock, CacheFragment)

cache(x::Function, level::Int = 1; recursive = false) =
    n -> cache(x(n), level; recursive = recursive)

"""
    cache(x[, level=1; recursive=false])

Create a [`CachedBlock`](@ref) with given block `x`, which will cache the matrix of `x` for the first time
it calls [`mat`](@ref), and use the cached matrix in the following calculations.

### Examples

```jldoctest; setup=:(using YaoBlocks)
julia> cache(control(3, 1, 2=>X))
nqubits: 3
[cached] control(1)
   └─ (2,) X


julia> chain(cache(control(3, 1, 2=>X)), repeat(H))
nqubits: 3
chain
├─ [cached] control(1)
│     └─ (2,) X
└─ repeat on (1, 2, 3)
   └─ H

```
"""
function cache(x::AbstractBlock, level::Int = 1; recursive = false)
    return cache(DefaultCacheServer, x, level, recursive = recursive)
end

function clearall!(x::CachedBlock)
    return clear!(x)
end

function clearall!(x::CachedBlock{ST,BT}) where {ST,BT<:CompositeBlock}
    for each in subblocks(x.content)
        clearall!(each)
    end
    clear!(x)
    return x
end

function cache(
    server::AbstractCacheServer,
    x::AbstractBlock,
    level::Int;
    recursive::Bool = false,
)
    return CachedBlock(server, x, level)
end

function cache(
    server::AbstractCacheServer,
    x::ChainBlock,
    level::Int;
    recursive::Bool = false,
)
    if recursive
        chain = similar(x)
        for (i, each) in enumerate(block)
            chain[i] = cache(server, each, level, recursive)
        end
    else
        chain = x
    end

    return CachedBlock(server, chain, level)
end

function cache(
    server::AbstractCacheServer,
    block::KronBlock,
    level::Int;
    recursive::Bool = false,
)
    if recursive
        x = similar(block)
        for (k, v) in block
            x[k] = cache(server, v, level, recursive = recursive)
        end
    else
        x = block
    end

    return CachedBlock(server, x, level)
end

function unsafe_getindex(::Type{T}, c::CachedBlock, i::Integer, j::Integer) where T
    @inbounds mat(T, c)[i+1, j+1]
end
function unsafe_getcol(::Type{T}, c::CachedBlock, j::DitStr) where {T}
    @inbounds getcol(mat(T, c), j)
end

function Base.getindex(b::CachedBlock{ST, BT, D}, i::DitStr{D,N}, j::DitStr{D,N}) where {ST,BT,D,N}
    invoke(Base.getindex, Tuple{AbstractBlock{D}, DitStr{D,N}, DitStr{D,N}} where {D,N}, b, i, j)
end
function Base.getindex(b::CachedBlock{ST, BT, D}, ::Colon, j::DitStr{D,N}) where {D,N,ST,BT}
    T = promote_type(ComplexF64, parameters_eltype(b))
    return cleanup(_getindex(T, b, :, j))
end
function Base.getindex(b::CachedBlock{ST, BT, D}, i::DitStr{D,N}, ::Colon) where {D,N,ST,BT}
    T = promote_type(ComplexF64, parameters_eltype(b))
    return cleanup(_getindex(T, b, i, :))
end
function Base.getindex(b::CachedBlock{ST, BT, D}, ::Colon, j::EntryTable{DitStr{D,N,TI},T}) where {D,N,TI,T,ST,BT}
    return cleanup(_getindex(b, :, j))
end
function Base.getindex(b::CachedBlock{ST, BT, D}, i::EntryTable{DitStr{D,N,TI},T}, ::Colon) where {D,N,TI,T,ST,BT}
    return cleanup(_getindex(b, i, :))
end

using YaoBlocks, YaoBlocks.AD
using YaoArrayRegister
using YaoAPI: NotImplementedError
using Random, Test

AA(i, j) = control(i, j => shift(2π / (1 << (i - j + 1))))
B(n, i) = chain(n, i == j ? put(i => H) : AA(j, i) for j = i:n)
qftcirc(n) = chain(B(n, i) for i = 1:n)

function state_numgrad(f, reg)
    map(1:length(reg.state)) do i
        reg.state[i] += 1e-5
        pos = f(reg)
        reg.state[i] -= 2e-5
        neg = f(reg)
        reg.state[i] += 1e-5 + 1e-5im
        ipos = f(reg)
        reg.state[i] -= 2e-5im
        ineg = f(reg)
        reg.state[i] += 1e-5im
        ((pos - neg) + im * (ipos - ineg)) / 2e-5
    end
end

@testset "expect grad" begin
    Random.seed!(2)
    nbit = 4
    c = qftcirc(nbit)
    H = repeat(nbit, X, 1:nbit)
    for reg in [rand_state(nbit), rand_state(nbit; nbatch = 10)]
        adjin, adjparams = expect'(H, reg => c)
        numgrad =
            YaoBlocks.AD.ng(x -> sum(expect(H, reg => dispatch!(c, x))), parameters(c))
        @test adjparams ≈ vec(numgrad)
        numgrad2 = state_numgrad(reg -> sum(expect(H, reg => c)), reg)
        @test isapprox(vec(adjin.state), numgrad2, atol = 1e-4)

        adjin2 = expect'(H, reg)
        numgrad3 = state_numgrad(reg -> sum(expect(H, reg)), reg)
        @test isapprox(vec(adjin2.state), numgrad3, atol = 1e-4)
    end
end

@testset "fidelity grad" begin
    nbit = 4
    Random.seed!(2)
    for nbatch in [NoBatch(), 10]
        reg1 = rand_state(nbit; nbatch = nbatch)
        reg2 = rand_state(nbit; nbatch = nbatch)
        c1 = qftcirc(nbit)
        c2 = chain(put(nbit, 2 => Rx(0.5)), control(nbit, 1, 3 => Ry(0.5)))

        g1, g2 = fidelity'(reg1, reg2)
        @test isapprox(
            vec(g1.state),
            state_numgrad(reg1 -> sum(fidelity(reg1, reg2)), reg1),
            atol = 1e-4,
        )
        @test isapprox(
            vec(g2.state),
            state_numgrad(reg2 -> sum(fidelity(reg1, reg2)), reg2),
            atol = 1e-4,
        )

        (g1, pg1), (g2, pg2) = fidelity'(reg1 => c1, reg2 => c2)
        npg1 = YaoBlocks.AD.ng(
            x -> sum(fidelity(reg1 => dispatch!(c1, x), reg2 => c2)),
            parameters(c1),
        )
        npg2 = YaoBlocks.AD.ng(
            x -> sum(fidelity(reg1 => c1, reg2 => dispatch!(c2, x))),
            parameters(c2),
        )
        @test isapprox(pg1, vec(npg1), atol = 1e-5)
        @test isapprox(pg2, vec(npg2), atol = 1e-5)
        @test isapprox(
            vec(g1.state),
            state_numgrad(reg1 -> sum(fidelity(reg1 => c1, reg2 => c2)), reg1),
            atol = 1e-4,
        )
        @test isapprox(
            vec(g2.state),
            state_numgrad(reg2 -> sum(fidelity(reg1 => c1, reg2 => c2)), reg2),
            atol = 1e-4,
        )
    end

    nbatch = NoBatch()
    reg1 = rand_state(nbit; nbatch = nbatch) |> focus!(2, 1, 4)
    reg2 = rand_state(nbit; nbatch = nbatch) |> focus!(2, 1, 4)
    c1 = qftcirc(3)
    c2 = chain(put(3, 2 => Rx(0.5)), control(3, 1, 3 => Ry(0.5)))

    @test_throws ArgumentError fidelity'(reg1, reg2)
    #g1, g2 = fidelity'(reg1, reg2)
    #@test isapprox(vec(g1.state), state_numgrad(reg1->sum(fidelity(reg1, reg2)), reg1), atol=1e-5)
    #@test isapprox(vec(g2.state), state_numgrad(reg2->sum(fidelity(reg1, reg2)), reg2), atol=1e-5)

    #(g1,pg1), (g2,pg2) = fidelity'(reg1 => c1, reg2 => c2)
    #npg1 = YaoBlocks.AD.ng(x -> sum(fidelity(reg1 => dispatch!(c1, x), reg2=>c2)), parameters(c1))
    #npg2 = YaoBlocks.AD.ng(x -> sum(fidelity(reg1 => c1, reg2 => dispatch!(c2, x))), parameters(c2))
    #@test isapprox(pg1, vec(npg1),atol=1e-5)
    #@test isapprox(pg2, vec(npg2),atol=1e-5)
    #@test isapprox(vec(g1.state), state_numgrad(reg1->sum(fidelity(reg1=>c1, reg2=>c2)), reg1), atol=1e-5)
    #@test isapprox(vec(g2.state), state_numgrad(reg2->sum(fidelity(reg1=>c1, reg2=>c2)), reg2), atol=1e-5)
end

@testset "fidelity2 grad" begin
    nbit = 4
    Random.seed!(2)
    for nbatch in [NoBatch(), 10]
        reg1 = rand_state(nbit; nbatch = nbatch)
        reg2 = rand_state(nbit; nbatch = nbatch)
        c1 = qftcirc(nbit)
        c2 = chain(put(nbit, 2 => Rx(0.5)), control(nbit, 1, 3 => Ry(0.5)))

        g1, g2 = fidelity2'(reg1, reg2)
        @test isapprox(
            vec(g1.state),
            state_numgrad(reg1 -> sum(fidelity2(reg1, reg2)), reg1),
            atol = 1e-4,
        )
        @test isapprox(
            vec(g2.state),
            state_numgrad(reg2 -> sum(fidelity2(reg1, reg2)), reg2),
            atol = 1e-4,
        )

        (g1, pg1), (g2, pg2) = fidelity2'(reg1 => c1, reg2 => c2)
        npg1 = YaoBlocks.AD.ng(
            x -> sum(fidelity2(reg1 => dispatch!(c1, x), reg2 => c2)),
            parameters(c1),
        )
        npg2 = YaoBlocks.AD.ng(
            x -> sum(fidelity2(reg1 => c1, reg2 => dispatch!(c2, x))),
            parameters(c2),
        )
        @test isapprox(pg1, vec(npg1), atol = 1e-5)
        @test isapprox(pg2, vec(npg2), atol = 1e-5)
        @test isapprox(
            vec(g1.state),
            state_numgrad(reg1 -> sum(fidelity2(reg1 => c1, reg2 => c2)), reg1),
            atol = 1e-4,
        )
        @test isapprox(
            vec(g2.state),
            state_numgrad(reg2 -> sum(fidelity2(reg1 => c1, reg2 => c2)), reg2),
            atol = 1e-4,
        )
    end

    nbatch = NoBatch()
    reg1 = rand_state(nbit; nbatch = nbatch) |> focus!(2, 1, 4)
    reg2 = rand_state(nbit; nbatch = nbatch) |> focus!(2, 1, 4)

    @test_throws ArgumentError fidelity2'(reg1, reg2)
end

@testset "operator fideliy" begin
    nbit = 4
    c1 = qftcirc(nbit)
    c2 = chain(put(nbit, 2 => Rx(0.5)), control(nbit, 1, 3 => Ry(0.5)))

    g1, g2 = operator_fidelity'(c1, c2)
    npg1 = YaoBlocks.AD.ng(x -> operator_fidelity(dispatch!(c1, x), c2), parameters(c1))
    npg2 = YaoBlocks.AD.ng(x -> operator_fidelity(c1, dispatch!(c2, x)), parameters(c2))
    @test isapprox(g1, vec(npg1), atol = 1e-5)
    @test isapprox(g2, vec(npg2), atol = 1e-5)
end

@testset "fix #360" begin
    greg, (greg2, gcirc) = fidelity'(rand_state(10), rand_state(10)=>put(10, 1=>X))
    @test gcirc isa Vector
end

using YaoBlocks, Test

@testset "errortypes" begin
    @test PauliError(BitFlipError(0.1)) == PauliError(0.1, 0.0, 0.0)
    @test PauliError(PhaseFlipError(0.1)) == PauliError(0.0, 0.0, 0.1)
    @test PauliError(DepolarizingError(1, 0.1)) == PauliError(0.1/4, 0.1/4, 0.1/4)
    @test KrausChannel(BitFlipError(0.1)) == KrausChannel([sqrt(1-0.1)*I2, sqrt(0.1)*X])
    @test KrausChannel(PhaseFlipError(0.1)) == KrausChannel([sqrt(1-0.1)*I2, sqrt(0.1)*Z])
    @test KrausChannel(DepolarizingError(1, 0.1)) == KrausChannel([sqrt(1-0.025-0.025-0.025)*I2, sqrt(0.1/4)*X, sqrt(0.1/4)*Y, sqrt(0.1/4)*Z])
    @test KrausChannel(ResetError(0.1, 0.2)) == KrausChannel([sqrt(1-0.1-0.2)*I2, sqrt(0.1)*ConstGate.P0, sqrt(0.1)*ConstGate.Pd, sqrt(0.2)*ConstGate.P1, sqrt(0.2)*ConstGate.Pu])

    @test quantum_channel(BitFlipError(0.1)) == MixedUnitaryChannel([I2, X], [1-0.1, 0.1])
    @test quantum_channel(PhaseFlipError(0.1)) == MixedUnitaryChannel([I2, Z], [1-0.1, 0.1])
    @test quantum_channel(DepolarizingError(1, 0.1)) == DepolarizingChannel(1, 0.1)
    @test quantum_channel(ResetError(0.1, 0.2)) == KrausChannel([sqrt(1-0.1-0.2)*I2, sqrt(0.1)*ConstGate.P0, sqrt(0.1)*ConstGate.Pd, sqrt(0.2)*ConstGate.P1, sqrt(0.2)*ConstGate.Pu])
end


@testset "basic error channels" begin
    dm = rand_density_matrix(3)
    ch = put(3, 1 => quantum_channel(PhaseFlipError(0.2)))
    opZ = mat(put(3, 1=>Z))
    @test 0.8 * dm.state + 0.2 * opZ * dm.state * opZ ≈ apply(dm, ch).state

    dm = rand_density_matrix(3)
    ch = put(3, 1 => quantum_channel(BitFlipError(0.2)))
    opX = mat(put(3, 1=>X))
    @test 0.8 * dm.state + 0.2 * opX * dm.state * opX ≈ apply(dm, ch).state

    dm = rand_density_matrix(3)
    ch = quantum_channel(DepolarizingError(3, 0.2))
    @test (0.8 .* dm.state .+ (0.2 / 2^3) .* IMatrix(1<<3)) ≈ apply(dm, ch).state

    dm = rand_density_matrix(3)
    ch = depolarizing_channel(3, p=1.)
    @test apply(dm, ch).state ≈ IMatrix(1<<3) ./ 2^3

    dm = rand_density_matrix(1)
    ch1 = put(1, 1 => quantum_channel(DepolarizingError(1, 0.1)))
    ch2 = depolarizing_channel(1, p=0.1)
    @test apply(dm, ch1) ≈ apply(dm, ch2)

    dm = rand_density_matrix(2)
    ch1 = put(2, (1, 2) => quantum_channel(DepolarizingError(2, 0.1)))
    ch2 = depolarizing_channel(2, p=0.1)
    @test apply(dm, ch1) ≈ apply(dm, ch2)
end

@testset "pauli channel" begin
    dm = rand_density_matrix(3)
    ch = put(3, 1 => quantum_channel(PauliError(0.3, 0.1, 0.2)))
    opX = mat(put(3, 1=>X))
    opY = mat(put(3, 1=>Y))
    opZ = mat(put(3, 1=>Z))

    @test 0.4 * dm.state + 0.3 * opX * dm.state * opX + 
        0.1 * opY * dm.state * opY +
        0.2 * opZ * dm.state * opZ ≈ apply(dm, ch).state
end

@testset "super operators and kraus operators" begin
    # bit flip
    p_error = 0.05
    bit_flip = BitFlipError(p_error)
    @test SuperOp(bit_flip).superop ≈ [0.95 0.0 0.0 0.05;
        0.0 0.95 0.05 0.0;
        0.0 0.05 0.95 0.0;
        0.05 0.0 0.0 0.95]
    bit_flip_kraus = KrausChannel(bit_flip)
    # Note: the phase of the matrix can be arbitrary, so we only check the magnitude
    @test mat(bit_flip_kraus.operators[1]) ≈ [sqrt(0.95) 0.0; 0.0 sqrt(0.95)]
    @test mat(bit_flip_kraus.operators[2]) ≈ [0.0 sqrt(0.05); sqrt(0.05) 0.0]

    # phase flip
    p_error = 0.05
    phase_flip = PhaseFlipError(p_error)
    @test SuperOp(phase_flip).superop ≈ [1.0 0.0 0.0 0.0;
        0.0 0.9 0.0 0.0;
        0.0 0.0 0.9 0.0;
        0.0 0.0 0.0 1.0]

    phase_flip_kraus = KrausChannel(phase_flip)
    @test mat(phase_flip_kraus.operators[1]) ≈ [sqrt(0.95) 0.0; 0.0 sqrt(0.95)]
    @test mat(phase_flip_kraus.operators[2]) ≈ [sqrt(0.05) 0.0; 0.0 -sqrt(0.05)]

    # depolarizing
    p_error = 0.1
    depolarizing = DepolarizingError(1, p_error)
    @test SuperOp(depolarizing).superop ≈ [0.95 0.0 0.0 0.05;
        0.0 0.9 0.0 0.0;
        0.0 0.0 0.9 0.0;
        0.05 0.0 0.0 0.95]

    depolarizing_kraus = KrausChannel(depolarizing)
    function effectively_same(a, b)
        res = a * a' ≈ b * b'
        if !res
            println("a: ", a)
            println("b: ", b)
        end
        res
    end
    @test effectively_same(mat(depolarizing_kraus.operators[1]), [-sqrt(0.925) 0.0; 0.0 -sqrt(0.925)])
    @test effectively_same(mat(depolarizing_kraus.operators[2]), [-sqrt(0.025) 0.0; 0.0 sqrt(0.025)])
    @test effectively_same(mat(depolarizing_kraus.operators[3]), [0.0 -sqrt(0.025)*im; sqrt(0.025)*im 0.0])
    @test effectively_same(mat(depolarizing_kraus.operators[4]), [0.0 sqrt(0.025); sqrt(0.025) 0.0])

    # reset
    p_error = 0.1
    reset = ResetError(p_error, p_error)
    reset_kraus = KrausChannel(reset)
    @test SuperOp(reset_kraus).superop ≈ [0.9 0 0 0.1; 0 0.8 0 0; 0 0 0.8 0; 0.1 0 0 0.9]

    # NOTE: this is not the simplest form of Kraus operators for reset channel!!
    @test mat(reset_kraus.operators[1]) ≈ [sqrt(0.8) 0.0; 0.0 sqrt(0.8)]
    @test mat(reset_kraus.operators[2]) ≈ [sqrt(0.1) 0.0; 0.0 0.0]
    @test mat(reset_kraus.operators[3]) ≈ [0.0 0.0; sqrt(0.1) 0.0]
    @test mat(reset_kraus.operators[4]) ≈ [0.0 0.0; 0.0 sqrt(0.1)]
    @test mat(reset_kraus.operators[5]) ≈ [0.0 sqrt(0.1); 0.0 0.0]
end

@testset "super operators" begin
    # bit flip
    p_error = 0.05
    bit_flip = BitFlipError(p_error)
    @test SuperOp(bit_flip).superop ≈ [0.95 0.0 0.0 0.05;
        0.0 0.95 0.05 0.0;
        0.0 0.05 0.95 0.0;
        0.05 0.0 0.0 0.95]

    # phase flip
    p_error = 0.05
    phase_flip = PhaseFlipError(p_error)
    @test SuperOp(phase_flip).superop ≈ [1.0 0.0 0.0 0.0;
        0.0 0.9 0.0 0.0;
        0.0 0.0 0.9 0.0;
        0.0 0.0 0.0 1.0]

    # depolarizing
    p_error = 0.1
    depolarizing = DepolarizingError(1, p_error)
    @test SuperOp(depolarizing).superop ≈ [0.95 0.0 0.0 0.05;
        0.0 0.9 0.0 0.0;
        0.0 0.0 0.9 0.0;
        0.05 0.0 0.0 0.95]

    # thermal relaxation
    T1 = 100.0
    T2 = 200.0
    time = 1.0
    excited_state_population = 0.0
    thermal_relaxation = ThermalRelaxationError(T1, T2, time, excited_state_population)
    @test SuperOp(thermal_relaxation).superop ≈ [1.0 0.0 0.0 0.00995017;
        0.0 0.99501248 0.0 0.0;
        0.0 0.0 0.99501248 0.0;
        0.0 0.0 0.0 0.99004983]

    # coherent error
    block = X
    coherent_error = CoherentError(block)
    @test SuperOp(coherent_error).superop ≈ [0.0 0.0 0.0 1.0;
        0.0 0.0 1.0 0.0;
        0.0 1.0 0.0 0.0;
        1.0 0.0 0.0 0.0]

    # pauli error
    px, py, pz = 0.1, 0.0, 0.0
    pauli_error = PauliError(px, py, pz)
    @test SuperOp(pauli_error).superop ≈ [0.9 0.0 0.0 0.1;
        0.0 0.9 0.1 0.0;
        0.0 0.1 0.9 0.0;
        0.1 0.0 0.0 0.9]

    # amplitude damping
    param_amp = 0.1
    amplitude_damping = AmplitudeDampingError(param_amp)
    @test SuperOp(amplitude_damping).superop ≈ [1.0 0.0 0.0 0.1;
        0.0 0.9486833 0.0 0.0;
        0.0 0.0 0.9486833 0.0;
        0.0 0.0 0.0 0.9]

    # phase damping
    param_phase = 0.1
    phase_damping = PhaseDampingError(param_phase)
    @test SuperOp(phase_damping).superop ≈ [1.0 0.0 0.0 0.0;
        0.0 0.9486833 0.0 0.0;
        0.0 0.0 0.9486833 0.0;
        0.0 0.0 0.0 1.0]

    # phase amplitude damping
    param_amp = 0.1
    param_phase = 0.05
    excited_state_population = 0.0
    phase_amplitude_damping = PhaseAmplitudeDampingError(param_amp, param_phase, excited_state_population)
    @test SuperOp(phase_amplitude_damping).superop ≈ [1.0 0.0 0.0 0.1;
        0.0 0.92195445 0.0 0.0;
        0.0 0.0 0.92195445 0.0;
        0.0 0.0 0.0 0.9]

    # phase amplitude damping with excited state population
    excited_state_population = 0.1
    phase_amplitude_damping_excited = PhaseAmplitudeDampingError(param_amp, param_phase, excited_state_population)
    @test SuperOp(phase_amplitude_damping_excited).superop ≈ [0.99 0.0 0.0 0.09;
        0.0 0.92195445 0.0 0.0;
        0.0 0.0 0.92195445 0.0;
        0.01 0.0 0.0 0.91]
end

using Test, YaoBlocks
import YaoBlocks: print_annotation

@testset "printing" begin
    g1 = kron(2, 1 => (im * X))
    g2 = control(2, 1, 2 => (im * X))
    g3 = chain(im * X, X, Y)

    io = IOBuffer()
    print_annotation(io, g1, g1, g1[1])
    @test String(take!(io)) == "1=>[+im] "

    print_annotation(io, g2, g2, content(g2))
    @test String(take!(io)) == "(2,) [+im] "

    print(Measure(3; locs=(3,), operator=X, resetto=bit"1"))
    YaoBlocks.print_subtypetree(AbstractBlock)
end

using Test, YaoBlocks, YaoArrayRegister
using YaoBlocks: BlockMap
using LinearAlgebra

function myheisenberg(n::Int; periodic::Bool = true)
    Sx(i) = put(n, i => X)
    Sy(i) = put(n, i => Y)
    Sz(i) = put(n, i => Z)

    res = map(1:(periodic ? n : n - 1)) do i
        j = mod1(i, n)
        Sx(i) * Sx(j) + Sy(i) * Sy(j) + Sz(i) * Sz(j)
    end
    Add(res)
end

@testset "constructor:time evolution" begin
    hm = myheisenberg(4)
    te = TimeEvolution(hm, 0.2)
    # copy
    cte = copy(te)
    @test cte == te
    @test cte !== te

    # dispatch
    dispatch!(cte, [2.0])
    @test cte != te
    @test cte.dt == 2.0
    @test setiparams!(cte, 0.5).dt == 0.5
    @test setiparams!(cte, :random).dt != 0.5
    @test setiparams!(cte, :zero).dt == 0.0
    @test setiparams(cte, 0.5).dt == 0.5
    @test setiparams(cte, :random).dt != 0.5
    @test setiparams(cte, :zero).dt == 0.0
end

@testset "test imaginary time evolution" begin
    hm = myheisenberg(4)
    tei = TimeEvolution(hm, 0.2im)
    r = rand_state(4)
    r1 = copy(r) |> tei
    @test exp(Matrix(mat(hm)) * 0.2) * r.state ≈ r1.state

    @test applymatrix(tei) ≈ mat(tei)
    @test applymatrix(adjoint(tei)) ≈ applymatrix(tei)'
    @test !isunitary(tei)
    @test !isunitary(tei |> mat)

    # diagonal time evolution
    hm = matblock(Diagonal(randn(1<<4)))
    tei = TimeEvolution(hm, 0.2im)
    r = rand_state(4)
    r1 = copy(r) |> tei
    @test exp(Matrix(mat(hm)) * 0.2) * r.state ≈ r1.state

    @test applymatrix(tei) ≈ mat(tei)
    @test applymatrix(adjoint(tei)) ≈ applymatrix(tei)'
    @test !isunitary(tei)
    @test !isunitary(tei |> mat)
end

@testset "test time evolution" begin
    hm = myheisenberg(4)
    te = TimeEvolution(hm, 0.2)

    r = rand_state(4)
    r1 = copy(r) |> te
    @test exp(Matrix(mat(hm)) * -0.2im) * r.state ≈ r1.state
    @test applymatrix(adjoint(te)) ≈ applymatrix(te)'

    @test applymatrix(te) ≈ mat(te)
    @test isunitary(te)
    @test isunitary(te |> mat)
    cte = copy(te)
    @test cte == te

    # diagonal
    te = TimeEvolution(kron(Z, Z), 0.5)
    @test applymatrix(te) ≈ mat(te)
    @test mat(te) isa Diagonal

    @test !isdiagonal(time_evolve(X, 0.5))
    @test isdiagonal(time_evolve(Z, 0.5))
end

@testset "block map" begin
    @test BlockMap(ComplexF64, X) isa BlockMap{ComplexF64,typeof(X)}

    @test BlockMap(ComplexF64, X).block === X

    st = rand(ComplexF64, 2)
    @test BlockMap(ComplexF64, X) * st ≈ mat(X) * st
    @test ishermitian(BlockMap(ComplexF64, X))
    @test size(BlockMap(ComplexF64, X)) == (2, 2)
end

@testset "qudits" begin
    reg = zero_state(1; nlevel=3)
    H = randn(ComplexF64, 3,3)
    reg2 = apply(reg, time_evolve(matblock(H + H'; nlevel=3), 0.5))
    @test nlevel(reg2) == 3
    @test isnormalized(reg2)
end

@testset "instruct_get_element" begin
    for pb in [time_evolve(put(3, 2=>Y), 0.5), time_evolve(cache(put(3, (3,1)=>matblock(rand_hermitian(9); nlevel=3))), 0.5)
            ]
        mpb = mat(pb)
        allpass = true
        for i=basis(pb), j=basis(pb)
            allpass &= isapprox(pb[i, j], mpb[Int(i)+1, Int(j)+1]; atol=1e-6)
            allpass &= isapprox(pb[i, j], mpb[Int(i)+1, Int(j)+1]; atol=1e-6, rtol=1e-6)
        end
        @test allpass

        allpass = true
        for j=basis(pb)
            allpass &= isapprox(vec(pb[:, j]), mpb[:, Int(j)+1]; atol=1e-6)
            allpass &= isapprox(vec(pb[j,:]), mpb[Int(j)+1,:]; atol=1e-6)
            allpass &= isapprox(vec(pb[:, EntryTable([j], [1.0+0im])]), mpb[:, Int(j)+1]; atol=1e-6)
            allpass &= isapprox(vec(pb[EntryTable([j], [1.0+0im]),:]), mpb[Int(j)+1,:]; atol=1e-6)
            allpass &= isapprox(vec(pb[:, j]), mpb[:, Int(j)+1]; atol=1e-6, rtol=1e-6)
            allpass &= isapprox(vec(pb[j,:]), mpb[Int(j)+1,:]; atol=1e-6, rtol=1e-6)
            allpass &= isapprox(vec(pb[:, EntryTable([j], [1.0+0im])]), mpb[:, Int(j)+1]; atol=1e-6, rtol=1e-6)
            allpass &= isapprox(vec(pb[EntryTable([j], [1.0+0im]),:]), mpb[Int(j)+1,:]; atol=1e-6, rtol=1e-6)
            allpass &= isclean(pb[:,j])
        end
        @test allpass
    end
end

export Daggered

"""
    Daggered{BT, D} <: TagBlock{BT,D}

Wrapper block allowing to execute the inverse of a block of quantum circuit.
"""
struct Daggered{BT<:AbstractBlock,D} <: TagBlock{BT,D}
    content::BT
end

"""
    Daggered(block)

Create a [`Daggered`](@ref) block.
Let ``G`` be a input block, `G'` or `Daggered(block)` in code represents ``G^\\dagger``.

### Examples

The inverse QFT is not hermitian, thus it will be tagged with a `Daggered` block.

```jldoctest; setup=:(using YaoBlocks)
julia> A(i, j) = control(i, j=>shift(2π/(1<<(i-j+1))));

julia> B(n, i) = chain(n, i==j ? put(i=>H) : A(j, i) for j in i:n);

julia> qft(n) = chain(B(n, i) for i in 1:n);

julia> struct QFT <: PrimitiveBlock{2} n::Int end

julia> YaoBlocks.nqudits(q::QFT) = q.n


julia> circuit(q::QFT) = qft(nqubits(q));

julia> YaoBlocks.mat(x::QFT) = mat(circuit(x));

julia> QFT(2)'
 [†]QFT
```
"""
Daggered(x::BT) where {D,BT<:AbstractBlock{D}} = Daggered{BT,D}(x)

PropertyTrait(::Daggered) = PreserveAll()
mat(::Type{T}, blk::Daggered) where {T} = adjoint(mat(T, content(blk)))
chsubblocks(blk::Daggered, target::AbstractBlock) = Daggered(target)

Base.adjoint(x::AbstractBlock) = ishermitian(x) ? x : Daggered(x)
Base.adjoint(x::Daggered) = content(x)
Base.copy(x::Daggered) = Daggered(copy(content(x)))

function unsafe_getindex(::Type{T}, d::Daggered, i::Integer, j::Integer) where {T}
    return unsafe_getindex(T, content(d), j, i) |> conj
end
function unsafe_getcol(::Type{T}, d::Daggered, j::DitStr{D}) where {T,D}
    locs, vals = force_getrowconj(T, content(d), j)
    return locs, vals
end
function force_getrowconj(::Type{T}, mb::GeneralMatrixBlock, i::DitStr{D}) where {T,D}
    locs, vals = getcol(mb.mat', i)
    if eltype(vals) != T
        vals = convert.(T, vals)
    end
    return locs, vals
end
function force_getrowconj(::Type{T}, mb::AbstractBlock{D}, i::DitStr{D}) where {T,D}
    if nqudits(mb) > 10  # for block size larger than 10, throw a warning
        @warn "fallback to slow get row implementation! Try avoid using `Daggered` type or implement the `force_getrowconj` method for your block."
    end
    return getcol(mat(T, mb)', i)
end

using YaoBlocks, PauliPropagation, YaoArrayRegister, Test
using Random

_isequal(a::GA, b::GB) where {GA<:Gate, GB<:Gate} =  all([getproperty(a, pn) == getproperty(b, pn) for pn in fieldnames(GA)])
_isequal(a::Vector{GA}, b::Vector{GB}) where {GA<:Gate, GB<:Gate} = all(_isequal.(a, b))

@testset "test PauliPropagationExt" begin
    nq = 3
    nl = 2
    circuit = tfitrottercircuit(nq, nl)
    yaocirc = YaoBlocks.paulipropagation2yao(nq, circuit, randn(countparameters(circuit)))
    obs = put(nq, 1=>Z)
    pc = YaoBlocks.yao2paulipropagation(yaocirc; observable=obs)
    @test pc.n == nq
    @test _isequal(getfield.(pc.gates, :gate), circuit)
    # Test that observable is a PauliSum
    @test pc.observable isa PauliSum
    # Test round-trip conversion
    yaocirc2 = paulipropagation2yao(pc)
    println(pc)
    @test nqubits(yaocirc) == nqubits(yaocirc2)
end

@testset "expectation value" begin
    n_qubits = 8
    n_layers = 20
    error_rate = 0.01

    function build_noisy_layer(n::Int, error_rate::Float64)
        layer = chain(n)

        for i in 1:n
            if rand() < 0.5
                push!(layer, put(n, i => Rx(2π * rand())))
            else
                push!(layer, put(n, i => Rz(2π * rand())))
            end
        end

        for i in 1:2:n-1
            push!(layer, put(n, (i, i + 1) => YaoBlocks.ConstGate.CNOT))
        end

        for i in 1:n
            push!(layer, put(n, i => quantum_channel(DepolarizingError(1, error_rate))))
        end

        return layer
    end

    circuit = chain(n_qubits)
    for i in 1:n_qubits
        push!(circuit, put(n_qubits, i => H))
    end

    for layer_idx in 1:n_layers
        append!(circuit, build_noisy_layer(n_qubits, error_rate))
    end

    reg = zero_state(n_qubits) |> density_matrix
    reg_final = apply!(copy(reg), circuit)

    pauli_z_expectations = Float64[]
    yao_z_expectations = Float64[]
    for i in 1:min(10, n_qubits)
        pc = yao2paulipropagation(circuit; observable=put(n_qubits, i => Z))
        exp_pauli = real(overlapwithzero(propagate(pc)))
        push!(pauli_z_expectations, exp_pauli)
        exp_yao = real(expect(put(n_qubits, i => Z), reg_final))
        push!(yao_z_expectations, exp_yao)
    end

    @test pauli_z_expectations ≈ yao_z_expectations atol=1e-6
end

@testset "simulation" begin
    nq = 8
    pstr = PauliString(nq, :Z, 3)
    nl = 4
    topology = bricklayertopology(nq; periodic=false)

    circuit = hardwareefficientcircuit(nq, nl; topology=topology)
    nparams = countparameters(circuit)
    thetas = randn(nparams) * 0.5

    yao_circ = YaoBlocks.paulipropagation2yao(nq, circuit, thetas)
    psum_exact = propagate(circuit, pstr, thetas; min_abs_coeff=0)
    psum_yao = apply!(zero_state(nq), yao_circ)

    exact_expectation = overlapwithzero(psum_exact)
    yao_expectation = expect(put(nq, 3 => Z), psum_yao)
    @test isapprox(exact_expectation, yao_expectation, atol=1e-6)
end

# noisy simulation
@testset "pauli noisy simulation" begin
    Random.seed!(1234)
    nq = 3
    nl = 2
    W = Inf
    min_abs_coeff = 0.0
    opind = rand(1:nq)
    pstr = PauliString(nq, :Z, opind)

    topo = bricklayertopology(nq; periodic=false)
    circ = hardwareefficientcircuit(nq, nl; topology=topo)

    m = countparameters(circ)

    depolarizing_circ = deepcopy(circ)
    pauli_circ = deepcopy(circ)

    where_ind = rand(1:m)
    q_ind = opind
    noise_p = 0.1
    insert!(depolarizing_circ, where_ind, DepolarizingNoise(q_ind))
    insert!(pauli_circ, where_ind, PauliZNoise(q_ind))
    insert!(pauli_circ, where_ind, PauliYNoise(q_ind))
    insert!(pauli_circ, where_ind, PauliXNoise(q_ind))

    thetas1 = rand(m)
    thetas2 = deepcopy(thetas1)
    insert!(thetas1, where_ind, noise_p)
    pauli_p = 1 - sqrt(1 - noise_p)
    insert!(thetas2, where_ind, pauli_p)
    insert!(thetas2, where_ind, pauli_p)
    insert!(thetas2, where_ind, pauli_p)


    dnum1 = propagate(depolarizing_circ, pstr, thetas1; max_weight=W, min_abs_coeff=min_abs_coeff)
    dnum2 = propagate(pauli_circ, pstr, thetas2; max_weight=W, min_abs_coeff=min_abs_coeff)

    exp1 = overlapwithzero(dnum1)
    exp2 = overlapwithzero(dnum2)
    @test exp1 ≈ exp2

    # convert to Yao blocks
    yao_depolarizing_circ = YaoBlocks.paulipropagation2yao(nq, depolarizing_circ, thetas1)
    yao_pauli_circ = YaoBlocks.paulipropagation2yao(nq, pauli_circ, thetas2)
    exp_yao1 = expect(put(nq, opind => Z), zero_state(nq) |> density_matrix |> yao_depolarizing_circ)
    exp_yao2 = expect(put(nq, opind => Z), zero_state(nq) |> density_matrix |> yao_pauli_circ)

    @test exp1 ≈ exp_yao1
    @test exp2 ≈ exp_yao2

    # convert back
    pc1 = YaoBlocks.yao2paulipropagation(yao_depolarizing_circ; observable=put(nq, opind => Z))
    @test _isequal(getfield.(pc1.gates, :gate), depolarizing_circ)
    pc2 = YaoBlocks.yao2paulipropagation(yao_pauli_circ; observable=put(nq, opind => Z))
    @test _isequal(getfield.(pc2.gates, :gate), pauli_circ)
end

@testset "observable types" begin
    n = 5
    circ = chain(n, put(n, 1=>X), put(n, 2=>Rx(0.5)))
    
    # Test PutBlock with different Pauli gates
    for (pauli_gate, pauli_sym) in [(X, :X), (Y, :Y), (Z, :Z)]
        obs = put(n, 1=>pauli_gate)
        pc = yao2paulipropagation(circ; observable=obs)
        @test pc.observable isa PauliSum
        @test length(pc.observable) == 1
    end
    
    # Test KronBlock (multi-qubit Pauli product)
    obs_kron = kron(n, 1=>X, 2=>Z, 3=>Y)
    pc_kron = yao2paulipropagation(circ; observable=obs_kron)
    @test pc_kron.observable isa PauliSum
    @test length(pc_kron.observable) == 1
    psum_kron = propagate(pc_kron)
    @test psum_kron isa PauliSum
    
    # Test Scale (scaled observable)
    obs_scale = 2.5 * put(n, 2=>Y)
    pc_scale = yao2paulipropagation(circ; observable=obs_scale)
    @test pc_scale.observable isa PauliSum
    @test length(pc_scale.observable) == 1
    # Check coefficient (access via terms dict)
    coeffs = collect(values(pc_scale.observable.terms))
    @test abs(coeffs[1]) ≈ 2.5
    
    # Test Scale with KronBlock
    obs_scale_kron = 3.0 * kron(n, 1=>X, 2=>Z)
    pc_scale_kron = yao2paulipropagation(circ; observable=obs_scale_kron)
    @test pc_scale_kron.observable isa PauliSum
    coeffs_kron = collect(values(pc_scale_kron.observable.terms))
    @test abs(coeffs_kron[1]) ≈ 3.0
    
    # Test Add (sum of observables)
    obs_add = put(n, 1=>X) + put(n, 2=>Z)
    pc_add = yao2paulipropagation(circ; observable=obs_add)
    @test pc_add.observable isa PauliSum
    @test length(pc_add.observable) == 2
    psum_add = propagate(pc_add)
    @test psum_add isa PauliSum
    
    # Test complex expression (sum with scaled terms)
    obs_complex = kron(n, 1=>X, 2=>Z) + 2.0 * put(n, 3=>Y) + 0.5 * kron(n, 4=>X, 5=>X)
    pc_complex = yao2paulipropagation(circ; observable=obs_complex)
    @test pc_complex.observable isa PauliSum
    @test length(pc_complex.observable) == 3
    psum_complex = propagate(pc_complex)
    @test psum_complex isa PauliSum
end

@testset "propagate with kwargs" begin
    n = 6
    circuit = chain(n, 
        put(n, 1=>Rx(0.5)), 
        put(n, 2=>X),
        put(n, (1,2)=>YaoBlocks.ConstGate.CNOT))
    obs = put(n, 1=>Z)
    
    pc = yao2paulipropagation(circuit; observable=obs)
    
    # Test propagate without kwargs
    psum1 = propagate(pc)
    @test psum1 isa PauliSum
    
    # Test propagate with max_weight
    psum2 = propagate(pc; max_weight=10)
    @test psum2 isa PauliSum
    
    # Test propagate with min_abs_coeff
    psum3 = propagate(pc; min_abs_coeff=1e-10)
    @test psum3 isa PauliSum
    
    # Test propagate with both kwargs
    psum4 = propagate(pc; max_weight=10, min_abs_coeff=1e-10)
    @test psum4 isa PauliSum
    
    # Verify expectation values are similar
    exp1 = real(overlapwithzero(psum1))
    exp2 = real(overlapwithzero(psum2))
    @test exp1 ≈ exp2 atol=1e-6
end

@testset "error cases" begin
    n = 3
    circ = chain(n, put(n, 1=>X))
    
    # Test invalid observable (non-Pauli gate)
    @test_throws AssertionError yao2paulipropagation(circ; observable=put(n, 1=>H))
    
    # Test invalid observable (Hadamard in kron)
    @test_throws Exception yao2paulipropagation(circ; observable=kron(n, 1=>H, 2=>X))
    
    # Test invalid observable (rotation gate)
    @test_throws AssertionError yao2paulipropagation(circ; observable=put(n, 1=>Rx(0.5)))
end

@testset "Base.show" begin
    n = 3
    circ = chain(n, put(n, 1=>X), put(n, 2=>Rx(0.5)))
    obs = put(n, 1=>Z)
    pc = yao2paulipropagation(circ; observable=obs)
    
    # Test that show produces output without error
    io = IOBuffer()
    show(io, pc)
    output = String(take!(io))
    
    @test contains(output, "PauliPropagationCircuit")
    @test contains(output, "Qubits: 3")
    @test contains(output, "Gates: 2")
    @test contains(output, "Observable:")
end

@testset "round-trip with different observables" begin
    nq = 4
    nl = 2
    circuit = tfitrottercircuit(nq, nl)
    thetas = randn(countparameters(circuit))
    
    # Test round-trip with different observable types
    observables = [
        put(nq, 1=>Z),
        kron(nq, 1=>X, 2=>Z),
        2.0 * put(nq, 2=>Y),
        put(nq, 1=>X) + put(nq, 2=>Z)
    ]
    
    for obs in observables
        yaocirc = YaoBlocks.paulipropagation2yao(nq, circuit, thetas)
        pc = yao2paulipropagation(yaocirc; observable=obs)
        
        # Verify structure
        @test pc.n == nq
        @test pc.observable isa PauliSum
        
        # Test back conversion
        yaocirc2 = paulipropagation2yao(pc)
        @test nqubits(yaocirc) == nqubits(yaocirc2)
        
        # Test propagation works
        psum = propagate(pc)
        @test psum isa PauliSum
        exp_val = overlapwithzero(psum)
        @test exp_val isa Number
    end
end

@testset "control blocks" begin
    n = 4
    
    # Test CNOT gate
    circ_cnot = chain(n, 
        put(n, 1=>H),
        control(n, 1, 2=>X),
        put(n, 2=>X)
    )
    obs = put(n, 1=>Z)
    pc_cnot = yao2paulipropagation(circ_cnot; observable=obs)
    
    @test pc_cnot.n == n
    @test length(pc_cnot.gates) == 3
    @test pc_cnot.gates[2] isa CliffordGate
    @test getfield(pc_cnot.gates[2], :symbol) == :CNOT
    
    # Test CZ gate
    circ_cz = chain(n,
        put(n, 1=>H),
        control(n, 1, 2=>Z),
        put(n, 2=>Z)
    )
    pc_cz = yao2paulipropagation(circ_cz; observable=obs)
    
    @test pc_cz.n == n
    @test length(pc_cz.gates) == 3
    @test pc_cz.gates[2] isa CliffordGate
    @test getfield(pc_cz.gates[2], :symbol) == :CZ
    
    # Test round-trip for controlled gates
    circ_back = paulipropagation2yao(pc_cnot)
    @test nqubits(circ_back) == n
    @test length(circ_back) == 3
    
    # Test propagation with control gates
    psum = propagate(pc_cnot)
    @test psum isa PauliSum
    exp_val = real(overlapwithzero(psum))
    @test exp_val isa Real
end

@testset "square root gates (SX, SY)" begin
    n = 3
    
    # Test SX gate (Rx(π/2))
    circ_sx = chain(n,
        put(n, 1=>Rx(π/2)),
        put(n, 2=>X)
    )
    obs = put(n, 1=>Z)
    pc_sx = yao2paulipropagation(circ_sx; observable=obs)
    
    @test pc_sx.n == n
    @test length(pc_sx.gates) == 2
    # First gate should be a frozen rotation (SX is stored as frozen rotation)
    @test pc_sx.gates[1] isa FrozenGate
    @test getfield(pc_sx.gates[1], :gate) isa PauliRotation
    
    # Test SY gate (Ry(π/2))
    circ_sy = chain(n,
        put(n, 1=>Ry(π/2)),
        put(n, 2=>Y)
    )
    pc_sy = yao2paulipropagation(circ_sy; observable=obs)
    
    @test pc_sy.n == n
    @test length(pc_sy.gates) == 2
    @test pc_sy.gates[1] isa FrozenGate
    @test getfield(pc_sy.gates[1], :gate) isa PauliRotation
    
    # Test propagation with square root gates
    psum_sx = propagate(pc_sx)
    @test psum_sx isa PauliSum
    exp_val_sx = real(overlapwithzero(psum_sx))
    @test exp_val_sx isa Real
    
    psum_sy = propagate(pc_sy)
    @test psum_sy isa PauliSum
    exp_val_sy = real(overlapwithzero(psum_sy))
    @test exp_val_sy isa Real
end

@testset "ZZpihalf gate" begin
    n = 4
    
    # Test ZZ(π/2) gate (two-qubit rotation)
    circ_zz = chain(n,
        put(n, 1=>H),
        put(n, (1,2)=>rot(kron(Z, Z), π/2)),
        put(n, 2=>X)
    )
    obs = kron(n, 1=>Z, 2=>Z)
    pc_zz = yao2paulipropagation(circ_zz; observable=obs)
    
    @test pc_zz.n == n
    @test length(pc_zz.gates) == 3
    # ZZ gate should be stored as a frozen rotation
    @test pc_zz.gates[2] isa FrozenGate
    inner_gate = getfield(pc_zz.gates[2], :gate)
    @test inner_gate isa PauliRotation
    @test length(getfield(inner_gate, :qinds)) == 2
    
    # Test propagation with ZZ gate
    psum = propagate(pc_zz)
    @test psum isa PauliSum
    exp_val = real(overlapwithzero(psum))
    @test exp_val isa Real
    
    # Test round-trip conversion
    circ_back = paulipropagation2yao(pc_zz)
    @test nqubits(circ_back) == n
    @test length(circ_back) == 3
end

@testset "combined gates and control blocks" begin
    n = 5
    
    # Test circuit with multiple gate types
    circ = chain(n,
        put(n, 1=>H),
        put(n, 2=>Rx(π/2)),  # SX
        control(n, 1, 2=>X),  # CNOT
        put(n, (2,3)=>rot(kron(Z, Z), π/2)),  # ZZ
        control(n, 3, 4=>Z),  # CZ
        put(n, 5=>Ry(π/2)),  # SY
        put(n, 1=>quantum_channel(DepolarizingError(1, 0.01)))
    )
    
    obs = put(n, 1=>Z) + kron(n, 2=>X, 3=>X)
    pc = yao2paulipropagation(circ; observable=obs)
    
    @test pc.n == n
    @test length(pc.gates) == 7
    @test pc.observable isa PauliSum
    
    # Test propagation
    psum = propagate(pc)
    @test psum isa PauliSum
    exp_val = real(overlapwithzero(psum))
    @test exp_val isa Real
    
    # Test round-trip
    circ_back = paulipropagation2yao(pc)
    @test nqubits(circ_back) == n
    @test length(circ_back) == 7
end

@testset "expectation values with control blocks" begin
    n = 4
    
    # Build a simple entangling circuit
    circ = chain(n,
        put(n, 1=>H),
        control(n, 1, 2=>X),
        control(n, 2, 3=>X),
        put(n, 1=>quantum_channel(DepolarizingError(1, 0.02)))
    )
    
    obs = put(n, 1=>Z)
    pc = yao2paulipropagation(circ; observable=obs)
    
    # Pauli propagation result
    psum = propagate(pc)
    exp_pauli = real(overlapwithzero(psum))
    
    # Compare with exact simulation
    reg = zero_state(n) |> density_matrix
    reg_final = apply!(reg, circ)
    exp_exact = real(expect(obs, reg_final))
    
    # Should be close (within numerical tolerance)
    @test isapprox(exp_pauli, exp_exact, atol=1e-10)
end

using YaoBlocks
using YaoBlocks: sprand_hermitian, sprand_unitary
using SparseArrays: sparse
using BitBasis
using Test

@testset "random matrices" begin
    mat = rand_unitary(8)
    @test isunitary(mat)
    mat = rand_hermitian(8)
    @test ishermitian(mat)

    @test ishermitian(sprand_hermitian(8, 0.5))
    @test isunitary(sprand_unitary(8, 0.5))
end

@testset "projector" begin
    @test projector(0) ≈ [1 0; 0 0]
    @test projector(1) ≈ [0 0; 0 1]
end

@testset "entry table" begin
    for table in [EntryTable(BitStr64{3}[], ComplexF64[]),
        EntryTable([bit"000", bit"101", bit"001", bit"101", bit"101", bit"000"], randn(ComplexF64, 6))
        ]
        @test vec(table) == sparse(table)
        @test vec(table) == vec(cleanup(table))
        println(table)
    end
    e1 = EntryTable([bit"001"], [2.0])
    @test merge(e1,e1,e1) == EntryTable([bit"001",bit"001",bit"001"], fill(2.0, 3))

    # case 1, has zero values
    @test !isclean(EntryTable([bit"110", bit"111"], [0.0im, 0.1]))
    # case 2, has duplicated entries
    @test !isclean(EntryTable([bit"110", bit"110"], [1.0im, 0.1]))
    # case 3, has inversed order
    @test !isclean(EntryTable([bit"111", bit"110"], [0.0im, 0.1]))

    et = EntryTable([bit"000",bit"011",bit"101",bit"101",bit"011",bit"110",bit"110",bit"011",], [1.0 + 0.0im,-1, 1,1,1,-1,1,1,-1])
    @test_throws ErrorException et[bit"000"]
    @test !isclean(et)
    cet = cleanup(et)
    @test cet |> length == 3
    @test isclean(cet)
    @test cet[bit"000"] == 1.0+0im
    @test cet[bit"111"] == 0.0im
end

@testset "#issue 508" begin
    @test YaoBlocks.safe_real(0 + 1e-323im) ≈ 0
    @test YaoBlocks.safe_real(0+0im) ≈ 0
    @test_warn () YaoBlocks.safe_real(0+1e-15im)
    @test YaoBlocks.safe_real(0+1e-17im) == 0
    @test YaoBlocks.safe_real(1e10+1e-10im) == 1e10
    @test_warn () YaoBlocks.safe_real(0+1im)
end

using YaoBlocks, YaoArrayRegister, Test

@testset "SuperOp" begin
    so = SuperOp{2}(1, [1 0 0 0; 0 0 1 0; 0 1 0 0; 0 0 0 1])
    println(so)
    @test occupied_locs(so) == (1,)
    @test so isa SuperOp{2}
    @test nqudits(so) == 1
    so2 = copy(so)
    @test so == so2
end

@testset "apply" begin
    # single qubit
    for op in [X, Y, ConstGate.T]
        @info "Testing $op"
        so = SuperOp(op)
        reg = rand_state(1)
        rho = density_matrix(reg)
        res_reg = apply(reg, op)
        res_rho = apply(rho, so)
        @test density_matrix(res_reg) ≈ res_rho
    end

    # multi-qubit
    n = 5
    for (k, op0) in [(2, X), (3, Y), (4, T), ((3, 1), cnot(2, 2, 1))]
        op = put(n, k=>op0)
        @info "Testing $op"
        so = put(n, k=>SuperOp(op0))
        reg = rand_state(n)
        rho = density_matrix(reg)
        res_reg = apply(reg, op)
        res_rho = apply(rho, so)
        @test density_matrix(res_reg) ≈ res_rho
    end

    # composed
    n = 3
    mb = matblock(rand(ComplexF64, 2^n, 2^n))
    c1 = chain(n, put(n, 1=>X), put(n, 3=>SuperOp(T)), SuperOp(mb), kron(X, Y, SuperOp(T)), repeat(n, SuperOp(X)))
    c2 = chain(n, put(n, 1=>X), put(n, 3=>T), mb, kron(X, Y, T), repeat(n, X))
    reg = rand_state(n)
    rho = density_matrix(reg)
    res_reg = apply(reg, c2)
    res_rho = apply(rho, c1)
    res_rho2 = apply(rho, c2)
    @test density_matrix(res_reg) ≈ res_rho2
    @test density_matrix(res_reg) ≈ res_rho
end

@testset "noisy superop" begin
    n = 3
    c_noisy = chain(n, put(n, 1=>chain(Z, quantum_channel(BitFlipError(0.1)))))
    sp = chain(n, put(n, 1=>SuperOp(chain(Z, quantum_channel(BitFlipError(0.1))))))
    reg = rand_state(n)
    rho = density_matrix(reg)
    res_rho = apply(rho, c_noisy)
    res_rho2 = apply(rho, sp)
    @test res_rho ≈ res_rho2
end

using Test, YaoBlocks, YaoArrayRegister, LuxurySparse, BitBasis
using YaoBlocks.ConstGate

U = mat(X)
⊗ = kron

@testset "construct" begin
    @test_throws DimensionMismatch control(3, 2, 1 => swap(2, 1, 2))
    @test_throws MethodError control(3, 1, 2:3 => rand(4, 4))
    @test_throws LocationConflictError control(3, 2, (1, 2) => swap(2, 1, 2))

    @test cnot(4, (1, 2), 3) == control(4, (1, 2), 3 => X)
    @test cnot((1, 2), 3)(4) == cnot(4, (1, 2), 3) # curried version

    @test cz(4, (1, 2), 3) == control(4, (1, 2), 3 => Z)
    @test cz((1, 2), 3)(4) == cz(4, (1, 2), 3)

    @test control((1, 2), 3 => X)(4) == control(4, (1, 2), 3 => X)
end

@testset "single control" begin
    g = ControlBlock(2, (1,), X, (2,))
    @test nqubits(g) == 2
    m = IMatrix(U) ⊗ mat(P0) + U ⊗ mat(P1)
    @test mat(g) == m
end

@testset "single control with inferred size" begin
    g = ControlBlock(3, (2,), X, (3,))
    @test nqubits(g) == 3
    m = (IMatrix(U) ⊗ mat(P0) + U ⊗ mat(P1)) ⊗ mat(I2)
    @test mat(g) == m
end

@testset "control with fixed size" begin
    g = ControlBlock(4, (2,), X, (3,))
    @test nqubits(g) == 4
    m = mat(I2) ⊗ (IMatrix(U) ⊗ mat(P0) + U ⊗ mat(P1)) ⊗ mat(I2)
    @test mat(g) == m
end

@testset "control with blank" begin
    g = ControlBlock(4, (3,), X, (2,))
    @test nqubits(g) == 4

    m = mat(I2) ⊗ (mat(P0) ⊗ IMatrix(U) + mat(P1) ⊗ U) ⊗ mat(I2)
    @test mat(g) == m
end

@testset "multi control" begin
    g = ControlBlock(4, (2, 3), X, (4,))
    @test nqubits(g) == 4

    op = IMatrix(U) ⊗ mat(P0) + U ⊗ mat(P1)
    op = IMatrix(op) ⊗ mat(P0) + op ⊗ mat(P1)
    op = op ⊗ mat(I2)
    @test mat(g) == op
end

@testset "multi control with blank" begin
    g = ControlBlock(7, (6, 4, 2), X, (3,)) # -> [2, 4, 6]
    @test nqubits(g) == 7
    @test occupied_locs(g) == (6, 4, 2, 3)

    op = IMatrix(U) ⊗ mat(P0) + U ⊗ mat(P1) # 2, 3
    op = mat(P0) ⊗ IMatrix(op) + mat(P1) ⊗ op # 2, 3, 4
    op = mat(P0) ⊗ mat(I2) ⊗ IMatrix(op) + mat(P1) ⊗ mat(I2) ⊗ op # 2, 3, 4, blank, 6
    op = op ⊗ mat(I2) # blank, 2, 3, blank, 4, 6
    op = mat(I2) ⊗ op # blnak, 2, 3, blank, 4, 6, blank

    @test mat(g) == op
end

@testset "inverse control" begin
    g = ControlBlock(2, (1,), (0,), X, (2,))
    op = U ⊗ mat(P0) + IMatrix(U) ⊗ mat(P1)
    @test mat(g) ≈ op
end

@testset "control two-bit gate" begin
    @test_throws DimensionMismatch ControlBlock(3, (1,), CNOT, (2,))
    g = ControlBlock(3, (1,), CNOT, (2, 3))
    @test applymatrix(g) ≈ mat(Toffoli)
    @test occupied_locs(g) == (1, 2, 3)
    g = ControlBlock(3, (3,), CNOT, (2, 1))
    @test applymatrix(g) ≈ mat(Toffoli) |> invorder
    @test occupied_locs(g) == (3, 2, 1)
    g = ControlBlock(3, (2,), CNOT, (3, 1))
    g2 = PutBlock(3, Toffoli, (3, 2, 1))
    g3 = ControlBlock(3, (3, 2), X, (1,))
    @test applymatrix(g) == applymatrix(g2) == applymatrix(g3)
    @test mat(g) == mat(g2)
    @test mat(g) == mat(g3)
end

@testset "push tests" begin
    @test !iscommute(control(5, 1, 2=>X), control(5, 1, 2=>Y))
    @test iscommute(control(5, 1, 2=>X), control(5, 1, 3=>Y))
    @test !iscommute(control(5, 1, 2=>X), control(5, 2, 3=>Y))

    c = control((2,3), 1=>X)(5)
    @test c == control(5, (2,3), 1=>X)
    @test copy(c) == c
end

@testset "instruct_get_element" begin
    for pb in [control(3, 2, 1=>Y), control(4, 3, (4,2)=>matblock(rand_unitary(4)))]
        mpb = mat(pb)
        allpass = true
        for i=basis(pb), j=basis(pb)
            allpass &= pb[i, j] == mpb[Int(i)+1, Int(j)+1]
        end
        @test allpass
        allpass = true
        for j=basis(pb)
            allpass &= vec(pb[:, j]) == mpb[:, Int(j)+1]
            allpass &= vec(pb[j, :]) == mpb[Int(j)+1, :]
            allpass &= isclean(pb[:,j])
        end
        @test allpass
    end
end

@testset "fix dispatch" begin
    circuit1 = control(10, (2, -6, 4), (9, 1)=>chain(put(2, 1=>X), rot(kron(X, X), 0.3)))
    circuit2 = control(10, (2, -6, 4), (9, 1)=>matblock(mat(chain(put(2, 1=>X), rot(kron(X, X), 0.3)))))
    @test mat(circuit1) ≈ mat(circuit2)
end

export PhaseGate, phase

"""
    PhaseGate

Global phase gate.
"""
mutable struct PhaseGate{T} <: PrimitiveBlock{2}
    theta::T
end
nqudits(pg::PhaseGate) = 1

"""
    phase(theta)

Returns a global phase gate. Defined with following matrix form:

```math
e^{iθ} I
```

### Examples

You can create a global phase gate with a phase (a real number).

```jldoctest; setup=:(using YaoBlocks)
julia> phase(0.1)
phase(0.1)
```
"""
phase(θ::Real) = PhaseGate(θ)

mat(::Type{T}, gate::PhaseGate) where {T} = exp(T(im * gate.theta)) * IMatrix{T}(2)

# parametric interface
niparams(::Type{<:PhaseGate}) = 1
getiparams(x::PhaseGate) = x.theta
setiparams!(r::PhaseGate, param::Number) = (r.theta = param; r)
setiparams(r::PhaseGate, param::Number) = PhaseGate(param)
render_params(::PhaseGate{T}, ::Val{:random}) where {T} = (T(rand()*2π),)

# fallback to matrix method if it is not real
YaoAPI.isunitary(r::PhaseGate{<:Real}) = true

function YaoAPI.isunitary(r::PhaseGate)
    isreal(r.theta) && return true
    @warn "θ in phase(θ) is not real, got $(r.theta), fallback to matrix-based method"
    return isunitary(mat(r))
end
YaoAPI.isdiagonal(r::PhaseGate) = true

Base.adjoint(blk::PhaseGate) = PhaseGate(-blk.theta)
Base.copy(block::PhaseGate{T}) where {T} = PhaseGate{T}(block.theta)
Base.:(==)(lhs::PhaseGate, rhs::PhaseGate) = lhs.theta == rhs.theta

cache_key(gate::PhaseGate) = gate.theta

function iparams_range(::PhaseGate{T}) where {T}
    return ((zero(T), T(2.0 * pi)),)
end

using YaoBlocks, Test
using YaoArrayRegister
using YaoBlocks: check_dumpload

block_A(i, j) = control(i, j => shift(2π / (1 << (i - j + 1))))
block_B(n, i) = chain(n, i == j ? put(i => H) : block_A(j, i) for j = i:n)
qft(n) = chain(block_B(n, i) for i = 1:n)

@testset "map address" begin
    # chain, put, concentrator
    c2 = map_address(
        chain(5, subroutine(5, put(2, 2 => X), (4, 1)), put(5, 3 => X)),
        AddressInfo(10, [2, 1, 4, 6, 3]),
    )
    @test c2 == chain(10, subroutine(10, put(2, 2 => X), (6, 2)), put(10, 4 => X))

    # control, kron, rot
    c3 = map_address(
        chain(5, control(5, 2, 1 => Rx(0.3)), kron(5, 2 => Y, 3 => X)),
        AddressInfo(10, [2, 1, 4, 6, 3]),
    )
    @test c3 == chain(10, control(10, 1, 2 => Rx(0.3)), kron(10, 1 => Y, 4 => X))

    # repeat, measure
    c4 = map_address(
        chain(5, repeat(5, Y, (2, 3)), Measure(5), Measure(5; locs = (3, 2, 1))),
        AddressInfo(10, [2, 1, 4, 6, 3]),
    )
    @test c4 == chain(
        10,
        repeat(10, Y, (1, 4)),
        Measure(10; locs = (2, 1, 4, 6, 3)),
        Measure(10; locs = (4, 1, 2)),
    )

    # sum, cache, scale
    c5 = map_address(
        2 * put(5, 2 => X) + Daggered(Scale(Val(2), put(5, 3 => X) |> cache)),
        AddressInfo(10, [2, 1, 4, 6, 3]),
    )
    @test c5 == 2 * put(10, 1 => X) + Daggered(Scale(Val(2), put(10, 4 => X) |> cache))

    # qft
    c = qft(4)
    @test mat(subroutine(10, c, (6, 2, 3, 7))) ≈
          mat(map_address(c, AddressInfo(10, [6, 2, 3, 7])))
end

using Test, YaoBlocks, YaoBlocks.ConstGate

@testset "primitive blocks" begin
    @test qasm(I2) == "id"
    @test qasm(X) == "x"
    @test qasm(Y) == "y"
    @test qasm(Z) == "z"
    @test qasm(S) == "s"
    @test qasm(T) == "t"
    @test qasm(Sdag) == "inv @ s"
    @test qasm(Tdag) == "inv @ t"
    @test qasm(Rx(0.7)) == "rx(0.7)"
    @test qasm(Ry(0.7)) == "ry(0.7)"
    @test qasm(Rz(0.7)) == "rz(0.7)"

    # customized gate
    @test qasm(matblock(rand_unitary(4); tag="zz")) == "zz"

    # phase gate
    @test qasm(shift(0.7)) == "p(0.7)"

    # undefined gate
    @const_gate UU = rand_unitary(4)
    @test_throws ErrorException qasm(UU)
end

@testset "put block" begin
    # note qubit index of OpenQASM is 0-based
    @test qasm(put(6, 5=>X)) == "x q[4]"
end

@testset "control block" begin
    # QASM 2.0 compatible gates
    @test qasm(control(6, 3, 5=>X)) == "cx q[2], q[4]"
    @test qasm(control(6, 3, 5=>Y)) == "cy q[2], q[4]"
    @test qasm(control(6, 3, 5=>Z)) == "cz q[2], q[4]"
    @test qasm(control(6, 3, 5=>H)) == "ch q[2], q[4]"
    @test qasm(control(6, 3, 5=>shift(0.5))) == "cu1(0.5) q[2], q[4]"
    @test qasm(control(6, 3, 5=>Rz(0.5))) == "crz(0.5) q[2], q[4]"

    # Toffoli gate
    @test qasm(control(6, (2, 3), 5=>X)) == "ccx q[1], q[2], q[4]"

    # Fallback to QASM 3.0 syntax for negative controls
    @test qasm(control(6, -3, 5=>X)) == "negctrl @ x q[2], q[4]"
    @test qasm(control(6, (-3, 2), 5=>X)) == "negctrl @ ctrl @ x q[2], q[1], q[4]"

    # cphase with negative control (fallback)
    @test qasm(control(6, (-3, 2), 5=>shift(0.5))) == "negctrl @ ctrl @ p(0.5) q[2], q[1], q[4]"
end

@testset "chain block" begin
    # Single-element chain is simplified to the inner block by canonicalize
    @test qasm(chain(put(6, 5=>X))) == "x q[4]"
    @test qasm(chain(put(6, 5=>X), put(6, 3=>X))) == "x q[4];\nx q[2];\n"
    expected = "OPENQASM 2.0;\ninclude \"qelib1.inc\";\nqreg q[6];\ncreg c[6];\nx q[4];\nx q[2];\n"
    @test qasm(chain(put(6, 5=>X), put(6, 3=>X)); include_header=true) == expected
    @test_throws AssertionError qasm(chain(X, Y))

    # nested chain blocks are flattened by canonicalize
    nested = chain(2, chain(put(2, 1=>X), put(2, 2=>Y)), chain(put(2, 1=>Z)))
    @test qasm(nested) == "x q[0];\ny q[1];\nz q[0];\n"
end

@testset "dagger block" begin
    @test qasm(Daggered(put(6, 5=>X))) == "inv @ x q[4]"
end

@testset "compile-parse roundtrip" begin
    using YaoBlocks.YaoArrayRegister: fidelity, rand_state

    # Test roundtrip for various circuits
    circuits = [
        # Simple gates
        chain(2, put(1=>H), put(2=>X)),
        # Controlled gates
        chain(2, put(1=>H), control(1, 2=>X)),
        # Controlled phase
        chain(3, put(1=>H), control(2, 1=>shift(π/4)), control(3, 1=>shift(π/8))),
        # Toffoli
        chain(3, put(1=>H), control((1, 2), 3=>X)),
        # Rotation gates
        chain(2, put(1=>Rx(0.5)), put(2=>Ry(0.7)), put(1=>Rz(0.3))),
    ]

    for (i, circuit) in enumerate(circuits)
        qasm_str = qasm(circuit; include_header=true)
        task = parseblock(qasm_str)
        parsed = task.circuit

        # Test functional equivalence
        n = nqubits(circuit)
        reg1 = rand_state(n)
        reg2 = copy(reg1)
        apply!(reg1, circuit)
        apply!(reg2, parsed)
        @test fidelity(reg1, reg2) ≈ 1.0 atol=1e-10
    end
end

using YaoBlocks, YaoArrayRegister
using Test, LinearAlgebra

@testset "test reflect gate" begin
    for reg in [rand_state(3), arrayreg(rand_unitary(8)[:,1:3]; nbatch=3)]
        rf = reflect(reg)
        reg0 = rand_state(3)
        reg = copy(reg0)
        apply!(reg, rf)

        v0, v1 = reg.state, reg0.state
        @test mat(rf) * state(reg0) ≈ state(apply!(copy(reg0), rf))
        @test state(rf.H.psi)' * v0 ≈ -state(rf.H.psi)' * v1
        @test isapprox(v0 - state(rf.H.psi) * (state(rf.H.psi)'*v0),
            (v1- state(rf.H.psi) * (state(rf.H.psi)' * v1)); atol=1e-8)

        @test mat(ComplexF32, rf) ≈ ComplexF32.(mat(rf))

        @test rf == reflect(rf.H.psi)
        # copy do not occur on register
        @test copy(rf) == rf

        @test isunitary(rf) == isunitary(mat(rf))
        @test (mat(rf) ≈ mat(rf)') == ishermitian(rf)
        @test isreflexive(mat(rf)) == isreflexive(rf)
    end

    rf = reflect(arrayreg(rand_unitary(8)[:,1:3]; nbatch=3), π/8)
    reg0 = rand_state(3)
    reg = copy(reg0)
    apply!(reg, rf)

    v0, v1 = reg.state, reg0.state
    @test mat(rf) * state(reg0) ≈ state(apply!(copy(reg0), rf))
    @test invoke(mat, Tuple{TimeEvolution}, rf) ≈ mat(rf)
    @test state(rf.H.psi)' * v0 ≈ exp(-im*π/8)*state(rf.H.psi)' * v1
    @test isapprox(v0 - state(rf.H.psi) * (state(rf.H.psi)'*v0),
        (v1- state(rf.H.psi) * (state(rf.H.psi)' * v1)); atol=1e-8)

    @test mat(ComplexF32, rf) ≈ ComplexF32.(mat(rf))

    @test rf == reflect(rf.H.psi, π/8)
    # copy do not occur on register
    @test copy(rf) == rf

    @test isunitary(rf) == isunitary(mat(rf))
    @test (mat(rf) ≈ mat(rf)') == ishermitian(rf)
    @test isreflexive(mat(rf)) == isreflexive(rf)
end

"""
    pauli_error_channel(; px::Real, py::Real=px, pz::Real=px)

Create the Pauli error channel as a [`UnitaryChannel`](@ref)

```math 
    (1 - (p_x + p_y + p_z))⋅ρ + p_x⋅XρX + p_y⋅YρY  + p_z⋅ZρZ
```
"""
function pauli_error_channel(; px::Real, py::Real=px, pz::Real=px)
    pz + px + py ≤ 1 || throw(ArgumentError("sum of error probability is larger than 1"))
    return UnitaryChannel(
        [I2, X, Y, Z],
        [1-(px+py+pz), px, py, pz],
    )
end

"""
    bit_flip_channel(p::Real)

Create a bit flip channel as a [`UnitaryChannel`](@ref).

```math
(1-p)⋅ρ + p⋅XρX
```
"""
function bit_flip_channel(p::Real)
    return unitary_channel([I2, X], [1-p, p])
end

"""
    phase_flip_channel(::Real)

Create a phase flip channel as [`UnitaryChannel`](@ref).

```math
(1-p)⋅ρ + p⋅ZρZ
```
"""
function phase_flip_channel(p::Real)
    return UnitaryChannel([I2, Z], [1-p, p])
end

struct DepolarizingChannel{T} <: PrimitiveBlock{2}
    n::Int # n is not necessary but this is required by a block
    p::T
end

YaoAPI.nqudits(ch::DepolarizingChannel) = ch.n

function YaoAPI.unsafe_apply!(dm::DensityMatrix, ch::DepolarizingChannel)
    regscale!(dm, 1 - ch.p)
    dm.state .+= ch.p/(2^nqubits(dm)) * IMatrix(size(dm.state, 1))
    return dm
end

"""
    depolarizing_channel(n::Int; p::Real)

Create a global depolarizing channel.

### Arguments
- `n`: number of qubits.

### Keyword Arguments
- `p`: probability of this error to occur.

### See also
[`single_qubit_depolarizing_channel`](@ref) and [`two_qubit_depolarizing_channel`](@ref)
for depolarizing channels acting on only one or two qubits.
"""
function depolarizing_channel(n::Int; p::Real)
    return DepolarizingChannel(n, p)
end

"""
    single_qubit_depolarizing_channel(p::Real)

Create a single-qubit depolarizing channel.

The factor of 3/4 in front of p ensures that 
`single_qubit_depolarizing_channel(p) == depolarizing_channel(1, p)`

```math
(1 - 3p/4 ⋅ρ) + p/4⋅(XρX + YρY + ZρZ)
```
"""
function single_qubit_depolarizing_channel(p::Real)
    return pauli_error_channel(px=p/4, py=p/4, pz=p/4)
end

"""
    two_qubit_depolarizing_channel(p::Real)

Create a two-qubit depolarizing channel. Note that this is not the same 
as `kron(single_qubit_depolarizing_channel(p), single_qubit_depolarizing_channel(p))`.
"""
function two_qubit_depolarizing_channel(p::Real)
    return UnitaryChannel(
        [kron(I2, I2), kron(I2, X), kron(I2, Y), kron(I2, Z),
         kron(X, I2), kron(X, X), kron(X, Y), kron(X, Z),
         kron(Y, I2), kron(Y, X), kron(Y, Y), kron(Y, Z),
         kron(Z, I2), kron(Z, X), kron(Z, Y), kron(Z, Z),
        ],
        [1-15p/16, p/16, p/16, p/16,
         p/16, p/16, p/16, p/16,
         p/16, p/16, p/16, p/16,
         p/16, p/16, p/16, p/16,
        ],
    )
end

using Test
using YaoBlocks.AD
using YaoBlocks, YaoArrayRegister
using Random

@testset "apply put" begin
    Random.seed!(5)
    for reg0 in [rand_state(3), rand_state(3, nbatch = 10)]
        # put block, diagonal
        @test test_apply_back(reg0, put(3, 1 => shift(0.5)), 0.5; δ = 1e-5)
        @test test_apply_back(reg0, control(3, (2, 3), 1 => Rz(0.5)), 0.5; δ = 1e-5)
        @test test_apply_back(reg0, control(3, 2, 1 => shift(0.5)), 0.5; δ = 1e-5)
        # dense matrix
        @test test_apply_back(reg0, put(3, 1 => cache(Rx(0.5))), 0.5; δ = 1e-5)
        @test test_apply_back(
            reg0,
            put(3, 1 => chain(Rz(0.5), Rx(0.8))),
            [0.5, 0.8];
            δ = 1e-5,
        )
        @test test_apply_back(reg0, control(3, (2, 3), 1 => Rx(0.5)), 0.5; δ = 1e-5)
        # sparse matrix csc
        @test test_apply_back(reg0, put(3, (1, 2) => rot(SWAP, 0.5)), 0.5; δ = 1e-5)
        @test test_apply_back(
            reg0,
            control(3, (3,), (1, 2) => rot(SWAP, 0.5)),
            0.5;
            δ = 1e-5,
        )

        # special cases: DiffBlock
        @test test_apply_back(reg0, put(3, 1 => Rz(0.5)), 0.5; δ = 1e-5)
        @test test_apply_back(reg0, put(3, 1 => Rx(0.5)), 0.5; δ = 1e-5)
        @test test_apply_back(rand_state(1), Rx(0.0), 0.5; δ = 1e-5)

        # TimeEvolution
        @test test_apply_back(reg0, TimeEvolution(put(3, 1 => X), 0.5), 0.5; δ = 1e-5)

        # scale
        @test test_apply_back(reg0, Scale(3.0, put(3, 1 => X)), 3.5; δ = 1e-5)
        @test test_apply_back(reg0, Scale(3.0, put(3, 1 => Scale(2.0,Y))), [1.3, 0.6]; δ = 1e-5)
        @test test_apply_back(reg0, chain(Scale(2.0, repeat(3,X)), Scale(3.0, put(3, 1 => Scale(2.0,Y)))), [-0.4, 2.0, -0.2]; δ = 1e-5)
    end
end

@testset "apply chain" begin
    Random.seed!(5)
    for reg0 in [rand_state(3), rand_state(3, nbatch = 10)]
        @test test_apply_back(
            reg0,
            chain(3, put(3, 1 => shift(0.0)), control(3, (2, 3), 1 => Rz(0.0))),
            [0.5, 0.5];
            δ = 1e-5,
        )
        c = chain(3, put(3, 1 => shift(0.0)), NoParams(control(3, (2, 3), 1 => Rz(0.0))))
        @test nparameters(c) == 1
        @test test_apply_back(reg0, c, 0.5; δ = 1e-5)
    end
end

@testset "apply dagger, scale" begin
    Random.seed!(5)
    for reg0 in [rand_state(3), rand_state(3, nbatch = 10)]
        @test test_apply_back(
            reg0,
            chain(put(3, 1 => Rx(0.0)), 3.0 * control(3, (2, 3), 1 => Rz(0.0))),
            [0.5, 1.5, 0.6];
            δ = 1e-5,
        )
        @test test_apply_back(reg0, Daggered(put(3, 1 => Rx(0.0))), 0.5; δ = 1e-5)
        @test test_apply_back(
            reg0,
            control(3, (2, 3), 1 => Daggered(Rz(0.0))),
            0.5;
            δ = 1e-5,
        )
        @test test_apply_back(
            reg0,
            chain(
                3,
                Daggered(put(3, 1 => Rx(0.0))),
                control(3, (2, 3), 1 => Daggered(Rz(0.0))),
            ),
            [0.5, 0.5];
            δ = 1e-5,
        )
    end
end

@testset "apply subroutine" begin
    Random.seed!(5)
    for reg0 in [rand_state(3), rand_state(3, nbatch = 10)]
        @test test_apply_back(
            reg0,
            chain(
                3,
                put(3, 1 => Rx(0.0)),
                subroutine(3, control(2, 2, 1 => shift(0.0)), (3, 1)),
            ),
            [0.5, 0.5];
            δ = 1e-5,
        )
    end
end

@testset "apply kron repeated" begin
    Random.seed!(5)
    for reg0 in [rand_state(3), rand_state(3, nbatch = 10)]
        @test test_apply_back(
            reg0,
            chain(3, put(3, 1 => Rx(0.0)), kron(Rx(0.4), Y, Rz(0.5))),
            [0.5, 0.3, 0.8];
            δ = 1e-5,
        )
        @test test_apply_back(
            reg0,
            chain(repeat(3, Rx(0.5), 1:2), repeat(3, Ry(0.6), 2:3)),
            [0.5, 0.8];
            δ = 1e-5,
        )
        @test test_apply_back(
            reg0,
            chain(repeat(3, H, 1:2), repeat(3, Ry(0.6), 2:3)),
            [0.8];
            δ = 1e-5,
        )
    end
end

@testset "apply Add" begin
    # + is not reversible
    for reg0 in [rand_state(3), rand_state(3, nbatch = 10)]
        @test_broken test_apply_back(
            reg0,
            0.2 * (3.0 * control(3, (2, 3), 1 => Rz(0.0)) + put(3, 2 => Rx(0.0))),
            [0.5, 0.9, 0.6, 0.1];
            δ = 1e-5,
            in = copy(reg0),
        )
    end
end

export NoParams

struct NoParams{D,BT<:AbstractBlock{D}} <: TagBlock{BT,D}
    content::BT
end

YaoBlocks.parameters!(out, x::NoParams) = out
YaoBlocks.nparameters(x::NoParams) = 0
YaoBlocks.niparams(x::NoParams) = 0
YaoBlocks.mat(::Type{T}, x::NoParams) where {T} = mat(T, content(x))
YaoAPI.unsafe_apply!(r::AbstractRegister, pb::NoParams) = YaoAPI.unsafe_apply!(r, pb.content)
YaoBlocks.PropertyTrait(x::NoParams) = PreserveAll()
YaoBlocks.dispatch!(f::Union{Function,Nothing}, x::NoParams, it::YaoBlocks.Dispatcher) = x
YaoBlocks.generic_dispatch!(f::Union{Function,Nothing}, x::NoParams, it::YaoBlocks.Dispatcher) = x
Base.adjoint(x::NoParams) = NoParams(adjoint(content(x)))
YaoBlocks.chsubblocks(x::NoParams, blk::AbstractBlock) = NoParams(blk)
YaoBlocks.gatecount!(c::NoParams, storage::AbstractDict) = YaoBlocks.gatecount!(c.content, storage)

using YaoBlocks, YaoArrayRegister
using Test

@testset "check apply" begin
    r = rand_state(1)
    @test_throws ErrorException UnitaryChannel([X, Y, Z], [1, 0.2, 0])
    channel = UnitaryChannel([X, Y, Z], [1, 0, 0])
    print(channel)
    k1 = cache_key(channel)
    k2 = cache_key(chsubblocks(channel, [Z, Z, Z]))
    @test k1 != k2
    # broken because Unitary channel does not have a matrix representation
    @test_throws ErrorException apply!(copy(r), channel)
    @test apply!(density_matrix(r), channel) ≈ density_matrix(apply!(copy(r), X))

    r = rand_state(3)
    @test_throws QubitMismatchError apply!(copy(r), channel)
end

@testset "check mat" begin
    @test_throws ErrorException mat(UnitaryChannel([X, Y, Z], [1, 0, 0]))
end

@testset "check compare" begin
    @test UnitaryChannel([X, Y, Z], [1, 0, 0]) == UnitaryChannel([X, Y, Z], [1, 0, 0])
    @test_throws AssertionError UnitaryChannel([X, Y], [1, 1, 0])
end

@testset "check adjoint" begin
    channel = UnitaryChannel([X, Y, Z], [0.2, 0.8, 0.0])
    adj_channel = adjoint(channel)
    @test adjoint.(adj_channel.operators) == channel.operators
end

@testset "check ocuppied locations" begin
    channel = UnitaryChannel(put.(6, [1 => X, 3 => Y, 5 => Z]), [0.1, 0.2, 0.7])
    @test occupied_locs(channel) == [1, 3, 5]
end

@testset "density matrix" begin
    @test_throws ErrorException UnitaryChannel(put.(6, [1 => X, 3 => Y, 5 => Z]), [0.1, 0.3, 0.1])
    ops = put.(6, [1 => chain(Rx(0.4), Ry(0.5), Rz(0.4)), 3 => Y, 5 => Z])
    channel = UnitaryChannel(ops, [0.3, 0.1, 0.6])
    r = density_matrix(rand_state(12), (3,2,1,5,6,9))
    ms = mat.(ops)
    @test apply(r, channel).state ≈ channel.probs[1] * ms[1] * r.state * ms[1]' + channel.probs[2] * ms[2] * r.state * ms[2]' + channel.probs[3] * ms[3] * r.state * ms[3]'

    channel1 = unitary_channel([put(6, 2=>chain(Rx(0.4), Ry(0.5), Rz(0.4))), put(6, 3=>Y), put(6, 2=>Z)], [0.3, 0.1, 0.6])
    ops = unitary_channel([put(2, 1=>chain(Rx(0.4), Ry(0.5), Rz(0.4))), put(2,2=>Y), put(2,1=>Z)], [0.3, 0.1, 0.6])
    channel2 = put(6, (2,3)=>ops)
    @test apply(r, channel1) ≈ apply(r, channel2)
end

@testset "kron and repeat" begin
    dm = density_matrix(ghz_state(5), 1:3)
    dpolarizing = single_qubit_depolarizing_channel(0.1)
    dmkron = apply(dm, kron(3, 1=>dpolarizing, 2=>dpolarizing))
    dmrepeat = apply(dm, repeat(3, dpolarizing, (1, 2)))
    dmput = apply(apply(dm, put(3, 1=>dpolarizing)), put(3, 2=>dpolarizing))
    @test dmkron ≈ dmrepeat
    @test dmkron ≈ dmput
end

using Test, YaoBlocks, BitBasis
using YaoBlocks: check_dumpload

@testset "check_dumpload" begin
    @test check_dumpload(X)
    @test check_dumpload(X + Y)
    @test check_dumpload(+(put(5, 4 => X), put(5, 5 => X)))
    @test check_dumpload(kron(put(1, 1 => X), Y))
    @test check_dumpload(kron(5, 2 => X, 4 => Y))
    @test check_dumpload(shift(0.5))
    @test check_dumpload(phase(0.5))
    @test check_dumpload(time_evolve(X, 0.5))
    @test check_dumpload(put(5, 2 => X))
    @test check_dumpload(chain(put(5, 2 => X)))
    @test check_dumpload(put(5, 2 => rot(X, 0.5)))
    @test check_dumpload(control(5, 1, 2 => rot(X, 0.5)))
    @test check_dumpload(control(5, (1, -4), 2 => rot(X, 0.5)))
    @test check_dumpload(subroutine(5, rot(SWAP, 0.5), (2, 5)))
    @test check_dumpload(repeat(5, put(1, 1 => X), (2, 5)))
    @test check_dumpload(Measure(5))
    @test check_dumpload(Measure(5, operator = put(5, 2 => X)))
    @test check_dumpload(Measure(5, locs = (3, 1), resetto = bit"01"))
    @test check_dumpload(
        Measure(5, locs = (3, 2), operator = put(2, 2 => X), resetto = bit"11"),
    )
    @test check_dumpload(Daggered(X))
    @test check_dumpload(2 * X)
    @test check_dumpload(cache(2 * X))
    @test_throws ErrorException check_dumpload(kron(5, 2:3 => SWAP))

    block_A(i, j) = control(i, j => shift(2π / (1 << (i - j + 1))))
    block_B(n, i) = chain(n, i == j ? put(i => H) : block_A(j, i) for j = i:n)
    qft(n) = chain(block_B(n, i) for i = 1:n)
    @test check_dumpload(qft(5))
end

@testset "yao macro" begin
    c = yao"""
    let nqubits = 5
        3 => rot(X, 0.3)
        2 => X
    end
    """
    c2 = @yaoscript let nqubits = 5
        3 => rot(X, 0.3)
        2 => X
    end

    y = chain(5, put(3 => rot(X, 0.3)), put(2 => X))
    @test c == y
    @test c == c2
    @test check_dumpload(y)
    yaotofile("_test.yao", y)
    yy = @eval $(yaofromfile("_test.yao"))
    @test y == yy

    g = eval(yaofromfile(joinpath(dirname(@__FILE__), "yaoscript.yao")))
    s = string(yaotoscript(g))
    g1 = eval(yaofromstring(s))
    @test g == g1
end

export Add, AbstractAdd

# We need this abstract type for supporting Hamiltonian types.
"""
    AbstractAdd{D} <: CompositeBlock{D}

The abstract add interface, aimed to support Hamiltonian types.

### Required Interfaces
* `chsubblocks`
* `subblocks`

### Provides
* `unsafe_apply!` and its backward
* `mat` and its backward
* `adjoint`
* `occupied_locs`
* `getindex` over dit strings
* `ishermitian`
"""
abstract type AbstractAdd{D} <: CompositeBlock{D} end

"""
    Add{D} <: AbstractAdd{D}
    Add(blocks::AbstractBlock...) -> Add

Type for block addition.

```jldoctest; setup=:(using Yao)
julia> X + X
nqubits: 1
+
├─ X
└─ X
```
"""
struct Add{D} <: AbstractAdd{D}
    n::Int
    list::Vector{AbstractBlock{D}}
    Add(n::Int, blocks::Vector{AbstractBlock{D}}) where {D} = new{D}(_check_block_sizes(blocks, n), blocks)
    Add(blocks::Vector{AbstractBlock{D}}) where {D} = new{D}(_check_block_sizes(blocks), blocks)
    Add(n::Int; nlevel=2) = new{nlevel}(n, AbstractBlock{nlevel}[])
end

Add(blocks::NTuple{M,AbstractBlock{D}}) where {M,D} = Add(collect(AbstractBlock{D}, blocks))
Add(n::Int, blocks::AbstractVector{<:AbstractBlock{D}}) where {D} = Add(n, collect(AbstractBlock{D}, blocks))
Add(blocks::AbstractVector{<:AbstractBlock{D}}) where {D} = Add(collect(AbstractBlock{D}, blocks))
Add(block::AbstractBlock{D}, blocks::AbstractBlock{D}...) where {D} = Add(AbstractBlock{D}[block, blocks...])
nqudits(add::Add) = add.n

function mat(::Type{T}, x::AbstractAdd{D}) where {D,T}
    blocks = subblocks(x)
    length(blocks) == 0 && return Diagonal(zeros(T, D^x.n))
    mapreduce(x -> mat(T, x), +, blocks)
end

chsubblocks(x::Add, it) = Add(it)
chsubblocks(x::Add, it::AbstractBlock) = chsubblocks(x, (it,))

function YaoAPI.unsafe_apply!(r::AbstractRegister, x::AbstractAdd)
    blocks = subblocks(x)
    isempty(blocks) && return r
    length(blocks) == 1 && return YaoAPI.unsafe_apply!(r, blocks[])

    res = mapreduce(blk -> YaoAPI.unsafe_apply!(copy(r), blk), regadd!, blocks[1:end-1])
    YaoAPI.unsafe_apply!(r, blocks[end])
    regadd!(r, res)
    r
end

export Add

subblocks(x::Add) = x.list
cache_key(x::Add) = map(cache_key, subblocks(x))
Base.copy(x::Add) = Add(x.n, copy(subblocks(x)))
Base.similar(c::Add) = Add(c.n, empty!(similar(subblocks(c))))

function Base.:(==)(lhs::Add{D}, rhs::Add{D}) where {D}
    nqudits(lhs) == nqudits(rhs) && (length(lhs.list) == length(rhs.list)) && all(lhs.list .== rhs.list)
end

for FUNC in [:length, :iterate, :eltype, :eachindex, :popfirst!, :lastindex]
    @eval Base.$FUNC(x::Add, args...) = $FUNC(subblocks(x), args...)
end
Base.getindex(x::Add, i::Integer) = getindex(subblocks(x), i)
Base.getindex(c::Add{D}, index::Union{UnitRange,Vector}) where {D} =
    Add(c.n, getindex(c.list, index))
Base.setindex!(c::Add{D}, val::AbstractBlock{D}, index::Integer) where {D} =
    (setindex!(c.list, val, index); c)
Base.insert!(c::Add{D}, index::Integer, val::AbstractBlock{D}) where {D} =
    (insert!(c.list, index, val); c)
Base.adjoint(blk::AbstractAdd{D}) where {D} = chsubblocks(blk, map(adjoint, subblocks(blk)))

## Iterate contained blocks
occupied_locs(c::AbstractAdd) =
    (unique(Iterators.flatten(occupied_locs(b) for b in subblocks(c)))...,)

# Additional Methods for Add
Base.push!(c::Add{D}, val::AbstractBlock{D}) where {D} = (_check_block_sizes(c, val); push!(c.list, val); c)

function Base.push!(c::Add{D}, val::Function) where {D}
    push!(c, val(c.n))
end

function Base.append!(c::Add, list)
    for blk in list
        push!(c, blk)
    end
    c
end

function Base.prepend!(c::Add, list)
    for blk in list[end:-1:1]
        insert!(c, 1, blk)
    end
    c
end

LinearAlgebra.ishermitian(ad::AbstractAdd) = all(ishermitian, subblocks(ad)) || ishermitian(mat(ad))

# this is not type stable, possible to fix?
function unsafe_getindex(::Type{T}, ad::AbstractAdd{D}, i::Integer, j::Integer) where {T, D}
    blocks = subblocks(ad)
    !isempty(blocks) ? sum(b->unsafe_getindex(T,b,i,j), subblocks(ad)) : zero(T)
end
function unsafe_getcol(::Type{T}, ad::AbstractAdd{D}, j::DitStr{D,N,TI}) where {T,D,N,TI}
    blocks = subblocks(ad)
    isempty(blocks) && return DitStr{D,N,TI}[], T[]
    locs = Vector{DitStr{D,N,TI}}[]
    amps = Vector{T}[]
    for block in blocks
        loc, amp = unsafe_getcol(T, block, j)
        push!(locs, loc)
        push!(amps, amp)
    end
    return vcat(locs...), vcat(amps...)
end
function Base.getindex(b::AbstractAdd{D}, i::DitStr{D,N}, j::DitStr{D,N}) where {D,N}
    invoke(Base.getindex, Tuple{AbstractBlock{D}, DitStr{D,N}, DitStr{D,N}} where {D,N}, b, i, j)
end
function Base.getindex(b::AbstractAdd{D}, ::Colon, j::DitStr{D,N}) where {D,N}
    T = promote_type(ComplexF64, parameters_eltype(b))
    return cleanup(_getindex(T, b, :, j))
end
function Base.getindex(b::AbstractAdd{D}, i::DitStr{D,N}, ::Colon) where {D,N}
    T = promote_type(ComplexF64, parameters_eltype(b))
    return cleanup(_getindex(T, b, i, :))
end
# the performance of this block important! so specialize it will make it slightly faster.
function Base.getindex(ad::AbstractAdd{D}, ::Colon, j::EntryTable{DitStr{D,N,TI},T}) where {D,N,TI,T}
    cfgs = Vector{DitStr{D,N,TI}}[]
    amps = Vector{T}[]
    for b in subblocks(ad)
        _single_block!(cfgs, amps, b, j)
    end
    return cleanup(merge(EntryTable(vcat(cfgs...), vcat(amps...))))
end
function _single_block!(cfgs, amps, b, j::EntryTable)
    for (c, a) in zip(j.configs, j.amplitudes)
        et = b[:,c]
        rmul!(et.amplitudes, a)
        push!(cfgs, et.configs)
        push!(amps, et.amplitudes)
    end
end
function Base.getindex(ad::AbstractAdd{D}, i::EntryTable{DitStr{D,N,TI},T}, ::Colon) where {D,N,TI,T}
    return cleanup(_getindex(ad, i, :))
end

# NOTE: this can have a better support in YaoIR directly with StatsBase
# as an compiled instruction, but store the probabilities is the best solution
# here

"""
    UnitaryChannel{D, W<:AbstractVector} <: CompositeBlock{D}
    UnitaryChannel(operators, probs)

Create a unitary channel, where `probs` is a real vector that sum up to 1.
"""
struct UnitaryChannel{D, W<:AbstractVector} <: CompositeBlock{D}
    n::Int
    operators::Vector{AbstractBlock{D}}
    probs::W

    function UnitaryChannel(operators::Vector{AbstractBlock{D}}, w::AbstractVector) where D
        @assert length(operators) == length(w) && length(w) != 0
        if !(all(x->x>=0, w) && sum(w) ≈ 1)
            error("The probabilities must be ⩾ 0 and its sum must be 1!")
        end
        n = _check_block_sizes(operators)
        new{D,typeof(w)}(n, operators, w)
    end
end

function UnitaryChannel(it, probs)
    length(it) == 0 && error("The input operator list size can not be 0!")
    D = nlevel(first(it))
    UnitaryChannel(collect(AbstractBlock{D}, it), probs)
end
nqudits(uc::UnitaryChannel) = uc.n

function YaoAPI.unsafe_apply!(r::DensityMatrix{D,T}, x::PutBlock{D,C,<:UnitaryChannel}) where {D,C,T}
    unsafe_apply!(r, UnitaryChannel([PutBlock(x.n, operator, x.locs) for operator in x.content.operators], x.content.probs))
end
function YaoAPI.unsafe_apply!(r::DensityMatrix{D,T}, x::UnitaryChannel) where {D,T}
    r0 = copy(r)
    # first
    regscale!(unsafe_apply!(r, first(x.operators)), first(x.probs))
    for (w, o) in zip(x.probs[2:end-1], x.operators[2:end-1])
        r.state .+= w .* unsafe_apply!(copy(r0), o).state
    end
    # last
    r.state .+= last(x.probs) .* unsafe_apply!(r0, last(x.operators)).state
    return r
end

function YaoAPI.unsafe_apply!(r::DensityMatrix{D,T}, 
                              k::KronBlock{D,M,NTuple{M,U}}) where {D,M,T,U<:UnitaryChannel}
    for (locs, block) in zip(k.locs, k.blocks)
        YaoAPI.unsafe_apply!(r, put(k.n, locs => block))
    end
    return r
end

function mat(::Type{T}, x::UnitaryChannel) where {T}
    error("`UnitaryChannel` does not have a matrix representation!")
end

subblocks(x::UnitaryChannel) = x.operators
chsubblocks(x::UnitaryChannel, it) = UnitaryChannel(collect(it), x.probs)
occupied_locs(x::UnitaryChannel) = union(occupied_locs.(x.operators)...)

function cache_key(x::UnitaryChannel)
    key = hash(x.probs)
    for each in x.operators
        key = hash(each, key)
    end
    return key
end

function Base.:(==)(lhs::UnitaryChannel, rhs::UnitaryChannel)
    return (lhs.n == rhs.n) && (lhs.probs == rhs.probs) && (lhs.operators == rhs.operators)
end

Base.adjoint(x::UnitaryChannel) = UnitaryChannel(adjoint.(x.operators), x.probs)

"""
    unitary_channel(operators, probs) -> UnitaryChannel

Returns a [`UnitaryChannel`](@ref) instance, where ``operators` is a list of operators, `probs` is a real vector that sum up to 1.
The unitary channel is defined as below

```math
\\phi(\\rho) = \\sum_i p_i U_i ρ U_i^\\dagger,
```

where ``\\rho`` in a [`DensityMatrix`](@ref) as the register to apply on, ``p_i`` is the i-th element in `probs`, `U_i` is the i-th operator in `operators`.

### Examples

```jldoctest; setup=:(using Yao)
julia> unitary_channel([X, Y, Z], [0.1, 0.2, 0.7])
nqubits: 1
unitary_channel
├─ [0.1] X
├─ [0.2] Y
└─ [0.7] Z
```
"""
unitary_channel(operators, probs::AbstractVector) = UnitaryChannel(operators, probs)

export KronBlock, kron

const KronLocT = Union{Int,UnitRange{Int}}

"""
    KronBlock{D,M,MT<:NTuple{M,Any}} <: CompositeBlock{D}

composite block that combine blocks by kronecker product.
"""
struct KronBlock{D,M,MT<:NTuple{M,Any}} <: CompositeBlock{D}
    n::Int
    locs::NTuple{M,UnitRange{Int}}
    blocks::MT

    function KronBlock{D,M,MT}(n::Int,
        locs::NTuple{M,UnitRange{Int}},
        blocks::MT,
    ) where {D,M,MT<:NTuple{M,AbstractBlock{D}}}
        perm = TupleTools.sortperm(locs, by = first)
        locs = TupleTools.permute(locs, perm)
        blocks = TupleTools.permute(blocks, perm)
        @assert_locs_safe n locs

        for (each, b) in zip(locs, blocks)
            length(each) != nqudits(b) && throw(
                LocationConflictError("locs $locs is inconsistent with target block $b"),
            )
        end
        return new{D,M,typeof(blocks)}(n, locs, blocks)
    end
end

KronBlock(n::Int, ::Tuple{}, ::Tuple{}; nlevel=2) = KronBlock{nlevel,0,Tuple{}}(n, (), ())
KronBlock(n::Int,
    locs::NTuple{M,UnitRange{Int}},
    blocks::MT,
) where {D,M,MT<:NTuple{M,AbstractBlock{D}}} = KronBlock{D,M,MT}(n,locs, blocks)

function KronBlock(n::Int, itr::Pair{<:Any,<:AbstractBlock{D}}...) where {D}
    locs = map(itr) do p
        _render_kronloc(first(p))
    end
    return KronBlock(n, locs, last.(itr))
end

function KronBlock(itr::AbstractBlock...)
    locs = UnitRange{Int}[]
    count = 0
    for each in itr
        count += nqudits(each)
        push!(locs, count-nqudits(each)+1:count)
    end
    return KronBlock(count, (locs...,), itr)
end

KronBlock(blk::KronBlock) = copy(blk)

nqudits(pb::KronBlock) = pb.n

"""
    kron(n, locs_and_blocks::Pair{<:Any, <:AbstractBlock}...) -> KronBlock

Returns a `n`-qudit [`KronBlock`](@ref). The inputs contains a list of location-block pairs, where a location can be an integer or a range.
It is conceptually a [`chain`](@ref) of [`put`](@ref) block without address conflicts,
but it has a richer type information that can be useful for various purposes such as more efficient [`mat`](@ref) function.

Let ``I`` be a ``2\\times 2`` identity matrix, ``G`` and ``H`` be two ``2\\times 2`` matrix,
the matrix representation of `kron(n, i=>G, j=>H)` (assume ``j > i``) is defined as

```math
I^{\\otimes n-j} \\otimes H \\otimes I^{\\otimes j-i-1} \\otimes G \\otimes I^{i-1}
```

For multiple locations, the expression can be complicated.

### Examples

Use `kron` to construct a `KronBlock`, it will put an `X` gate on the `1`st qubit,
and a `Y` gate on the `3`rd qubit.

```jldoctest; setup=:(using Yao)
julia> kron(4, 1=>X, 3=>Y)
nqubits: 4
kron
├─ 1=>X
└─ 3=>Y
```
"""
Base.kron(total::Int, blocks::Pair{<:Any,<:AbstractBlock}...) = KronBlock(total, blocks...)
Base.kron(total::Int) = KronBlock(total)

"""
    kron(blocks::AbstractBlock...)
    kron(n, itr)

Return a [`KronBlock`](@ref), with total number of qubits `n`, and `blocks` should use all
the locations on `n` wires in quantum circuits.

### Examples

You can use kronecker product to composite small blocks to a large blocks.

```jldoctest; setup=:(using Yao)
julia> kron(X, Y, Z, Z)
nqubits: 4
kron
├─ 1=>X
├─ 2=>Y
├─ 3=>Z
└─ 4=>Z
```
"""
Base.kron(blocks::AbstractBlock...) = KronBlock(blocks...)
Base.kron(fs::Union{Function,AbstractBlock}...) = @λ(n -> kron(n, fs...))

function Base.kron(total::Int, blocks::AbstractBlock...)
    sum(nqudits, blocks) == total || error("total number of qubits mismatch")
    return kron(blocks...)
end

function _render_kronloc(l)
    for i = 1:length(l)-1
        l[i+1] == l[i] + 1 || error("Non-Contiguous location in Kron!")
    end
    l[1]:l[end]
end

Base.kron(total::Int, blocks::Base.Generator) = kron(total, blocks...)
function Base.kron(total::Int, blocks::Union{Pair{<:Any,<:AbstractBlock},AbstractBlock}...)
    throw(MethodError(:kron, blocks))
end

"""
    kron(blocks...) -> f(n)
    kron(itr) -> f(n)

Return a lambda, which will take the total number of qubits as input.

### Examples

If you don't know the number of qubit yet, or you are just too lazy, it is fine.

```jldoctest; setup=:(using Yao)
julia> kron(put(1=>X) for _ in 1:2)
(n -> kron(n, ((n  ->  put(n, 1 => X)), (n  ->  put(n, 1 => X)))...))

julia> kron(X for _ in 1:2)
nqubits: 2
kron
├─ 1=>X
└─ 2=>X

julia> kron(1=>X, 3=>Y)
(n -> kron(n, (1 => X, 3 => Y)...))
```
"""
Base.kron(blocks::Pair{<:Any,<:AbstractBlock}...) = @λ(n -> kron(n, blocks...))
Base.kron(blocks::Base.Generator) = kron(blocks...)

occupied_locs(k::KronBlock) = (vcat([[getindex.(Ref(loc), occupied_locs(b))...] for (loc, b) in zip(k.locs, k.blocks)]...)...,)
subblocks(x::KronBlock) = x.blocks
chsubblocks(pb::KronBlock, it) = KronBlock(pb.n, pb.locs, (it...,))
chsubblocks(x::KronBlock, it::AbstractBlock) = chsubblocks(x, (it,))
cache_key(x::KronBlock) = [cache_key(each) for each in x.blocks]
color(::Type{T}) where {T<:KronBlock} = :cyan

function mat(::Type{T}, k::KronBlock{D,M}) where {T,D,M}
    M == 0 && return IMatrix{T}(D^k.n)
    ntrail = k.n - last(last(k.locs))  # number of trailing bits
    num_bit_list = map(i -> first(k.locs[i]) - (i > 1 ? last(k.locs[i-1]) : 0) - 1, 1:M)
    return reduce(
        Iterators.reverse(zip(subblocks(k), num_bit_list)),
        init = IMatrix{T}(D^ntrail),
    ) do x, y
        fastkron(fastkron(x, mat(T, y[1])), IMatrix(D^y[2]))
    end
end

function YaoAPI.unsafe_apply!(r::AbstractRegister, k::KronBlock)
    for (locs, block) in zip(k.locs, k.blocks)
        _instruct!(r, block, Tuple(locs))
    end
    return r
end

function _instruct!(reg::AbstractRegister, block::AbstractBlock, locs)
    isnoisy(block) && return noisy_instruct!(reg, block, locs)
    instruct!(reg, mat_matchreg(reg, block), locs)
end
function noisy_instruct!(reg::AbstractRegister, k::KronBlock, locs)
    for (loc, block) in zip(k.locs, k.blocks)
        if isnoisy(block)
            noisy_instruct!(reg, block, Tuple(map(i -> locs[i], loc)))
        else
            instruct!(reg, mat_matchreg(reg, block), Tuple(map(i -> locs[i], loc)))
        end
    end
    return reg
end

# specialization
for G in [:X, :Y, :Z, :T, :S, :Sdag, :Tdag]
    GT = Expr(:(.), :ConstGate, QuoteNode(Symbol(G, :Gate)))
    @eval _instruct!(reg::AbstractRegister, block::$GT, locs) =
        instruct!(reg, Val($(QuoteNode(G))), locs)
end

function Base.copy(k::KronBlock)
    locs = copy.(k.locs)
    blocks = copy.(k.blocks)
    return KronBlock(k.n, locs, blocks)
end

function Base.getindex(k::KronBlock, addr::UnitRange)
    index = findfirst(==(addr), k.locs)
    return k.blocks[index]
end
Base.getindex(k::KronBlock, addr::Integer) = getindex(k, addr:addr)

function Base.iterate(k::KronBlock, st = 1)
    if st > length(k)
        return nothing
    else
        return (k.locs[st], k.blocks[st]), st + 1
    end
end

Base.eltype(k::KronBlock) = Tuple{UnitRange{Int},AbstractBlock}
Base.length(k::KronBlock) = length(k.blocks)
Base.eachindex(k::KronBlock) = k.locs

function Base.:(==)(lhs::KronBlock, rhs::KronBlock)
    return nqudits(lhs) == nqudits(rhs) && length(lhs.locs) == length(rhs.locs) && all(lhs.locs .== rhs.locs) && all(lhs.blocks .== rhs.blocks)
end

Base.adjoint(blk::KronBlock) = KronBlock(blk.n, blk.locs, map(adjoint, blk.blocks))

LinearAlgebra.ishermitian(k::KronBlock) = all(ishermitian, k.blocks) || ishermitian(mat(k))
YaoAPI.isunitary(k::KronBlock) = all(isunitary, k.blocks) || isunitary(mat(k))
YaoAPI.isreflexive(k::KronBlock) = all(isreflexive, k.blocks) || isreflexive(mat(k))

function unsafe_getindex(::Type{T}, k::KronBlock{D}, i::Integer, j::Integer) where {T,D}
    kron_instruct_get_element(T, Val{D}(), nqudits(k), k.blocks, k.locs, i, j)
end
function unsafe_getcol(::Type{T}, pb::KronBlock{D}, j::DitStr{D}) where {T,D}
    kron_instruct_get_column(T, pb.blocks, pb.locs, j)
end

function create_circuit_tangent(circuit, params)
    gc = dispatch(circuit, params)
    res = recursive_create_tangent(gc)
    return res
end

# fallback
function recursive_create_tangent(c::AbstractBlock)
    if nparameters(c) == 0
        return NoTangent()
    else
        error("`Tangent` for type $(typeof(c)) is not defined!")
    end
end
# primitive blocks
unsafe_primitive_tangent(::Any) = NoTangent()
unsafe_primitive_tangent(x::Number) = x
for GT in [:RotationGate, :ShiftGate, :PhaseGate, :(Scale{<:Number})]
    @eval function recursive_create_tangent(c::$GT)
        lst = map(fieldnames(typeof(c))) do fn
            fn => unsafe_primitive_tangent(unthunk(getfield(c, fn)))
        end
        nt = NamedTuple(lst)
        Tangent{typeof(c),typeof(nt)}(nt)
    end
end
function recursive_create_tangent(c::TimeEvolution)
    Tangent{typeof(c)}(; H=NoTangent(), dt=c.dt, tol=NoTangent())
end

# composite blocks
unsafe_composite_tangent(::Any) = NoTangent()
unsafe_composite_tangent(c::AbstractVector{<:AbstractBlock}) = recursive_create_tangent.(c)
unsafe_composite_tangent(c::AbstractBlock) = recursive_create_tangent(c)
for GT in [
    :ChainBlock,
    :Add,
    :KronBlock,
    :RepeatedBlock,
    :PutBlock,
    :ControlBlock,
    :Subroutine,
    :CachedBlock,
    :Daggered,
    :Scale,
]
    @eval function recursive_create_tangent(c::$GT)
        lst = map(fieldnames(typeof(c))) do fn
            fn => unsafe_composite_tangent(unthunk(getfield(c, fn)))
        end
        nt = NamedTuple(lst)
        Tangent{typeof(c),typeof(nt)}(nt)
    end
end

extract_circuit_gradients!(c::Number, output) = push!(output, c)
extract_circuit_gradients!(::Nothing, output) = output
extract_circuit_gradients!(::NoTangent, output) = output
extract_circuit_gradients!(::ZeroTangent, output) = output
function extract_circuit_gradients!(c::AbstractVector, output)
    for ci in c
        extract_circuit_gradients!(ci, output)
    end
    return output
end
function extract_circuit_gradients!(c::Tangent, output)
    for fn in getfield(c, :backing)
        extract_circuit_gradients!(fn, output)
    end
    return output
end
function extract_circuit_gradients!(c::NamedTuple, output)
    for fn in c
        extract_circuit_gradients!(fn, output)
    end
    return output
end

function rrule(::typeof(apply), reg::AbstractArrayReg, block::AbstractBlock)
    out = apply(reg, block)
    out, function (outδ)
        (in, inδ), paramsδ = apply_back((copy(out), tangent_to_reg(out, outδ)), block)
        return (NoTangent(), inδ, create_circuit_tangent(block, paramsδ))
    end
end
function rrule(::typeof(apply), reg::AbstractArrayReg, block::AbstractAdd)
    out = apply(reg, block)
    out, function (outδ)
        (in, inδ), paramsδ = apply_back((copy(out), tangent_to_reg(out, outδ)), block; in = reg)
        return (NoTangent(), inδ, create_circuit_tangent(block, paramsδ))
    end
end
tangent_to_reg(reg::T, grad) where {D, T<:ArrayReg{D}} = grad isa Tangent ? ArrayReg{D}(grad.state) : grad
tangent_to_reg(reg::T, grad) where {D, T<:BatchedArrayReg{D}} = grad isa Tangent ? BatchedArrayReg{D}(grad.state, reg.nbatch) : grad


function rrule(::typeof(dispatch), block::AbstractBlock, params)
    out = dispatch(block, params)
    out, function (outδ::AbstractTangent)
        g = extract_circuit_gradients!(outδ, empty(params))
        res = (NoTangent(), NoTangent(), g)
        return res
    end
end

function rrule(::typeof(expect), op::AbstractBlock, reg::AbstractArrayReg)
    B = YaoArrayRegister._asint(nbatch(reg))
    out = expect(op, reg)
    out, function (outδ)
        greg = expect_g(op, reg)
        for b = 1:B
            viewbatch(greg, b).state .*= outδ[b]
        end
        return (NoTangent(), NoTangent(), greg)
    end
end

function rrule(
    ::typeof(expect),
    op::AbstractBlock,
    reg_and_circuit::Pair{<:AbstractArrayReg,<:AbstractBlock})
    out = expect(op, reg_and_circuit)
    out,
    function (outδ)
        reg, c = reg_and_circuit
        out = copy(reg) |> c
        goutreg = 2copy(out) |> op
        for b = 1:YaoArrayRegister._asint(nbatch(goutreg))
            viewbatch(goutreg, b).state .*= outδ[b]
        end
        # apply backward rule
        (in, greg), gcircuit = apply_back((out, goutreg), c)
        return (
            NoTangent(),
            NoTangent(),
            Tangent{typeof(reg_and_circuit)}(;
                first = greg,
                second = create_circuit_tangent(reg_and_circuit.second, gcircuit),
            ),
        )
    end
end

function rrule(::Type{T}, block::AbstractBlock) where {T<:Matrix}
    out = T(block)
    out, function (outδ)
        paramsδ = mat_back(block, outδ)
        return (NoTangent(), create_circuit_tangent(block, paramsδ))
    end
end

function rrule(::typeof(mat), ::Type{T}, block::AbstractBlock) where {T}
    out = mat(T, block)
    out, function (outδ)
        paramsδ = mat_back(block, outδ)
        return (NoTangent(), NoTangent(), create_circuit_tangent(block, paramsδ))
    end
end

function rrule(::Type{ArrayReg{D}}, raw::AbstractArray) where {D}
    ArrayReg{D}(raw), adjy -> (NoTangent(), reshape(adjy.state, size(raw)))
end

function rrule(::Type{ArrayReg}, raw::AbstractArray)
    ArrayReg(raw), adjy -> (NoTangent(), reshape(adjy.state, size(raw)))
end

function rrule(::Type{BatchedArrayReg{D}}, raw::AbstractArray, nbatch::Int) where {D}
    BatchedArrayReg{D}(raw, nbatch), adjy -> (NoTangent(), reshape(adjy.state, size(raw)), NoTangent())
end

function rrule(::Type{BatchedArrayReg}, raw::AbstractArray, nbatch::Int)
    BatchedArrayReg(raw, nbatch), adjy -> (NoTangent(), reshape(adjy.state, size(raw)), NoTangent())
end

function rrule(::typeof(copy), reg::AbstractArrayReg)
    copy(reg), adjy -> (NoTangent(), adjy)
end

for (BT, BLOCKS) in [(:Add, :(outδ.list)) (:ChainBlock, :(outδ.blocks))]
    @eval function rrule(::Type{BT}, source::AbstractVector) where {BT<:$BT}
        out = BT(source)
        out, function (outδ)
            return (NoTangent(), collect($BLOCKS))
        end
    end
    @eval function rrule(::Type{BT}, source::Tuple) where {BT<:$BT}
        out = BT(source)
        out, function (outδ)
            return (NoTangent(), ($BLOCKS...,))
        end
    end
    @eval function rrule(::Type{BT}, args::AbstractBlock...) where {BT<:$BT}
        out = BT(args...)
        out, function (outδ)
            return (NoTangent(), $BLOCKS...)
        end
    end
end

rrule(::typeof(state), reg::AbstractArrayReg{D,T}) where {D,T} =
    state(reg), adjy -> (NoTangent(), _match_type(reg, _totype(T, adjy)))
rrule(::typeof(statevec), reg::AbstractArrayReg{D,T}) where {D,T} =
    statevec(reg), adjy -> (NoTangent(), _match_type(reg, _totype(T, adjy)))
rrule(::typeof(state), reg::AdjointArrayReg{D,T}) where {D,T} =
    state(reg), adjy -> (NoTangent(), _match_type(parent(reg), _totype(T, adjy)')')
rrule(::typeof(statevec), reg::AdjointArrayReg{D,T}) where {D,T} =
    statevec(reg), adjy -> (NoTangent(), _match_type(parent(reg), _totype(T, adjy)')')
rrule(::typeof(parent), reg::AdjointArrayReg) = parent(reg), adjy -> (NoTangent(), adjy')
rrule(::typeof(Base.adjoint), reg::AbstractArrayReg) =
    Base.adjoint(reg), adjy -> (NoTangent(), parent(adjy))

_totype(::Type{T}, x::AbstractThunk) where {T} = _totype(T, unthunk(x))
_totype(::Type{T}, x::AbstractArray{T}) where {T} = x
_totype(::Type{T}, x::AbstractArray{T2}) where {T,T2} = convert.(T, x)
_match_type(::ArrayReg{D}, mat) where D = ArrayReg{D}(mat)
_match_type(r::BatchedArrayReg{D}, mat) where D = BatchedArrayReg{D}(mat, r.nbatch)

@non_differentiable nparameters(::Any)
@non_differentiable zero_state(args...)
@non_differentiable rand_state(args...)
@non_differentiable uniform_state(args...)
@non_differentiable product_state(args...)

using Test
using YaoBlocks.AD, YaoBlocks
using YaoArrayRegister
using Random

using SparseArrays, LuxurySparse, LinearAlgebra

@testset "mat rot/shift/phase/scale" begin
    Random.seed!(5)
    for G in [X, Y, Z, ConstGate.SWAP, ConstGate.CZ, ConstGate.CNOT]
        @test test_mat_back(ComplexF64, rot(G, 0.0), 0.5; δ = 1e-5)
    end

    for G in [ShiftGate, PhaseGate]
        @test test_mat_back(ComplexF64, G(0.0), 0.5; δ = 1e-5)
    end

    G = time_evolve(put(3, 2 => X), 0.0)
    @test test_mat_back(ComplexF64, G, 0.5; δ = 1e-5)

    # NOTE: inputs of chain blocks must be unitary!
    G = 5.0 * matblock(rand_unitary(2))
    @test test_mat_back(ComplexF64, G, 0.5; δ = 1e-5)
    G = chain(Rx(0.5), Val(1.0im) * matblock(rand_unitary(2)), Ry(0.5))
    @test test_mat_back(ComplexF64, G, [0.1, 0.2]; δ = 1e-5)
    G = chain(Rx(0.5), 1.0 * matblock(rand_unitary(2)), Ry(0.5))
    @test test_mat_back(ComplexF64, G, [0.1, -1.0, 1.0]; δ = 1e-5)
    G = chain(Rx(0.5), 1.0 * Rx(0.6), Ry(0.5))
    @test test_mat_back(ComplexF64, G, [0.3, -1.0, 0.4, 1.0]; δ = 1e-5)
end

@testset "mat put block, control block" begin
    Random.seed!(5)
    for use_outeradj in [false, true]
        # put block, diagonal
        @test test_mat_back(
            ComplexF64,
            put(3, 1 => chain(Rz(0.5), Ry(0.9), Rz(0.3))),
            [0.5, 0.9, 0.3];
            δ = 1e-5,
            use_outeradj = use_outeradj,
        )
        @test test_mat_back(
            ComplexF64,
            put(3, 1 => Rz(0.5)),
            0.5;
            δ = 1e-5,
            use_outeradj = use_outeradj,
        )
        @test test_mat_back(
            ComplexF64,
            control(3, (2, 3), 1 => Rz(0.5)),
            0.5;
            δ = 1e-5,
            use_outeradj = use_outeradj,
        )
        # dense matrix
        @test test_mat_back(
            ComplexF64,
            put(3, 1 => Rx(0.5)),
            0.5;
            δ = 1e-5,
            use_outeradj = use_outeradj,
        )
        @test test_mat_back(
            ComplexF64,
            control(3, (2, 3), 1 => Rx(0.5)),
            0.5;
            δ = 1e-5,
            use_outeradj = use_outeradj,
        )
        # sparse matrix csc
        @test test_mat_back(
            ComplexF64,
            put(3, (1, 2) => rot(SWAP, 0.5)),
            0.5;
            δ = 1e-5,
            use_outeradj = use_outeradj,
        )
        @test test_mat_back(
            ComplexF64,
            control(3, (3,), (1, 2) => rot(SWAP, 0.5)),
            0.5;
            δ = 1e-5,
            use_outeradj = use_outeradj,
        )
    end

    # is permatrix even possible?
    #@test test_mat_back(ComplexF64, put(3, 1=>matblock(pmrand(2))), [0.5, 0.6]; δ=1e-5)
    # ignore identity matrix.
end

@testset "mat subroutine" begin
    Random.seed!(5)
    @test test_mat_back(
        ComplexF64,
        subroutine(3, control(2, 2, 1 => shift(0.0)), (3, 1)),
        0.5;
        δ = 1e-5,
    )
end

@testset "mat chain" begin
    Random.seed!(5)
    @test test_mat_back(ComplexF64, chain(3, control(3, 2, 1 => shift(0.0))), 0.5; δ = 1e-5)
    @test test_mat_back(
        ComplexF64,
        chain(3, put(3, 2 => X), control(3, 2, 1 => shift(0.0))),
        0.5;
        δ = 1e-5,
    )
    @test test_mat_back(
        ComplexF64,
        chain(3, control(3, 2, 1 => shift(0.0)), put(3, 2 => X)),
        0.5;
        δ = 1e-5,
    )
    @test test_mat_back(
        ComplexF64,
        chain(3, control(3, 2, 1 => shift(0.0)), NoParams(put(3, 1 => Rx(0.0)))),
        0.5;
        δ = 1e-5,
    )
    @test test_mat_back(
        ComplexF64,
        chain(
            3,
            control(3, 2, 1 => shift(0.0)),
            chain(put(3, 1 => Rx(0.0)), put(3, 2 => Ry(0.0))),
        ),
        [0.5, 0.5, 0.5];
        δ = 1e-5,
    )
    @test test_mat_back(
        ComplexF64,
        chain(3, chain(3, put(3, 1 => Rx(0.0)), put(3, 2 => Ry(0.0)))),
        [0.5, 0.5];
        δ = 1e-5,
    )
end

@testset "mat kron" begin
    use_outeradj = false
    @test test_mat_back(
        ComplexF64,
        kron(Rx(0.5), Rz(0.6)),
        [0.5, 0.5];
        δ = 1e-5,
        use_outeradj = use_outeradj,
    )
end

using YaoBlocks, YaoArrayRegister
using Test, LinearAlgebra

@testset "test projector" begin
    reg0 = rand_state(3)
    rf = projector(reg0)
    @test mat(rf) ≈ state(reg0) * state(reg0)'
    reg = copy(reg0)
    apply!(reg, rf)

    v0, v1 = vec(reg.state), vec(reg0.state)
    @test mat(rf) * statevec(reg0) ≈ statevec(apply!(copy(reg0), rf))
    @test mat(rf) ≈ mat(rf^2)
    @test statevec(rf.psi)' * v0 ≈ statevec(rf.psi)' * v1
    @test statevec(rf.psi)'*v0* statevec(rf.psi) ≈ v1

    @test mat(ComplexF32, rf) ≈ ComplexF32.(mat(rf))

    @test rf == projector(rf.psi)
    # copy do not occur on register
    @test copy(rf) == rf

    @test ishermitian(rf)
    @test !isreflexive(rf)
    @test !isunitary(rf)
    @test isunitary(rf) == isunitary(mat(rf))
    @test ishermitian(mat(rf)) == ishermitian(rf)
    @test isreflexive(mat(rf)) == isreflexive(rf)
end

using Test, YaoBlocks, YaoArrayRegister
using YaoAPI

@testset "Yao/#186" begin
    @test getiparams(phase(0.1)) == 0.1
    @test getiparams(Val(2) * phase(0.1)) == ()
    @test_throws NotImplementedError setiparams!(rot(X, 0.5), :nothing)
    @test_throws NotImplementedError setiparams(rot(X, 0.5), :nothing)
end

@testset "block to matrix conversion" begin
    for each in [X, Y, Z, H]
        Matrix{ComplexF64}(each) == Matrix{ComplexF64}(mat(each))
    end
    @test eltype(mat(chain(X))) == ComplexF64
    @test eltype(mat(chain(X, Rx(0.5)))) == ComplexF64
end

@testset "apply lambda" begin
    r = rand_state(3)
    @test apply!(copy(r), put(1 => X)) ≈ apply!(copy(r), put(3, 1 => X))
    r2 = copy(r)
    @test apply(r, put(1 => X)) ≈ apply!(copy(r), put(3, 1 => X))
    @test r2.state == r.state
    f(x::Float32) = x
    @test_throws ErrorException apply!(r, f)
end

@testset "push tests" begin
    # copy return itself by default
    @test copy(X) === X

    # block type can be used as traits
    @test nqubits(X) == 1

    @test isunitary(XGate)
    @test isreflexive(XGate)
    @test ishermitian(XGate)
    @test setiparams(Rx(0.3), 0.5) == Rx(0.5)
    @test setiparams(+, Rx(0.3), 0.5) == Rx(0.8)
    @test YaoBlocks.parameters_range(chain(Z, shift(0.3), phase(0.2), Rx(0.5), time_evolve(X, 0.5), Ry(0.5))) == [(0.0, 2π), (0.0, 2π), (0.0, 2π), (-Inf, Inf), (0.0, 2π)]
end

@testset "indexing pxp" begin
    function proj(::Type{T}, configs::AbstractVector{<:DitStr{D,N}}) where {T,D,N}
        mask = zeros(T, D^N)
        for c in configs
            mask[Int(c)+1] = one(T)
        end
        return matblock(Diagonal(mask); tag="Projector")
    end
    display(mat(proj(ComplexF64, [bit"00"])))
    function pxp(neighbors, i::Int)
        n = length(neighbors)
        P = chain([put(n, (i,j)=>proj(ComplexF64, [bit"10", bit"01", bit"00"])) for j in neighbors[i]])
        P * put(n, i=>X) * P
    end
    h = sum([pxp([[2], [1,3], [2, 4], [3, 5], [4]], i) for i=1:5])
    @test length(h[:,bit"11000"]) == 2
    @test length(h[:,bit"10100"]) == 3
end

@testset "render params" begin
    # rotation gate
    params = [first(YaoBlocks.render_params(Rx(0.5), Val(:random))) for i=1:100]
    @test any(>(1), params)  # in range [0, 2π]
    @test all(x -> 0<=x<=2π, params)
    @test YaoBlocks.render_params(Rx(0.5), Val(:zero)) == (0.0,)

    # shift gate
    sg = shift(0.5)
    params = [first(YaoBlocks.render_params(sg, Val(:random))) for i=1:100]
    @test any(>(1), params)  # in range [0, 2π]
    @test all(x -> 0<=x<=2π, params)
    @test YaoBlocks.render_params(sg, Val(:zero)) == (0.0,)

    # phase gate
    pg = phase(0.5)
    params = [first(YaoBlocks.render_params(pg, Val(:random))) for i=1:100]
    @test any(>(1), params)  # in range [0, 2π]
    @test all(x -> 0<=x<=2π, params)
    @test YaoBlocks.render_params(pg, Val(:zero)) == (0.0,)

    # time evolve gate
    sg = time_evolve(X, 0.5)
    params = [first(YaoBlocks.render_params(sg, Val(:random))) for i=1:100]
    @test all(x -> 0<=x<=1, params)
    @test YaoBlocks.render_params(sg, Val(:zero)) == (0.0,)
end

export dump_gate, yaotofile, yaotoscript
export yaofromfile, yaofromstring, @yao_str, @yaoscript

include("dump.jl")
include("load.jl")
include("address_manipulate.jl")
include("optimise.jl")

print_blocktree() = print_subtypetree(AbstractBlock)

export Projector, projector

"""
$(TYPEDEF)

Projection operator to target state `psi`.

### Definition
`projector(s)` defines the following operator.

```math
|s⟩ → |s⟩⟨s|
```
"""
struct Projector{D, T, AT<:AbstractArrayReg{D, T}} <: PrimitiveBlock{D}
    psi::AT
    function Projector(psi::AbstractArrayReg{D, T}) where {D,T}
        @assert isnormalized(psi) && nremain(psi) == 0 "the state in the projector must be normalized and does not contain environment."
        new{D,T,typeof(psi)}(psi)
    end
end
nqudits(v::Projector) = nqudits(v.psi)
print_block(io::IO, p::Projector) = print(io, "|s⟩⟨s|, nqudits = $(nqudits(p))")

"""
$(TYPEDSIGNATURES)

Create a [`Projector`](@ref) with an quantum state vector `v`.

### Example

```jldoctest; setup=:(using YaoBlocks, YaoArrayRegister)
julia> projector(rand_state(3))
|s⟩⟨s|, nqudits = 3
```
"""
projector(v::AbstractArrayReg)::Projector = Projector(v)

function YaoAPI.unsafe_apply!(r::AbstractArrayReg, g::Projector{D, T}) where {D, T}
    v = state(g.psi)
    r.state .= v' * r.state .* v
    return r
end

# target type is the same with block's
function mat(::Type{T1}, r::Projector{D, T2}) where {D, T1, T2}
    v = state(r.psi)
    if T1 != T2
        v = copyto!(similar(v, T1), v)
    end
    return OuterProduct(v, conj.(v))
end

Base.:(==)(A::Projector, B::Projector) = A.psi == B.psi
Base.copy(r::Projector) = Projector(copy(r.psi))

LinearAlgebra.ishermitian(::Projector) = true
YaoAPI.isdiagonal(::Projector) = false
#YaoAPI.isreflexive(r::Projector) = false
#YaoAPI.isunitary(r::Projector) = false

export AD

"""
    AD

This module provides the basic routines and syntax for automatic differentiation (AD).
However, one need to port this to AD frameworks like [Zygote](https://github.com/FluxML/Zygote.jl),
[Tracker](https://github.com/FluxML/Tracker.jl) or [Yota](https://github.com/dfdx/Yota.jl) to make
it composable with a general Julia program. You can also check the work-in-progress package
[YaoAD](https://github.com/QuantumBFS/YaoAD.jl) that provides this functionality.
"""
module AD

using BitBasis, YaoArrayRegister, YaoAPI
using ..YaoBlocks
import ChainRulesCore:
    rrule, @non_differentiable, NoTangent, Tangent, backing, AbstractTangent, ZeroTangent, AbstractThunk, unthunk
import YaoAPI: mat_back!, apply_back!
using SparseArrays, LuxurySparse, LinearAlgebra

include("NoParams.jl")
include("adjroutines.jl")
include("mat_back.jl")
include("apply_back.jl")
include("specializes.jl")
include("gradcheck.jl")
include("chainrules_patch.jl")

end

using Test, YaoBlocks, YaoArrayRegister
using YaoAPI, BitBasis

struct MockedTag{BT,D} <: TagBlock{BT,D}
    content::BT

    MockedTag(x::BT) where {D,BT<:AbstractBlock{D}} = new{BT,D}(x)
end

@test nqubits(MockedTag(X)) == nqubits(X)
@test nqubits(MockedTag(kron(X, Y))) == nqubits(kron(X, Y))

@test getiparams(MockedTag(phase(0.1))) == ()
@test getiparams(MockedTag(cache(phase(0.1)))) == ()
@test getiparams(MockedTag(Rx(0.1))) == ()

@test parameters(MockedTag(phase(0.1))) == [0.1]
@test parameters(MockedTag(cache(phase(0.1)))) == [0.1]
@test parameters(MockedTag(Rx(0.1))) == [0.1]

@test occupied_locs(MockedTag(chain(3, put(1 => X), put(3 => X)))) ==
      occupied_locs(chain(3, put(1 => X), put(3 => X)))

@testset "scale apply" begin
    # factor
    @test factor(-X) == -1
    @test factor(-2 * X) == -2

    # type
    @test -X isa Scale{<:Val}
    @test -im * X isa Scale{<:Number}
    @test Val(-im) * X isa Scale{<:Val}
    @test -2 * X isa Scale{<:Number}

    # apply!
    reg = rand_state(1)
    @test apply!(copy(reg), -X) ≈ -apply!(copy(reg), X)
    @test apply!(copy(reg), (Val(-im) * Y)') ≈ apply!(copy(reg), im * Y)
    @test apply!(copy(reg), (-2im * Y)') ≈ apply!(copy(reg), 2im * Y)

    # mat
    @test mat(-X) ≈ -mat(X)
    @test mat((Val(-im) * Y)') ≈ (-im * mat(Y))'
    @test mat((-2im * Y)') ≈ (-2im * mat(Y))'

    # other
    @test chsubblocks(-X, Y) == -Y
    @test cache_key(Scale(Val(-1), X)) == cache_key(Scale(-1, X))
    @test copy(-X) == -X
    @test copy(-X) isa Scale{<:Val}

    # parameters
    @test getiparams(2X) == (2,)
    @test setiparams(2X, 4.0) == 4.0X
    s = 2.0X
    setiparams!(s, 4.0)
    @test s == 4.0X
end

@testset "properties" begin
    xg = put(100, 3 => X)
    yg = put(100, 3 => Y)
    yg = put(100, 3 => Y)
    @test_throws Exception !ishermitian(im * xg)
    @test ishermitian(3 * xg)
    @test_throws Exception !isreflexive(im * xg)
    @test isreflexive(-1 * xg)
    @test isunitary(im * xg)
    @test_throws Exception !isunitary(2 * xg)
    @test !iscommute(2 * xg, 2 * yg)
    @test iscommute(2 * xg, 2 * xg)
end

@testset "daggered" begin
    dg = Daggered(ConstGate.T)
    @test dg isa Daggered
    @test apply!(product_state(bit"1"), dg) ≈ apply!(product_state(bit"1"), ConstGate.Tdag)
    @test chsubblocks(dg, X) == Daggered(X)
end

@testset "instruct_get_element: dagger, scale" begin
    for pb in [3*put(3, 2=>2*matblock(rand_unitary(2)))', Val(2) * Daggered(put(4, (4,2)=>-matblock(rand_unitary(9); nlevel=3)))]
        mpb = mat(pb)
        allpass = true
        for i=basis(pb), j=basis(pb)
            allpass &= pb[i, j] == mpb[Int(i)+1, Int(j)+1]
        end
        @test allpass

        allpass = true
        for i=basis(pb), j=basis(pb)
            allpass &= vec(pb[:, j]) == mpb[:, Int(j)+1]
            allpass &= isclean(pb[:,j])
        end
        @test allpass
    end
end

@testset "density matrix" begin
    reg = rand_state(3)
    r = density_matrix(reg)
    @test density_matrix(apply(reg, 2*put(3, 2=>X))) ≈ apply(r, 2*put(3, 2=>X))
end

@testset "gatecount" begin
    @test gatecount(0.3 * X) == Dict(typeof(X)=>1)
    @test gatecount(Val(0.1) * X) == Dict(typeof(Val(0.1)*X)=>1)
    @test gatecount(cache(Val(0.1) * X)) == Dict(typeof(Val(0.1)*X)=>1)
    @test gatecount(Daggered(X)) == Dict(typeof(Daggered(X))=>1)
end

@testset "OnLevels" begin
    Z1r = OnLevels{3}(Z, (2, 3))
    mz = mat(ComplexF64, Z1r)
    @test YaoBlocks.SparseArrays.nnz(mz) == 2
    g = OnLevels{3}(Rx(0.5), (2, 3))
    g2 = copy(g)
    g2.gate.theta = 0.6
    @test !ishermitian(g)
    @test isunitary(g)
    @test g2.gate.theta == 0.6
    @test g.gate.theta == 0.5
    @test parameters(g) == [0.5]
    @test g' == OnLevels{3}(Rx(-0.5), (2, 3))
    println(g)
end

export ReflectGate, reflect

"""
    ReflectGate{D, T, Tt, AT<:AbstractArrayReg{D, T}} = TimeEvolution{D,Tt,Projector{D,T,AT}}

Let `|v⟩` be a quantum state vector, a reflection gate is a unitary operator that defined as the following operation.

```math
|v⟩ → 1 - (1-exp(-iθ)) |v⟩⟨v|
```

When ``θ = π``, it defines a standard reflection gate ``1-2|v⟩⟨v|``.
"""
ReflectGate{D, T, Tt, AT<:AbstractArrayReg{D, T}} = TimeEvolution{D,Tt,Projector{D,T,AT}}

"""
$(TYPEDSIGNATURES)

Create a [`ReflectGate`](@ref) with respect to an quantum state vector `v`.

### Example

```jldoctest; setup=:(using YaoBlocks, YaoArrayRegister)
julia> reflect(rand_state(3))
Time Evolution Δt = π, tol = 1.0e-7
|s⟩⟨s|, nqudits = 3
```
"""
reflect(v::AbstractArrayReg, θ::Real=π)::ReflectGate = time_evolve(Projector(v), θ)

function YaoAPI.unsafe_apply!(r::AbstractArrayReg, g::ReflectGate)
    v = state(g.H.psi)
    r.state .= r.state .- (1-exp(-im*g.dt)) .* (v * (v' * r.state))
    return r
end

# target type is the same with block's
function mat(::Type{T1}, r::ReflectGate{D, T2}) where {D, T1, T2}
    v = state(r.H.psi)
    return T1.(IMatrix(size(v, 1)) .- (1-exp(-im*r.dt)) .* mat(T1, r.H))
end

LinearAlgebra.ishermitian(r::ReflectGate) = r.dt ≈ π
YaoAPI.isreflexive(r::ReflectGate) = r.dt ≈ π

export Measure,
    MeasureAndReset, AllLocs, ComputationalBasis, chmeasureoperator, num_measured

"""
    Measure{D,K, OT, LT, PT, RNG} <: PrimitiveBlock{D}
    Measure(n::Int; rng=Random.GLOBAL_RNG, operator=ComputationalBasis(), locs=1:n, resetto=nothing, remove=false, nlevel=2, error_prob=0.0)

Measurement block.

### Fields
* `n::Int`: number of qubits.
* `rng::RNG`: random number generator.
* `operator::OT`: operator to measure, by default it is `ComputationalBasis()`.
* `locations::LT`: locations to measure, by default it is `1:n`.
* `postprocess::PT`: postprocess to apply to the measurement result, e.g. `ResetTo` to reset the measured qubits to a specific state.
* `error_prob::Float64`: error probability, by default it is `0.0`. This is only supported for 2-level systems, and the operator must be `ComputationalBasis` or a single qubit operator.
* `results::Any`: measurement results, by default it is `undef`.
"""
mutable struct Measure{D,K,OT,LT<:Union{NTuple{K,Int},AllLocs},PT<:PostProcess,RNG} <:
               PrimitiveBlock{D}
    n::Int
    rng::RNG
    operator::OT
    locations::LT
    postprocess::PT
    error_prob::Float64
    results::Any
    function Measure{D,K,OT,LT,PT,RNG}(n::Int,
        rng::RNG,
        operator::OT,
        locations::LT,
        postprocess::PT,
        error_prob::Float64,
    ) where {RNG,D,K,OT,LT<:Union{NTuple{K,Int},AllLocs},PT<:PostProcess}
        locations isa AllLocs || @assert_locs_safe n locations
        if !(operator isa ComputationalBasis)
            @assert nqudits(operator) == (locations isa AllLocs ? n : length(locations)) "operator size `$(nqudits(operator))` does not match measurement location `$locations`"
        end
        if error_prob > 0.0
            @assert D == 2 "`error_prob` argument is only supported for 2-level systems, got D=$D"
            @assert operator isa ComputationalBasis || nqudits(operator) == 1 "`error_prob` argument is only supported for single qubit operators, got $(typeof(operator))"
        end
        new{D,K,OT,LT,PT,RNG}(n, rng, operator, locations, postprocess, error_prob)
    end
end
nqudits(m::Measure) = m.n

function Measure{D}(n::Int,
    rng::RNG,
    operator::OT,
    locations::LT,
    postprocess::PT,
    error_prob::Float64,
) where {D,RNG,OT,LT<:Union{NTuple{K,Int} where K,AllLocs},PT<:PostProcess}
    k = locations isa AllLocs ? n : length(locations)
    Measure{D,k,OT,LT,PT,RNG}(n, rng, operator, locations, postprocess, error_prob)
end

const MeasureAndReset{D,K,OT,LT,RNG} = Measure{D,K,OT,LT,ResetTo{BitStr64{K}},RNG}
function MeasureAndReset(
    N::Int,
    resetto = 0;
    operator = ComputationalBasis,
    rng = Random.GLOBAL_RNG,
    nlevel=2,
)
    Measure{nlevel}(N; nlevel=nlevel, postprocess = ResetTo(resetto), operator = operator, rng = rng, locs = locs)
end

"""
    chmeasureoperator(m::Measure, op::AbstractBlock)

change the measuring `operator`. It will also discard existing measuring results.
"""
function chmeasureoperator(m::Measure{D}, op::AbstractBlock) where D
    Measure{D}(m.n, m.rng, op, m.locations, m.postprocess, m.error_prob)
end

function Base.:(==)(m1::Measure, m2::Measure)
    res =
        m1.rng == m2.rng &&
        m1.operator == m2.operator &&
        m1.locations == m2.locations &&
        m1.postprocess == m2.postprocess
    res = res && isdefined(m1, :results) == isdefined(m2, :results)
    res && (!isdefined(m1, :results) || m1.results == m2.results)
end

num_measured(::Measure{D,K}) where {D,K} = K

"""
    Measure(n::Int; rng=Random.GLOBAL_RNG, operator=ComputationalBasis(), locs=AllLocs(), resetto=nothing, remove=false, error_prob=0.0)

Create a `Measure` block with number of qudits `n`.

### Examples

You can create a `Measure` block on given basis (default is the computational basis).

```jldoctest; setup=:(using Yao)
julia> Measure(4)
Measure(4)
```

Or you could specify which qudits you are going to measure

```jldoctest; setup=:(using Yao)
julia> Measure(4; locs=1:3)
Measure(4;locs=(1, 2, 3))
```

by default this will collapse the current register to measure results.

```jldoctest; setup=:(using Yao, Random; Random.seed!(123))
julia> r = normalize!(arrayreg(bit"000") + arrayreg(bit"111"))
ArrayReg{2, ComplexF64, Array...}
    active qubits: 3/3
    nlevel: 2

julia> state(r)
8×1 Matrix{ComplexF64}:
 0.7071067811865475 + 0.0im
                0.0 + 0.0im
                0.0 + 0.0im
                0.0 + 0.0im
                0.0 + 0.0im
                0.0 + 0.0im
                0.0 + 0.0im
 0.7071067811865475 + 0.0im

julia> r |> Measure(3)
ArrayReg{2, ComplexF64, Array...}
    active qubits: 3/3
    nlevel: 2

julia> state(r)
8×1 Matrix{ComplexF64}:
 0.0 + 0.0im
 0.0 + 0.0im
 0.0 + 0.0im
 0.0 + 0.0im
 0.0 + 0.0im
 0.0 + 0.0im
 0.0 + 0.0im
 1.0 + 0.0im
```

But you can also specify the target bit configuration you want to collapse to with keyword `resetto`.

```jldoctest; setup=:(using Yao)
julia> m = Measure(4; resetto=bit"0101")
Measure(4;postprocess=ResetTo{BitStr{4,Int64}}(0101 ₍₂₎))

julia> m.postprocess
ResetTo{BitStr{4,Int64}}(0101 ₍₂₎)```
"""
function Measure(
    n::Int;
    rng::RNG = Random.GLOBAL_RNG,
    operator::OT = ComputationalBasis(),
    locs = AllLocs(),
    resetto = nothing,
    remove = false,
    nlevel = 2,
    error_prob = 0.0,
) where {OT,RNG}
    if resetto !== nothing
        if remove
            error(
                "invalid keyword combination, expect resetto or remove, got (resetto=$resetto, remove=true)",
            )
        else
            postprocess = ResetTo(BitStr64{locs isa AllLocs ? n : length(locs)}(resetto))
        end
    else
        if remove
            postprocess = RemoveMeasured()
        else
            postprocess = NoPostProcess()
        end
    end
    if locs isa AllLocs
        K = n
    else
        locs = (locs...,)
        K = length(locs)
    end
    Measure{nlevel,K,OT,typeof(locs),typeof(postprocess),RNG}(n,rng, operator, locs, postprocess, error_prob)
end

Measure(;
    rng = Random.GLOBAL_RNG,
    locs = AllLocs(),
    operator = ComputationalBasis(),
    resetto = nothing,
    remove = false,
    nlevel = 2,
) = @λ(
    n -> Measure(
        n;
        rng = rng,
        locs = locs,
        operator = operator,
        resetto = resetto,
        remove = remove,
        nlevel = nlevel,
    )
)
mat(x::Measure) = error("use BlockMap to get its matrix.")

function YaoAPI.unsafe_apply!(r::AbstractRegister{D}, m::Measure{D}) where {D}
    m.results = measure!(m.postprocess, m.operator, r, m.locations; rng = m.rng)
    iszero(m.error_prob) && return r
    if m.operator isa ComputationalBasis
        for i in 1:length(m.results)  # try to flip each qubit
            if rand(m.rng) < m.error_prob
                m.results ⊻= 1 << (i-1)
            end
        end
    else   # operators
        E, V = eigenbasis(m.operator)
        evals = diag(mat(E))  # must have exactly 2 eigenvalues
        if rand(m.rng) < m.error_prob  # flip results
            m.results = m.results == evals[1] ? evals[2] : evals[1]
        end
    end
    return r
end

occupied_locs(m::Measure) = m.locations isa AllLocs ? (1:nqudits(m)...,) : m.locations

module PauliPropagationExt
using YaoBlocks
using PauliPropagation
using YaoBlocks.ConstGate
using MLStyle
using LinearAlgebra: Diagonal

export yao2paulipropagation, paulipropagation2yao, PauliPropagationCircuit
export yao2pauli  # Backward compatibility alias

"""
    PauliPropagationCircuit{IT<:Integer}

An intermediate representation of a quantum circuit in the Pauli propagation framework.

### Fields
- `n::Int`: Number of qubits
- `gates::Vector{Gate}`: Vector of PauliPropagation gates
- `observable::PauliSum`: Observable to measure (sum of Pauli strings)

### Usage
```julia
pc = yao2paulipropagation(circuit; observable=obs)
result = propagate(pc)
```
"""
struct PauliPropagationCircuit{IT<:Integer}
    n::Int
    gates::Vector{StaticGate}
    observable::PauliSum{IT, Float64}
end

function Base.show(io::IO, pc::PauliPropagationCircuit)
    print(io, "PauliPropagationCircuit")
    print(io, "\n  Qubits: ", pc.n)
    print(io, "\n  Gates: ", length(pc.gates))
    print(io, "\n  Observable: ", pc.observable)
end

function pauli_to_yao_gate!(c::ChainBlock, g::Gate, parameter)
    @match g begin
        ::CliffordGate => begin
            # Check if it's a controlled gate
            if g.symbol ∈ [:CNOT, :CZ]
                @assert length(g.qinds) == 2 "Controlled gates should have exactly 2 qubits"
                ctrl_loc, target_loc = g.qinds
                if g.symbol == :CNOT
                    push!(c, control(c.n, ctrl_loc, target_loc=>X))
                elseif g.symbol == :CZ
                    push!(c, control(c.n, ctrl_loc, target_loc=>Z))
                end
            elseif g.symbol == :ZZpihalf
                # Special handling for ZZpihalf two-qubit gate
                @assert length(g.qinds) == 2 "ZZpihalf gate should have exactly 2 qubits"
                push!(c, put(c.n, (g.qinds...,) => rot(kron(Z,Z), π/2)))
            else
                # Single qubit Clifford gate
                push!(c, put(c.n, (g.qinds...,) => symbol_to_yao(g.symbol)))
            end
        end
        ::PauliRotation => push!(c, put(c.n, (g.qinds...,) => rot(kron(symbol_to_yao.(g.symbols)...), parameter)))
        ::DepolarizingNoise =>
            begin
                @assert length(g.qind) == 1 "Depolarizing noise should be applied to a single qubit"
                push!(c, put(c.n, (g.qind...,) => single_qubit_depolarizing_channel(parameter)))
            end
        ::PauliXNoise => push!(c, put(c.n, (g.qind...,) => MixedUnitaryChannel(PauliError( parameter / 2, 0.0, 0.0))))
        ::PauliYNoise => push!(c, put(c.n, (g.qind...,) => MixedUnitaryChannel(PauliError( 0.0, parameter / 2, 0.0))))
        ::PauliZNoise => push!(c, put(c.n, (g.qind...,) => MixedUnitaryChannel(PauliError( 0.0, 0.0, parameter / 2))))
        ::AmplitudeDampingNoise => quantum_channel(AmplitudeDampingError(parameter))
        _ => error("Unsupported gate type: $(typeof(g))")
    end
end

const AllowedObservableTypes = Union{
    KronBlock{<:Any, <:Any, <:NTuple{<:Any, ConstGate.PauliGate}},
    Scale{<:Any, <:Any, <:KronBlock{<:Any, <:Any, <:NTuple{<:Any, ConstGate.PauliGate}}},
    PutBlock{<:Any, <:Any, <:ConstGate.PauliGate},
    Scale{<:Any, <:Any, <:PutBlock{<:Any, <:Any, <:ConstGate.PauliGate}}}

"""
    yao2paulipropagation(circuit::ChainBlock; observable)

Convert a Yao quantum circuit to a PauliPropagationCircuit intermediate representation.

### Arguments
- `circuit::ChainBlock`: The quantum circuit to convert. Must contain only gates supported by PauliPropagation.

### Keyword Arguments
- `observable`: A Yao block specifying the observable to measure, which must be a sum of Pauli strings. e.g. `kron(5, 2=>X, 3=>X) + 2.0 * kron(5, 1=>Z)`

### Returns
- `PauliPropagationCircuit`: An intermediate representation containing the circuit and observable.

### Example
```julia
using Yao, YaoBlocks, PauliPropagation
circuit = chain(3, put(3, 1=>Rx(0.5)), put(3, 2=>X), control(3, 1, 2=>Y))
obs = put(3, 1=>Z)
pc = yao2paulipropagation(circuit; observable=obs)
psum = propagate(pc)  # Returns a PauliSum
result = overlapwithzero(psum)  # Get expectation value
```
"""
function YaoBlocks.yao2paulipropagation(circuit::ChainBlock; observable)
    circ = YaoBlocks.Optimise.to_basictypes(circuit)
    n = nqubits(circ)
    gates = StaticGate[]
    
    # Convert circuit gates
    for g in circ
        @match g begin
            ::PutBlock => yao_to_pauli_gates!(gates, g)
            ::ControlBlock => yao_to_pauli_control!(gates, g, n)
            _ => error("Unsupported gate type: $(typeof(g))")
        end
    end
    
    # Convert observable
    obs = Optimise.eliminate_nested(observable)
    @assert obs isa AllowedObservableTypes || obs isa Add && all(b isa AllowedObservableTypes for b in subblocks(obs)) "Observable must be a sum of Pauli strings, e.g. kron(5, 2=>X, 3=>X) + 2.0 * kron(5, 1=>Z), got: $obs"
    psum = cast_observable(observable)
    return PauliPropagationCircuit(n, gates, psum isa PauliSum ? psum : PauliSum([psum]))
end

"""
    propagate(pc::PauliPropagationCircuit; kwargs...)

Propagate a Pauli observable through the circuit using Pauli propagation.

### Arguments
- `pc::PauliPropagationCircuit`: The circuit containing gates, parameters, and the observable to propagate.
- `kwargs...`: Additional keyword arguments passed to the underlying `propagate` function (e.g., `max_weight`, `min_abs_coeff`).

### Returns
- A `PauliSum` representing the propagated observable. Use `overlapwithzero(psum)` to get the expectation value.

### Example
```julia
pc = yao2paulipropagation(circuit; observable=obs)
psum = propagate(pc)  # Returns a PauliSum
result = overlapwithzero(psum)  # Get expectation value
```
"""
function PauliPropagation.propagate(pc::PauliPropagationCircuit; kwargs...)
    return propagate(pc.gates, pc.observable, Float64[]; kwargs...)
end

"""
    paulipropagation2yao(n::Int, circ::AbstractVector{<:Gate}, thetas::AbstractVector)
    paulipropagation2yao(pc::PauliPropagationCircuit)

Convert a PauliPropagation circuit back to a Yao circuit.

### Arguments
- `n::Int`: Number of qubits
- `circ::AbstractVector{<:Gate}`: Vector of PauliPropagation gates
- `thetas::AbstractVector`: Gate parameters

Or:
- `pc::PauliPropagationCircuit`: A PauliPropagationCircuit intermediate representation

### Returns
- `ChainBlock`: A Yao quantum circuit
"""
function YaoBlocks.paulipropagation2yao(n::Int, circ::AbstractVector{<:Gate}, thetas::AbstractVector)
    @assert length(thetas) == countparameters(circ)
    thetas = copy(thetas)
    c = chain(n)
    for g in circ
        if g isa FrozenGate
            pauli_to_yao_gate!(c, g.gate, g.parameter)
        elseif g isa CliffordGate
            pauli_to_yao_gate!(c, g, nothing)
        elseif g isa ParametrizedGate
            pauli_to_yao_gate!(c, g, popfirst!(thetas))
        else
            error("Unsupported gate type: $(typeof(g))")
        end
    end
    return c
end

YaoBlocks.paulipropagation2yao(pc::PauliPropagationCircuit) = paulipropagation2yao(pc.n, pc.gates, Float64[])

function yao_to_pauli_gates!(gates::Vector{StaticGate}, g)
    @match g.content begin
        ::ConstantGate => push!(gates, CliffordGate(yao_to_symbols(g.content)[], collect(g.locs)))
        ::RotationGate => push!(gates, PauliRotation(yao_to_symbols(g.content.block), collect(g.locs), g.content.theta))
        ::DepolarizingChannel =>
            begin
                push!(gates, FrozenGate(DepolarizingNoise(g.locs[1]), g.content.p))
            end
        ::AmplitudeDampingError =>
            begin
                push!(gates, FrozenGate(AmplitudeDampingNoise(g.locs), g.content.p))
            end
        ::MixedUnitaryChannel =>
            begin
                for (prob, operator) in zip(g.content.probs, g.content.operators)
                    if prob > 0
                        if operator isa YaoBlocks.XGate
                            push!(gates, FrozenGate(PauliXNoise(g.locs[1]), 2 * prob))
                        elseif operator isa YaoBlocks.YGate
                            push!(gates, FrozenGate(PauliYNoise(g.locs[1]), 2 * prob))
                        elseif operator isa YaoBlocks.ZGate
                            push!(gates, FrozenGate(PauliZNoise(g.locs[1]), 2 * prob))
                        elseif !(operator isa YaoBlocks.I2Gate)
                            error("Unsupported error type: $(typeof(operator))")
                        end
                    else
                        continue
                    end
                end
            end

        _ => error("Unsupported gate type: $(typeof(g.content))")
    end
end

function yao_to_pauli_control!(gates::Vector{StaticGate}, g::ControlBlock, n::Int)
    # Handle controlled gates
    # For now, support single-control single-target gates (CNOT, CZ, CY)
    @assert length(g.ctrl_locs) == 1 && length(g.locs) == 1 "Only single-control single-target gates are currently supported"
    @assert all(g.ctrl_config .== 1) "Only positive controls (ctrl_config=1) are supported"
    
    ctrl_loc = g.ctrl_locs[1]
    @match g.content begin
        ::XGate => push!(gates, CliffordGate(:CNOT, [ctrl_loc, g.locs[1]]))
        ::ZGate => push!(gates, CliffordGate(:CZ, [ctrl_loc, g.locs[1]]))
        _ => error("Unsupported controlled gate: control($(ctrl_loc), $(g.locs[1])=>$(typeof(g.content)))")
    end
end

function cast_observable(observable::Add)
    return PauliSum([cast_observable(b) for b in subblocks(observable)])
end
function cast_observable(observable::Scale)
    return cast_observable(observable.content) * observable.alpha
end
function cast_observable(observable::KronBlock)
    n = nqubits(observable)
    return PauliString(n, [yao_to_symbol(block) for block in observable.blocks], [loc[1] for loc in observable.locs])
end
function cast_observable(observable::PutBlock)
    n = nqubits(observable)
    pauli = yao_to_symbol(observable.content)
    locs = observable.locs[1]
    return PauliString(n, pauli, locs)
end

const symbol_yao_map = Dict(
    :I => I2,
    :X => X,
    :Y => Y,
    :Z => Z,
    :H => H,
    :S => S,
    :T => T,
    :SX => Rx(π/2),
    :SY => Ry(π/2),
    :CNOT => control(2, 1, 2=>X),
    :CZ => control(2, 1, 2=>Z),
    :CY => control(2, 1, 2=>Y),
)

# Create the reverse mapping with proper type handling
const yao_symbol_map = Dict{Any, Symbol}(
    I2 => :I,
    X => :X,
    Y => :Y,
    Z => :Z,
    H => :H,
    S => :S,
    T => :T,
    ConstGate.CNOT => :CNOT,
    ConstGate.CZ => :CZ,
    Rx(π/2) => :SX,
    Ry(π/2) => :SY,
)
function symbol_to_yao(sym::Symbol)
    return symbol_yao_map[sym]
end

function yao_to_symbols(yaoblock::KronBlock)
    return [yao_to_symbol(b) for b in yaoblock.blocks]
end
yao_to_symbols(yaoblock) = [yao_to_symbol(yaoblock)]

function yao_to_symbol(yaoblock)
    return yao_symbol_map[yaoblock]
end

end

"""
circuit optimisation
"""
module Optimise
using YaoBlocks, YaoBlocks.ConstGate
using YaoBlocks: NotImplementedError

export replace_block, flatten_basic, simplify, raise_chain, canonicalize, to_basictypes, is_pauli
export merge_pauli, eliminate_nested, merge_scale, combine_similar

"""
    replace_block(actor, tree::AbstractBlock) -> AbstractBlock
    replace_block(pair::Pair{Type{ST}, TT}, tree::AbstractBlock) -> AbstractBlock

replace blocks in a circuit, where `actor` is a function that given input block,
returns the block to replace, or `nothing` for skip replacing and visit sibling.
If `pair` is provided, then replace original block with type `ST` with new block (`pair.second`).
"""
function replace_block(actor, tree::AbstractBlock)
    res = actor(tree)
    if res === tree || res === nothing # not replaced
        return chsubblocks(tree, replace_block.(Ref(actor), subblocks(tree)))
    else
        return res
    end
end

function replace_block(
    pair::Pair{ST,TT},
    tree::AbstractBlock,
) where {ST<:AbstractBlock,TT<:AbstractBlock}
    replace_block(x -> (x == pair.first ? pair.second : nothing), tree)
end


"""
    to_basictypes(block::AbstractBlock)

convert gates to basic types

    * ChainBlock
    * PutBlock
    * PrimitiveBlock
"""
function to_basictypes end

to_basictypes(block::PrimitiveBlock) = block
to_basictypes(block::MixedUnitaryChannel) = block
to_basictypes(block::KrausChannel) = block
to_basictypes(block::DepolarizingChannel) = block
to_basictypes(block::SuperOp) = block
function to_basictypes(block::AbstractBlock)
    throw(NotImplementedError(:to_basictypes, typeof(block)))
end

function to_basictypes(block::RepeatedBlock)
    chain(block.n, map(i -> put(block.n, i => content(block)), block.locs))
end

to_basictypes(block::CachedBlock) = content(block)
function to_basictypes(block::Subroutine{D,<:PrimitiveBlock}) where {D}
    put(nqudits(block), block.locs => content(block))
end
function to_basictypes(block::Subroutine)
    to_basictypes(map_address(content(block), AddressInfo(block.n, [block.locs...])))
end
function to_basictypes(block::Subroutine{D,<:Measure}) where {D}
    map_address(content(block), AddressInfo(nqudits(block), [block.locs...]))
end
to_basictypes(block::Daggered) = Daggered(block.content)
to_basictypes(block::Scale) = Scale(block.alpha, block.content)
to_basictypes(block::KronBlock) =
    chain(block.n, [put(block.n, i => block[i]) for i in block.locs])
to_basictypes(block::Union{Add,PutBlock,ChainBlock,ControlBlock}) = block

"""
    is_pauli(x)

Check if `x` is an element of pauli group.
"""
is_pauli(xs...) = all(is_pauli, xs)
is_pauli(::Union{XGate,YGate, ZGate, I2Gate}) = true
is_pauli(::AbstractBlock) = false
function is_pauli(s::Scale)
    if factor(s) == im || factor(s) == -im || factor(s) == 1 || factor(s) == -1
        return is_pauli(content(s))
    else
        return false
    end
end

for G in [:I2, :X, :Y, :Z]
    ImG = Symbol(:Im, G)
    nImG = Symbol(:nIm, G)
    nG = Symbol(:n, G)

    @eval const $ImG = im * $G
    @eval const $nImG = -im * $G
    @eval const $nG = -$G
end

merge_pauli(x) = x
merge_pauli(x::AbstractBlock, y::AbstractBlock) = x * y

function merge_pauli(ex::ChainBlock)
    if ex.n != 1
        return ex
    end
    L = length(ex)
    new_ex = chain(1)

    # find all contiguous pauli and merge them
    # note we need to iterate in inverse order
    iterm = L
    while iterm > 0
        if iterm > 1 && is_pauli(ex[iterm], ex[iterm-1])
            pushfirst!(new_ex, merge_pauli(ex[iterm], ex[iterm-1]))
            iterm = iterm - 2
        else
            # search next
            pushfirst!(new_ex, ex[iterm])
            iterm -= 1
        end
    end
    return new_ex
end

merge_pauli(::XGate, ::YGate) = ImZ
merge_pauli(::XGate, ::ZGate) = -ImY
merge_pauli(::YGate, ::XGate) = -ImZ
merge_pauli(::YGate, ::ZGate) = ImX
merge_pauli(::ZGate, ::XGate) = ImY
merge_pauli(::ZGate, ::YGate) = nImX

for G in [:X, :Y, :Z]
    GT = Symbol(G, :Gate)

    @eval merge_pauli(::I2Gate, x::$GT) = x
    @eval merge_pauli(x::$GT, ::I2Gate) = x
    @eval merge_pauli(::$GT, ::$GT) = I2
end

merge_pauli(::I2Gate, ::I2Gate) = I2

eliminate_nested(ex::AbstractBlock) = ex

# eliminate nested put blocks
function eliminate_nested(ex::PutBlock)
    content = eliminate_nested(ex.content)
    if content isa PutBlock
        return put(nqubits(ex), map(x -> ex.locs[x], content.locs) => content.content)
    else
        return ex
    end
end

function eliminate_nested(ex::T) where {T<:Union{ChainBlock,Add}}
    _flatten(x) = (x,)
    _flatten(x::T) = subblocks(x)

    isone(length(ex)) && return first(subblocks(ex))
    return chsubblocks(ex, collect(AbstractBlock{nlevel(ex)}, Iterators.flatten(map(_flatten, subblocks(ex)))))
end

raise_chain(ex::AbstractBlock) = ex
raise_chain(ex::ChainBlock) = chain(nqubits(ex), [raise_chain(block) for block in ex])
function raise_chain(ex::PutBlock)
    content = raise_chain(ex.content)
    if content isa ChainBlock
        return chain(nqubits(ex), [put(nqubits(ex), ex.locs => block) for block in content])
    else
        return ex
    end
end

# temporary utils
_unscale(x::AbstractBlock) = x
_unscale(x::Scale) = content(x)
merge_alpha(alpha, x::AbstractBlock) = alpha
merge_alpha(alpha, x::Scale) = alpha * x.alpha
merge_alpha(alpha, x::Scale{Val{S}}) where {S} = alpha * S

# since we don't have T in blocks, this is a workaround
# to get correct identity in type stable term
merge_alpha(::Nothing, x::Scale) = x.alpha
merge_alpha(::Nothing, x::Scale{Val{S}}) where {S} = S
merge_alpha(::Nothing, x::AbstractBlock) = nothing

merge_scale(ex::AbstractBlock) = ex

# a simple function to find one for Val and Number
_one(x) = one(x)
_one(::Type{Val{S}}) where {S} = one(S)
_one(::Val{S}) where {S} = one(S)



function merge_scale(ex::Union{Scale{S,N},ChainBlock{N}}) where {S,N}
    alpha = nothing
    for each in subblocks(ex)
        alpha = merge_alpha(alpha, each)
    end
    ex = chsubblocks(ex, map(_unscale, subblocks(ex)))
    if alpha === nothing
        return ex
    else
        return alpha * ex
    end
end

combine_similar(ex::AbstractBlock) = ex

combine_alpha(alpha, x) = alpha
combine_alpha(alpha, x::AbstractBlock) = alpha + 1
combine_alpha(alpha, x::Scale) = alpha + x.alpha
combine_alpha(alpha, x::Scale{Val{S}}) where {S} = alpha + S

function combine_similar(ex::Add{D}) where D
    table = zeros(Bool, length(ex))
    list = AbstractBlock{D}[]
    p = 1
    while p <= length(ex)
        if table[p] == true
            # checked term, skip
            p += 1
        else
            # check similar term
            term = ex[p]
            table[p] = true # mark it in the table
            alpha = 1
            for (k, each) in enumerate(ex)
                if table[k] == true # checked term, skip
                    continue
                else
                    # check if unscaled term is the same
                    # merge them if they are
                    if _unscale(term) == _unscale(each)
                        alpha = combine_alpha(alpha, each)
                        # mark checked term in the table
                        table[k] = true
                    end
                end
            end

            # eliminate zeros
            if alpha != 0
                alpha = imag(alpha) == 0 ? real(alpha) : alpha
                alpha = isinteger(alpha) ? Integer(alpha) : alpha
                push!(list, alpha * term)
            end
        end
    end

    if isempty(list)
        return Add(ex.n)
    else
        return Add(ex.n, list)
    end
end

const __default_simplification_rules__ =
    Function[merge_pauli, eliminate_nested, merge_scale, combine_similar]
const __flatten_basic__ = Function[eliminate_nested, to_basictypes]
const __canonicalize__ = Function[eliminate_nested, raise_chain, to_basictypes]

flatten_basic(ex::AbstractBlock) = simplify(ex; rules = __flatten_basic__)
canonicalize(ex::AbstractBlock) = simplify(ex; rules = __canonicalize__)

# Inspired by MasonPotter/Symbolics.jl
"""
    simplify(block[; rules=__default_simplification_rules__])

Simplify a block tree accroding to given rules, default to use
`YaoBlocks.Optimise.__default_simplification_rules__`.
"""
function simplify(ex::AbstractBlock; rules = __default_simplification_rules__)
    out1 = simplify_pass(rules, ex)
    out2 = simplify_pass(rules, out1)
    counter = 1
    while (out1 isa AbstractBlock) && (out2 isa AbstractBlock) && (out2 != out1)
        out1 = simplify_pass(rules, out2)
        out2 = simplify_pass(rules, out1)
        counter += 1
        if counter > 1000
            @warn "possible infinite loop in simplification rules. Breaking"
            return out2
        end
    end
    return out2
end

function simplify_pass(rules, ex)
    if length(subblocks(ex)) > 0
        ex = chsubblocks(ex, map(x -> simplify_pass(rules, x), subblocks(ex)))
    end

    for rule in rules
        ex = rule(ex)
    end
    return ex
end

end

export TrivialGate, IdentityGate, igate

abstract type TrivialGate{D} <: PrimitiveBlock{D} end

mat(::Type{T}, d::TrivialGate{D}) where {T,D} = IMatrix{T}(D^nqudits(d))
Base.adjoint(g::TrivialGate) = g
occupied_locs(g::TrivialGate) = ()

"""
    IdentityGate{D} <: TrivialGate{D}

The identity gate.
"""
struct IdentityGate{D} <: TrivialGate{D}
    n::Int
end
nqudits(ig::IdentityGate) = ig.n

function print_block(io::IO, x::IdentityGate{2})
    print(io, "igate(", x.n, ")")
end

function print_block(io::IO, x::IdentityGate{D}) where {D}
    print(io, "igate(", x.n, ";nlevel=", D, ")")
end

"""
    igate(n::Int; nlevel=2)

The constructor for [`IdentityGate`](@ref).
Let ``I_d`` be a ``d \\times d`` identity matrix, `igate(n; nlevel=d)` is defined as ``I_d^{\\otimes n}``.

### Examples

```jldoctest; setup=:(using Yao)
julia> igate(2)
igate(2)

julia> igate(2; nlevel=3)
igate(2;nlevel=3)
```
"""
igate(n::Int; nlevel=2) = IdentityGate{nlevel}(n)

function unsafe_getindex(::Type{T}, rg::IdentityGate{D}, i::Integer, j::Integer) where {D,T}
    i==j ? one(T) : zero(T)
end
function unsafe_getcol(::Type{T}, rg::IdentityGate{D}, j::DitStr{D}) where {D,T}
    [j], [one(T)]
end

LinearAlgebra.ishermitian(::IdentityGate) = true
YaoAPI.isunitary(::IdentityGate) = true

using Test, YaoBlocks, LuxurySparse, BitBasis, YaoBlocks.ConstGate
using LinearAlgebra

@testset "test builtin gates" begin

    @testset "test $each" for each in [X, Y, Z, H, CNOT, SWAP, Toffoli]
        @test isunitary(each) == true
        @test isreflexive(each) == true
        @test ishermitian(each) == true
        @test isdiagonal(each) == isdiagonal(mat(each))
    end


    @testset "test $each nqubits" for each in [X, Y, Z, H, T, S, Tdag, Sdag, P0, P1, Pu, Pd]
        @test nqubits(each) == 1
    end

    @testset "test $each" for each in [S, T]
        @test isunitary(each)
        @test isreflexive(each) == false
        @test ishermitian(each) == false
        @test isdiagonal(each) == isdiagonal(mat(each)) == true
    end

    @testset "test $each" for each in [P0, P1]
        @test isunitary(each) == false
        @test isreflexive(each) == false
        @test ishermitian(each) == true
        @test isdiagonal(each) == isdiagonal(mat(each)) == true
    end

    @testset "test $each" for each in [Pu, Pd]
        @test isunitary(each) == false
        @test isreflexive(each) == false
        @test ishermitian(each) == false
        @test isdiagonal(each) == isdiagonal(mat(each)) == false
    end

    @test nqubits(CNOT) == 2
    @test nqubits(CZ) == 2
    @test nqubits(SWAP) == 2
    @test nqubits(Toffoli) == 3


end

@testset "matrix" begin
    CNOT_R = PermMatrix([1, 2, 4, 3], ones(ComplexF64, 4))
    Toffoli_R = PermMatrix([1, 2, 3, 4, 5, 6, 8, 7], ones(ComplexF64, 8))

    for (each, MAT) in [
        (X, [0 1; 1 0]),
        (Y, [0 -im; im 0]),
        (Z, [1 0; 0 -1]),
        (H, (elem = 1 / sqrt(2); [elem elem; elem -elem])),
    ]
        @test mat(each) ≈ MAT

    end
    @test mat(CNOT) |> invorder == CNOT_R
    @test mat(Toffoli) |> invorder == Toffoli_R
    @test mat(T) * mat(T) ≈ mat(S)

    @test mat(T)' ≈ mat(T')
    @test mat(Tdag)' ≈ mat(Tdag')
    @test T' isa TdagGate
    @test Tdag' isa TGate

    @test mat(S)' ≈ mat(S')
    @test mat(Sdag)' ≈ mat(Sdag')
    @test S' isa SdagGate
    @test Sdag' isa SGate
end

@testset "test @const_gate" begin

    @testset "bind new type" begin
        @const_gate X::ComplexF32
        @test mat(ComplexF32, X) isa PermMatrix{ComplexF32}
    end

    @testset "define new" begin
        @const_gate TEST = rand(ComplexF64, 2, 2)

        # errors if given matrix is not a square matrix
        @test_throws DimensionMismatch @const_gate TEST::ComplexF32 = rand(2, 3)
    end

    @testset "define new 3-level" begin
        @const_gate TEST2 = rand(ComplexF64, 3, 3) nlevel=3
        @test nlevel(TEST2) == 3
    end
end

@testset "test adjoints" begin
    @test adjoint(Pu) == Pd
    @test adjoint(Pd) == Pu
end

@testset "P0/P1" begin
    @test mat(P0) isa Diagonal
    @test mat(P0) ≈ [1 0;0 0]
    @test mat(P1) ≈ [0 0;0 1]
end

@testset "instruct_get_element" begin
    for pb in [X, Y, Z, I2, S, T, Pu, Pd, P0, P1]
        mpb = mat(pb)
        allpass = true
        for i=basis(pb), j=basis(pb)
            allpass &= pb[i, j] == mpb[Int(i)+1, Int(j)+1]
        end
        @test allpass

        allpass = true
        for j=basis(pb)
            allpass &= vec(pb[:, j]) == mpb[:, Int(j)+1]
            allpass &= vec(pb[j,:]) == mpb[Int(j)+1,:]
            allpass &= isclean(pb[:,j])
        end
        @test allpass
    end
    # regression test
    @test P0[:,bit"0"] |> length == 1
    @test P0[:,bit"1"] |> length == 0
    @test P1[:,bit"0"] |> length == 0
    @test P1[:,bit"1"] |> length == 1
end

using Test, YaoBlocks, YaoArrayRegister

@testset "basic" begin
    reg = rand_state(10)
    block = kron(4, 2 => X)
    c = subroutine(10, block, [1, 3, 9, 2])
    @test nqubits(c) == 10
    @test nactive(c) == 4
    @test isunitary(c) == true
    @test isreflexive(c) == true
    @test ishermitian(c) == true
    blk = kron(4, 2 => Rx(0.3))
    @test chsubblocks(c, [blk]) |> subblocks |> first == blk
    @test occupied_locs(c) == (3,)

    @test apply!(copy(reg), c) == apply!(copy(reg), kron(10, 3 => X))
    @test apply!(rand_state(12, nbatch = 10) |> focus!(Tuple(1:10)...), c) |> nactive == 10
end

@testset "test repeat" begin
    c = subroutine(8, repeat(5, H), 1:5)
    r = rand_state(8)
    r1 = copy(r) |> c
    r2 = copy(r) |> repeat(8, H, 1:5)
    @test r1 ≈ r2
end

@testset "mat" begin
    cc = subroutine(5, kron(X, X), (1, 3))
    @test applymatrix(cc) ≈ mat(cc)
end

@testset "push coverage" begin
    @test subroutine(put(3, 2=>X), (3,4,5))(5) isa Subroutine
    @test subroutine(put(2=>X), (3,4,5))(5) isa Subroutine
    s = subroutine(put(2=>X), (3,4,5))(5)
    q = subroutine(put(3=>Y), (3,4,5))(5)
    z = subroutine(put(3=>Val(im)*X), (3,4,5))(5)
    @test s' == s
    @test iscommute(s', s)
    @test iscommute(s', z)
    @test_throws LocationConflictError subroutine(5, put(3,2=>X), (1,4,2,5))
    @test_throws ErrorException subroutine(5, put(3,2=>X), (7,4,5))
    @test YaoBlocks.PropertyTrait(s) == YaoBlocks.PreserveAll()
end

@testset "instruct_get_element" begin
    for pb in [subroutine(3, Y, (2,)), subroutine(4, matblock(rand_unitary(4)), (4,2))]
        mpb = mat(pb)
        allpass = true
        for i=basis(pb), j=basis(pb)
            allpass &= pb[i, j] == mpb[Int(i)+1, Int(j)+1]
        end
        @test allpass

        allpass = true
        for j=basis(pb)
            allpass &= vec(pb[:, j]) == mpb[:, Int(j)+1]
            allpass &= vec(pb[:, EntryTable([j], [1.0+0im])]) == mpb[:, Int(j)+1]
            allpass &= vec(pb[j, :]) == mpb[Int(j)+1, :]
            allpass &= isclean(pb[:,j])
        end
        @test allpass
    end
end

using Test, YaoBlocks, YaoBlocks.ConstGate
using OpenQASM

# Get the OpenQASM extension module
const OpenQASMExt = Base.get_extension(YaoBlocks, :OpenQASMExt)
using .OpenQASMExt: ErrorPattern, SimulationTask, AtLoc, parse_noise_model, CustomKrausError, ReadOutError
using .OpenQASMExt: parse_instruction!
# Note: parseblock is extended on YaoBlocks.parseblock, so use it from YaoBlocks
using YaoBlocks: parseblock

@testset "parse instruction" begin
    c1 = chain(1)
    pattern = ErrorPattern[]
    # single qubits gates
    @test Matrix(parse_instruction!(c1, "id", [1], [], pattern)[end]) ≈ [1 0; 0 1]
    @test Matrix(parse_instruction!(c1, "x", [1], [], pattern)[end]) ≈ [0 1; 1 0]
    @test Matrix(parse_instruction!(c1, "y", [1], [], pattern)[end]) ≈ [0 -im; im 0]
    @test Matrix(parse_instruction!(c1, "z", [1], [], pattern)[end]) ≈ [1 0; 0 -1]
    @test Matrix(parse_instruction!(c1, "h", [1], [], pattern)[end]) ≈ [1 1; 1 -1] / sqrt(2)
    @test Matrix(parse_instruction!(c1, "s", [1], [], pattern)[end]) ≈ [1 0; 0 im]
    @test Matrix(parse_instruction!(c1, "sdg", [1], [], pattern)[end]) ≈ [1 0; 0 -im]
    @test Matrix(parse_instruction!(c1, "t", [1], [], pattern)[end]) ≈ [1 0; 0 exp(im*pi/4)]
    @test Matrix(parse_instruction!(c1, "tdg", [1], [], pattern)[end]) ≈ [1 0; 0 exp(-im*pi/4)]
    @test Matrix(parse_instruction!(c1, "rx", [1], [0.5], pattern)[end]) ≈ [cos(0.5/2) -im*sin(0.5/2); -im*sin(0.5/2) cos(0.5/2)]
    @test Matrix(parse_instruction!(c1, "ry", [1], [0.5], pattern)[end]) ≈ [cos(0.5/2) -sin(0.5/2); sin(0.5/2) cos(0.5/2)]
    @test Matrix(parse_instruction!(c1, "rz", [1], [0.5], pattern)[end]) ≈ [exp(-im*0.5/2) 0; 0 exp(im*0.5/2)]
    # u1, u2, u3
    @test Matrix(parse_instruction!(c1, "u1", [1], [0.5], pattern)[end]) ≈ [1 0; 0 exp(im*0.5)]
    @test Matrix(parse_instruction!(c1, "u2", [1], [0.5, 0.6], pattern)[end]) ≈ [1 -exp(im*0.6); exp(im*0.5) exp(im*1.1)] ./ sqrt(2)
    @test Matrix(parse_instruction!(c1, "u3", [1], [0.3, 0.5, 0.6], pattern)[end]) ≈ [cos(0.3/2) -exp(im*0.6)*sin(0.3/2); exp(im*0.5)*sin(0.3/2) exp(im*1.1)*cos(0.3/2)]
    # sx and sxdg
    @test Matrix(parse_instruction!(c1, "sx", [1], [], pattern)[end]) ≈ [1+im 1-im; 1-im 1+im]/2
    # r
    @test Matrix(parse_instruction!(c1, "r", [1], [0.5, 0.6], pattern)[end]) ≈ [cos(0.5/2) -im*exp(-im*0.6)*sin(0.5/2); -im*exp(im*0.6)*sin(0.5/2) cos(0.5/2)]
    # two qubits gates
    c2 = chain(2)
    reorder(x) = reshape(permutedims(reshape(x, 2, 2, 2, 2), (2, 1, 4, 3)), 4, 4)
    @test Matrix(parse_instruction!(c2, "cx", [1, 2], [], pattern)[end]) ≈ reorder([1 0 0 0; 0 1 0 0; 0 0 0 1; 0 0 1 0])
    @test Matrix(parse_instruction!(c2, "cy", [1, 2], [], pattern)[end]) ≈ reorder([1 0 0 0; 0 1 0 0; 0 0 0 -im; 0 0 im 0])
    @test Matrix(parse_instruction!(c2, "cz", [1, 2], [], pattern)[end]) ≈ reorder([1 0 0 0; 0 1 0 0; 0 0 1 0; 0 0 0 -1])
    @test Matrix(parse_instruction!(c2, "ch", [1, 2], [], pattern)[end]) ≈ reorder([1 0 0 0; 0 1 0 0; 0 0 1/sqrt(2) 1/sqrt(2); 0 0 1/sqrt(2) -1/sqrt(2)])
    @test Matrix(parse_instruction!(c2, "crz", [1, 2], [0.5], pattern)[end]) ≈ reorder([1 0 0 0; 0 1 0 0; 0 0 exp(-im*0.5/2) 0; 0 0 0 exp(im*0.5/2)])
    # cu1 and cu3
    @test Matrix(parse_instruction!(c2, "cu1", [1, 2], [0.5], pattern)[end]) ≈ reorder([1 0 0 0; 0 1 0 0; 0 0 1 0; 0 0 0 exp(im*0.5)])
    @test Matrix(parse_instruction!(c2, "cu3", [1, 2], [0.3, 0.5, 0.6], pattern)[end]) ≈ reorder([1 0 0 0; 0 1 0 0; 0 0 cos(0.3/2) -exp(im*0.6)*sin(0.3/2); 0 0 exp(im*0.5)*sin(0.3/2) exp(im*1.1)*cos(0.3/2)])
    # rxx and rzz
    @test Matrix(parse_instruction!(c2, "rxx", [1, 2], [0.5], pattern)[end]) ≈ [cos(0.25) 0 0 -im*sin(0.25); 0 cos(0.25) -im*sin(0.25) 0; 0 -im*sin(0.25) cos(0.25) 0; -im*sin(0.25) 0 0 cos(0.25)]
    @test Matrix(parse_instruction!(c2, "rzz", [1, 2], [0.5], pattern)[end]) ≈ [exp(-im*0.25) 0 0 0; 0 exp(im*0.25) 0 0; 0 0 exp(im*0.25) 0; 0 0 0 exp(-im*0.25)]
    # swap
    @test Matrix(parse_instruction!(c2, "swap", [1, 2], [], pattern)[end]) ≈ [1 0 0 0; 0 0 1 0; 0 1 0 0; 0 0 0 1]

    # ccx
    c3 = chain(3)
    reorder3(x) = reshape(permutedims(reshape(x, 2, 2, 2, 2, 2, 2), (3, 2, 1, 6, 5, 4)), 8, 8)
    @test Matrix(parse_instruction!(c3, "ccx", [1, 2, 3], [], pattern)[end]) ≈ reorder3([1 0 0 0 0 0 0 0; 0 1 0 0 0 0 0 0; 0 0 1 0 0 0 0 0; 0 0 0 1 0 0 0 0; 0 0 0 0 1 0 0 0; 0 0 0 0 0 1 0 0; 0 0 0 0 0 0 0 1; 0 0 0 0 0 0 1 0])
end

@testset "parse instruction with noise" begin
    # different gates
    pattern = [
        ErrorPattern([[1]], ["id"], DepolarizingError(1, 0.01)),
        ErrorPattern([[1]], ["x"], DepolarizingError(1, 0.01)),
        ErrorPattern([[1]], ["y"], DepolarizingError(1, 0.01)),
        ErrorPattern([[1]], ["z"], DepolarizingError(1, 0.01)),
        ErrorPattern([[1]], ["h"], DepolarizingError(1, 0.01)),
        ErrorPattern([[1]], ["s"], DepolarizingError(1, 0.01)),
        ErrorPattern([[1]], ["sdg"], DepolarizingError(1, 0.01)),
        ErrorPattern([[1]], ["t"], DepolarizingError(1, 0.01)),
        ErrorPattern([[1]], ["tdg"], DepolarizingError(1, 0.01)),
        ErrorPattern([[1]], ["rx"], DepolarizingError(1, 0.01)),
        ErrorPattern([[1]], ["ry"], DepolarizingError(1, 0.01)),
        ErrorPattern([[1]], ["rz"], DepolarizingError(1, 0.01)),
        ErrorPattern([[1]], ["u1"], DepolarizingError(1, 0.01)),
        ErrorPattern([[1]], ["u2"], DepolarizingError(1, 0.01)),
        ErrorPattern([[1]], ["u3"], DepolarizingError(1, 0.01)),
        ErrorPattern([[1, 2]], ["cx"], DepolarizingError(2, 0.01)),
        ErrorPattern([[1, 2]], ["cy"], DepolarizingError(2, 0.01)),
        ErrorPattern([[1, 2]], ["cz"], DepolarizingError(2, 0.01)),
        ErrorPattern([[1, 2]], ["ch"], DepolarizingError(2, 0.01)),
        ErrorPattern([[1, 2]], ["crz"], DepolarizingError(2, 0.01)),
        ErrorPattern([[1, 2]], ["cu1"], DepolarizingError(2, 0.01)),
        ErrorPattern([[1, 2]], ["cu3"], DepolarizingError(2, 0.01)),
        ErrorPattern([[1, 2, 3]], ["ccx"], DepolarizingError(3, 0.01)),
    ]
    qasm_str = """
        OPENQASM 2.0;
        include "qelib1.inc";
        qreg q[3];
        creg c1[3];
        id q[0];
        x q[0];
        y q[0];
        z q[0];
        h q[0];
        s q[0];
        sdg q[0];
        t q[0];
        tdg q[0];
        rx(0.7) q[0];
        ry(0.7) q[0];
        rz(0.7) q[0];
        u1(0.7) q[0];
        u2(0.7, 0.8) q[0];
        u3(0.7, 0.8, 0.9) q[0];
        cx q[0],q[1];
        cy q[0],q[1];
        cz q[0],q[1];
        ch q[0],q[1];
        crz(0.7) q[0],q[1];
        cu1(0.7) q[0],q[1];
        cu3(0.7, 0.8, 0.9) q[0],q[1];
        ccx q[0],q[1],q[2];
        measure q[0] -> c1[0];
        measure q[1] -> c1[1];
        measure q[2] -> c1[2];    
    """
    ast = OpenQASM.parse(qasm_str)
    @test ast isa OpenQASM.Types.MainProgram
    task = parseblock(ast, pattern)
    @test length(task.circuit) == 49

    # at different locations
    pattern = [
        ErrorPattern([[1, 2]], ["cx"], DepolarizingError(2, 0.01)),
        ErrorPattern([[2]], ["x"], DepolarizingError(1, 0.01)),
        ErrorPattern([[2]], ["x"], PhaseDampingError(0.1)),
        ErrorPattern([[1]], ["x"], DepolarizingError(1, 0.01)),
        ErrorPattern([[1]], ["y"], DepolarizingError(1, 0.01)),
    ]
    qasm_str = """
        OPENQASM 2.0;
        include "qelib1.inc";
        qreg q[3];
        creg c1[3];
        x q[0];
        x q[1];
        y q[1];
        z q[2];
        cx q[0],q[1];
        cx q[1],q[0];
        measure q[0] -> c1[0];
        measure q[1] -> c1[1];
        measure q[2] -> c1[2];    
    """
    ast = OpenQASM.parse(qasm_str)
    task = parseblock(ast, pattern)
    @test task.circuit == chain(3,
        put(3, 1=>X),   # rule 4 match
        put(3, 1=>quantum_channel(DepolarizingError(1, 0.01))),

        put(3, 2=>X),   # rule 2,3 match
        put(3, 2=>quantum_channel(DepolarizingError(1, 0.01))),
        put(3, 2=>quantum_channel(PhaseDampingError(0.1))),

        put(3, 2=>Y),   # no rule match
        put(3, 3=>Z),   # no rule match

        control(3, 1, 2=>X),   # rule 4 match
        put(3, (1, 2)=>quantum_channel(DepolarizingError(2, 0.01))),

        control(3, 2, 1=>X),   # no rule match
        Measure(3; locs=1),
        Measure(3; locs=2),
        Measure(3; locs=3),
    )
end

@testset "parse" begin
    qasm_str = """
        OPENQASM 2.0;
        include "qelib1.inc";
        qreg q[3];
        creg c1[3];
        h q[0];
        CX q[1],q[2];
        cy q[1],q[0];
        cz q[0],q[2];
        x q[0];
        swap q[1],q[2];
        id q[0];
        t q[1];
        rz(0.7) q[2];
        z q[0];
        p(0.7) q[1];
        ry(0.7) q[2];
        y q[0];
        rx(0.7) q[1];
        measure q[0] -> c1[0];
        measure q[1] -> c1[1];
        measure q[2] -> c1[2];    
    """
    ast = OpenQASM.parse(qasm_str)
    @test ast isa OpenQASM.Types.MainProgram
end

@testset "parse block" begin
    qasm_str = """
        OPENQASM 2.0;
        include "qelib1.inc";
        qreg q[3];
        creg c1[3];
        h q[0];
        CX q[1],q[2];
        cy q[1],q[0];
        cz q[0],q[2];
        x q[0];
        swap q[1],q[2];
        id q[0];
        t q[1];
        rz(0.7) q[2];
        z q[0];
        ry(0.7) q[2];
        y q[0];
        rx(0.7) q[1];
        measure q[0] -> c1[0];
        measure q[1] -> c1[1];
        measure q[2] -> c1[2];    
    """
    task = parseblock(qasm_str)
    @test length(task.circuit) == 16
    @test length(task.outcomes) == 3
    @test task.outcomes[1] == Measure(3; locs=1)
    @test task.outcomes[2] == Measure(3; locs=2)
    @test task.outcomes[3] == Measure(3; locs=3)
end

@testset "parse with comments" begin
    qasm_str = """
OPENQASM 2.0;
include "qelib1.inc";
qreg q[4]; // claim a quantum register named 'q' with 4 qubits
creg c[4]; // claim a classical register named 'c' with 4 bits for measurement

x q[0]; 
x q[2];

h q[0];
cu1(pi/2) q[1],q[0];
h q[1];
cu1(pi/4) q[2],q[0];
cu1(pi/2) q[2],q[1];
h q[2];
cu1(pi/8) q[3],q[0];
cu1(pi/4) q[3],q[1];
cu1(pi/2) q[3],q[2];
h q[3];
measure q -> c;
"""
    ast = OpenQASM.parse(qasm_str)
    @test ast isa OpenQASM.Types.MainProgram
    task = parseblock(ast, ErrorPattern[])
    @test length(task.circuit) == 13
    @test length(task.outcomes) == 4
    @test task.outcomes[1] == AtLoc(Measure(4), 1)
    @test task.outcomes[2] == AtLoc(Measure(4), 2)
    @test task.outcomes[3] == AtLoc(Measure(4), 3)
    @test task.outcomes[4] == AtLoc(Measure(4), 4)
end

@testset "comprehensive noise parsing tests" begin
    
    @testset "depolarizing noise" begin
        noise_data = [Dict(
            "type" => "depolarizing",
            "operations" => ["ry"],
            "qubits" => [[0]],
            "probability" => 0.1
        )]
        gate_errors, ro_error = parse_noise_model(noise_data)
        @test length(gate_errors) == 1
        @test gate_errors[1].locs == [[1]]
        @test gate_errors[1].operations == ["ry"]
        @test gate_errors[1].error isa DepolarizingError
        @test gate_errors[1].error.p == 0.1
        @test ro_error isa Vector{ReadOutError}
    end
    
    @testset "depolarizing2 noise" begin
        noise_data = [Dict(
            "type" => "depolarizing2",
            "operations" => ["cx"],
            "qubits" => [[0, 1]],
            "probability" => 0.05
        )]
        gate_errors, ro_error = parse_noise_model(noise_data)
        @test length(gate_errors) == 1
        @test gate_errors[1].locs == [[1, 2]]
        @test gate_errors[1].operations == ["cx"]
        @test gate_errors[1].error isa DepolarizingError
        @test gate_errors[1].error.p == 0.05
    end
    
    @testset "thermal_relaxation noise" begin
        noise_data = [Dict(
            "type" => "thermal_relaxation",
            "operations" => ["u3"],
            "qubits" => [[0]],
            "T1" => 50000.0,
            "T2" => 70000.0,
            "time" => 100.0
        )]
        gate_errors, ro_error = parse_noise_model(noise_data)
        @test length(gate_errors) == 1
        @test gate_errors[1].error isa ThermalRelaxationError
        @test gate_errors[1].error.T1 == 50000.0
        @test gate_errors[1].error.T2 == 70000.0
        @test gate_errors[1].error.time == 100.0
    end
    
    @testset "coherent_unitary noise" begin
        noise_data = [Dict(
            "type" => "coherent_unitary",
            "operations" => ["u1"],
            "qubits" => [[0]],
            "unitary" => [[1.0, 0.0], [0.0, 1.0]]  # Identity matrix
        )]
        gate_errors, ro_error = parse_noise_model(noise_data)
        @test length(gate_errors) == 1
        @test gate_errors[1].error isa CoherentError
        @test gate_errors[1].error.block isa AbstractBlock
    end
    
    @testset "pauli noise" begin
        noise_data = [Dict(
            "type" => "pauli",
            "operations" => ["u2"],
            "qubits" => [[0]],
            "probability" => [0.01, 0.01, 0.01]  # X, Y, Z probabilities
        )]
        gate_errors, ro_error = parse_noise_model(noise_data)
        @test length(gate_errors) == 1
        @test gate_errors[1].error isa PauliError
        @test gate_errors[1].error.px == 0.01
        @test gate_errors[1].error.py == 0.01
        @test gate_errors[1].error.pz == 0.01
    end
    
    @testset "amplitude_damping noise" begin
        noise_data = [Dict(
            "type" => "amplitude_damping",
            "operations" => ["x"],
            "qubits" => [[0]],
            "gamma_amplitude" => 0.1,
            "excited_state_population" => 0.0
        )]
        gate_errors, ro_error = parse_noise_model(noise_data)
        @test length(gate_errors) == 1
        @test gate_errors[1].error isa AmplitudeDampingError
        @test gate_errors[1].error.amplitude == 0.1
        @test gate_errors[1].error.excited_state_population == 0.0
    end
    
    @testset "phase_damping noise" begin
        noise_data = [Dict(
            "type" => "phase_damping",
            "operations" => ["z"],
            "qubits" => [[0]],
            "gamma_phase" => 0.05
        )]
        gate_errors, ro_error = parse_noise_model(noise_data)
        @test length(gate_errors) == 1
        @test gate_errors[1].error isa PhaseDampingError
        @test gate_errors[1].error.phase == 0.05
    end
    
    @testset "phase_amplitude_damping noise" begin
        noise_data = [Dict(
            "type" => "phase_amplitude_damping",
            "operations" => ["y"],
            "qubits" => [[0]],
            "gamma_amplitude" => 0.1,
            "gamma_phase" => 0.05,
            "excited_state_population" => 0.0
        )]
        gate_errors, ro_error = parse_noise_model(noise_data)
        @test length(gate_errors) == 1
        @test gate_errors[1].error isa PhaseAmplitudeDampingError
        @test gate_errors[1].error.amplitude == 0.1
        @test gate_errors[1].error.phase == 0.05
        @test gate_errors[1].error.excited_state_population == 0.0
    end
    
    @testset "kraus noise" begin
        noise_data = [Dict(
            "type" => "kraus",
            "operations" => ["h"],
            "qubits" => [[0]],
            "kraus_ops" => [[[1.0, 0.0], [0.0, 1.0]], [[0.0, 1.0], [1.0, 0.0]]]  # Identity and X
        )]
        gate_errors, ro_error = parse_noise_model(noise_data)
        @test length(gate_errors) == 1
        @test gate_errors[1].error isa CustomKrausError
        @test length(gate_errors[1].error.kraus_ops) == 2
    end
    
    @testset "roerror (readout error)" begin
        noise_data = [Dict(
            "type" => "roerror",
            "operations" => ["measure"],
            "qubits" => [[0]],
            "probability" => [[0.8, 0.2], [0.1, 0.9]]
        )]
        gate_errors, ro_error = parse_noise_model(noise_data)
        @test length(gate_errors) == 0  # No gate errors for readout error
        @test ro_error isa Vector{ReadOutError}
        @test ro_error[1].probability == [[0.8, 0.2], [0.1, 0.9]]
    end
    
    @testset "mixed noise types" begin
        noise_data = [
            Dict(
                "type" => "depolarizing",
                "operations" => ["x"],
                "qubits" => [[0]],
                "probability" => 0.1
            ),
            Dict(
                "type" => "roerror",
                "operations" => ["measure"],
                "qubits" => [[0]],
                "probability" => [[0.9, 0.1], [0.05, 0.95]]
            )
        ]
        gate_errors, ro_error = parse_noise_model(noise_data)
        @test length(gate_errors) == 1
        @test gate_errors[1].error isa DepolarizingError
        @test ro_error[1].probability == [[0.9, 0.1], [0.05, 0.95]]
    end
    
    @testset "unknown noise type error" begin
        noise_data = [Dict(
            "type" => "unknown_noise",
            "operations" => ["x"],
            "qubits" => [[0]],
            "probability" => 0.1
        )]
        @test_throws ErrorException parse_noise_model(noise_data)
    end
end

@testset "partial measurement" begin
    qasm_str = """
    OPENQASM 2.0;
    include "qelib1.inc";
    qreg q[3];
    creg c[1];
    measure q[2] -> c[0];
    """
    ast = OpenQASM.parse(qasm_str)
    @test ast isa OpenQASM.Types.MainProgram
    task = parseblock(ast, ErrorPattern[])
    @test task.outcomes[1] == Measure(3; locs=3)
end

@testset "negative angles" begin
    qasm_str = """
    OPENQASM 2.0;
    include "qelib1.inc";
    qreg q[1];

    ry(-1.44734) q[0];
    h q[0];

    creg c[1];
    measure q -> c;
    """
    ast = OpenQASM.parse(qasm_str)
    @test ast isa OpenQASM.Types.MainProgram
    task = parseblock(ast, ErrorPattern[])
    @test task isa SimulationTask
end

using Test, YaoBlocks, YaoArrayRegister
using YaoBlocks.ConstGate
using StatsBase: mean
using LinearAlgebra: tr

@testset "blockfilter expect" begin
    ghz = (arrayreg(bit"0000") + arrayreg(bit"1111")) |> normalize!
    obs1 = kron(4, 2 => Z)
    obs2 = kron(4, 2 => X)
    obs3 = repeat(4, X)
    @test expect(obs1, ghz) ≈ 0
    @test expect(obs2, ghz) ≈ 0
    @test expect(obs3, ghz) ≈ 1

    @test expect(obs3, zero_state(4) => kron(H, H, H, H)) ≈
          expect(obs3, zero_state(4) |> kron(H, H, H, H))
    @test expect(obs1 + obs2 + obs3, ghz) ≈ 1
    @test expect(obs1 + obs2 + obs3, clone(ghz, 3)) ≈ [1, 1, 1]
    @test expect(2 * obs3, ghz) ≈ 2
    @test expect(2 * obs3, clone(ghz, 3)) ≈ [2, 2, 2]

    @test blockfilter(
        ishermitian,
        chain(2, kron(2, X, P0), repeat(2, Rx(0), (1, 2)), kron(2, 2 => Rz(0.3))),
    ) == Any[X, P0, kron(2, X, P0), Rx(0), repeat(2, Rx(0), (1, 2))]
    @test blockfilter(
        b -> ishermitian(b) && b isa PrimitiveBlock,
        chain(2, kron(2, X, P0), repeat(2, Rx(0), (1, 2)), kron(2, 2 => Rz(0.3))),
    ) == [X, P0, Rx(0)]
end

@testset "density matrix" begin
    reg = rand_state(4)
    dm = reg |> density_matrix
    op = 3*(2*put(4, 3 => X) + put(4, 2=>Y))
    @test expect(op, dm) ≈ expect(op, reg)

    reg = rand_state(4; nbatch = 3)
    dms = reg .|> density_matrix
    op = put(4, 3 => X)
    @test expect.(Ref(op), dms) ≈ expect(op, reg)

    # test partial trace
    reg = rand_state(4)
    dm = reg |> density_matrix
    dmt = partial_tr(dm, (3,4))
    h = matblock(rand_hermitian(4))
    @test expect(h, dmt) ≈ expect(put(4, (1,2)=>h), dm)
end

@testset "insert_qubits!" begin
    reg = rand_state(5; nbatch = 10)
    insert_qudits!(reg, 3, 2)
    @test reg |> nqubits == 7
    @test expect(put(7, 3 => Z), reg) .|> tr |> mean ≈ 1
    @test expect(put(7, 4 => Z), reg) .|> tr |> mean ≈ 1
end

@testset "expect" begin
    for reg in [
        rand_state(3, nbatch = 10),
        rand_state(3, nbatch = 10, no_transpose_storage = true),
    ]
        e1 = expect.(Ref(put(2, 2 => X)), reg |> copy |> focus!(1, 2) .|> density_matrix)
        e2 = expect(put(2, 2 => X), reg |> copy |> focus!(1, 2))
        e3 = expect.(Ref(put(3, 2 => X)), reg .|> density_matrix)
        e4 = expect(put(3, 2 => X), reg)
        e5 = expect(put(3, 2 => -X), reg)
        @test e1 ≈ e2
        @test e1 ≈ e3
        @test e1 ≈ e4
        @test e5 ≈ -e4
    end
end

@testset "viewbatch apply" begin
    reg = zero_state(1, nbatch = 2)
    viewbatch(reg, 1) |> X
    @test reg.state[:, 1] == [0, 1]
    @test reg.state[:, 2] == [1, 0]
end

@testset "operator fidelity" begin
    @test operator_fidelity(H, H) ≈ 1
    @test operator_fidelity(im * H, X) ≈ sqrt(0.5)
    @test operator_fidelity(im * H, Z) ≈ sqrt(0.5)
    @test operator_fidelity(H, Y) ≈ 0
end

@testset "gate count, time" begin
    cphase(i, j) = control(i, j => shift(2π / (2^(i - j + 1))))
    hcphases(n, i) = chain(n, i == j ? put(i => H) : cphase(j, i) for j = i:n)
    qft_circuit(n::Int) = chain(n, hcphases(n, i) for i = 1:n)
    qc = qft_circuit(3)
    @test qc |> gatecount |> length == 2
    @test qc |> gatecount |> values |> sum == 6
    res = gatecount(repeat(5, X, (2, 3)))
    @test res |> values |> sum == 2
end

using YaoBlocks, YaoArrayRegister
using Random, Test

@testset "identity gate" begin
    block = igate(4)
    reg = rand_state(4)
    @test reg |> block == reg
    @test mat(block) != nothing
    @test ishermitian(block)
    @test isreflexive(block)
    @test isunitary(block)
    @test isdiagonal(block) == isdiagonal(mat(block)) == true
    @test occupied_locs(block) == ()
    @test getiparams(block) == ()
    @test nqudits(igate(3; nlevel=3)) == 3
    @test mat(igate(3; nlevel=3)) == YaoBlocks.IMatrix(27)
end


@testset "instruct_get_element" begin
    for pb in [igate(1), igate(2; nlevel=3)
            ]
        mpb = mat(pb)
        allpass = true
        for i=basis(pb), j=basis(pb)
            allpass &= pb[i, j] == mpb[Int(i)+1, Int(j)+1]
        end
        @test allpass

        allpass = true
        for j=basis(pb)
            allpass &= vec(pb[:, j]) == mpb[:, Int(j)+1]
            allpass &= vec(pb[j,:]) == mpb[Int(j)+1,:]
            allpass &= isclean(pb[:,j])
        end
        @test allpass
    end
end

# A Simple Computational Algebra System

_mul(::Val{X}, ::Val{Y}) where {X, Y} = Val(X*Y)
_mul(x::Number, y::Number) = x * y
_neg(::Val{X}) where X = Val(-X)
_neg(x::Number) = -x

# negate
Base.:(-)(x::AbstractBlock) = Scale(Val(-1), x)
Base.:(-)(x::Scale{Val{-1}}) = content(x)
Base.:(-)(x::Scale) = Scale(_neg(x.alpha), content(x))

# scaler multiply block
Base.:(*)(α::T, x::AbstractBlock) where {T<:Union{Val, Number}} = Scale(α, x)
Base.:(*)(α::T, x::Scale{T2}) where {T<:Val,T2<:Val} = Scale(_mul(α, x.alpha), content(x))
Base.:(*)(α::T, x::Scale{T2}) where {T<:Number,T2<:Number} = Scale(_mul(α, x.alpha), content(x))
Base.:(*)(x::AbstractBlock, α::Union{Val, Number}) = α * x

# block multiply block
Base.:(*)(x::Scale, y::Scale) = (_mul(x.alpha, y.alpha)) * (content(x) * content(y))
Base.:(*)(x::Scale, y::AbstractBlock) = x.alpha * chain(y, content(x))
Base.:(*)(y::AbstractBlock, x::Scale) = x.alpha * chain(content(x), y)
Base.:(*)(xs::AbstractBlock...) = chain(Iterators.reverse(xs)...)

# add
Base.:(+)(xs::AbstractBlock...) = Add(xs...)

# div
Base.:(/)(A::AbstractBlock, x::Number) = (1 / x) * A

# reduce
Base.prod(blocks::AbstractVector{<:AbstractBlock{D}}) where D =
    chain(Iterators.reverse(blocks)...)
Base.sum(blocks::AbstractVector{<:AbstractBlock{D}}) where D = Add(blocks)

#sub
Base.:(-)(lhs::AbstractBlock, rhs::AbstractBlock) = Add(lhs, -rhs)

# pow
Base.:(^)(x::AbstractBlock, n::Int) = chain((copy(x) for k = 1:n)...)

# error types
export AbstractErrorType, BitFlipError, PhaseFlipError, DepolarizingError, PauliError, ResetError,
    ThermalRelaxationError, PhaseAmplitudeDampingError, PhaseDampingError, AmplitudeDampingError,
    CoherentError

# channels
export KrausChannel, MixedUnitaryChannel, DepolarizingChannel, quantum_channel, SuperOp,
    noisy_simulation

"""
    quantum_channel(error::AbstractErrorType)

Convert an error type to a quantum channel. The output type can be `KrausChannel`, `MixedUnitaryChannel`.
"""
function quantum_channel end

"""
    noisy_simulation(reg::ArrayReg, circuit::AbstractBlock)

Simulate a circuit with noise.

### Arguments
- `reg::ArrayReg`: the initial state of the system.
- `circuit::AbstractBlock`: the circuit to simulate.

### Returns
- `DensityMatrix`: the final state of the system.

### Examples
Add noise after each single-qubit gate and simulate the circuit.

```jldoctest; setup=:(using Yao)
julia> circ = Optimise.replace_block(chain(2, put(1=>X), control(2, 1=>X))) do block
           n = nqubits(block)
           if block isa PutBlock && length(block.locs) == 1
               return chain(block, put(n, block.locs => quantum_channel(BitFlipError(0.1))))  # add noise after each single-qubit gate
           elseif block isa ControlBlock && length(block.ctrl_locs) == 1 && length(block.locs) == 1
               return chain(block, put(n, (block.ctrl_locs..., block.locs...) => kron(quantum_channel(BitFlipError(0.1)), quantum_channel(BitFlipError(0.1)))))  # add noise after each control gate
           else
               return block
           end
       end
nqubits: 2
chain
├─ chain
│  ├─ put on (1)
│  │  └─ X
│  └─ put on (1)
│     └─ mixed_unitary_channel
│        ├─ [0.9] I2
│        └─ [0.1] X
└─ chain
   ├─ control(2)
   │  └─ (1,) X
   └─ put on (2, 1)
      └─ mixed_unitary_channel
         ├─ [0.81] kron
         │  ├─ 1=>I2
         │  └─ 2=>I2
         ├─ [0.09000000000000001] kron
         │  ├─ 1=>I2
         │  └─ 2=>X
         ├─ [0.09000000000000001] kron
         │  ├─ 1=>X
         │  └─ 2=>I2
         └─ [0.010000000000000002] kron
            ├─ 1=>X
            └─ 2=>X

julia> noisy_simulation(zero_state(2), circ)
DensityMatrix{2, ComplexF64, Array...}
    active qubits: 2/2
    nlevel: 2
```
"""
function noisy_simulation(reg::ArrayReg, circuit::AbstractBlock)
    return apply(density_matrix(reg), circuit)
end

include("superop.jl")
include("kraus.jl")
include("mixed_unitary_channel.jl")
include("errortypes.jl")

export ChainBlock, chain

"""
    ChainBlock{D} <: CompositeBlock{D}

`ChainBlock` is a basic construct tool to create
user defined blocks horizontically. It is a `Vector`
like composite type.
"""
struct ChainBlock{D} <: CompositeBlock{D}
    n::Int
    blocks::Vector{AbstractBlock{D}}
    function ChainBlock(n::Int, blocks::Vector{<:AbstractBlock{D}}) where {D}
        _check_block_sizes(blocks, n)
        return new{D}(n, blocks)
    end
end

ChainBlock(blocks::Vector{<:AbstractBlock{D}}) where {D} = ChainBlock(_check_block_sizes(blocks), blocks)
ChainBlock(blocks::AbstractBlock{D}...) where {D} =
    ChainBlock(collect(AbstractBlock{D}, blocks))

nqudits(c::ChainBlock) = c.n

"""
    chain(blocks...) -> ChainBlock
    chain(n) -> ChainBlock

Return a [`ChainBlock`](@ref) which chains a list of blocks with the same number of qudits.
Let ``G_i`` be a sequence of n-qudit blocks, the matrix representation of block `chain(G_1, G_2, ..., G_m)` is

```math
G_m G_{m-1}\\ldots G_1
```

It is almost equivalent to matrix multiplication except the order is reversed.
We make its order different from regular matrix multiplication because quantum circuits can be represented more naturally in this form.

### Examples

```jldoctest; setup=:(using Yao)
julia> chain(X, Y, Z)
nqubits: 1
chain
├─ X
├─ Y
└─ Z

julia> chain(2, put(1=>X), put(2=>Y), cnot(2, 1))
nqubits: 2
chain
├─ put on (1)
│  └─ X
├─ put on (2)
│  └─ Y
└─ control(2)
   └─ (1,) X
```
"""
chain(blocks::AbstractBlock{D}...) where {D} = ChainBlock(blocks...)
function chain(blocks::Union{AbstractBlock{D},Function}...) where {D}
    concrete_blocks = filter(x->x isa AbstractBlock, blocks)
    return chain(map(x -> parse_block(_check_block_sizes(concrete_blocks...), x), blocks)...)
end

function chain(list::Vector{<:AbstractVector{D}}) where D
    return ChainBlock(list)
end

# if not all matrix block, try to put the number of qudits.
chain(n::Int, blocks...) = chain(map(x -> parse_block(n, x), blocks)...)
chain(n::Int, itr) = isempty(itr) ? chain(n) : chain(map(x -> parse_block(n, x), itr)...)
# disambiguity
# NOTE: we use parse_block here to make sure the behaviour are the same
chain(n::Int, it::Pair) = chain(n, parse_block(n, it))
chain(n::Int, f::Function) = chain(n, parse_block(n, f))
function chain(n::Int, block::AbstractBlock{D}) where D
    if n != nqudits(block)
        throw(QubitMismatchError("number of qudits mismatch: expect $n, got $(nqudits(block))"))
    end
    return ChainBlock(n, AbstractBlock{D}[block])
end
chain(blocks::Function...) = @λ(n -> chain(n, blocks...))
chain(it) = chain(it...) # forward iterator to vargs, so we could dispatch based on types
chain(it::Pair) = error("got $it, do you mean put($it)?")
chain(blocks...) = @λ(n -> chain(n, blocks))

"""
    chain(n)

Return an empty [`ChainBlock`](@ref) which can be used like a list of blocks.

### Examples

```jldoctest; setup=:(using Yao)
julia> chain(2)
nqubits: 2
chain


julia> chain(2; nlevel=3)
nqudits: 2
chain


```
"""
chain(n::Int; nlevel=2) = ChainBlock(n::Int, AbstractBlock{nlevel}[])

"""
    chain()

Return an lambda `n->chain(n)`.
"""
chain() = @λ(n -> chain(n))

subblocks(c::ChainBlock) = c.blocks
occupied_locs(c::ChainBlock) =
    Tuple(unique(Iterators.flatten(occupied_locs(b) for b in subblocks(c))))

chsubblocks(pb::ChainBlock{D}, blocks::Vector{<:AbstractBlock{D}}) where {D} =
    length(blocks) == 0 ? ChainBlock(pb.n, AbstractBlock{D}[]) : ChainBlock(pb.n, blocks)
chsubblocks(pb::ChainBlock, it) = chain(it...)
chsubblocks(x::ChainBlock, it::AbstractBlock) = chsubblocks(x, (it,))

function mat(::Type{T}, c::ChainBlock{D}) where {T,D}
    if isempty(c.blocks)
        return IMatrix{T}(D^nqudits(c))
    else
        return prod(x -> mat(T, x), Iterators.reverse(c.blocks))
    end
end

function YaoAPI.unsafe_apply!(r::AbstractRegister, c::ChainBlock)
    for each in c.blocks
        YaoAPI.unsafe_apply!(r, each)
    end
    return r
end

function noisy_instruct!(r::AbstractRegister, c::ChainBlock, locs)
    for each in c.blocks
        if isnoisy(each)
            noisy_instruct!(r, each, locs)
        else
            YaoAPI.instruct!(r, mat_matchreg(r, each), locs)
        end
    end
    return r
end

cache_key(c::ChainBlock) = Tuple(cache_key(each) for each in c.blocks)

function Base.:(==)(lhs::ChainBlock{D}, rhs::ChainBlock{D}) where {D}
    nqudits(lhs) == nqudits(rhs) &&
    (length(lhs.blocks) == length(rhs.blocks)) &&
    all(lhs.blocks .== rhs.blocks)
end

Base.copy(c::ChainBlock{D}) where {D} = ChainBlock(c.n, copy(c.blocks))
Base.similar(c::ChainBlock{D}) where {D} = ChainBlock(c.n, empty!(similar(c.blocks)))
Base.getindex(c::ChainBlock, index) = getindex(c.blocks, index)
Base.getindex(c::ChainBlock, index::Union{UnitRange,Vector}) =
    ChainBlock(c.n, getindex(c.blocks, index))
Base.setindex!(c::ChainBlock{D}, val::AbstractBlock{D}, index::Integer) where {D} =
    (_check_block_sizes(c, val); setindex!(c.blocks, val, index); c)
Base.insert!(c::ChainBlock{D}, index::Integer, val::AbstractBlock{D}) where {D} =
    (_check_block_sizes(c, val); insert!(c.blocks, index, val); c)
Base.adjoint(blk::ChainBlock{D}) where {D} =
    ChainBlock(blk.n, AbstractBlock{D}[adjoint(b) for b in reverse(subblocks(blk))])
Base.lastindex(c::ChainBlock) = lastindex(c.blocks)
## Iterate contained blocks
Base.iterate(c::ChainBlock, st = 1) = iterate(c.blocks, st)
Base.length(c::ChainBlock) = length(c.blocks)
Base.eltype(c::ChainBlock) = eltype(c.blocks)
Base.eachindex(c::ChainBlock) = eachindex(c.blocks)
Base.popfirst!(c::ChainBlock) = popfirst!(c.blocks)
Base.pop!(c::ChainBlock) = pop!(c.blocks)
Base.push!(c::ChainBlock{D}, m::AbstractBlock{D}) where {D} = (_check_block_sizes(c, m); push!(c.blocks, m); c)
Base.push!(c::ChainBlock{D}, f::Function) where {D} = (push!(c.blocks, f(c.n)); c)
Base.pushfirst!(c::ChainBlock{D}, m::AbstractBlock{D}) where {D} =
    (_check_block_sizes(c, m); pushfirst!(c.blocks, m); c)
Base.pushfirst!(c::ChainBlock{D}, f::Function) where {D} = (pushfirst!(c.blocks, f(c.n)); c)
Base.append!(c::ChainBlock{D}, list::Vector{<:AbstractBlock{D}}) where {D} =
    (_check_block_sizes(c, list...); append!(c.blocks, list); c)
Base.append!(c1::ChainBlock{D}, c2::ChainBlock{D}) where {D} =
    (_check_block_sizes(c1, c2); append!(c1.blocks, c2.blocks); c1)
Base.prepend!(c1::ChainBlock{D}, list::Vector{<:AbstractBlock{D}}) where {D} =
    (_check_block_sizes(c1, list...); prepend!(c1.blocks, list); c1)
Base.prepend!(c1::ChainBlock{D}, c2::ChainBlock{D}) where {D} =
    (_check_block_sizes(c1, c2); prepend!(c1.blocks, c2.blocks); c1)

YaoAPI.isunitary(c::ChainBlock) = all(isunitary, c.blocks) || isunitary(mat(c))
YaoAPI.isreflexive(c::ChainBlock) =
    (iscommute(c.blocks...) && all(isreflexive, c.blocks)) || isreflexive(mat(c))
LinearAlgebra.ishermitian(c::ChainBlock) =
    (all(ishermitian, c.blocks) && iscommute(c.blocks...)) || ishermitian(mat(c))

# this is not type stable, possible to fix?
function unsafe_getindex(::Type{T}, c::ChainBlock{D}, i::Integer, j::Integer) where {D,T}
    if length(c) == 0
        return i==j ? one(T) : zero(T)
    elseif length(c) == 1
        return unsafe_getindex(T, c.blocks[1], i, j)
    else
        table = propagate_chain(c.blocks[2:end-1], _getindex(T, c.blocks[1],:,DitStr{D,nqudits(c)}(j)))
        res = zero(T)
        for (loc, amp) in table
            res += unsafe_getindex(T, c.blocks[end], i, buffer(loc)) * amp
        end
        return res
    end
end

function unsafe_getcol(::Type{T}, c::ChainBlock{D}, j::DitStr{D,N,TI}) where {D,N,TI,T}
    if length(c) == 0
        return [j], [one(T)]
    elseif length(c) == 1
        return unsafe_getcol(T, c.blocks[1], j)
    else
        table = propagate_chain(c.blocks[2:end], _getindex(T,c.blocks[1],:,j))
        return table.configs, table.amplitudes
    end
end
# propagate the configurations along the chain
function propagate_chain(blocks, i::EntryTable; cleanup_threshold=0)
    for b in blocks
        i = b[:,i]
        if length(i) >= cleanup_threshold
            i = cleanup(i)
        end
    end
    return i
end
function Base.getindex(b::ChainBlock{D}, i::DitStr{D,N}, j::DitStr{D,N}) where {D,N}
    invoke(Base.getindex, Tuple{AbstractBlock{D}, DitStr{D,N}, DitStr{D,N}} where {D,N}, b, i, j)
end
function Base.getindex(b::ChainBlock{D}, ::Colon, j::DitStr{D,N}) where {D,N}
    T = promote_type(ComplexF64, parameters_eltype(b))
    return _getindex(T, b, :, j)
end
function Base.getindex(b::ChainBlock{D}, i::DitStr{D,N}, ::Colon) where {D,N}
    T = promote_type(ComplexF64, parameters_eltype(b))
    return _getindex(T, b, i, :)
end
function Base.getindex(b::ChainBlock{D}, ::Colon, j::EntryTable{DitStr{D,N,TI},T}) where {D,N,TI,T}
    return _getindex(b, :, j)
end
function Base.getindex(b::ChainBlock{D}, i::EntryTable{DitStr{D,N,TI},T}, ::Colon) where {D,N,TI,T}
    return _getindex(b, i, :)
end

# TODO: add documents
# 1. generate a table from SYM_LIST
# 2. auto attach docs to each gate instance and type

# note!!!
# Here, we don't need gates like swap^α and √X.
# swap^α = rot(SWAP, -α*π)
# √X = rot(X, -α*π)
# since both of them are reflexive.
const ConstGateDefaultType = ComplexF64
const SYM_LIST = [
    (:P0, Diagonal(ConstGateDefaultType[1, 0])),
    (:P1, Diagonal(ConstGateDefaultType[0, 1])),
    (:X, PermMatrix([2, 1], ConstGateDefaultType[1+0im, 1])),
    (:Y, PermMatrix([2, 1], ConstGateDefaultType[-im, im])),
    (:Z, Diagonal(ConstGateDefaultType[1+0im, -1])),
    (:S, Diagonal(ConstGateDefaultType[1, im])),
    (:Sdag, Diagonal(ConstGateDefaultType[1, -im])),
    (:T, Diagonal(ConstGateDefaultType[1, exp(π * im / 4)])),
    (:Tdag, Diagonal(ConstGateDefaultType[1, exp(-π * im / 4)])),
    (:I2, IMatrix{ConstGateDefaultType}(2)),
    (:H, (elem = 1 / sqrt(2); ConstGateDefaultType[elem elem; elem -elem])),
    (:CNOT, PermMatrix([1, 4, 3, 2], ones(ConstGateDefaultType, 4))),
    (:CZ, Diagonal(ConstGateDefaultType[1, 1, 1, -1])),
    (:SWAP, PermMatrix([1, 3, 2, 4], ones(ConstGateDefaultType, 4))),
    (:Toffoli, PermMatrix([1, 2, 3, 8, 5, 6, 7, 4], ones(ConstGateDefaultType, 8))),
    (:Pu, sparse([1], [2], ConstGateDefaultType[1+0im], 2, 2)),
    (:Pd, sparse([2], [1], ConstGateDefaultType[1+0im], 2, 2)),
]

for (NAME, MAT) in SYM_LIST
    GT = Symbol(NAME, "Gate")
    @eval begin
        @const_gate $NAME = $MAT
    end
end

Base.adjoint(::PuGate) = Pd
Base.adjoint(::PdGate) = Pu
Base.adjoint(::SGate) = Sdag
Base.adjoint(::SdagGate) = S
Base.adjoint(::TGate) = Tdag
Base.adjoint(::TdagGate) = T

# Docs
"""
    X
    XGate <: ConstantGate{1,2}

Pauli X gate. `X` is the instance of `XGate`.
"""
X, XGate

"""
    Y
    YGate  <: ConstantGate{1,2}

Pauli Y gate. `Y` is the instance of `YGate`.
"""
Y, YGate

"""
    Z
    ZGate  <: ConstantGate{1,2}

Pauli Z gate. `Z` is the instance of `YGate`.
"""
Z, ZGate

using Test

include("errortypes.jl")
include("superop.jl")
include("kraus.jl")
include("mixed_unitary_channel.jl")

@testset "add noise and noisy simulation" begin
    # simulate a clean circuit
    reg = rand_state(2)
    circuit = chain(put(2, 1=>X), put(2, 2=>X))
    @test noisy_simulation(reg, circuit) ≈ density_matrix(apply(reg, circuit))

    # add noise to a circuit
    reg = rand_state(2)
    circuit = chain(put(2, 1=>X), put(2, 2=>X))
    ncirc = Optimise.replace_block(circuit) do block
        if block isa PutBlock && length(block.locs) == 1
            return chain(block, put(nqubits(block), block.locs => quantum_channel(BitFlipError(0.1))))
        else
            return block
        end
    end
    @info "simulating noisy circuit: $ncirc"
    @test ncirc isa ChainBlock && length(ncirc) == 2 && length(ncirc[1]) == 2 && length(ncirc[2]) == 2
    cn = quantum_channel(BitFlipError(0.1))
    expected_ncirc = chain(put(2, 1=>X), put(2, 1=>cn), put(2, 2=>X), put(2, 2=>cn))
    @test noisy_simulation(reg, ncirc) ≈ apply(density_matrix(reg), expected_ncirc)
end

using Test, YaoBlocks, LuxurySparse, YaoAPI
using YaoBlocks.ConstGate
import YaoBlocks: u1mat, unmat, cunmat, unij!
using YaoArrayRegister

@testset "dense-u1mat-unmat" begin
    nbit = 4
    mmm = Rx(0.5) |> mat
    m1 = u1mat(nbit, mmm, 2)
    m2 = YaoArrayRegister.linop2dense(v -> instruct!(Val(2), v, mmm, (2,)), nbit)
    m3 = unmat(Val(2), nbit, mmm, (2,))
    @test m1 ≈ m2
    @test m1 ≈ m3

    # test control not
    ⊗ = kron
    res = mat(I2) ⊗ mat(I2) ⊗ mat(P1) ⊗ mat(I2) + mat(I2) ⊗ mat(I2) ⊗ mat(P0) ⊗ mat(Rx(0.5))
    m3 = cunmat(nbit, (2,), (0,), mmm, (1,))
    @test m3 ≈ res
end

@testset "sparse-u1mat-unmat" begin
    nbit = 4
    # test control not
    ⊗ = kron
    res = mat(I2) ⊗ mat(I2) ⊗ mat(P1) ⊗ mat(I2) + mat(I2) ⊗ mat(I2) ⊗ mat(P0) ⊗ mat(P1)
    m3 = cunmat(nbit, (2,), (0,), mat(P1), (1,))
    @test m3 ≈ res
    # cunmat fallback
    m4 = cunmat(nbit, (2,), (0,), view(mat(P1), :,:), (1,))
    @test m4 ≈ res
end

@testset "perm-unij-unmat" begin
    perm = PermMatrix([1, 2, 3, 4], [1, 1, 1, 1.0])
    pm = unij!(copy(perm), [2, 3, 4], PermMatrix([3, 1, 2], [0.1, 0.2, 0.3]))
    @test pm ≈ PermMatrix([1, 4, 2, 3], [1, 0.1, 0.2, 0.3])
    pm = unij!(copy(perm), [2, 3, 4], PermMatrix([3, 1, 2], [0.1, 0.2, 0.3]) |> staticize)
    @test pm ≈ PermMatrix([1, 4, 2, 3], [1, 0.1, 0.2, 0.3])

    nbit = 4
    mmm = X |> mat
    m1 = unmat(Val(2), nbit, mmm, (2,))
    m2 = YaoArrayRegister.linop2dense(v -> instruct!(Val(2), v, mmm, (2,)), nbit)
    @test m1 ≈ m2
end

@testset "identity-unmat" begin
    nbit = 4
    mmm = Z |> mat
    m1 = unmat(Val(2), nbit, mmm, (2,))
    m2 = YaoArrayRegister.linop2dense(v -> instruct!(Val(2), v, mmm, (2,)), nbit)
    @test m1 ≈ m2

    nbit = 4
    mmm = igate(2) |> mat
    m1 = unmat(Val(2), nbit, mmm, (2,1))
    m2 = YaoArrayRegister.linop2dense(v -> instruct!(Val(2), v, mmm, (2,1)), nbit)
    @test m1 ≈ m2
end

@testset "fix-static and adjoint for mat" begin
    G1 = matblock(rand_unitary(2))
    G6 = matblock(rand_unitary(1 << 6))
    @test mat(put(3, 2 => G1')) ≈ mat(put(3, 2 => matblock(G1)))'
    @test mat(put(7, (3, 2, 1, 5, 4, 6) => G6')) ≈ mat(put(7, (3, 2, 1, 5, 4, 6) => G6))'
end

@testset "use routines" begin
    rows, vals = YaoBlocks.unsafe_getcol(ComplexF64, put(5, 1=>ConstGate.P1), bit"00000")
    @test eltype(rows) <: DitStr
    @test eltype(vals) <: ComplexF64
end

# NOTE: this can have a better support in YaoIR directly with StatsBase
# as an compiled instruction, but store the probabilities is the best solution
# here

"""
    MixedUnitaryChannel{D, W<:AbstractVector} <: CompositeBlock{D}
    MixedUnitaryChannel(operators, probs)

Create a mixed unitary channel, where `probs` is a real vector that sum up to 1.
The mixed unitary channel is defined as below

```math
\\phi(\\rho) = \\sum_i p_i U_i ρ U_i^\\dagger,
```

where ``\\rho`` in a [`DensityMatrix`](@ref) as the register to apply on, ``p_i`` is the i-th element in `probs`, `U_i` is the i-th operator in `operators`.

### Examples

```jldoctest; setup=:(using Yao)
julia> MixedUnitaryChannel([X, Y, Z], [0.1, 0.2, 0.7])
nqubits: 1
mixed_unitary_channel
├─ [0.1] X
├─ [0.2] Y
└─ [0.7] Z
```
"""
struct MixedUnitaryChannel{D, W<:AbstractVector} <: AbstractQuantumChannel{D}
    n::Int
    operators::Vector{AbstractBlock{D}}
    probs::W

    function MixedUnitaryChannel(operators::Vector{AbstractBlock{D}}, w::AbstractVector) where D
        @assert length(operators) == length(w) && length(w) != 0
        if !(all(x->x>=0, w) && sum(w) ≈ 1)
            error("The probabilities must be ⩾ 0 and its sum must be 1!")
        end
        n = _check_block_sizes(operators)
        new{D,typeof(w)}(n, operators, w)
    end
end

function MixedUnitaryChannel(it, probs)
    length(it) == 0 && error("The input operator list size can not be 0!")
    D = nlevel(first(it))
    MixedUnitaryChannel(collect(AbstractBlock{D}, it), probs)
end
nqudits(uc::MixedUnitaryChannel) = uc.n

function noisy_instruct!(r::DensityMatrix{D,T}, x::MixedUnitaryChannel, locs) where {D,T}
    return unsafe_apply!(r, MixedUnitaryChannel([put(nqudits(r), locs => op) for op in x.operators], x.probs))
end

function YaoAPI.unsafe_apply!(r::DensityMatrix{D,T}, x::MixedUnitaryChannel) where {D,T}
    r0 = copy(r)
    # first
    regscale!(unsafe_apply!(r, first(x.operators)), first(x.probs))
    for (w, o) in zip(x.probs[2:end-1], x.operators[2:end-1])
        r.state .+= w .* unsafe_apply!(copy(r0), o).state
    end
    # last
    r.state .+= last(x.probs) .* unsafe_apply!(r0, last(x.operators)).state
    return r
end

subblocks(x::MixedUnitaryChannel) = x.operators
chsubblocks(x::MixedUnitaryChannel, it) = MixedUnitaryChannel(collect(it), x.probs)
occupied_locs(x::MixedUnitaryChannel) = union(occupied_locs.(x.operators)...)

function cache_key(x::MixedUnitaryChannel)
    key = hash(x.probs)
    for each in x.operators
        key = hash(each, key)
    end
    return key
end

function Base.:(==)(lhs::MixedUnitaryChannel, rhs::MixedUnitaryChannel)
    return (lhs.n == rhs.n) && (lhs.probs == rhs.probs) && (lhs.operators == rhs.operators)
end

Base.adjoint(x::MixedUnitaryChannel) = MixedUnitaryChannel(adjoint.(x.operators), x.probs)

# convert unitary channel to kraus channel and superop
KrausChannel(x::MixedUnitaryChannel{D}) where D = KrausChannel(AbstractBlock{D}[sqrt(f) * oi for (f, oi) in zip(x.probs, x.operators)])
SuperOp(x::MixedUnitaryChannel{D, WT}) where {T, D, WT<:AbstractVector{T}} = SuperOp(Complex{T}, KrausChannel(x))
SuperOp(::Type{T}, x::MixedUnitaryChannel) where T = SuperOp(T, KrausChannel(x))

function LinearAlgebra.kron(x::MixedUnitaryChannel, y::MixedUnitaryChannel)
    return MixedUnitaryChannel([kron(op1, op2) for op1 in x.operators for op2 in y.operators], [px * py for px in x.probs for py in y.probs])
end

### DepolarizingChannel - a special case of mixed unitary channel
"""
    DepolarizingChannel{D, RT<:Real} <: AbstractQuantumChannel{D}
    DepolarizingChannel(n::Int, p::Real; nlevel::Int=2)

Create a global depolarizing channel. For qubit system (D = 2), the depolarizing channel is defined as
```math
\\phi(\\rho) = (1 - p) \\rho + \\frac{p}{4^n} \\sum_{i=1}^{4^n} P_i \\rho P_i^\\dagger,
```
where ``P_i`` is the i-th Pauli operator, ``n`` is the number of qubits, and ``p`` is the probability of the error to occur.

It is different from the kronecker product of the single-qubit depolarizing channel, in which case the errors on different qubits are independent.

### Fields
- `n`: number of qubits.
- `p`: probability of this error to occur.
"""
struct DepolarizingChannel{D, RT<:Real} <: AbstractQuantumChannel{D}
    n::Int
    p::RT
    function DepolarizingChannel{D}(n::Int, p::Real) where {D}
        @assert 0 ≤ p ≤ 1 "The probability must be in [0, 1]!"
        new{D, typeof(p)}(n, p)
    end
end
function DepolarizingChannel(n::Int, p::Real; nlevel::Int=2)
    return DepolarizingChannel{nlevel}(n, p)
end

YaoAPI.nqudits(ch::DepolarizingChannel) = ch.n

function YaoAPI.unsafe_apply!(dm::DensityMatrix{D,T}, ch::DepolarizingChannel{D}) where {D,T}
    regscale!(dm, 1 - ch.p)
    dm.state .+= ch.p/(D^nqubits(dm)) * IMatrix(size(dm.state, 1))
    return dm
end
function noisy_instruct!(r::DensityMatrix{D,T}, x::DepolarizingChannel, locs) where {D,T}
    noisy_instruct!(r, MixedUnitaryChannel(x), locs)
end
subblocks(::DepolarizingChannel) = ()
print_block(io::IO, x::DepolarizingChannel) = print(io, "DepolarizingChannel{$(nqudits(x))}($(x.p))")

function cache_key(x::DepolarizingChannel)
    return hash(x.n, hash(x.p))
end
function Base.:(==)(lhs::DepolarizingChannel, rhs::DepolarizingChannel)
    return (lhs.n == rhs.n) && (lhs.p == rhs.p)
end
Base.adjoint(x::DepolarizingChannel{D}) where D = DepolarizingChannel{D}(x.n, x.p)

function MixedUnitaryChannel(c::DepolarizingChannel{D, RT}) where {D, RT}
    operators = AbstractBlock{D}[]
    for op in Iterators.product([[I2, X, Y, Z] for i=1:c.n]...)
        push!(operators, kron(op...))
    end
    probs = fill(c.p/D^(2*c.n), D^(2*c.n))
    probs[1] += 1 - c.p
    return MixedUnitaryChannel(operators, probs)
end

function SuperOp(::Type{T}, c::DepolarizingChannel{D, RT}) where {T, D, RT}
    N = D^c.n
    # the scaling factor
    i1 = collect(1:N^2)
    j1 = collect(1:N^2)
    v1 = fill(T(1 - c.p), N^2)
    # the tracial part (constant)
    i2 = repeat(collect(1:N+1:N^2), inner=N)
    j2 = repeat(collect(1:N+1:N^2), outer=N)
    v2 = fill(T(c.p/N), length(i2))
    return SuperOp{D}(sparse(vcat(i1, i2), vcat(j1, j2), vcat(v1, v2), N^2, N^2))
end
SuperOp(c::DepolarizingChannel{D, RT}) where {D, RT} = SuperOp(Complex{RT}, c)

using YaoAPI
using YaoBlocks
using Test

mutable struct EchoReg <: AbstractRegister{2}
    nactive::Int
    nqubits::Int
end
YaoAPI.nactive(reg::EchoReg) = reg.nactive
YaoAPI.nqudits(reg::EchoReg) = reg.nqubits

function YaoAPI.instruct!(::EchoReg, ::Val{G}, locs, args...) where {G}
    println("apply -> $G on $locs")
    return true
end

function YaoAPI.focus!(reg::EchoReg, locs)
    println("focus -> $locs")
    reg.nactive = length(locs)
    return true
end

function YaoAPI.relax!(reg::EchoReg, locs; to_nactive = nqubits(reg))
    reg.nactive = to_nactive
    println("relax -> $locs/$to_nactive")
    return true
end

function YaoAPI.measure!(
    post::PostProcess,
    ::ComputationalBasis,
    reg::EchoReg,
    locs;
    kwargs...,
)
    println("measure -> $locs, post-process = $post")
    return true
end

@testset "test ArrayRegister extension" begin
    reg = EchoReg(3, 5)
    @test_throws QubitMismatchError reg |> cache(X)
    @test reg |>
          put(3, 2 => X) |>
          control(3, 3, 2 => X) |>
          subroutine(3, put(1, 1 => X), 2:2) |>
          measure!
end

using YaoBlocks, YaoArrayRegister, BitBasis
using YaoBlocks: eigenbasis, isdiagonal
using Random, Test
using YaoAPI: QubitMismatchError
using LinearAlgebra

function check_eigenbasis(op)
    E, V = eigenbasis(op)
    mat(V) * mat(E) * mat(V') ≈ mat(op)
end

@testset "eigen basis" begin
    for op in [
        X,
        Y,
        H,
        Z,
        put(4, 2 => X),
        kron(X, Y, Z),
        repeat(3, H, 2:3),
        cache(Rx(0.5)),
        Daggered(Rx(0.5)),
        rot(SWAP, 0.5),
        time_evolve(kron(X, X), 0.5),
        3 * put(3, 2 => X),
        chain(10, put(2 => X), chain(put(4 => Y))),
        chain(10, put(2 => X), chain(put(2 => Y))),
    ]
        @show op
        @test check_eigenbasis(op)
    end
end

@testset "better operator measure" begin
    Random.seed!(21)
    nbit = 3
    for op in [
        put(nbit, 2 => X),
        control(nbit, 2, 1 => X),
        kron(X, X, X),
        put(nbit, (3, 1, 2) => kron(X, Y, Z)),
        repeat(nbit, X, 2:3),
        +(put(nbit, 2 => X), put(nbit, 1 => Rx(π))),
        2.8 * put(nbit, 1 => X),
        chain(nbit, put(nbit, 3 => X), put(nbit, 1 => Z)),
        cache(put(nbit, 2 => X)),
        Daggered(put(nbit, 2 => Rx(0.8))),
    ]
        reg = rand_state(nbit)
        reg2 = copy(reg)
        @show op
        @test isapprox(
            sum(measure(op, reg2; nshots = 100000)) / 100000,
            sandwich(reg, op, reg),
            rtol = 0.1,
        )
        @test reg ≈ reg2

        reg = rand_state(nbit; nbatch = 10)
        reg2 = copy(reg)
        @test isapprox(
            dropdims(sum(measure(op, reg2; nshots = 100000), dims = 1), dims = 1) / 100000,
            sandwich(reg, op, reg),
            rtol = 0.1,
        )
        @test reg ≈ reg2
    end
end

@testset "measure op, specify locs" begin
    Random.seed!(21)
    Nbit = 4
    nbit = 3
    locs = (1, 3, 2)
    @test_throws QubitMismatchError measure(X, rand_state(5), locs)
    @test_throws QubitMismatchError measure(X, rand_state(5), AllLocs())
    for op in [
        put(nbit, 2 => X),
        control(nbit, 2, 1 => X),
        kron(X, Y, Z),
        put(nbit, (3, 1, 2) => kron(X, Y, Z)),
        repeat(nbit, X, 2:3),
        +(put(nbit, 2 => X), put(nbit, 1 => Rx(π))),
        2.8 * put(nbit, 1 => X),
        chain(nbit, put(nbit, 3 => X), put(nbit, 1 => Z)),
        cache(put(nbit, 2 => X)),
        Daggered(put(nbit, 2 => Rx(0.8))),
    ]
        reg = rand_state(Nbit)
        reg2 = copy(reg)
        @show op
        @test isapprox(
            sum(measure(op, reg2, locs; nshots = 100000)) / 100000,
            sandwich(reg, put(Nbit, locs => op), reg),
            rtol = 0.2,
        )
        @test reg ≈ reg2
    end
end

@testset "better operator measure!" begin
    Random.seed!(9)
    nbit = 3
    for op in [
        put(nbit, 2 => X),
        control(nbit, 2, 1 => X),
        kron(X, X, X),
        put(nbit, (3, 1, 2) => kron(X, X, X)),
        repeat(nbit, X, 2:3),
        +(put(nbit, 2 => X), put(nbit, 1 => im * Rx(π))),
        2.8 * put(nbit, 1 => X),
        chain(nbit, put(nbit, 3 => X), put(nbit, 1 => Z)),
        chain(nbit, put(nbit, 3 => X), put(nbit, 3 => Z)),
        cache(put(nbit, 2 => X)),
        Daggered(put(nbit, 2 => im * Rx(π))),
    ]
        @show op
        reg = rand_state(nbit)
        res = measure!(op, reg)
        @test isapprox(res, sum(measure(op, reg; nshots = 100))[1] / 100, rtol = 0.1)

        reg = rand_state(nbit; nbatch = 10)
        res = measure!(op, reg)
        @test isapprox(
            res,
            vec(sum(measure(op, reg; nshots = 100); dims = 1)) / 100,
            rtol = 0.1,
        )
    end
end

@testset "commute to eachother" begin
    @test YaoBlocks.simple_commute_eachother([put(5, 2 => X), put(5, 3 => Y)])
    @test !YaoBlocks.simple_commute_eachother([put(5, 2 => X), put(5, 2 => Y)])
end

@testset "fix measuring add" begin
    circ_wfn = zero_state(2) |> put(2, 1=>H)
    sp = put(2, 1=>(X + Val(1im)*Y)/2)
    X_diff = sp + sp'
    @test measure(X_diff, circ_wfn, nshots=100) |> sum ≈ 100.0
end

@testset "measure operator with post processing" begin
    # measure! and reset
    reg = rand_state(8; nbatch=32)
    op = repeat(5, X, 1:5)
    @test_throws ArgumentError measure!(ResetTo(0), op, reg, 2:6)
    relax!(reg)
    @test_throws ArgumentError measure!(RemoveMeasured(), op, reg, 2:6)
end

@testset "is diagonal" begin
    # Rydberg blockade term + zterm
    block = 0.5 * sum([kron(3, 1=>ConstGate.P1, 2=>ConstGate.P1), kron(3, 2=>ConstGate.P1, 3=>ConstGate.P1)]) + 0.5 * sum([put(3, i=>Z) for i=1:3])
    @test eigenbasis(block) == (block, igate(3))
    # Rydberg xterm
    block = 0.5 * sum([put(3, i=>X) for i=1:3])
    @test eigenbasis(block) == (
                0.5 * sum([put(3, i=>Z) for i=1:3]),
                chain([put(3, i=>H) for i=1:3]))
end

@testset "measure on density matrix" begin
    reg = uniform_state(4)
    rho = density_matrix(reg, 1:3)
    res = measure!(kron(Z, Z, Z), rho)
    p = probs(rho)
    @test count(!iszero, p) == 4
    res2 = measure(kron(Z, Z, Z), rho; nshots=10)
    @test all(==(res), res2)
end

"""
    cunmat(nbit::Int, cbits::NTuple{C, Int}, cvals::NTuple{C, Int}, U0::AbstractMatrix, locs::NTuple{M, Int}) where {C, M} -> AbstractMatrix

control-unitary matrix
"""
function cunmat end

"""
    u1ij!(target, i, j, a, b, c, d)
single u1 matrix into a target matrix.

!!! note
    For coo, we take an additional parameter
        * ptr: starting position to store new data.
"""
function u1ij! end

"""
    setcol!(csc::SparseMatrixCSC, icol::Int, rowval::AbstractVector, nzval) -> SparseMatrixCSC

set specific col of a CSC matrix
"""
@inline function setcol!(csc::SparseMatrixCSC, icol::Int, rowval::AbstractVector, nzval)
    @inbounds begin
        S = csc.colptr[icol]
        E = csc.colptr[icol+1] - 1
        csc.rowval[S:E] = rowval
        csc.nzval[S:E] = nzval
    end
    csc
end

"""
    num_nonzero(nbits, nctrls, U, [N])

Return number of nonzero entries of the matrix form of control-U gate. `nbits`
is the number of qubits, and `nctrls` is the number of control qubits.
"""
@inline function num_nonzero(nbits::Int, nctrls::Int, U, N::Int = 1 << nbits)
    return N + (1 << (nbits - nctrls - log2dim1(U))) * (length(U) - size(U, 2))
end

@inline function num_nonzero(
    nbits::Int,
    nctrls::Int,
    U::SDSparseMatrixCSC,
    N::Int = 1 << nbits,
)
    return N + (1 << (nbits - nctrls - log2dim1(U))) * (nnz(U) - size(U, 2))
end

"""
    getcol(csc::SDparseMatrixCSC, icol::Int) -> (View, View)

get specific col of a CSC matrix, returns a slice of (rowval, nzval)
"""
@inline function getcol(csc::SDSparseMatrixCSC, icol::Int)
    @inbounds begin
        S = csc.colptr[icol]
        E = csc.colptr[icol+1] - 1
        view(csc.rowval, S:E), view(csc.nzval, S:E)
    end
end

@inline function reorder_unitary(
    nbit::Int,
    cbits::NTuple{C,Int},
    cvals::NTuple{C,Int},
    U0::AbstractMatrix,
    locs::NTuple{M,Int},
) where {C,M}
    # reorder a unirary matrix.
    U = all(diff(locs) .> 0) ? U0 : reorder(U0, collect(locs) |> sortperm)
    locked_bits = [cbits..., locs...]
    locked_vals = [cvals..., zeros(Int, M)...]
    locs_raw =
        [i + 1 for i in itercontrol(nbit, setdiff(1:nbit, locs), zeros(Int, nbit - M))]
    ic = itercontrol(nbit, locked_bits, locked_vals)
    return U |> autostatic, ic, locs_raw |> staticize
end

adaptive_pow2(n::Int) = adaptive_pow2(UInt(n))

function adaptive_pow2(n::UInt)
    n < 62 ? Int64(1) << n : n < 126 ? Int128(1) << n : big(1) << n
end

const LARGE_MATRIX_WARN = 62

function large_mat_check(n::Int)
    if n > LARGE_MATRIX_WARN
        error(
            "matrix is too large, expect n <= $LARGE_MATRIX_WARN, got $n, integer overflows",
        )
    end
    return nothing
end

function cunmat(n::Int, cbits::NTuple{C,Int}, cvals::NTuple{C,Int}, U::IMatrix, locs::NTuple{M,Int}) where {C,M}
    large_mat_check(n)
    IMatrix(1 << n)
end

"""
    unmat(::Val{D}, nbit::Int, U::AbstractMatrix, locs::NTuple) -> AbstractMatrix

Return the matrix representation of putting matrix at locs.
"""
function unmat(::Val{2}, nbit::Int, U::AbstractMatrix, locs::NTuple)
    large_mat_check(nbit)
    cunmat(nbit::Int, (), (), U, locs)
end

############################### Dense Matrices ###########################
function u1mat(nbit::Int, U1::AbstractMatrix, ibit::Int)
    large_mat_check(nbit)
    unmat(Val{2}(), nbit, U1, (ibit,))
end

u1mat(nbit::Int, U1::Adjoint, ibit::Int) = u1mat(nbit, copy(U1), ibit)

function u1mat(nbits::Int, U1::SDMatrix, ibit::Int)
    large_mat_check(nbits)
    mask = bmask(ibit)
    N = 1 << nbits
    a, c, b, d = U1
    step = 1 << (ibit - 1)
    step_2 = 1 << ibit
    NNZ = num_nonzero(nbits, 0, U1, N)

    colptr = Vector{Int}(1:2:2*N+1)
    rowval = Vector{Int}(undef, NNZ)
    nzval = Vector{eltype(U1)}(undef, NNZ)

    mat = SparseMatrixCSC(N, N, colptr, rowval, nzval)
    for j = 0:step_2:N-step
        @inbounds @simd for i = j+1:j+step
            u1ij!(mat, i, i + step, a, b, c, d)
        end
    end
    return mat
end

@inline function u1ij!(csc::SparseMatrixCSC, i::Int, j::Int, a, b, c, d)
    @inbounds begin
        csc.rowval[2*i-1] = i
        csc.rowval[2*i] = j
        csc.rowval[2*j-1] = i
        csc.rowval[2*j] = j

        csc.nzval[2*i-1] = a
        csc.nzval[2*i] = c
        csc.nzval[2*j-1] = b
        csc.nzval[2*j] = d
    end
    csc
end

@inline function unij!(mat::SparseMatrixCSC, locs, U::SDMatrix)
    @simd for j = 1:size(U, 2)
        @inbounds setcol!(mat, locs[j], locs, view(U, :, j))
    end
    csc
end

function cunmat(
    nbit::Int,
    cbits::NTuple{C,Int},
    cvals::NTuple{C,Int},
    U0::Adjoint,
    locs::NTuple{M,Int},
) where {C,M}
    cunmat(nbit, cbits, cvals, copy(U0), locs)
end

function cunmat(
    nbit::Int,
    cbits::NTuple{C,Int},
    cvals::NTuple{C,Int},
    U0::SDMatrix,
    locs::NTuple{M,Int},
) where {C,M}
    large_mat_check(nbit)
    MM = size(U0, 1)
    U, ic, locs_raw = reorder_unitary(nbit, cbits, cvals, U0, locs)

    N = 1 << nbit
    NNZ = num_nonzero(nbit, C, U0, N)
    colptr = Vector{Int}(undef, N + 1)
    rowval = Vector{Int}(undef, NNZ)
    nzval = ones(eltype(U0), NNZ)

    @inbounds colptr[1] = 1
    ctest = controller(cbits, cvals)
    @inbounds @simd for b in 0:1<<nbit-1
        if ctest(b)
            colptr[b+2] = colptr[b+1] + MM
        else
            colptr[b+2] = colptr[b+1] + 1
            rowval[colptr[b+1]] = b + 1
        end
    end

    mat = SparseMatrixCSC(N, N, colptr, rowval, nzval)
    controldo(ic) do i
        unij!(mat, locs_raw .+ i, U)
    end
    return mat
end

# the fallback
function cunmat(
    nbit::Int,
    cbits::NTuple{C,Int},
    cvals::NTuple{C,Int},
    U0::AbstractMatrix,
    locs::NTuple{M,Int},
) where {C,M}
    return cunmat(nbit, cbits, cvals, Matrix(U0), locs)
end

############################### SparseMatrix ##############################
function cunmat(
    nbit::Int,
    cbits::NTuple{C,Int},
    cvals::NTuple{C,Int},
    U0::SparseMatrixCSC{Tv},
    locs::NTuple{M,Int},
)::SparseMatrixCSC{Tv} where {C,M,Tv}
    large_mat_check(nbit)
    N = 1 << nbit
    U, ic, locs_raw = reorder_unitary(nbit, cbits, cvals, U0, locs)

    NNZ = num_nonzero(nbit, C, U0, N)
    colptr = Vector{Int}(undef, N + 1)
    rowval = Vector{Int}(undef, NNZ)
    nzval = ones(eltype(U0), NNZ)
    @inbounds colptr[1] = 1

    ns = diff(U.colptr) |> autostatic
    Ns = ones(Int, N)
    controldo(ic) do i
        @inbounds Ns[locs_raw.+i] = ns
    end
    @inbounds @simd for j = 1:N
        colptr[j+1] = colptr[j] + Ns[j]
        if Ns[j] == 1
            rowval[colptr[j]] = j
        end
    end

    mat = SparseMatrixCSC(N, N, colptr, rowval, nzval)
    controldo(ic) do i
        unij!(mat, locs_raw .+ i, U)
    end
    mat
end

@inline function unij!(mat::SparseMatrixCSC, locs, U::SDSparseMatrixCSC)
    @simd for j = 1:size(U, 2)
        rows, vals = getcol(U, j)
        @inbounds setcol!(mat, locs[j], view(locs, rows), vals)
    end
    csc
end

############################# PermMatrix ###############################
@inline function unij!(pm::PermMatrix, locs::AbstractVector, U::SDPermMatrix)
    M = size(U, 1)
    @inbounds pm.perm[locs] = locs[U.perm]
    @inbounds pm.vals[locs] = U.vals
    return pm
end

function _initialize_output(nbit::Int, nctrl::Int, U::SDPermMatrix{T}) where {T}
    N = 1 << nbit
    PermMatrix(collect(1:N), ones(T, N))
end

function cunmat(
    nbit::Int,
    cbits::NTuple{C,Int},
    cvals::NTuple{C,Int},
    U0::SDPermMatrix,
    locs::NTuple{M,Int},
) where {C,M}
    large_mat_check(nbit)
    U, ic, locs_raw = reorder_unitary(nbit, cbits, cvals, U0, locs)
    pm = _initialize_output(nbit, C, U0)
    controldo(ic) do i
        unij!(pm, locs_raw .+ i, U)
    end
    return pm
end

############################ Diagonal ##########################
function _initialize_output(nbit::Int, nctrl::Int, U::SDDiagonal{T}) where {T}
    Diagonal(ones(T, 1 << nbit))
end

function cunmat(
    nbit::Int,
    cbits::NTuple{C,Int},
    cvals::NTuple{C,Int},
    U0::SDDiagonal,
    locs::NTuple{M,Int},
) where {C,M}
    large_mat_check(nbit)
    U, ic, locs_raw = reorder_unitary(nbit, cbits, cvals, U0, locs)
    dg = _initialize_output(nbit, C, U0)
    controldo(ic) do i
        unij!(dg, locs_raw .+ i, U)
    end
    return dg
end

@inline function unij!(dg::SDDiagonal, locs, U)
    @inbounds dg.diag[locs] = U.diag
    return dg
end

function unmat(::Val{D}, nbits::Int, U::AbstractMatrix{T}, locs::NTuple{C}) where {T,C,D}
    mat = sparse(U)
    # create stride for indexing
    strides = ntuple(i->D^(i-1), nbits)
    baselocs = (setdiff(1:nbits, locs)...,)
    basestrides = map(i->strides[i], baselocs)
    substrides = map(i->strides[i], locs)

    # allocate storage
    m = nnz(mat)
    basedim = D ^ (nbits - C)
    is = Vector{Int}(undef, basedim * m)
    js = Vector{Int}(undef, basedim * m)
    vs = Vector{T}(undef, basedim * m)
    CI = CartesianIndices(ntuple(i->D, C))
    return outerloop!(Val{D}(), Val{C}(), nbits, mat, is, js, vs, CI, substrides, basestrides, basedim)
end

function outerloop!(::Val{D}, ::Val{C}, nbits, mat, is, js, vs, CI, substrides, basestrides, basedim) where {D,C}
    offset = 0
    # does not support multi-threading
    @inbounds for (i, j, v) in IterNz(mat)
        # set indices
        I, J = CI[i].I, CI[j].I
        ioffset = sum(i->(I[i]-1) * substrides[i], 1:C)
        joffset = sum(i->(J[i]-1) * substrides[i], 1:C)
        innerloop!(Val{D}(), offset, is, js, ioffset, joffset, basestrides)
        # set values
        for k=offset+1:offset+basedim
            vs[k] = v
        end
        offset += basedim
    end
    N = D^nbits
    return sparse(is, js, vs, N, N)
end

@generated function innerloop!(::Val{D}, k, is, js, ioffset::Int, joffset::Int, basestrides::NTuple{BN}) where {D,BN}
    quote
        sumc = length(basestrides) == 0 ? 1 : 1 - sum(basestrides)
        Base.Cartesian.@nloops($BN, i, d->1:$D,
                d->(@inbounds sumc += i_d*basestrides[d]), # PRE
                d->(@inbounds sumc -= i_d*basestrides[d]), # POST
                begin # BODY
                    k += 1
                    @inbounds is[k] = ioffset + sumc
                    @inbounds js[k] = joffset + sumc
                end)

    end
end


####################### getindex ######################
# take last dit
_take_last(x::T, ::Val{D}) where {T,D} = mod(x, D)
_take_last(x::T, ::Val{2}) where T = x & one(T)
# take last k-th dit
_take_last(x::T, ::Val{D}, k::Int) where {T,D} = mod(x, D^k)
_take_last(x::T, ::Val{2}, k::Int) where T = x & (one(T) << k - 1)
# take k-th dit
_takeat(x::T, ::Val{D}, k::Int) where {T,D} = _take_last(BitBasis._rshift(Val{D}(), x, k-1), Val{D}())
function take_last_and_shift(x, ::Val{D}, k::Int) where D
    return _take_last(x, Val{D}(), k), BitBasis._rshift(Val{D}(), x, k)
end

# Implements general multi-control, multi-qudit getindex(block, :, j).
# `T` is the return type
# `D` is the `D` in qudits.
# `N` is the the number of qudits.
# `U` is an content (operator) in e.g. put block
# `locs` is the `locs` in e.g. put block
# `cbits` is the control locations in e.g. control block
# `cvals` is the target controlled value in e.g. control block
# `i` and `j` are the row and column indices to get.
function instruct_get_element(::Type{T}, ::Val{D}, N::Int, U, locs::NTuple{M}, cbits::NTuple{C}, cvals::NTuple{C}, i::TI, j::TI) where {T,C,M,TI<:Integer,D}
    subi, subj = 0, 0  # subspace location (in U)
    _i, _j = i, j
    @inbounds for ibit=1:N
        ival = _take_last(_i, Val{D}())
        jval = _take_last(_j, Val{D}())
        _i = BitBasis._rshift(Val{D}(), _i, 1)
        _j = BitBasis._rshift(Val{D}(), _j, 1)
        # return zero if rest dimensions do not match
        if ibit ∉ locs
            if ival != jval
                return zero(T)
            end
        else
            subloc_1 = findfirst(==(ibit), locs)-1
            subi += BitBasis._lshift(Val{D}(), ival, subloc_1)
            subj += BitBasis._lshift(Val{D}(), jval, subloc_1)
        end
    end
    # check controlled bits
    @inbounds for k=1:C
        if cvals[k] != _takeat(i, Val{D}(), cbits[k])
            return i==j ? one(T) : zero(T)
        end
    end
    # get the target element in U
    return unsafe_getindex(T, U, subi, subj)
end

# same as `instruct_get_element`, but faster!
# blocks are operators, locs are sorted ranges
function kron_instruct_get_element(::Type{T}, ::Val{D}, N::Int, blocks, locs::NTuple{M}, i::TI, j::TI) where {T,D,M,TI}
    _i, _j = i, j
    res = one(T)
    pre = 0
    @inbounds for k=1:M
        block = blocks[k]
        loc = locs[k]  # a range
        # compute gap: return zero if rest dimensions do not match
        gapsize = loc.start - pre - 1
        if gapsize > 0
            ival, _i = take_last_and_shift(_i, Val{D}(), gapsize)
            jval, _j = take_last_and_shift(_j, Val{D}(), gapsize)
            if ival != jval
                return zero(T)
            end
        end

        # compute block
        l = nqudits(block)
        ival, _i = take_last_and_shift(_i, Val{D}(), l)
        jval, _j = take_last_and_shift(_j, Val{D}(), l)
        # get the target element in U
        res *= unsafe_getindex(T, block, ival, jval)
        pre = loc.stop
    end
    if pre != N  # one extra identity
        gapsize = N - pre
        if gapsize > 0
            ival, _i = take_last_and_shift(_i, Val{D}(), gapsize)
            jval, _j = take_last_and_shift(_j, Val{D}(), gapsize)
            if ival != jval
                return zero(T)
            end
        end
    end
    return res
end

# same as `kron_instruct_get_element`, but faster!
# block is an operator, locs are sorted integers
function repeat_instruct_get_element(::Type{T}, ::Val{D}, N::Int, block, locs::NTuple{M}, i::TI, j::TI) where {T,D,M,TI}
    _i, _j = i, j
    res = one(T)
    n = nqudits(block)
    pre = 0
    @inbounds for k=1:M
        loc = locs[k]  # a range
        # compute gap: return zero if rest dimensions do not match
        gapsize = loc - pre - 1
        if gapsize > 0
            ival, _i = take_last_and_shift(_i, Val{D}(), gapsize)
            jval, _j = take_last_and_shift(_j, Val{D}(), gapsize)
            if ival != jval
                return zero(T)
            end
        end

        # compute block
        l = nqudits(block)
        ival, _i = take_last_and_shift(_i, Val{D}(), l)
        jval, _j = take_last_and_shift(_j, Val{D}(), l)
        # get the target element in U
        res *= unsafe_getindex(T, block, ival, jval)
        pre = loc + n-1
    end
    if pre != N  # one extra identity
        gapsize = N - pre
        if gapsize > 0
            ival, _i = take_last_and_shift(_i, Val{D}(), gapsize)
            jval, _j = take_last_and_shift(_j, Val{D}(), gapsize)
            if ival != jval
                return zero(T)
            end
        end
    end
    return res
end

# Implements general multi-control, multi-qudit getindex(block, :, j).
# `T` is the return type
# `U` is an content (operator) in e.g. put block
# `locs` is the `locs` in e.g. put block
# `cbits` is the control locations in e.g. control block
# `cvals` is the target controlled value in e.g. control block
# `dj` is the column index as a `DitStr`.
# Returns operator[:,dj]
function instruct_get_column(::Type{T}, U, locs::NTuple{M}, cbits::NTuple{C}, cvals::NTuple{C}, dj::DitStr{D,L,TI}) where {T,C,M,TI,D,L}
    j = buffer(dj)
    # check controlled bits
    @inbounds for k=1:C
        # not controlled!
        if cvals[k] != _takeat(j, Val{D}(), cbits[k])
            return [dj], [one(T)]
        end
    end
    # get subindex
    subj = zero(TI)
    @inbounds for ind in 1:M
        subj += BitBasis._lshift(Val{D}(), _takeat(j, Val{D}(), locs[ind]), ind-1)
    end
    # get the target element in U
    rows, vals = unsafe_getcol(T, U, DitStr{D,M,TI}(subj))
    # map rows
    newrows = Vector{DitStr{D,L,TI}}(undef, length(rows))
    for (idx, row) in enumerate(rows)
        subi = DitStr{D,L,TI}(j)
        @inbounds for ind in 1:M
            subi += BitBasis._lshift(Val{D}(), _takeat(buffer(row), Val{D}(), ind) - _takeat(subj, Val{D}(), ind), locs[ind]-1)
        end
        newrows[idx] = subi
    end
    return newrows, vals
end

# `blocks` is a list of operators, locs are sorted ranges
function kron_instruct_get_column(::Type{T}, blocks, locs::NTuple{M}, j::DitStr{D,L,TI}) where {T,D,L,M,TI}
    if M == 0
        return [j], [one(T)]
    end
    _j = buffer(j)
    rows = Vector{DitStr{D,L,TI}}[]
    vals = Vector{T}[]
    pre = 0
    @inbounds for k=1:M
        block = blocks[k]
        loc = locs[k]  # a range
        # compute gap: return zero if rest dimensions do not match
        gapsize = loc.start - pre - 1
        if gapsize > 0
            jval, _j = take_last_and_shift(_j, Val{D}(), gapsize)
        end

        # compute block
        l = length(loc)
        jval, _j = take_last_and_shift(_j, Val{D}(), l)
        # get the target element in U
        subrows, subvals = unsafe_getcol(T, block, DitStr{D,L,TI}(jval))
        # map rows to the larger space
        newrows = map(subrows) do i
            subi = zero(DitStr{D,L,TI})
            @inbounds for ind in 1:l
                subi += BitBasis._lshift(Val{D}(), _takeat(buffer(i), Val{D}(), ind) - _takeat(jval, Val{D}(), ind), loc[ind]-1)
            end
            subi
        end
        pushfirst!(rows, newrows)
        pushfirst!(vals, subvals)
        pre = loc.stop
    end
    # kron rows and vals
    totalrows = foldl(_addkron, rows) .+ j
    totalvals = kron(vals...)
    return totalrows, totalvals
end
_addkron(x, y)  = vec([x[i]+y[j] for j=1:length(y), i=1:length(x)])

using YaoBlocks.AD
using SparseArrays, YaoBlocks.LuxurySparse
using YaoArrayRegister
using LinearAlgebra
using Test

@testset "outer prod" begin
    D = 8
    T = ComplexF64
    for (l, r) in [(randn(T, D), randn(T, D)), (randn(T, D, 3), randn(T, D, 3))]
        a = outerprod(l, r)
        A = Matrix(a)
        B = randn(T, D, D)
        V = randn(T, D)
        @test A * B ≈ a * B
        @test A * A ≈ a * a
        @test B * A ≈ B * a
        @test V' * A ≈ V' * a
        @test A * V ≈ a * V
        @test size(a) == size(A)
        @test size(a, 2) == size(A, 2)
        @test A[4] == a[4]
        @test A[4, 4] == a[4, 4]
        @test A' == a'
        @test transpose(A) == transpose(a)
        @test conj(A) == conj(a)
        @test conj!(A) == conj!(a)
        if l isa Vector
            outerprod(ArrayReg(l), ArrayReg(r)) == a
        else
            outerprod(BatchedArrayReg(l), BatchedArrayReg(r)) == a
        end

        a = outerprod(l, r)
        @test rmul!(copy(a), 0.3) ≈ a .* 0.3

        if ndims(a) == 2
            @test AD._sum_A_Bconj(a, B) ≈ AD._sum_A_Bconj(Matrix(a), B)
        end

        @test 3 * a ≈ Matrix(a) * 3
        @test a * 3 ≈ Matrix(a) * 3
    end
end

@testset "projection" begin
    T = ComplexF64
    D = 8
    for y in Any[pmrand(T, D), sprand(T, D, D, 0.5), Diagonal(randn(T, D))]
        @test projection(y, y) == y
        l, r = randn(T, D), randn(T, D)
        op = outerprod(l, r)
        @test projection(y, op) == projection(y, Matrix(op))
    end
end

"""
Standard basic quantum circuit simulator building blocks.

This is a component package for [Yao.jl](https://github.com/QuantumBFS/Yao.jl). It contains the abstract definitions and basic implementation of Yao's circuit building blocks.
"""
module YaoBlocks

using YaoAPI
using LinearAlgebra
using YaoArrayRegister
using YaoArrayRegister: @λ, matvec, diff, autostatic, rot_mat
using BitBasis, LuxurySparse, SparseArrays
using LuxurySparse: fastkron
using StatsBase, TupleTools, InteractiveUtils
using MLStyle: @match
using LinearAlgebra: eigen!
using Random, CacheServers
import KrylovKit: exponentiate
using DocStringExtensions
import StaticArrays: SMatrix

import YaoAPI:
    apply!,
    apply_back!,
    chcontent,
    chsubblocks,
    content,
    dispatch!,
    expect,
    fidelity,
    fidelity2,
    focus!,
    getiparams,
    iparams_eltype,
    iscommute,
    isreflexive,
    isunitary,
    isdiagonal,
    mat,
    mat_back!,
    niparams,
    nqubits,
    nqudits,
    nlevel,
    occupied_locs,
    operator_fidelity,
    parameters,
    parameters_eltype,
    print_block,
    render_params,
    setiparams!,
    subblocks,
    nparameters,
    measure!,
    measure,
    apply_back!,
    mat_back!

export AbstractBlock,
    AbstractContainer,
    CompositeBlock,
    LocationConflictError,
    PrimitiveBlock,
    QubitMismatchError,
    RemoveMeasured,
    ResetTo,
    TagBlock,
    apply!,
    apply,
    apply_back!,
    chcontent,
    chsubblocks,
    content,
    dispatch!,
    dispatch,
    sandwich,
    expect,
    getiparams,
    iparams_eltype,
    iscommute,
    isreflexive,
    isunitary,
    isdiagonal,
    isnoisy,
    mat,
    mat_back!,
    niparams,
    nqubits,
    nqudits,
    nlevel,
    occupied_locs,
    operator_fidelity,
    parameters,
    parameters_eltype,
    print_block,
    render_params,
    setiparams!,
    setiparams,
    subblocks,
    ishermitian,
    nparameters,
    rand_unitary,
    rand_hermitian,
    EntryTable,
    cleanup,
    isclean,
    canonicalize,
    paulipropagation2yao,
    yao2paulipropagation
export applymatrix, cache_key

include("utils.jl")
include("outerproduct_and_projection.jl")
# include("traits.jl")

include("abstract_block.jl")

# concrete blocks
include("routines.jl")
include("primitive/primitive.jl")
include("composite/composite.jl")
include("channel/channel.jl")


include("algebra.jl")
include("blocktools.jl")
include("measure_ops.jl")
include("layout.jl")
include("treeutils/treeutils.jl")

include("autodiff/autodiff.jl")
export AD, Optimise
using .Optimise: canonicalize

include("deprecations.jl")

include("pauli_propagation.jl")

# OpenQASM support (requires OpenQASM package to be loaded)
"""
    qasm(block::AbstractBlock; include_header::Bool=false) -> String

Convert a YaoBlocks circuit to an OpenQASM string.

This function requires the OpenQASM package to be loaded. Load it with:
```julia
using OpenQASM
```

See the OpenQASM extension documentation for more details.
"""
function qasm end

"""
    parseblock(qasm::String) -> SimulationTask

Parse an OpenQASM string into a YaoBlocks circuit.

This function requires the OpenQASM package to be loaded. Load it with:
```julia
using OpenQASM
```

See the OpenQASM extension documentation for more details.
"""
function parseblock end

export qasm, parseblock

end # YaoBlocks

export to_basictypes

"""
    to_basictypes(block::AbstractBlock)

convert gates to basic types

    * ChainBlock
    * PutBlock
    * PrimitiveBlock
"""
function to_basictypes end

to_basictypes(block::PrimitiveBlock) = block
to_basictypes(block::UnitaryChannel) = block
function to_basictypes(block::AbstractBlock)
    throw(NotImplementedError(:to_basictypes, typeof(block)))
end

function to_basictypes(block::RepeatedBlock)
    chain(block.n, map(i -> put(block.n, i => content(block)), block.locs))
end

to_basictypes(block::CachedBlock) = content(block)
function to_basictypes(block::Subroutine{D,<:PrimitiveBlock}) where {D}
    put(nqudits(block), block.locs => content(block))
end
function to_basictypes(block::Subroutine)
    to_basictypes(map_address(content(block), AddressInfo(block.n, [block.locs...])))
end
function to_basictypes(block::Subroutine{D,<:Measure}) where {D}
    map_address(content(block), AddressInfo(nqudits(block), [block.locs...]))
end
to_basictypes(block::Daggered) = Daggered(block.content)
to_basictypes(block::Scale) = Scale(block.alpha, block.content)
to_basictypes(block::KronBlock) =
    chain(block.n, [put(block.n, i => block[i]) for i in block.locs])
to_basictypes(block::Union{Add,PutBlock,ChainBlock,ControlBlock}) = block

using Test, YaoBlocks, YaoArrayRegister, LuxurySparse, CacheServers

@testset "constructor" begin
    @test CacheFragment(X) isa CacheFragment{XGate,UInt8,Any}
    @test CacheFragment{XGate,Int,PermMatrix{ComplexF64,Int}}(X) isa
          CacheFragment{XGate,Int,PermMatrix{ComplexF64,Int}}
    @test CacheFragment{XGate,Int}(X) isa CacheFragment{XGate,Int,Any}
end

@testset "CacheServer API" begin
    frag = CacheFragment(X)
    @test update!(frag, mat(X)) === frag
    @test pull(frag) == mat(X)
    clear!(frag)
    @test_throws KeyError pull(frag)
end

test_server = DefaultServer{AbstractBlock,CacheFragment}()

@testset "constructor" begin
    c = CachedBlock(test_server, X, 2)
    @test c isa CachedBlock{DefaultServer{AbstractBlock,CacheFragment},XGate}

    blk = kron(4, 2 => Rx(0.3))
    @test first(chsubblocks(c, blk) |> subblocks) == blk
end

@testset "methods" begin
    g = CachedBlock(test_server, X, 3)
    @test_throws KeyError pull(g)

    update_cache(ComplexF64, g)
    @test pull(g) ≈ mat(X)

    clear!(g)
    @test_throws KeyError pull(g)

    @test mat(g) ≈ mat(X)

    clear!(g)

    @test state(apply!(arrayreg(bit"1"), g)) ≈ state(arrayreg(bit"0"))
    @test pull(g) ≈ mat(X)
end

@testset "direct inherited methods" begin
    g = chain([X, Z, Y, I2])
    g = CachedBlock(test_server, g, 2)

    @test g[1] isa XGate
    @test g[3] isa YGate

    g[4] = Z
    @test g[4] isa ZGate

    g = chain(X, Y)
    g = CachedBlock(test_server, g, 2)

    @test g[1] isa XGate
    @test g[2] isa YGate

    #@test iterate(g) == iterate(g.content)
    #@test length(g) == length(g.content)

    @test subblocks(g) == (g.content,)

    gg = chain(g, g)
    cgg = CachedBlock(test_server, gg, 2)
    @test cgg isa CachedBlock
    @test content(cgg)[1] == g
end

@testset "matrix-chain cache" begin
    A = matblock(rand(ComplexF64, 2, 2))
    B = matblock(rand(ComplexF64, 2, 2))
    C = cache(chain(A, B))

    update_cache(ComplexF64, C)
    @test pull(C) ≈ mat(C)
end

@testset "instruct_get_element" begin
    for pb in [put(3, 2=>Y) |> cache, put(4, (4,2)=>matblock(rand_unitary(9); nlevel=3)) |> cache]
        mpb = mat(pb)
        allpass = true
        for i=basis(pb), j=basis(pb)
            allpass &= pb[i, j] == mpb[Int(i)+1, Int(j)+1]
        end
        @test allpass
        allpass = true
        for j=basis(pb)
            allpass &= vec(pb[:, j]) == mpb[:, Int(j)+1]
            allpass &= vec(pb[:, EntryTable([j], [1.0+0im])]) == mpb[:, Int(j)+1]
            allpass &= vec(pb[j,:]) == mpb[Int(j)+1,:]
            allpass &= vec(pb[EntryTable([j], [1.0+0im]),:]) == mpb[Int(j)+1,:]
            allpass &= isclean(pb[:,j])
        end
        @test allpass
    end
end

@testset "density matrix" begin
    reg = rand_state(3)
    r = density_matrix(reg)
    @test density_matrix(apply(reg, cache(put(3, 2=>X)))) ≈ apply(r, cache(put(3, 2=>X)))
end

export GeneralMatrixBlock, matblock

"""
    GeneralMatrixBlock{D, MT} <: PrimitiveBlock{D}
    GeneralMatrixBlock{D}(m, n, A, tag="matblock(...)")
    GeneralMatrixBlock(A; nlevel=2, tag="matblock(...)")

General matrix gate wraps a matrix operator to quantum gates. This is the most
general form of a quantum gate.

### Arguments

* `m` and `n` are the number of dits in row and column.
* `A` is a matrix.
* `tag` is the printed information.
* `D` and `nlevel` are the number of levels in each qudit.
"""
struct GeneralMatrixBlock{D,T,MT<:AbstractMatrix{T}} <: PrimitiveBlock{D}
    m::Int
    n::Int
    mat::MT
    tag::String

    function GeneralMatrixBlock{D}(m::Int, n::Int, A::MT, tag::String="matblock(...)") where {D,T,MT<:AbstractMatrix{T}}
        (D^m, D^n) == size(A) ||
            throw(DimensionMismatch("expect a $(D^m) x $(D^n) matrix, got $(size(A))"))

        return new{D,T,MT}(m, n, A, tag)
    end
end
YaoAPI.nqudits(m::GeneralMatrixBlock) = m.n

GeneralMatrixBlock(m::AbstractMatrix; nlevel=2, tag="matblock(...)") = GeneralMatrixBlock{nlevel}(logdi.(size(m), nlevel)..., m, tag)

"""
    matblock(mat_or_block; nlevel=2, tag="matblock(...)")

Create a [`GeneralMatrixBlock`](@ref) with a matrix `m`.

### Examples

```jldoctest; setup=:(using YaoBlocks)
julia> matblock(ComplexF64[0 1;1 0])
matblock(...)
```

!!!warn
    
    Instead of converting it to the default data type `ComplexF64`,
    this will return its contained matrix when calling `mat`.
"""
matblock(m::AbstractMatrix; nlevel=2, tag="matblock(...)") = GeneralMatrixBlock(m; nlevel, tag)
matblock(m::AbstractBlock{D}; tag="matblock(...)") where {D} = GeneralMatrixBlock(mat(m); nlevel=D, tag)

cache_key(m::GeneralMatrixBlock) = hash(m.mat)

"""
    mat(A::GeneralMatrixBlock)

Return the matrix of general matrix block.

!!! warn
    
    Instead of converting it to the default data type `ComplexF64`,
    this will return its contained matrix.
"""
mat(A::GeneralMatrixBlock) = A.mat

function mat(::Type{T}, A::GeneralMatrixBlock) where {T}
    if eltype(A.mat) == T
        return A.mat
    else
        # this errors before, but since we allow one to specify T in mat
        # this should be allowed but with a suggestion
        @warn "converting $(eltype(A.mat)) to eltype $T, consider create another matblock with eltype $T"
        return copyto!(similar(A.mat, T), A.mat)
    end
end

Base.:(==)(A::GeneralMatrixBlock, B::GeneralMatrixBlock) = A.mat == B.mat
Base.copy(A::GeneralMatrixBlock) = GeneralMatrixBlock(copy(A.mat))
Base.adjoint(x::GeneralMatrixBlock) = Daggered(x)
function isdiagonal(op::GeneralMatrixBlock)
    op.mat isa Diagonal || op.mat isa IMatrix
end
Base.setindex!(A::GeneralMatrixBlock, val, args::DitStr...) = setindex!(A.mat, val, (buffer.(args) .+ 1)...)

using Test, YaoBlocks, YaoArrayRegister
import YaoBlocks.ConstGate: Toffoli
using YaoAPI: QubitMismatchError
using LinearAlgebra: I

@testset "Add" begin
    ad = Add(put(3, 2 => X), 3 * put(3, 1 => rot(Y, 0.3)), repeat(3, Z, (2, 3)))
    @test [push!(copy(ad), put(3, 1 => X))...] |> length == 4
    @test insert!(copy(ad), 2, put(3, 1 => X)) isa Add
    @test append!(copy(ad), [put(3, 1 => X)]) |> length == 4
    @test prepend!(copy(ad), [put(3, 1 => X)]) |> length == 4

    @test [occupied_locs(ad)...] |> sort! == [1, 2, 3]
    @test occupied_locs(+(put(5, 2 => X), put(5, 3 => I2))) == (2,)
    ad2 = copy(ad)
    @test ad2 == ad
    push!(ad2, Toffoli)
    @test ad2 != ad
    @test ad2[1:end-1] == ad
    @test ad2[end] == Toffoli
    @test length(ad2) == 4
    println(ad2)
    @test cache_key(ad) != cache_key(ad2)
    @test hash(ad) != hash(ad2)
    ad3 = chsubblocks(ad, [put(3, 1 => X)])
    append!(prepend!(ad3, [rot(Toffoli, 0.2)]), [control(3, 1, 2 => X)])
    @test ad3 == Add(rot(Toffoli, 0.2), put(3, 1 => X), control(3, 1, 2 => X))
    ad3[3] = ad3[1]
    @test ad3 == Add(rot(Toffoli, 0.2), put(3, 1 => X), rot(Toffoli, 0.2))
    @test ad3' == Add(rot(Toffoli, -0.2), put(3, 1 => X), rot(Toffoli, -0.2))

    ad4 = similar(ad3)
    @test typeof(ad4) == typeof(ad3)
    @test length(ad4) == 0

    reg = rand_state(3)
    @test apply!(copy(reg), ad) ≈
          apply!(copy(reg), ad[1]) + apply!(copy(reg), ad[2]) + apply!(copy(reg), ad[3])
    @test mat(ad) * reg.state ≈
          apply!(copy(reg), ad[1]) + apply!(copy(reg), ad[2]) + apply!(copy(reg), ad[3]) |>
          state

    @test Add(3) isa Add
    @test Add(3, [put(3, 3 => X)]) isa Add
    @test_throws QubitMismatchError Add(3, [put(10, 2 => X)])
    @test_throws QubitMismatchError Add(put(10, 2 => X), put(4, 3 => X))
    @test_throws QubitMismatchError apply!(rand_state(2), Add(put(10, 2 => X)))
end

@testset "instruct_get_element" begin
    for pb in [put(3, 3=>Y) + control(3, (2,), 1=>X),
                put(5, 2=>Y) + control(5, (2,), (4,3)=>matblock(rand_unitary(4)))
                ]
        mpb = mat(pb)
        allpass = true
        for i=basis(pb), j=basis(pb)
            allpass &= pb[i, j] ≈ mpb[Int(i)+1, Int(j)+1]
        end
        @test allpass
        allpass = true
        for j=basis(pb)
            allpass &= vec(pb[:, j]) ≈ mpb[:, Int(j)+1]
            allpass &= vec(pb[j,:]) ≈ mpb[Int(j)+1,:]
            allpass &= vec(pb[:, EntryTable([j], [1.0+0im])]) ≈ mpb[:, Int(j)+1]
            allpass &= vec(pb[EntryTable([j], [1.0+0im]),:]) ≈ mpb[Int(j)+1,:]
            allpass &= isclean(pb[:,j])
        end
        @test allpass
    end
end

using Test, YaoBlocks

@testset "test constant gates" begin
    include("const_gate.jl")
end

@testset "test identity gates" begin
    include("identity_gate.jl")
end

@testset "test phase gate" begin
    include("phase_gate.jl")
end

@testset "test shift gate" begin
    include("shift_gate.jl")
end

@testset "test rotation gate" begin
    include("rotation_gate.jl")
end

@testset "test time evolution" begin
    include("time_evolution.jl")
end

@testset "test general matrix gate" begin
    include("general_matrix_gate.jl")
end

@testset "test measure" begin
    include("measure.jl")
end

@testset "reflect" begin
    include("reflect.jl")
end

@testset "projector" begin
    include("projector.jl")
end

# it does nothing
@test chsubblocks(X, Y) === X
@test X[bit"1", bit"0"] == 1
@test X[bit"1", bit"1"] == 0

"""
    content(x)

Returns the content of `x`.
"""
content(x::AbstractContainer) = x.content


"""
    chcontent(x, blk)

Create a similar block of `x` and change its content to blk.
"""
chcontent(x::AbstractContainer, blk) = chsubblocks(x, blk)

subblocks(x::AbstractContainer) = (content(x),)
# NOTE: there's only one block inside, so we expand the iterator
# this would error if there's more than one block in it. But will
# work if there exactly one block.
chsubblocks(x::AbstractContainer, it) = chsubblocks(x, it...)

# throw better error msg when no chsubblocks is overloaded
# for this container block
# since every AbstractContainer should overload this method
chsubblocks(x::AbstractContainer, it::AbstractBlock) =
    throw(NotImplementedError(:chsubblocks, (x, it)))

# TODO:
#   - use simple traits instead
#   - each property should have a trait
# NOTE: this is a holy trait, no overhead, don't use methods on this
"""
    PropertyTrait
    PropertyTrait(::AbstractContainer) -> PropertyTrait

Typically, it can be `PreserveAll()` for those containers that do not change `ishermitian`, `isunitary` and `isreflexive` properties, otherwise fallback to `PreserveNothing`.
"""
abstract type PropertyTrait end
struct PreserveAll <: PropertyTrait end
struct PreserveNothing <: PropertyTrait end

PropertyTrait(c::AbstractContainer) = PreserveNothing()

for METHOD in (:(LinearAlgebra.ishermitian), :(YaoAPI.isreflexive), :(YaoAPI.isunitary))
    @eval begin
        # forward to trait
        $METHOD(x::AbstractContainer) = $METHOD(PropertyTrait(x), x)
        # forward parent block property
        $METHOD(::PreserveAll, c::AbstractContainer) = $METHOD(content(c))
        # forward to default property by calculating the matrix
        $METHOD(::PreserveNothing, c::AbstractContainer) = $METHOD(mat(c))
    end
end

# diagonal is preserved by all composition!
function YaoAPI.isdiagonal(op::CompositeBlock)
    return all(isdiagonal, subblocks(op))
end

include("chain.jl")
include("kron.jl")
include("control.jl")
include("put_block.jl")
include("repeated.jl")
include("subroutine.jl")
include("add.jl")

# tag blocks
include("tag/tag.jl")
include("tag/cache.jl")
include("tag/dagger.jl")
include("tag/scale.jl")
include("tag/onlevels.jl")

@inline function adjunij!(mat::AbstractMatrix, locs, U::Matrix)
    for j = 1:size(U, 2)
        for i = 1:size(U, 2)
            @inbounds U[i, j] += mat[locs[i], locs[j]]
        end
    end
    return U
end

@inline function adjunij!(mat::AbstractMatrix, locs, U::SparseMatrixCSC)
    @inbounds for j = 1:size(U, 2)
        S = U.colptr[j]
        E = U.colptr[j+1] - 1
        for ii = S:E
            @inbounds U.nzval[ii] += mat[locs[U.rowval[ii]], locs[j]]
        end
    end
    return U
end

@inline function adjunij!(mat::SDDiagonal, locs, U::Diagonal)
    @inbounds U.diag .+= mat.diag[locs]
    return U
end

@inline function adjunij!(mat::AbstractMatrix, locs, U::Diagonal)
    @inbounds for i = 1:size(U, 1)
        li = locs[i]
        U.diag[i] += mat[li, li]
    end
    return U
end

@inline function adjunij!(mat::SDPermMatrix, locs, U::PermMatrix)
    @inbounds U.vals .+= mat.vals[locs]
    return U
end

@inline function adjunij!(mat::AbstractMatrix, locs, U::PermMatrix)
    for i = 1:size(U, 1)
        @inbounds U.vals[i] += mat[locs[i], locs[U.perm[i]]]
    end
    return U
end

function adjcunmat(
    adjy::AbstractMatrix,
    nbit::Int,
    cbits::NTuple{C,Int},
    cvals::NTuple{C,Int},
    U0::AbstractMatrix{T},
    locs::NTuple{M,Int},
) where {C,M,T}
    U, ic, locs_raw = YaoBlocks.reorder_unitary(nbit, cbits, cvals, U0, locs)
    adjU = _render_adjU(U)

    controldo(ic) do i
        adjunij!(adjy, locs_raw .+ i, adjU)
    end

    adjU =
        all(diff([locs...]) .> 0) ? adjU :
        YaoArrayRegister.reorder(adjU, collect(locs) |> sortperm |> sortperm)
    adjU
end

@inline function adju1ij!(csc::SparseMatrixCSC{T}, i::Int, j::Int, adjU::Matrix) where {T}
    @inbounds begin
        adjU[1, 1] += csc.nzval[2*i-1]
        adjU[1, 2] += csc.nzval[2*i]
        adjU[2, 1] += csc.nzval[2*j-1]
        adjU[2, 2] += csc.nzval[2*j]
    end
    adjU
end

function adju1mat(adjy, nbit::Int, U1::SDMatrix, ibit::Int)
    mask = bmask(ibit)
    step = 1 << (ibit - 1)
    step_2 = 1 << ibit

    adjy = projection(YaoBlocks._initialize_output(nbit, 0, U1), adjy)
    adjU = _render_adjU(U1)

    for j = 0:step_2:1<<nbit-step
        @inbounds @simd for i = j+1:j+step
            adju1ij!(adjy, i, i + step, adjU)
        end
    end
    adjU
end

_render_adjU(U0::AbstractMatrix{T}) where {T} = zeros(T, size(U0)...)
_render_adjU(U0::SDSparseMatrixCSC{T}) where {T} = SparseMatrixCSC(
    size(U0)...,
    dynamicize(U0.colptr),
    dynamicize(U0.rowval),
    zeros(T, U0.nzval |> length),
)
_render_adjU(U0::SDDiagonal{T}) where {T} = Diagonal(zeros(T, size(U0, 1)))
_render_adjU(U0::SDPermMatrix{T}) where {T} = PermMatrix(U0.perm, zeros(T, length(U0.vals)))

# DEPRECATED
#=
@inline function adjsetcol!(csc::SparseMatrixCSC, icol::Int, rowval::AbstractVector, nzval::SubArray)
    begin
        S = csc.colptr[icol]
        E = csc.colptr[icol+1]-1
        nzval .+= view(csc.nzval, S:E)
    end
    csc
end

@inline function adjunij!(mat::SparseMatrixCSC, locs, U::Matrix)
    for j = 1:size(U, 2)
        adjsetcol!(mat, locs[j], locs, view(U,:,j))
    end
    return U
end

@inline function adjunij!(mat::SparseMatrixCSC, locs, U::SparseMatrixCSC)
    for j = 1:size(U, 2)
        S = U.colptr[j]
        E = U.colptr[j+1]-1
        @inbounds adjsetcol!(mat, locs[j], locs, view(U.nzval,S:E))
    end
    return U
end
=#

using YaoBlocks.Optimise, YaoBlocks, Test, YaoArrayRegister

@testset "is pauli" begin
    @test is_pauli(Val(-im)*X)
    @test is_pauli(X, Z, -Z)
    @test !is_pauli(X, Z, -2Z)
end

@testset "merge pauli *" begin
    test_merge(a, b) = mat(merge_pauli(a, b)) ≈ (mat(a) * mat(b))

    for a in [X, Y, Z], b in [X, Y, Z]
        @test test_merge(a, b)
    end

    @test mat(simplify(X * Y)) ≈ mat(im * Z)
    @test mat(simplify(im * X * im * Y)) ≈ mat(Val(-im) * Z)
    @test mat(simplify(I2 * im * I2)) ≈ mat(im * I2)

    @test mat(simplify(X * Y * Y)) ≈ mat(X) ≈ mat(X) * mat(Y) * mat(Y)
    @test mat(simplify(X * Y * Z)) ≈ mat(im * I2) ≈ mat(X) * mat(Y) * mat(Z)
end

@testset "eliminate nested" begin
    @test simplify(*(X, *(H))) == *(X, H)
    @test simplify(*(X)) == X

    @test simplify(Add(X, Add(X, X))) == 3X
end

@testset "reduce matrices" begin
    @test mat(*(X, Y)) ≈ mat(X) * mat(Y)
    @test mat(*(X, Y)) ≈ mat(simplify(*(X, Y)))
    @test mat(Add(X, Y)) ≈ mat(X) + mat(Y)
end

@testset "composite strcuture" begin
    g = chain(2, kron(1 => chain(X, Y), 2 => X), control(1, 2 => X))
    @test simplify(g) == prod([control(2, 1, 2 => X), kron(2, 1 => (Val(-im) * Z), 2 => X)])
end

@testset "to basic types" begin
    # primitive
    @test to_basictypes(X) == X

    # chain, put, concentrator
    @test to_basictypes(chain(5, put(5, 3 => X))) == chain(5, put(5, 3 => X))
    @test to_basictypes(subroutine(5, put(2, 2 => X), (4, 1))) == put(5, 1 => X)
    @test to_basictypes(subroutine(5, Measure(2, locs = (2,)), (4, 1))) ==
          Measure(5; locs = (1,))
    @test to_basictypes(subroutine(5, Measure(2), (4, 1))) == Measure(5; locs = (4, 1))
    @test to_basictypes(subroutine(5, X, (1,))) == put(5, 1 => X)
    @test to_basictypes(put(5, 3 => X)) == put(5, 3 => X)

    # control, kron, rot
    @test to_basictypes(control(5, 2, 1 => Rx(0.3))) == control(5, 2, 1 => Rx(0.3))
    @test to_basictypes(kron(5, 2 => Y, 3 => X)) == chain(put(5, 2 => Y), put(5, 3 => X))

    # repeat, measure
    @test to_basictypes(repeat(5, Y, (2, 3))) == chain(put(5, 2 => Y), put(5, 3 => Y))
    @test to_basictypes(Measure(5)) == Measure(5)
    @test to_basictypes(Measure(5; locs = (3, 2, 1))) == Measure(5; locs = (3, 2, 1))
    @test to_basictypes(Measure(5; operator = repeat(3, X, 1:3), locs = (3, 2, 1))) ==
          Measure(5; operator = repeat(3, X, 1:3), locs = (3, 2, 1))

    # sum, cache, scale
    @test to_basictypes(2 * put(5, 2 => X)) == 2 * put(5, 2 => X)
    @test to_basictypes(put(5, 3 => X) |> cache) == put(5, 3 => X)
    @test to_basictypes(Daggered(X)) == Daggered(X)

    # channels
    c0 = DepolarizingChannel(5, 0.1)
    c1 = MixedUnitaryChannel([X, Y], [0.1, 0.9])
    c2 = KrausChannel([0.3*X, 0.1*Y])
    c3 = SuperOp(X)
    @test to_basictypes(c0) == c0
    @test to_basictypes(c1) == c1
    @test to_basictypes(c2) == c2
    @test to_basictypes(c3) == c3

    # tobasic_recursive
    sub = chain(
        5,
        Daggered(put(5, 4 => Rx(0.5)) * 2),
        put(5, 3 => ConstGate.P0 + ConstGate.P1),
        kron(5, 3 => X, 4 => Y),
        subroutine(5, kron(X, Z), (3, 2)),
        Measure(5, operator = X, locs = 1),
    )
    c = chain(10, repeat(10, H, 1:10), subroutine(10, sub, 6:10))

    sub2 = chain(
        10,
        Daggered(put(10, 9 => Rx(0.5)) * 2),
        put(10, 8 => ConstGate.P0 + ConstGate.P1),
        chain(put(10, 8 => X), put(10, 9 => Y)),
        chain(put(10, 8 => X), put(10, 7 => Z)),
        Measure(10, operator = X, locs = 6),
    )
    c2 = chain(10, chain(10, [put(10, i => H) for i = 1:10]), sub2)
    @test simplify(c, rules = [to_basictypes]) == c2

    # subroutine, chain, put, kron and control
    c = chain(
        6,
        [
            put(6, 3 => X),
            kron(6, 2 => X, 4 => X),
            chain(6, [subroutine(6, control(2, 1, 2 => Y), (6, 1))]),
        ],
    )
    @test zero_state(6) |> c ≈ zero_state(6) |> simplify(c, rules = [to_basictypes])
end

@testset "simplify" begin
    qc = chain(2)
    m = matblock(rand(ComplexF64,2,2))
    qc2 = chain(1,put(1,1=>H), matblock(m))
    push!(qc, subroutine(2,qc2,1))
    @test simplify(qc; rules=[to_basictypes, Optimise.eliminate_nested]) isa ChainBlock
end

@testset "replace block" begin
    @test eliminate_nested(chain(7, chain(7, control(7, 1, 2 => X)), put(7, 4 => X))) ==
          chain(7, [control(7, 1, 2 => X), put(7, 4 => X)])
    @test replace_block(X => Y, chain(put(2, 2 => X), put(2, 1 => Z), kron(X, Y))) ==
          chain(put(2, 2 => Y), put(2, 1 => Z), kron(Y, Y))
end

@testset "raise chain" begin
    @test raise_chain(put(2, 1 => chain(X, Y))) == chain(put(2, 1 => X), put(2, 1 => Y))
    @test raise_chain(chain(put(2, 1 => chain(X, Y)))) == chain(chain(put(2, 1 => X), put(2, 1 => Y)))
end

@testset "canonicalize" begin
    n_qubits = 4
    circ = chain(
        put(n_qubits, 1 => H),
        [put(n_qubits, (i, i+1) => ConstGate.CNOT) for i in 1:n_qubits-1]...,
    )

    # Example error probabilities
    p_reset = 0.03
    p_meas = 0.1
    p_gate1 = 0.05

    # QuantumError objects
    error_meas = KrausChannel(BitFlipError(p_meas))
    error_gate1 = KrausChannel(BitFlipError(p_gate1))
    error_gate2 = kron(KrausChannel(BitFlipError(p_gate1)), KrausChannel(BitFlipError(p_gate1)))

    # Add errors to noise model
    circ_noisy = YaoBlocks.Optimise.replace_block(circ) do x
        if x == H
            chain(H, error_gate1)
        elseif nqubits(x) == 2
            chain(x, error_gate2)
        else
            x
        end
    end
    # add measurement noise
    push!(circ_noisy, repeat(error_meas, n_qubits))

    circ_noisy = canonicalize(circ_noisy)

    @test circ_noisy isa ChainBlock
    @test length(circ_noisy) == 9
    println(circ_noisy)
    @test all(x -> x isa PutBlock && nqubits(x.content) <= 2 && (x.content in [ConstGate.CNOT, ConstGate.H] || x.content isa KrausChannel), circ_noisy)
end

using Test, Random, YaoAPI, YaoBlocks, LuxurySparse
using YaoBlocks.ConstGate

function random_dense_kron(n; gateset)
    locs = randperm(n)
    blocks = [i => rand(gateset) for i in locs]
    g = KronBlock(n, blocks...)
    sorted_blocks = sort(blocks, by = x -> x[1])
    t = mapreduce(x -> mat(x[2]), kron, reverse(sorted_blocks), init = IMatrix(1))
    mat(g) ≈ t || @info(g)
end

function rand_kron_test(n; gateset)
    firstn = rand(1:n)
    locs = randperm(n)
    blocks = [rand(gateset) for i = 1:firstn]
    seq = [i => each for (i, each) in zip(locs[1:firstn], blocks)]
    mats = Any[i => mat(each) for (i, each) in zip(locs[1:firstn], blocks)]
    append!(mats, [i => IMatrix(2) for i in locs[firstn+1:end]])
    sorted = sort(mats, by = x -> x.first)
    mats = map(x -> x.second, reverse(sorted))

    g = KronBlock(n, seq...)
    t = reduce(kron, mats, init = IMatrix(1))
    mat(g) ≈ t || @info(g)
end


@testset "test constructors" begin
    @test_throws LocationConflictError KronBlock(5, 4 => CNOT, 5 => X)
    @test_throws MethodError kron(3, 1 => X, Y)
    @test kron(2 => X)(4) == kron(4, 2 => X)
    @test_throws LocationConflictError kron(10, (2, 3) => CNOT, [3] => Y)
    @test kron(10, (2, 3) => CNOT, [5] => Y) isa KronBlock
    @test_throws ErrorException kron(5, (5, 3) => CNOT, [3] => Y)
end

@testset "test mat" begin
    TestGateSet =
        [X, Y, Z, phase(0.1), phase(0.2), phase(0.3), rot(X, 0.1), rot(Y, 0.4), rot(Z, 0.2)]

    U = Const.X
    U2 = Const.CNOT

    @testset "case 1" begin
        m = kron(Const.I2, U)
        g = kron(2, 1 => X)
        @test m == mat(g)

        m = kron(U, Const.I2)
        g = kron(2, 2 => X)
        @test m == mat(g)
        @test occupied_locs(g) == (2,)
        @test occupied_locs(kron(5, 3=>X, 4=>Y)) == (3, 4)
        @test occupied_locs(kron(5, 3=>X, 4=>I2)) == (3,)
        blks = [Rx(0.3)]
        @test chsubblocks(g, blks) |> subblocks |> collect == blks

        m = kron(U2, Const.I2, U, Const.I2)
        @test_throws LocationConflictError KronBlock(5, 4 => CNOT, 2 => X)
        g = KronBlock(5, 4:5 => CNOT, 2 => X)
        @test m == mat(g)
        @test g.locs == (2:2, 4:5)
        @test occupied_locs(g) == (2, 4, 5)
    end

    @testset "case 2" begin
        m = kron(mat(X), mat(Y), mat(Z))
        g = KronBlock(3, 1 => Z, 2 => Y, 3 => X)
        g1 = KronBlock(Z, Y, X)
        @test m == mat(g)
        @test m == mat(g1)

        m = kron(Const.I2, m)
        g = KronBlock(4, 1 => Z, 2 => Y, 3 => X)
        @test m == mat(g)
    end

    @testset "random dense sequence, n=$i" for i = 2:8
        @test random_dense_kron(i; gateset = TestGateSet)
    end

    @testset "random mat sequence, n=$i" for i = 4:8
        @test rand_kron_test(i; gateset = TestGateSet)
    end
end

@testset "test allocation" begin
    g = kron(4, 1 => X, 2 => phase(0.1))

    # copy
    cg = copy(g)
    cg[2].theta = 0.2
    @test g[2].theta == 0.1
    @test cg[2].theta == 0.2

    @test cache_key(cg) != cache_key(g)
end

@testset "test iteration" begin
    g = kron(5, 1 => X, 3 => Y, 4 => rot(X, 0.0), 5 => rot(Y, 0.0))
    for (src, tg) in zip(g, [1:1 => X, 3:3 => Y, 4:4 => rot(X, 0.0), 5:5 => rot(Y, 0.0)])
        @test src[1] == tg[1]
        @test src[2] == tg[2]
    end

    for (src, tg) in zip(eachindex(g), [1:1, 3:3, 4:4, 5:5])
        @test src == tg
    end
end

@testset "test inspect" begin
    g = kron(5, 1 => X, 3 => Y, 4 => rot(X, 0.0), 5 => rot(Y, 0.0))
    collect(subblocks(g)) === g.blocks
    eltype(g) == Tuple{Int,AbstractBlock}

    @test isunitary(g) == true
    @test isreflexive(g) == true
end

@testset "empty kron" begin
    T = Float64
    @test mat(T, kron(5)) === mat(T, chain(5)) == IMatrix{Float64}(1 << 5)
end

@testset "instruct_get_element" begin
    for pb in [kron(3), kron(3, 2=>Y, 3=>X),
            kron(6, 2:3=>matblock(rand_unitary(9); nlevel=3), 1=>matblock(rand_unitary(3); nlevel=3), 5=>matblock(rand_unitary(3); nlevel=3))]
        mpb = mat(pb)
        allpass = true
        for i=basis(pb), j=basis(pb)
            allpass &= pb[i, j] ≈ mpb[Int(i)+1, Int(j)+1]
        end
        @test allpass

        allpass = true
        for j=basis(pb)
            allpass &= vec(pb[:, j]) ≈ mpb[:, Int(j)+1]
            allpass &= vec(pb[:, EntryTable([j], [1.0+0im])]) == mpb[:, Int(j)+1]
            allpass &= vec(pb[j,:]) ≈ mpb[Int(j)+1,:]
            allpass &= isclean(pb[:,j])
        end
        @test allpass
    end
end

# deprecations
@deprecate iparameters(args...) getiparams(args...)
@deprecate setiparameters!(args...) setiparams!(args...)
@deprecate niparameters(args...) niparams(args...)
@deprecate parameter_type(args...) parameters_eltype(args...)
@deprecate PreserveStyle(args...) PropertyTrait(args...)
@deprecate Sum(args...) Add(args...)
@deprecate mathgate(f; nbits) mathgate(nbits, f)
@deprecate Concentrator Subroutine
@deprecate concentrate subroutine

@deprecate UnitaryChannel(args...) MixedUnitaryChannel(args...)
@deprecate unitary_channel MixedUnitaryChannel
@deprecate reset_error_channel(; p0::Real, p1::Real) KrausChannel(ResetError(p0, p1))
@deprecate pauli_error_channel(; px::Real, py::Real=px, pz::Real=px) MixedUnitaryChannel(PauliError(px, py, pz))
@deprecate single_qubit_depolarizing_channel(p::Real) quantum_channel(DepolarizingError(1, p))
@deprecate phase_flip_channel(p::Real) quantum_channel(PhaseFlipError(p))
@deprecate bit_flip_channel(p::Real) quantum_channel(BitFlipError(p))
@deprecate mixed_unitary_channel(operators, probs::AbstractVector) MixedUnitaryChannel(operators, probs)
@deprecate depolarizing_channel(n::Int; p::Real) DepolarizingChannel(n, p)
@deprecate kraus_channel(operators) KrausChannel(operators)

@deprecate two_qubit_depolarizing_channel(p::Real) MixedUnitaryChannel(
        [kron(I2, I2), kron(I2, X), kron(I2, Y), kron(I2, Z),
         kron(X, I2), kron(X, X), kron(X, Y), kron(X, Z),
         kron(Y, I2), kron(Y, X), kron(Y, Y), kron(Y, Z),
         kron(Z, I2), kron(Z, X), kron(Z, Y), kron(Z, Z),
        ],
        [1-15p/16, p/16, p/16, p/16,
         p/16, p/16, p/16, p/16,
         p/16, p/16, p/16, p/16,
         p/16, p/16, p/16, p/16,
        ],
    )

using Test, YaoBlocks, YaoAPI, LuxurySparse, YaoArrayRegister

@test_throws LocationConflictError swap(2, 1, 1)
@test swap(2, 1, 2) isa Swap
@test mat(swap(2, 1, 2)) ≈ PermMatrix([1, 3, 2, 4], ones(1 << 2))
@test mat(swap(4, 1, 3)) ≈ YaoArrayRegister.linop2dense(s -> instruct!(Val(2), s, Val(:SWAP), (1, 3)), 4)

@test swap(1, 2)(3) == swap(3, 1, 2)

@testset "check apply" begin
    r = rand_state(2)
    @test apply!(copy(r), YaoBlocks.ConstGate.SWAP) ≈ apply!(copy(r), swap(2, 1, 2))
end

@test occupied_locs(swap(3, 1, 2)) == (1, 2)
@test isunitary(swap(3, 1, 2))
@test ishermitian(swap(3, 1, 2))
@test isreflexive(swap(3, 1, 2))

@testset "pswap gate" begin
    pb = pswap(6, 2, 4, 0.0)
    @test pb isa PSwap{Float64} && pb.n == 6
    @test pb == pswap(2, 4, 0.0)(6)
    reg = rand_state(6)
    @test copy(reg) |> pb ≈ invoke(apply!, Tuple{ArrayReg,PutBlock}, copy(reg), pb)
    @test copy(reg) |> pb ≈ reg

    dispatch!(pb, π)
    @test copy(reg) |> pb ≈ -im * (copy(reg) |> swap(6, 2, 4))
    @test copy(reg) |> pb |> isnormalized
    pb = dispatch(pb, π)
    @test copy(reg) |> pb ≈ -im * (copy(reg) |> swap(6, 2, 4))
    @test copy(reg) |> pb |> isnormalized

    pb = pswap(6, 2, 4, 0.0)
    dispatch!(pb, :random)
    @test copy(reg) |> pb ≈ invoke(apply!, Tuple{ArrayReg,PutBlock}, copy(reg), pb)
    pb = dispatch(pb, :random)
    @test copy(reg) |> pb ≈ invoke(apply!, Tuple{ArrayReg,PutBlock}, copy(reg), pb)
end

export TimeEvolution, time_evolve

"""
    TimeEvolution{D, TT, GT} <: PrimitiveBlock{D}

TimeEvolution, where GT is block type. input matrix should be hermitian.

!!! note

    `TimeEvolution` contructor check hermicity of the input block by default,
    but sometimes it can be slow. Turn off the check manually by specifying
    optional parameter `check_hermicity = false`.
"""
mutable struct TimeEvolution{D,Tt,HT<:AbstractBlock{D}} <: PrimitiveBlock{D}
    H::HT
    dt::Tt
    tol::Float64

    function TimeEvolution(
        H::TH,
        dt::Tt;
        tol::Real = 1e-7,
        check_hermicity::Bool = true,
    ) where {D,Tt,TH<:AbstractBlock{D}}
        (check_hermicity && !ishermitian(H)) &&
            error("Time evolution Hamiltonian has to be a Hermitian")
        return new{D,Tt,TH}(H, dt, Float64(tol))
    end
end
nqudits(te::TimeEvolution) = nqudits(te.H)

"""
    time_evolve(H, dt[; tol=1e-7, check_hermicity=true])

Create a [`TimeEvolution`](@ref) block with Hamiltonian `H` and time step `dt`. The
`TimeEvolution` block will use Krylove based `expv` to calculate time propagation.
`TimeEvolution` block can also be used for
[imaginary time evolution](http://large.stanford.edu/courses/2008/ph372/behroozi2/)
if `dt` is complex.
Let ``H`` be a hamiltonian and ``t`` be a time, the matrix representation of `time_evolve(H, t)` is ``e^{-iHt}``.

### Arguments

- `H` the hamiltonian represented as an `AbstractBlock`.
- `dt`: the evolution duration (start time is zero).

### Keyword Arguments

- `tol::Real=1e-7`: error tolerance.
- `check_hermicity=true`: check hermicity or not.

### Examples

```jldoctest; setup=:(using Yao)
julia> time_evolve(kron(2, 1=>X, 2=>X), 0.1)
Time Evolution Δt = 0.1, tol = 1.0e-7
kron
├─ 1=>X
└─ 2=>X
```
"""
time_evolve(M::AbstractBlock, dt; kwargs...) = TimeEvolution(M, dt; kwargs...)
time_evolve(dt; kwargs...) = @λ(M -> time_evolve(M, dt; kwargs...))

content(te::TimeEvolution) = te.H
chcontent(te::TimeEvolution, blk::AbstractBlock) = time_evolve(blk, te.dt; tol = te.tol)

function mat(::Type{T}, te::TimeEvolution) where {T}
    return _exp((-im * T(te.dt)) .* mat(T, te.H))
end
_exp(m::AbstractMatrix) = exp(m)
_exp(m::SparseMatrixCSC) = exp(Matrix(m))

struct BlockMap{T,GT<:AbstractBlock} <: AbstractArray{T,2}
    block::GT
    BlockMap(::Type{T}, block::GT) where {T,GT<:AbstractBlock} = new{T,GT}(block)
end

Base.size(bm::BlockMap{T,GT}, i::Int) where {T,D,GT<:AbstractBlock{D}} =
    0 < i <= 2 ? D^nqudits(bm.block) : DimensionMismatch("")
Base.size(bm::BlockMap{T,GT}) where {T,D,GT<:AbstractBlock{D}} = (L = D^nqudits(bm.block); (L, L))
LinearAlgebra.ishermitian(bm::BlockMap) = ishermitian(bm.block)

function LinearAlgebra.mul!(y::AbstractVector, A::BlockMap{T,GT}, x::AbstractVector) where {T,D,GT<:AbstractBlock{D}}
    copyto!(y, x)
    apply!(ArrayReg{D}(y), A.block)
    return y
end

compatible_multiplicative_operand(::AbstractArray, source::AbstractArray) = source

function YaoAPI.unsafe_apply!(reg::AbstractArrayReg{D,T}, te::TimeEvolution) where {D,T}
    if isdiagonal(te.H)
        # `compatible_multiplicative_operand` is used to ensure GPU compatibility.
        reg.state .*= exp.((-im * te.dt) .* compatible_multiplicative_operand(reg.state, diag(mat(T, te.H))))
        return reg
    end
    st = state(reg)
    dt = real(te.dt) == 0 ? imag(te.dt) : -im * te.dt
    A = BlockMap(T, te.H)
    @inbounds for j = 1:size(st, 2)
        v = view(st, :, j)
        v_out, info = exponentiate(A, dt, v,
                                   tol=te.tol,
                                   krylovdim=min(1000, size(A,1)),
                                   ishermitian=true,
                                   eager=true,)
        # info.converged is 1 if it converged and 0 otherwise
        Bool(info.converged) || @warn "Application of $(typeof(te)) did not converge. error = $(info.normres) but tol=$(te.tol)"
        v .= v_out
    end
    return reg
end

cache_key(te::TimeEvolution) = (te.dt, cache_key(te.H))

# parametric interface
niparams(::Type{<:TimeEvolution}) = 1
getiparams(x::TimeEvolution) = x.dt
setiparams!(r::TimeEvolution, param::Number) = (r.dt = param; r)
setiparams(r::TimeEvolution, param::Number) =
    TimeEvolution(r.H, param; tol = r.tol, check_hermicity = false)

function Base.:(==)(lhs::TimeEvolution, rhs::TimeEvolution)
    return lhs.H == rhs.H && lhs.dt == rhs.dt
end

function Base.adjoint(te::TimeEvolution)
    return TimeEvolution(te.H, -adjoint(te.dt); tol = te.tol)
end
Base.copy(te::TimeEvolution) = TimeEvolution(te.H, te.dt, tol = te.tol)

YaoAPI.isdiagonal(te::TimeEvolution) = isdiagonal(te.H)
YaoAPI.isunitary(te::TimeEvolution) = iszero(imag(te.dt))

iparams_range(::TimeEvolution{D,T}) where {D,T} = ((typemin(T), typemax(T)),)

function unsafe_getindex(::Type{T}, te::TimeEvolution{D}, i::Integer, j::Integer) where {D,T}
    return apply!(ArrayReg{D}(BitBasis._onehot(T, D^nqudits(te), j+1)), te).state[i+1]
end
function unsafe_getcol(::Type{T}, te::TimeEvolution{D}, j::DitStr{D,L,TI}) where {D,T,L,TI<:Integer}
    map(x->DitStr{D,L,TI}(buffer(x)), basis(te)), statevec(apply!(ArrayReg{D}(BitBasis.onehot(T, j)), te))
end
function _getindex(te::TimeEvolution{D}, ::Colon, j::EntryTable{DitStr{D,L,TI},T}) where {D,L,TI<:Integer,T}
    EntryTable(map(x->DitStr{D,L,TI}(buffer(x)), basis(te)), YaoArrayRegister.matchtype(T, statevec(apply!(ArrayReg{D}(vec(j)), te))))
end

using Test, YaoBlocks, YaoArrayRegister

@testset "KrausChannel" begin
    op1 = matblock(rand_unitary(2))
    op2 = matblock(rand_unitary(2))
    kraus_channel = KrausChannel([op1, op2])
    @test kraus_channel.n == 1
    @test kraus_channel.operators == [op1, op2]
end

@testset "KrausChannel apply" begin
    n_qubits = 4
    circ = chain(
        put(n_qubits, 1 => H),
        put(n_qubits, 1 => KrausChannel(PhaseFlipError(0.1))),
        put(n_qubits, 1 => H),
    )
    rho = apply(density_matrix(zero_state(n_qubits)), circ)
    samples = measure(rho, nshots=1000)
    res = [(i => count(==(i), samples)) for i in unique(samples)]
    @test length(res) == 2
    if res[1].first == bit"0000"
        @test 850 < res[1][2] < 950  # the expected probability is 0.9
    else
        @test 850 < res[2][2] < 950  # the expected probability is 0.9
    end
end

@testset "kron" begin
    n_qubits = 3
    op1 = matblock(rand_unitary(2))
    op2 = matblock(rand_unitary(2))
    kraus_channel = KrausChannel([op1, op2])
    kraus_channel2 = KrausChannel([op1, op2])
    kraus_channel3 = kron(kraus_channel, kraus_channel2)

    circ1 = chain(n_qubits, put(n_qubits, 1 => kraus_channel), put(n_qubits, 2 => kraus_channel2))
    circ2 = chain(n_qubits, put(n_qubits, (1, 2) => kraus_channel3))

    reg = rand_state(n_qubits)
    @test noisy_simulation(reg, circ1) ≈ noisy_simulation(reg, circ2)
end

@testset "direct apply" begin
    n_qubits = 1
    c = KrausChannel(PhaseFlipError(0.1))
    mu = MixedUnitaryChannel([I2, X], [0.9, 0.1])
    so = SuperOp(rand_unitary(4))
    g = chain(1, c, mu, so)
    reg = density_matrix(rand_state(n_qubits))
    @test apply(reg, g) isa DensityMatrix
end

@testset "noisy_instruct!" begin
    n_qubits = 3
    c = KrausChannel(PhaseFlipError(0.1))
    g1 = chain(3, put(3, 1=>c))
    g1x = MixedUnitaryChannel([igate(3), put(3, 1=>Z)], [0.9, 0.1])
    g2 = put(3, (2,1)=>put(2, 1=>c))  # nested put
    g2x = MixedUnitaryChannel([igate(3), put(3, 2=>Z)], [0.9, 0.1])
    g3 = put(3, (2,1)=>put(2, 1=>chain(X, c, X)))  # nested put and chain
    g3x = chain(3, put(3, 2=>X), MixedUnitaryChannel([igate(3), put(3, 2=>Z)], [0.9, 0.1]), put(3, 2=>X))
    g4 = chain(3, put(3, 1=>c), put(3, (2,1)=>kron(chain(X, c, X), X)))  # nested put and chain, and kron
    g4x = chain(3, g1x, put(3, (2,1)=>kron(X, X)), g2x, put(3, 2=>X))
    g5 = chain(3, put(3, 1=>c) + 2*put(3, (2,1)=>kron(chain(X, c, X), X)))  # nested put and chain, and kron, and add, and scale
    g6 = chain(3, put(3, 1=>c), put(3, (2,1)=>kron(chain(X, c, X), X)))'  # nested put and chain, and kron, and adjoint
    g6x = g4x
    for g in [g1, g2, g3, g4, g5, g6]
        reg = density_matrix(rand_state(n_qubits))
        sg = canonicalize(g)
        @test apply(reg, g) ≈ apply(reg, sg)
    end
    for (i, (g1, g2)) in enumerate(zip([g1x, g2x, g3x, g4x, g6x], [g1, g2, g3, g4, g6]))
        @info "Testing $i: $g1 and $g2"
        reg = density_matrix(rand_state(n_qubits))
        @test apply(reg, g1) ≈ apply(reg, g2)
    end
end

using Test, YaoBlocks, YaoArrayRegister, LuxurySparse


@testset "test constructor" for T in [Float16, Float32, Float64]
    @test PhaseGate(0.1) isa PrimitiveBlock{2}
    @test phase(T(0.1)) isa PrimitiveBlock{2}
end

@testset "test copy" begin
    g = PhaseGate(0.1)
    cg = copy(g)
    cg.theta = 0.2
    @test g.theta == 0.1
end

@testset "test matrix" begin
    g = PhaseGate{Float64}(pi)
    @test mat(g) ≈ exp(im * pi) * IMatrix(2)
end

@testset "test operations" begin
    g = PhaseGate{Float64}(pi)
    reg = rand_state(1)
    @test mat(g) * state(reg) ≈ state(apply!(reg, g))

    @test (PhaseGate(2.0) == PhaseGate(2.0)) == true
end

@testset "test dispatch & parameters" begin
    @test nparameters(phase(0.1)) == 1
    @test adjoint(phase(0.1)) == phase(-0.1)
    @test dispatch!(phase(0.1), 0.3) == phase(0.3)
    @test dispatch(phase(0.1), 3) == phase(3) &&
          eltype(getiparams(dispatch(phase(0.1), 3))) == Int

    @testset "test $op" for op in [+, -, *, /]
        @test dispatch!(op, phase(0.1), π) == phase(op(0.1, π))
    end

    @test_throws AssertionError dispatch!(phase(0.1), (0.2, 0.3))
end

@testset "properties" begin
    g = PhaseGate{Float64}(0.1)
    @test nqubits(g) == 1
    @test isreflexive(g) == false
    @test isunitary(g) == true
    @test ishermitian(g) == false
    @test isdiagonal(g) == isdiagonal(mat(g)) == true

    g = PhaseGate{ComplexF64}(1.0 + 0im)
    @test @test_nowarn isunitary(g) == true

    g = PhaseGate{ComplexF64}(1.0 + 1im)
    @test @test_logs (
        :warn,
        "θ in phase(θ) is not real, got $(g.theta), fallback to matrix-based method",
    ) isunitary(g) == false
end

using Test
using YaoBlocks.AD
using YaoBlocks
using YaoArrayRegister

@testset "NoParams" begin
    c = chain(put(3, 2 => Ry(0.2)), put(3, 1 => Rx(0.5)))
    np = chain(NoParams(put(3, 2 => Ry(0.2))), put(3, 1 => Rx(0.5)))
    @test gatecount(np) == gatecount(c)
    reg = rand_state(3)
    @test content(np[1]) == put(3, 2 => Ry(0.2))
    @test parameters(np) == [0.5]
    @test nparameters(np) == 1
    @test getiparams(np[1]) == ()
    @test niparams(np[1]) == 0
    @test mat(c) ≈ mat(np)
    @test apply!(copy(reg), c) ≈ apply!(copy(reg), np)
    @test np' == chain(put(3, 1 => Rx(-0.5)), NoParams(put(3, 2 => Ry(-0.2))))
    @test dispatch!(np, [0.3]) ==
          chain(NoParams(put(3, 2 => Ry(0.2))), put(3, 1 => Rx(0.3)))

    u = chain(1, NoParams(Ry(1.0)), Rx(1.0))
    u2 = dispatch(u, [2.0]) # returns the following error 
    @test u2 == chain(1, NoParams(Ry(1.0)), Rx(2.0))
    @test chsubblocks(u2[1], X) == NoParams(X)
end

# properties
YaoAPI.isunitary(op) = op' * op ≈ IMatrix(size(op, 1))
YaoAPI.isunitary(op::Number) = op' * op ≈ one(op)

YaoAPI.isreflexive(op) = op * op ≈ IMatrix(size(op, 1))
YaoAPI.isreflexive(op::Number) = op * op ≈ one(op)
function YaoAPI.isdiagonal(m::AbstractMatrix)
    return m isa Diagonal || m isa IMatrix
end

"""
    ishermitian(op::AbstractBlock) -> Bool

Returns true if `op` is hermitian.
"""
LinearAlgebra.ishermitian(op) = op' ≈ op

function YaoAPI.iscommute(ops...)
    n = length(ops)
    for i = 1:n
        for j = i+1:n
            iscommute(ops[i], ops[j]) || return false
        end
    end
    true
end

YaoAPI.iscommute(op1, op2) = op1 * op2 ≈ op2 * op1

function YaoAPI.apply!(r::AbstractRegister, b::AbstractBlock)
    _check_size(r, b)
    unsafe_apply!(r, b)
end

function YaoAPI.unsafe_apply!(r::AbstractRegister, b::AbstractBlock)
    _apply_fallback!(r, b)
end

_apply_fallback!(r::AbstractRegister, b::AbstractBlock) =
    throw(NotImplementedError(:_apply_fallback!, (r, b)))

function _apply_fallback!(r::AbstractArrayReg{D,T}, b::AbstractBlock) where {D,T}
    r.state .= mat(T, b) * r.state
    return r
end
function _apply_fallback!(r::DensityMatrix{D,T}, b::AbstractBlock) where {D,T}
    m = mat(T, b)
    r.state .= m * r.state * m'
    return r
end

"""
    |>(register, circuit) -> register

Apply a quantum circuits to register, which modifies the register directly.

### Example

```julia
julia> arrayreg(bit"0") |> X |> Y
```

!!! warning

    `|>` is equivalent to [`apply!`](@ref), which means it has side effects. You
    need to use [`apply`](@ref) if you do not want to change it in-place.
"""
Base.:(|>)(r::AbstractRegister, blk::AbstractBlock) = apply!(r, blk)

function apply!(r::AbstractRegister, blk::Function)
    if applicable(blk, nactive(r))
        return apply!(r, blk(nactive(r)))
    else
        error(
            "input function is not applicable, it should take a integer as number of current active qubits.",
        )
    end
end

occupied_locs(x::AbstractBlock) = (1:nqudits(x)...,)

"""
    subblocks(x)

Returns an iterator of the sub-blocks of a composite block. Default is empty.
"""
subblocks(x::AbstractBlock)

"""
    chsubblocks(composite_block, itr)

Change the sub-blocks of a [`CompositeBlock`](@ref) with given iterator `itr`.
"""
chsubblocks(x::AbstractBlock, itr)

"""
    applymatrix(g::AbstractBlock) -> Matrix

Transform the apply! function of specific block to dense matrix.
"""
applymatrix(T, g::AbstractBlock) =
    YaoArrayRegister.linop2dense(T, r -> statevec(apply!(ArrayReg(r), g)), nqudits(g))
applymatrix(g::AbstractBlock) = applymatrix(ComplexF64, g)
# just use BlockMap maybe? No!

print_block(io::IO, blk::AbstractBlock) = print_block(io, MIME("text/plain"), blk)
print_block(blk::AbstractBlock) = print_block(stdout, blk)
print_block(io::IO, ::MIME"text/plain", blk::AbstractBlock) = summary(io, blk)

# return itself by default
Base.copy(x::AbstractBlock) = x

function cache_key end

"""
    mat([T=ComplexF64], blk)

Returns the matrix form of given block.
"""
mat(x::AbstractBlock) = mat(promote_type(ComplexF64, parameters_eltype(x)), x)

mat_matchreg(reg::AbstractRegister, x::AbstractBlock) = mat(x)
mat_matchreg(reg::AbstractArrayReg{D,T}, x::AbstractBlock) where {D,T} = mat(T,x)

Base.Matrix{T}(x::AbstractBlock) where {T} = Matrix(mat(T, x))

# YaoAPI interface
YaoAPI.nqubits(block::AbstractBlock{2}) = nqudits(block)
YaoAPI.nlevel(::Type{<:AbstractBlock{D}}) where {D} = D
YaoAPI.nlevel(x::AbstractBlock{D}) where {D} = nlevel(typeof(x))

# properties
# NOTE: isdiagonal does fallback to matrix implementation, because it will be used in eigenbasis, and it is known without knowing the matrix.
for each_property in [:(YaoAPI.isunitary), :(YaoAPI.isreflexive), :(LinearAlgebra.ishermitian)]
    @eval $each_property(x::AbstractBlock) = $each_property(mat(x))
    @eval $each_property(::Type{T}) where {T<:AbstractBlock} =
        $each_property(mat(T))
end

function iscommute_fallback(op1::AbstractBlock{D}, op2::AbstractBlock{D}) where {D}
    _check_block_sizes(op1, op2)
    if length(intersect(occupied_locs(op1), occupied_locs(op2))) == 0
        return true
    else
        return iscommute(mat(op1), mat(op2))
    end
end

YaoAPI.iscommute(op1::AbstractBlock{D}, op2::AbstractBlock{D}) where {D} =
    iscommute_fallback(op1, op2)

# parameters
"""
    getiparams(block)

Returns the intrinsic parameters of node `block`, default is an empty tuple.
"""
getiparams(x::AbstractBlock) = ()

"""
    setiparams!([f], block, itr)
    setiparams!([f], block, params...)

Set the parameters of `block`.
When `f` is provided, set parameters of `block` to the value in `collection` mapped by `f`.
`iter` can be an iterator or a symbol, the symbol can be `:zero`, `:random`.
"""
function setiparams! end

"""
    setiparams([f], block, itr)
    setiparams([f], block, params...)

Set the parameters of `block`, the non-inplace version.
When `f` is provided, set parameters of `block` to the value in `collection` mapped by `f`.
`iter` can be an iterator or a symbol, the symbol can be `:zero`, `:random`.
"""
function setiparams end

for F in [:setiparams!, :setiparams]
    @eval begin
        $F(x::AbstractBlock, args...) =
            niparams(x) == length(args) == 0 ? x :
            throw(NotImplementedError($(QuoteNode(F)), (x, args...)))

        $F(x::AbstractBlock, it::Union{Tuple,AbstractArray,Base.Generator}) = $F(x, it...)
        $F(x::AbstractBlock, a::Number, xs::Number...) =
            error("setparams!(x, θ...) is not implemented")
        $F(x::AbstractBlock, it::Symbol) = $F(x, render_params(x, it))

        $F(f::Function, x::AbstractBlock, it) =
            $F(x, map(x -> f(x...), zip(getiparams(x), it)))
        $F(f::Nothing, x::AbstractBlock, it) = $F(x, it)
        $F(f::Function, x::AbstractBlock, it::Symbol) = $F(f, x, render_params(x, it))
    end
end

"""
    parameters(block)

Returns all the parameters contained in block tree with given root `block`.
"""
parameters(x::AbstractBlock) = parameters!(parameters_eltype(x)[], x)

"""
    parameters!(out, block)

Append all the parameters contained in block tree with given root `block` to
`out`.
"""
function parameters!(out, x::AbstractBlock)
    append!(out, getiparams(x))
    for blk in subblocks(x)
        parameters!(out, blk)
    end
    return out
end

# = prewalk(blk->append!(out, getiparams(blk)), x)

niparams(x::AbstractBlock) = length(getiparams(x))

function nparameters(x::AbstractBlock)
    count = niparams(x)
    for each in subblocks(x)
        count += nparameters(each)
    end
    return count
end

"""
    iparams_eltype(block)

Return the element type of [`getiparams`](@ref).
"""
iparams_eltype(x::AbstractBlock) = eltype(getiparams(x))

"""
    parameters_eltype(x)

Return the element type of [`parameters`](@ref).
"""
function parameters_eltype(x::AbstractBlock)
    T = iparams_eltype(x)
    for each in subblocks(x)
        T = promote_type(T, parameters_eltype(each))
    end
    return T
end

mutable struct Dispatcher{VT}
    params::VT
    loc::Int
end

Dispatcher(params) = Dispatcher(params, 0)

function consume!(d::Dispatcher, n::Int)
    d.loc += n
    d.params[d.loc-n+1:d.loc]
end

function consume!(d::Dispatcher{<:Symbol}, n::Int)
    d.loc += n
    d.params
end

function consume!(d::Dispatcher{<:Number}, n::Int)
    if n == 0
        return ()
    elseif n == 1
        d.loc += n
        return d.params
    else
        error("do not have enough parameters to consume, expect 0, 1, got $n")
    end
end

function dispatch!(f::Union{Function,Nothing}, x::AbstractBlock, it::Dispatcher)
    setiparams!(f, x, consume!(it, niparams(x)))
    for each in subblocks(x)
        dispatch!(f, each, it)
    end
    return x
end

"""
    dispatch!(x::AbstractBlock, collection)

Dispatch parameters in collection to block tree `x`.

!!! note

    it will try to dispatch the parameters in collection first.
"""
function dispatch!(f::Union{Function,Nothing}, x::AbstractBlock, it)
    dp = Dispatcher(it)
    res = dispatch!(f, x, dp)
    @assert (it isa Symbol || length(it) == dp.loc) "expect $(dp.loc) parameters, got $(length(it))"
    return res
end

dispatch!(x::AbstractBlock, it) = dispatch!(nothing, x, it)

"""
    popdispatch!(f, block, list)

Pop the first [`nparameters`](@ref) parameters of list, map them with a function
`f`, then dispatch them to the block tree `block`. See also [`dispatch!`](@ref).
"""
function popdispatch!(f::Function, x::AbstractBlock, list::Vector)
    setiparams!(f, x, (popfirst!(list) for k = 1:niparams(x))...)
    for each in subblocks(x)
        popdispatch!(f, each, list)
    end
    return x
end

"""
    popdispatch!(block, list)

Pop the first [`nparameters`](@ref) parameters of list, then dispatch them to
the block tree `block`. See also [`dispatch!`](@ref).
"""
function popdispatch!(x::AbstractBlock, list::Vector)
    setiparams!(x, (popfirst!(list) for k = 1:niparams(x))...)
    for each in subblocks(x)
        popdispatch!(each, list)
    end
    return x
end

render_params(r::AbstractBlock, params) = params
render_params(r::AbstractBlock, params::Symbol) = render_params(r, Val(params))
render_params(r::AbstractBlock, ::Val{:random}) = ntuple(i -> rand(iparams_eltype(r)), niparams(r))
render_params(r::AbstractBlock, ::Val{:zero}) = ntuple(i -> zero(iparams_eltype(r)), niparams(r))

"""
    cache_type(::Type) -> DataType

Return the element type that a `CacheFragment`
will use.
"""
cache_type(::Type{<:AbstractBlock}) = Any

"""
    cache_key(block)

Returns the key that identify the matrix cache of this block. By default, we
use the returns of [`parameters`](@ref) as its key.
"""
cache_key(x::AbstractBlock)

function _check_size(r::AbstractRegister{D}, pb::AbstractBlock{D}) where D
    nqudits(pb) == nactive(r) ||
        throw(QubitMismatchError("register size $(nactive(r)) mismatch with block size $(nqudits(pb))"))
    nlevel(r) == nlevel(pb) ||
        throw(QubitMismatchError("register number of level $(nlevel(r)) mismatch with block number of level $(nlevel(pb))"))
end

_check_block_sizes(blocks::AbstractBlock{D}...) where D = _check_block_sizes(blocks)
function _check_block_sizes(blocks::Union{AbstractVector{<:AbstractBlock{D}}, NTuple{N, AbstractBlock{D}} where N}, n=nothing) where D
    if n === nothing
        if length(blocks) == 0
            error("number of blocks can not be 0!")
        else
            n = nqudits(first(blocks))
        end
    end
    for b in blocks
        if nqudits(b) != n
            throw(QubitMismatchError("number of qudits `$(nqudits(b))` does not match the expected value `$(n)`."))
        end
    end
    return n
end

"""
    parameters_range(block)

Return the range of real parameters present in `block`.

!!! note
    It may not be the case that `length(parameters_range(block)) == nparameters(block)`.

# Example

```jldoctest; setup=:(using YaoBlocks)
julia> YaoBlocks.parameters_range(RotationGate(X, 0.1))
1-element Vector{Tuple{Float64, Float64}}:
 (0.0, 6.283185307179586)
```
"""
function parameters_range(block::AbstractBlock)
    T = parameters_eltype(block)
    out = Tuple{T,T}[]
    parameters_range!(out, block)
    out
end

function parameters_range!(out::Vector{Tuple{T,T}}, block::AbstractBlock) where {T}
    np = niparams(block)
    if  np!= 0
        ranges = iparams_range(block)
        @assert length(ranges) == np
        for i=1:np
            push!(out, ranges[i])
        end
    end
    for subblock in subblocks(block)
        parameters_range!(out, subblock)
    end
end

# non-inplace versions
"""
    apply(register, block)

The non-inplace version of applying a block (of quantum circuit) to a quantum register.
Check `apply!` for the faster inplace version.
"""
function apply(reg::AbstractRegister{D}, block) where D
    return apply!(copy(reg), block)
end

function generic_dispatch!(f::Union{Function,Nothing}, x::AbstractBlock, it::Dispatcher)
    x = setiparams(f, x, consume!(it, niparams(x)))
    chsubblocks(x, map(subblocks(x)) do each
        generic_dispatch!(f, each, it)
    end)
end

"""
    dispatch(x::AbstractBlock, collection)

Dispatch parameters in collection to block tree `x`, the generic non-inplace version.

!!! note

    it will try to dispatch the parameters in collection first.
"""
function dispatch(f::Union{Function,Nothing}, x::AbstractBlock, it)
    dp = Dispatcher(it)
    res = generic_dispatch!(f, x, dp)
    @assert (it isa Symbol || length(it) == dp.loc) "expect $(dp.loc) parameters, got $(length(it))"
    return res
end

dispatch(x::AbstractBlock, it) = dispatch(nothing, x, it)

BitBasis.basis(b::AbstractBlock{D}) where D = basis(DitStr{D,nqudits(b),Int64})

################## get index ###################

function Base.getindex(b::AbstractBlock{D}, i::DitStr{D,N}, j::DitStr{D,N}) where {D,N}
    T = promote_type(ComplexF64, parameters_eltype(b))
    @assert nqudits(b) == N
    return unsafe_getindex(T, b, buffer(i), buffer(j))
end
function Base.getindex(b::AbstractBlock{D}, ::Colon, j::DitStr{D,N,TI}) where {D,N,TI}
    T = promote_type(ComplexF64, parameters_eltype(b))
    return cleanup(_getindex(T, b, :, j))
end
function Base.getindex(b::AbstractBlock{D}, i::DitStr{D,N,TI}, ::Colon) where {D,N,TI}
    T = promote_type(ComplexF64, parameters_eltype(b))
    return cleanup(_getindex(T, b, i, :))
end
function Base.getindex(b::AbstractBlock{D}, ::Colon, j::EntryTable{DitStr{D,N,TI},T}) where {D,N,TI,T}
    return cleanup(_getindex(b, :, j))
end
function Base.getindex(b::AbstractBlock{D}, i::EntryTable{DitStr{D,N,TI},T}, ::Colon) where {D,N,TI,T}
    return cleanup(_getindex(b, i, :))
end
function _getindex(::Type{T}, b::AbstractBlock{D}, ::Colon, j::DitStr{D,N,TI}) where {T, D,N,TI}
    @assert nqudits(b) == N
    rows, vals = unsafe_getcol(T, b, j)
    return EntryTable(rows, vals)
end
function _getindex(::Type{T}, b::AbstractBlock{D}, i::DitStr{D,N,TI}, ::Colon) where {D,N,TI,T}
    res = _getindex(T, b', :,i)
    conj!(res.amplitudes)
    return res
end
function _getindex(b::AbstractBlock{D}, ::Colon, j::EntryTable{DitStr{D,N,TI},T}) where {D,N,TI,T}
    length(j) == 0 && return j
    return merge([(et = _getindex(T,b,:,bs); rmul!(et.amplitudes, amp); et) for (bs, amp) in j]...)
end
function _getindex(b::AbstractBlock{D}, i::EntryTable{DitStr{D,N,TI},T}, ::Colon) where {D,N,TI,T}
    res = _getindex(b',:,i)
    conj!(res.amplitudes)
    return res
end

################## noisy simulation ###################
abstract type AbstractQuantumChannel{D} <: AbstractBlock{D} end
function mat(::Type{T}, x::AbstractQuantumChannel) where {T}
    error("Quantum channel does not have a matrix representation!")
end

"""
    isnoisy(block::AbstractBlock)

Check if a circuit contains any noisy channel.
"""
function isnoisy(block::AbstractBlock)
    return isa(block, AbstractQuantumChannel) || any(isnoisy, subblocks(block))
end

import Zygote, ForwardDiff
using Random, Test
using YaoBlocks, YaoArrayRegister
using ChainRulesCore: Tangent, unthunk, AbstractThunk

@testset "recursive_create_tangent" begin
    c = chain(put(5, 2 => chain(Rx(1.4), Rx(0.5))), cnot(5, 3, 1), put(5, 3 => Rx(-0.5)))
    tc = YaoBlocks.AD.recursive_create_tangent(c)
    @test tc isa Tangent
end

@testset "construtors" begin
    res = Zygote.gradient(x -> x.list[1].blocks[1].theta, sum([chain(1, Rz(0.3))]))[1]
    @test res.list[].blocks[1].theta ≈ 1.0
    res = Zygote.gradient(
        x -> getfield(getfield(x, :content), :theta),
        Daggered(Rx(0.5)),
    )[1]
    @test res.content.theta ≈ 1.0
end

@testset "rules" begin
    h = put(5, 3 => Z) + put(5, 2 => X)
    c = chain(put(5, 2 => chain(Rx(1.4), Rx(0.5))), cnot(5, 3, 1), put(5, 3 => Rx(-0.5)))
    r = rand_state(5)
    g0 = reinterpret(
        ComplexF64,
        ForwardDiff.gradient(
            x -> real(
                expect(h, ArrayReg([Complex(x[2i-1], x[2i]) for i = 1:length(x)÷2])),
            ),
            reinterpret(Float64, r.state),
        ),
    )
    @test Zygote.gradient(x -> real(expect(h, ArrayReg(x))), r.state)[1] ≈ g0
    @test Zygote.gradient(
        x -> real(expect(h, ArrayReg(reshape(statevec(x), :, 1)))),
        r,
    )[1].state ≈ g0
    @test Zygote.gradient(
        x -> real(expect(h, ArrayReg(reshape(state(x), :, 1)))),
        r,
    )[1].state ≈ g0
    @test Zygote.gradient(x -> real(expect(h, copy(x))), r)[1].state ≈ g0
    @test Zygote.gradient(x -> real(expect(h, parent(x'))), r)[1].state ≈ g0

    g1 = reinterpret(
        ComplexF64,
        ForwardDiff.gradient(
            x -> real(sum(abs2, [Complex(x[2i-1], x[2i]) for i = 1:length(x)÷2])),
            reinterpret(Float64, r.state),
        ),
    )
    @test Zygote.gradient(x -> real(sum(abs2, state(x'))), r)[1].state ≈ g1
    @test Zygote.gradient(x -> real(sum(abs2, statevec(x'))), r)[1].state ≈ g1
    # zygote does not work if `sin` is not here,
    # because it gives an adjoint of different type as the output matrix type.
    @test AD.extract_circuit_gradients!(
        Zygote.gradient(x -> real(sum(sin, Matrix(x))), c)[1].blocks,
        Float64[],
    ) ≈ ForwardDiff.gradient(x -> real(sum(sin, Matrix(dispatch(c, x)))), parameters(c))
end

@testset "adwith zygote" begin
    c = chain(put(5, 2 => chain(Rx(0.4), Rx(0.5))), cnot(5, 3, 1), put(5, 3 => Rx(-0.5)))
    dispatch!(c, :random)

    function loss(reg::AbstractRegister, circuit::AbstractBlock{N}) where {N}
        reg = apply(copy(reg), circuit)
        st = state(reg)
        sum(real(st .* st))
    end

    # apply
    reg0 = zero_state(5)
    params = rand!(parameters(c))
    paramsδ = Zygote.gradient(params -> loss(reg0, dispatch(c, params)), params)[1]
    regδ = Zygote.gradient(reg -> loss(reg, c), reg0)[1]
    fparamsδ = ForwardDiff.gradient(
        params -> loss(
            ArrayReg(Matrix{Complex{eltype(params)}}(reg0.state)),
            dispatch(c, params),
        ),
        params,
    )
    fregδ = ForwardDiff.gradient(
        x -> loss(
            ArrayReg([Complex(x[2i-1], x[2i]) for i = 1:length(x)÷2]),
            dispatch(c, Vector{real(eltype(x))}(parameters(c))),
        ),
        reinterpret(Float64, reg0.state),
    )
    @test fregδ ≈ reinterpret(Float64, regδ.state)
    @test fparamsδ ≈ paramsδ

    # expect and fidelity
    c = chain(
        put(5, 5 => Rx(1.5)),
        put(5, 1 => Rx(0.4)),
        put(5, 4 => Rx(0.2)),
        put(5, 2 => chain(Rx(0.4), Rx(0.5))),
        cnot(5, 3, 1),
        put(5, 3 => Rx(-0.5)),
    )
    h = chain(repeat(5, X, 1:5))
    reg = rand_state(5)
    function loss2(reg::AbstractRegister, circuit::AbstractBlock{N}) where {N}
        return 5 *
               real(expect(h, copy(reg) => circuit) + fidelity(reg, apply(reg, circuit)))
    end
    params = rand!(parameters(c))
    fδc = ForwardDiff.gradient(
        params -> loss2(
            ArrayReg(Matrix{Complex{eltype(params)}}(reg.state)),
            dispatch(c, params),
        ),
        params,
    )
    δr, δc = Zygote.gradient((reg, params) -> loss2(reg, dispatch(c, params)), reg, params)
    @test δc ≈ fδc

    fregδ = ForwardDiff.gradient(
        x -> loss2(
            ArrayReg([Complex(x[2i-1], x[2i]) for i = 1:length(x)÷2]),
            dispatch(c, Vector{real(eltype(x))}(params)),
        ),
        reinterpret(Float64, reg.state),
    )
    @test fregδ ≈ reinterpret(Float64, δr.state)

    # operator fidelity
    c = chain(
        put(5, 5 => Rx(1.5)),
        put(5, 1 => Rx(0.4)),
        put(5, 4 => Rx(0.2)),
        put(5, 2 => chain(Rx(0.4), Rx(0.5))),
        cnot(5, 3, 1),
        put(5, 3 => Rx(-0.5)),
    )
    h = chain(repeat(5, X, 1:5))
    function loss3(circuit::AbstractBlock{N}, h) where {N}
        return operator_fidelity(circuit, h)
    end
    params = rand!(parameters(c))
    fδc = ForwardDiff.gradient(params -> loss3(dispatch(c, params), h), params)
    δc, = Zygote.gradient(p -> loss3(dispatch(c, p), h), params)
    @test δc ≈ fδc

    # NOTE: operator back propagation in expect is not implemented!
    # to differentiate operators, we need to use the expensive `mat_back` function.
end

@testset "add block" begin
    H = sum([chain(5, put(k => Z)) for k = 1:5])
    c = chain(put(5, 2 => chain(Rx(0.4), Rx(0.5))), cnot(5, 3, 1), put(5, 3 => Rx(-0.5)))
    dispatch!(c, :random)
    function loss(reg::AbstractRegister, circuit::AbstractBlock{N}) where {N}
        reg = apply(copy(reg), circuit)
        st = state(reg)
        reg2 = apply(copy(reg), H)
        st2 = state(reg2)
        sum(real(st .* st2))
    end

    reg0 = zero_state(5)
    params = rand!(parameters(c))
    paramsδ = Zygote.gradient(params -> loss(reg0, dispatch(c, params)), params)[1]
    fparamsδ = ForwardDiff.gradient(
        params -> loss(
            ArrayReg(Matrix{Complex{eltype(params)}}(reg0.state)),
            dispatch(c, params),
        ),
        params,
    )
    @test fparamsδ ≈ paramsδ

    regδ = Zygote.gradient(reg -> loss(reg, c), reg0)[1]
    fregδ = ForwardDiff.gradient(
        x -> loss(
            ArrayReg([Complex(x[2i-1], x[2i]) for i = 1:length(x)÷2]),
            dispatch(c, Vector{real(eltype(x))}(parameters(c))),
        ),
        reinterpret(Float64, reg0.state),
    )
    @test fregδ ≈ reinterpret(Float64, regδ.state)
end

@testset "apply hami1" begin
    h = 0.2 * put(5, 3 => Z) + 0.5 * put(5, 2 => X) + 0.4 * repeat(5, Z, 1:3)
    reg0 = rand_state(5)
    loss(reg, params) = fidelity(reg0, apply(reg, dispatch(h, params)))

    reg = rand_state(5)
    params = randn(3)
    _adapt(::Type, reg) = reg
    _adapt(::Type{T}, reg::AbstractArrayReg) where T <:ForwardDiff.Dual = similar(reg, _adapt.(T, reg.state))
    _adapt(::Type{T}, x::Complex) where T <: ForwardDiff.Dual = T(x.re) + im * T(x.im)
    t1 = ForwardDiff.gradient(state->loss(ArrayReg{2}(state[1:32] .+ im .* state[33:64]), params), [real.(reg.state)..., imag.(reg.state)...])
    t2 = ForwardDiff.gradient(params->loss(_adapt(eltype(params), reg), params), params)
    g1, g2 = Zygote.gradient(loss, reg, params)
    @test g2 ≈ t2
    @test [real.(g1.state)..., imag.(g1.state)...] ≈ t1
end
    
@testset "apply hami2" begin
    N = 6
    cost = sum([put(N, i=>Z) for i in 1:N])
    theta = rand(96)
    c = chain(rand([[control(N, i, mod1(i+1,N)=>Rx(0.0)) for i=1:N]..., [put(N, i=>Ry(0.0)) for i=1:N]..., [put(N, i=>Rx(0.0)) for i=1:N]...], 96))
    new_var = dispatch(c, :random);
    function new_loss(theta::AbstractVector{T}) where T
        new_circ = dispatch(new_var, theta)
        diff_evalue = expect(cost, zero_state(Complex{T}, N) => new_circ)
        return 3*real.(diff_evalue)
    end

    g1 = Zygote.gradient(_theta->new_loss(_theta), theta)[1]
    g2 = ForwardDiff.gradient(_theta->new_loss(_theta), theta)
    @test g1 ≈ g2

    function new_loss2(reg::ArrayReg{T}) where T
        diff_evalue = expect(cost, reg => new_var)
        return 3*real.(diff_evalue)
    end
    regin = rand_state(N)
    g1 = Zygote.gradient(_theta->new_loss2(_theta), regin)[1]
    params = reinterpret(real(eltype(regin.state)), regin.state)
    g2 = ForwardDiff.gradient(p->new_loss2(arrayreg(reinterpret(complex(eltype(p)), p))), params)
    @test statevec(g1) ≈ reinterpret(ComplexF64, g2)
end

@testset "fix #348" begin
    n = 3
    h = sum([kron(n, i => Z, i+1=>Z) for i = 1:n-1])
    function wrap(U::AbstractBlock, θ::Vector{T}) where {T}
        n = nqubits(U)
        reg = apply(zero_state(Complex{T}, n), dispatch(U, θ))
        real(expect(h, reg))
    end

    hb = sum([put(n, i => X) for i = 1:n])
    U2 = chain(n, [time_evolve(hb, 0.0)])

    g1 = (wrap(U2, [0.618 + 1e-5]) - wrap(U2, [0.618-1e-5]))/2e-5
    g2 = Zygote.gradient(p -> wrap(U2, p), [0.618])[1][]
    @test isapprox(g1, g2, rtol=1e-3)
end

@testset "zygote add" begin
    function loss(theta::AbstractVector{T}, alpha::AbstractVector{T}, var, N) where T
        cost = Add([PutBlock(N, Scale(alpha[i], Z), (i,)) for i in 1:N])
        reg = apply(zero_state(Complex{T}, N), dispatch(var, theta))
        return real((reg' * apply(reg, cost))^2)
    end
    var = chain(put(6, i=>Rx(randn())) for i=1:6)
    params = parameters(var)
    alpha = rand(6)
    gt1 = Zygote.gradient(_theta -> loss(_theta, alpha, var, 6), params)[1]
    gt1f = ForwardDiff.gradient(_theta -> loss(_theta, eltype(_theta).(alpha), var, 6), params)
    ga1 = Zygote.gradient(_alpha -> loss(params, _alpha, var, 6), alpha)[1]
    ga1f = ForwardDiff.gradient(_alpha -> loss(eltype(_alpha).(params), _alpha, var, 6), alpha)
    @test gt1 ≈ gt1f
    @test ga1 ≈ ga1f

    # tuple version
    function loss(theta, alpha, var, N)
        cost = Add(([PutBlock(N, Scale(alpha[i], Z), (i,)) for i in 1:N]...,))
        reg = apply(zero_state(N), dispatch(var, theta))
        return real((reg' * apply(reg, cost))^2)
    end
    @test Zygote.gradient(_theta -> loss(_theta, alpha, var, 6), params)[1] ≈ gt1
end

@testset "zygote apply back" begin
    function loss3(c, θs)
        # the assign is nessesary!
        c = dispatch(c, θs)
        reg = zero_state(nqubits(c))
        reg = apply(reg, c)
        v = vec(reg.state)
        real(sum(abs2.(v .* v)))
    end
    N = 5
    c = chain(rand([[control(N, i, mod1(i+1,N)=>Rx(0.0)) for i=1:N]..., [put(N, i=>Ry(0.0)) for i=1:N]..., [put(N, i=>Rx(0.0)) for i=1:N]...], 6))
    loss3(c, rand(nparameters(c)))
    zygote_grad = Zygote.gradient(θs->loss3(c, θs), rand(nparameters(c)))[1]
    @test zygote_grad isa Vector
end

@testset "issue #545" begin
    function variational_circuit(q, nlayer)
        circuit = chain(q)
        for i = 1:nlayer
            push!(circuit, put(q, i=>chain(Rx(0.0), Ry(0.0), Rz(0.0))))
        end
        circuit
    end
    function bug_mwe()    
        q = 4
        vqc = variational_circuit(q, 2)
        param = 4pi*rand(nparameters(vqc))

        # bstate = rand_state(q) # works OK    
        bstate = rand_state(q, nbatch=2) # Zygote errors
        
        function loss(param)
            vqc_p = dispatch(vqc, param)
            bstate_p = apply(bstate, vqc_p)
            pr = probs(bstate_p)
            pr_s = sum(pr, dims = 2)
            r = -sum(pr_s[1:2^(4-1)])
            return r
        end   

        l = loss(param)
        grad = Zygote.gradient(loss, param)[1]

        return grad
    end

    @test bug_mwe() isa Vector
end

module OpenQASMExt

using YaoBlocks
using YaoBlocks: AbstractBlock, CompositeBlock, PrimitiveBlock, PutBlock, ControlBlock, ChainBlock
using YaoBlocks: Daggered, GeneralMatrixBlock, RotationGate, ShiftGate, PhaseGate, KronBlock
using YaoBlocks: XGate, YGate, ZGate, HGate, I2Gate, TGate, SWAPGate
using YaoBlocks: ConstGate, Measure, AllLocs
using YaoBlocks: content, subblocks, nqubits, nqudits, getiparams
using YaoBlocks: put, control, chain, swap, rot, kron, shift, matblock
using YaoBlocks: X, Y, Z, H, I2, T, Rx, Ry, Rz
using YaoBlocks: Optimise
using YaoBlocks: AbstractErrorType, DepolarizingError, ThermalRelaxationError, CoherentError
using YaoBlocks: PauliError, AmplitudeDampingError, PhaseDampingError, PhaseAmplitudeDampingError

import YaoBlocks: KrausChannel, quantum_channel

using OpenQASM
using OpenQASM.RBNF: Token

include("compile.jl")
include("parse.jl")

end # module

using Test, YaoBlocks, YaoArrayRegister
using YaoBlocks.ConstGate: CNOT

@testset "test constructor" for T in [Float16, Float32, Float64]
    # NOTE: type should follow the axis
    @test RotationGate(X, 0.1) isa PrimitiveBlock{2}

    @test Rx(1) isa RotationGate{2,Float64,XGate}
    @test Rx(T(0.1)) isa RotationGate{2,T,XGate}
    @test Ry(T(0.1)) isa RotationGate{2,T,YGate}
    @test Rz(T(0.1)) isa RotationGate{2,T,ZGate}
end

@testset "test matrix" begin
    theta = 2.0
    for (DIRECTION, MAT) in [
        (X, [cos(theta / 2) -im*sin(theta / 2); -im*sin(theta / 2) cos(theta / 2)]),
        (Y, [cos(theta / 2) -sin(theta / 2); sin(theta / 2) cos(theta / 2)]),
        (Z, [exp(-im * theta / 2) 0; 0 exp(im * theta / 2)]),
        (CNOT, exp(-mat(CNOT) / 2 * theta * im |> Matrix)),
        (control(2, (1,), 2 => X), exp(-mat(CNOT) / 2 * theta * im |> Matrix)),
    ]
        @test mat(RotationGate(DIRECTION, theta)) ≈ MAT
    end
end

@testset "test apply" begin
    r = rand_state(1)
    @test state(apply!(copy(r), Rx(0.1))) ≈ mat(Rx(0.1)) * state(r)
end

@testset "test dispatch" begin
    @test dispatch!(Rx(0.1), 0.3) == Rx(0.3)
    x = Rx(0.1)
    @test dispatch(x, 3.0f0) == Rx(3.0f0) &&
          eltype(getiparams(dispatch(x, 3.0f0))) == Float32
    @test x == Rx(0.1)
    @test nparameters(Rx(0.1)) == 1

    @testset "test $op" for op in [+, -, *, /]
        @test dispatch!(op, Rx(0.1), π) == Rx(op(0.1, π))
    end

    @test_throws AssertionError dispatch!(Rx(0.1), (0.2, 0.3))
end

@testset "adjoints" begin
    @test Rx(0.1)' == Rx(-0.1)
    @test Rx(0.2)' == Rx(-0.2)
    @test copy(Rx(0.1)) == Rx(0.1)

    g = Rx(0.1) # creates a new one
    @test copy(g) !== g
end

@testset "isunitary, isdiagonal" begin
    g = Rx(0.1 + 0im)
    @test @test_nowarn isunitary(g) == true

    g = Rx(0.1 + 1im)
    @test @test_logs (
        :warn,
        "θ in RotationGate is not real, got θ=$(g.theta), fallback to matrix-based method",
    ) isunitary(g) == false

    @test isdiagonal(rot(Z, 0.5))
    @test !isdiagonal(rot(X, 0.5))
end

@testset "occupied locs" begin
    g = rot(put(5, 2 => X), 0.5)
    @test occupied_locs(g) == (1,2,3,4,5)
end

@testset "instruct_get_element" begin
    pb = rot(Y, 0.4)
    mpb = mat(pb)
    allpass = true
    for i=basis(pb), j=basis(pb)
        allpass &= pb[i, j] == mpb[Int(i)+1, Int(j)+1]
    end
    @test allpass
end

@testset "instruct_get_element" begin
    for pb in [Rx(0.5), rot(SWAP, 0.5), shift(0.5), phase(0.5)
            ]
        mpb = mat(pb)
        allpass = true
        for i=basis(pb), j=basis(pb)
            allpass &= pb[i, j] == mpb[Int(i)+1, Int(j)+1]
        end
        @test allpass

        allpass = true
        for j=basis(pb)
            allpass &= vec(pb[:, j]) == mpb[:, Int(j)+1]
            allpass &= vec(pb[j,:]) == mpb[Int(j)+1,:]
            allpass &= isclean(pb[:,j])
        end
        @test allpass
    end
end

@testset "density matrix" begin
    reg = rand_state(1)
    r = density_matrix(reg)
    @test density_matrix(apply(reg, Rx(0.4))) ≈ apply(r, Rx(0.4))
end
